--------------------------------------------------------------------------------
--
--                COPYRIGHT (C) 2000-2001 - LSI LOGIC.
--    All rights reserved. Reproduction in whole or part is prohibited
--          without the written permission of the copyright owner.
--
--------------------------------------------------------------------------------


---------------------------------------------------------------------------
-- Entity declaration of 'PROC_MUX_Z8'
---------------------------------------------------------------------------

library ieee          ;

use ieee.std_logic_1164.all    ;
use ieee.std_logic_arith.all   ;

use WORK.package_g12.all ;

ENTITY proc_mux_z8 IS
  port(
    GCLEAR      ,
    CK          ,
    MUX_SEL     : IN  std_ulogic ;
    SHIFT_IN_D0 ,
    SHIFT_IN_D1 : IN  std_ulogic_vector(7 downto 0) ;
    SHIFT_OUT   : OUT std_ulogic_vector(7 downto 0)   ) ;
END proc_mux_z8 ;

---------------------------------------------------------------------------
-- Architecture 'beh' of 'PROC_MUX_Z8'
---------------------------------------------------------------------------

architecture beh of proc_mux_z8 is

    
    -- Signal declaration --
    signal shift_struc : array_8bit(7 downto 0) ;


BEGIN

    -- Sequential process --
p0 : process(GCLEAR, CK)
     begin
     
        if( GCLEAR = '0' ) then
        
           shift_struc <= (others => ( others => '0') ) ;
           
        elsif( CK'event and CK = '1' ) then
        
           -- shift register --
           if( MUX_SEL = '1' ) then
              shift_struc <= shift_struc(6 downto 0) & SHIFT_IN_D1 ;              
           else
              shift_struc <= shift_struc(6 downto 0) & SHIFT_IN_D0 ;
           end if ;
           
        end if ;
        
     end process ;
     
     -- ass.
     SHIFT_OUT <= shift_struc(7) ;
     


END beh ;

