//
// Verilog description for cell cpu, 
// Thu Mar  8 13:22:14 2001
//
// LeonardoSpectrum Level 3, v20001b.106 
//


module cpu ( PORT0O, PORT1O, PORT2O, PORT3O, NPORT1E, NPORT2E, NPORT3E, 
             XRAMDO, PROGA, XRAMA, NPSEN, NXRAMR, NXRAMW, PROGA_EN, 
             XRAMA_EN, SOURCE_A, DESTIN_A, DESTIN_DO, NDESTIN_WE, 
             NSOURCE_RE, SFRWE, SFRSA, XINTR_ACK, IDLE, PDOWN, NCCLKE, 
             NPCLKE, PORT0I, PORT1I, PORT2I, PORT3I, PROGDI, XRAMDI, 
             SOURCE_DI, ESFRDI, XINTR_SRC, MWAIT, CLK1, CLK2, CLK3, RESET, 
             TRESET ) ;

    output [7:0]PORT0O ;
    output [7:0]PORT1O ;
    output [7:0]PORT2O ;
    output [7:0]PORT3O ;
    output [7:0]NPORT1E ;
    output [7:0]NPORT2E ;
    output [7:0]NPORT3E ;
    output [7:0]XRAMDO ;
    output [15:0]PROGA ;
    output [15:0]XRAMA ;
    output NPSEN ;
    output NXRAMR ;
    output NXRAMW ;
    output PROGA_EN ;
    output XRAMA_EN ;
    output [7:0]SOURCE_A ;
    output [7:0]DESTIN_A ;
    output [7:0]DESTIN_DO ;
    output NDESTIN_WE ;
    output NSOURCE_RE ;
    output SFRWE ;
    output [6:0]SFRSA ;
    output [13:5]XINTR_ACK ;
    output IDLE ;
    output PDOWN ;
    output NCCLKE ;
    output NPCLKE ;
    input [7:0]PORT0I ;
    input [7:0]PORT1I ;
    input [7:0]PORT2I ;
    input [7:0]PORT3I ;
    input [7:0]PROGDI ;
    input [7:0]XRAMDI ;
    input [7:0]SOURCE_DI ;
    input [7:0]ESFRDI ;
    input [13:5]XINTR_SRC ;
    input MWAIT ;
    input CLK1 ;
    input CLK2 ;
    input CLK3 ;
    input RESET ;
    input TRESET ;

    wire RXDNE, TXDNE, TF1, IE1, TF0, IE0, TXD, RXD, RITI, T1_OVERFLOW, 
         EXCEPTION, INTR_VECTOR_6_, INTR_VECTOR_5_, INTR_VECTOR_4_, 
         INTR_VECTOR_3_, INTR_VECTOR_1_, INTR_ACKNOW_3_, INTR_ACKNOW_2_, 
         INTR_ACKNOW_1_, INTR_ACKNOW_0_, NPORT3E_I_1_, NPORT3E_I_0_, PORT3O_I_1_, 
         PORT3O_I_0_, CLK3_EN, INTERNAL_WAIT, NEXT_STATE_IDLE, INTR_LCALL, 
         INTERNAL_RESET, LAST_CYC, STATE_2_, STATE_1_, STATE_0_, INTR_CON, 
         PORT_CON, IMM_CON, STATE_CON_3_, STATE_CON_2_, STATE_CON_0_, PC_CON_17_, 
         PC_CON_16_, PC_CON_15_, PC_CON_14_, PC_CON_12_, PC_CON_10_, PC_CON_9_, 
         PC_CON_8_, PC_CON_7_, PC_CON_6_, PC_CON_5_, PC_CON_4_, PC_CON_3_, 
         PC_CON_2_, PC_CON_1_, PC_CON_0_, SFR_CON_6_, SFR_CON_5_, SFR_CON_4_, 
         SFR_CON_3_, SFR_CON_2_, SFR_CON_1_, SFR_CON_0_, MEM_CON_14_, 
         MEM_CON_13_, MEM_CON_12_, MEM_CON_11_, MEM_CON_10_, MEM_CON_9_, 
         MEM_CON_8_, MEM_CON_7_, MEM_CON_5_, MEM_CON_4_, MEM_CON_3_, MEM_CON_2_, 
         MEM_CON_1_, MEM_CON_0_, SWITCH_CON_5_, SWITCH_CON_4_, SWITCH_CON_3_, 
         SWITCH_CON_2_, SWITCH_CON_1_, SWITCH_CON_0_, ALU_CON_18_, ALU_CON_17_, 
         ALU_CON_16_, ALU_CON_15_, ALU_CON_14_, ALU_CON_13_, ALU_CON_12_, 
         ALU_CON_11_, ALU_CON_10_, ALU_CON_9_, ALU_CON_8_, ALU_CON_7_, 
         ALU_CON_6_, ALU_CON_5_, ALU_CON_4_, ALU_CON_3_, ALU_CON_2_, ALU_CON_1_, 
         ALU_CON_0_, IMMEDIATE_2_7_, IMMEDIATE_2_6_, IMMEDIATE_2_5_, 
         IMMEDIATE_2_4_, IMMEDIATE_2_3_, IMMEDIATE_2_2_, IMMEDIATE_2_1_, 
         IMMEDIATE_2_0_, IMMEDIATE_7_, IMMEDIATE_6_, IMMEDIATE_5_, IMMEDIATE_4_, 
         IMMEDIATE_3_, IMMEDIATE_2_, IMMEDIATE_1_, IMMEDIATE_0_, OPCODE_7_, 
         OPCODE_6_, OPCODE_5_, OPCODE_4_, OPCODE_3_, OPCODE_2_, OPCODE_1_, 
         OPCODE_0_, SAVE_ADDR_7_, SAVE_ADDR_6_, SAVE_ADDR_5_, SAVE_ADDR_4_, 
         SAVE_ADDR_3_, SAVE_ADDR_2_, SAVE_ADDR_1_, SAVE_ADDR_0_, 
         DATA_POINTER_15_, DATA_POINTER_14_, DATA_POINTER_13_, DATA_POINTER_12_, 
         DATA_POINTER_11_, DATA_POINTER_10_, DATA_POINTER_9_, DATA_POINTER_8_, 
         DATA_POINTER_7_, DATA_POINTER_6_, DATA_POINTER_5_, DATA_POINTER_4_, 
         DATA_POINTER_3_, DATA_POINTER_2_, DATA_POINTER_1_, DATA_POINTER_0_, 
         SFR_WRITE_EN_14_, SFR_WRITE_EN_13_, SFR_WRITE_EN_12_, SFR_WRITE_EN_11_, 
         SFR_WRITE_EN_10_, SFR_WRITE_EN_9_, SFR_WRITE_EN_8_, SFR_WRITE_EN_7_, 
         SFR_WRITE_EN_6_, SFR_WRITE_EN_5_, SFR_WRITE_EN_4_, SFR_WRITE_EN_3_, 
         SFR_WRITE_EN_2_, SFR_WRITE_EN_1_, SFR_WRITE_EN_0_, SOURCE_IS_SFR, 
         SSFRDI_7_, SSFRDI_6_, SSFRDI_5_, SSFRDI_4_, SSFRDI_3_, SSFRDI_2_, 
         SSFRDI_1_, SSFRDI_0_, TSFRDI_7_, TSFRDI_6_, TSFRDI_5_, TSFRDI_4_, 
         TSFRDI_3_, TSFRDI_2_, TSFRDI_1_, TSFRDI_0_, SFR_DATA_7_, SFR_DATA_6_, 
         SFR_DATA_5_, SFR_DATA_4_, SFR_DATA_3_, SFR_DATA_2_, SFR_DATA_1_, 
         SFR_DATA_0_, INTR_PRI1_7_, INTR_PRI1_6_, INTR_PRI1_5_, INTR_PRI1_4_, 
         INTR_PRI1_3_, INTR_PRI1_2_, INTR_PRI1_1_, INTR_PRI1_0_, INTR_PRI0_7_, 
         INTR_PRI0_6_, INTR_PRI0_5_, INTR_PRI0_4_, INTR_PRI0_3_, INTR_PRI0_2_, 
         INTR_PRI0_1_, INTR_PRI0_0_, INTR_EN1_7_, INTR_EN1_6_, INTR_EN1_5_, 
         INTR_EN1_4_, INTR_EN1_3_, INTR_EN1_2_, INTR_EN1_1_, INTR_EN1_0_, 
         INTR_EN0_7_, INTR_EN0_6_, INTR_EN0_5_, INTR_EN0_4_, INTR_EN0_3_, 
         INTR_EN0_2_, INTR_EN0_1_, INTR_EN0_0_, PORT_3_7_, PORT_3_6_, PORT_3_5_, 
         PORT_3_4_, PORT_3_3_, PORT_3_2_, PORT_3_1_, PORT_3_0_, PORT_2_7_, 
         PORT_2_6_, PORT_2_5_, PORT_2_4_, PORT_2_3_, PORT_2_2_, PORT_2_1_, 
         PORT_2_0_, PORT_1_7_, PORT_1_6_, PORT_1_5_, PORT_1_4_, PORT_1_3_, 
         PORT_1_2_, PORT_1_1_, PORT_1_0_, PORT_0_7_, PORT_0_6_, PORT_0_5_, 
         PORT_0_4_, PORT_0_3_, PORT_0_2_, PORT_0_1_, PORT_0_0_, PCON_7_, PCON_3_, 
         PCON_2_, STACK_POINTER_7_, STACK_POINTER_6_, STACK_POINTER_5_, 
         STACK_POINTER_4_, STACK_POINTER_3_, STACK_POINTER_2_, STACK_POINTER_1_, 
         STACK_POINTER_0_, PSW_7_, PSW_6_, PSW_5_, PSW_4_, PSW_3_, PSW_2_, 
         PSW_1_, PSW_0_, B_7_, B_6_, B_5_, B_4_, B_3_, B_2_, B_1_, B_0_, 
         INDIRECT_DATA_7_, INDIRECT_DATA_6_, INDIRECT_DATA_5_, INDIRECT_DATA_4_, 
         INDIRECT_DATA_3_, INDIRECT_DATA_2_, INDIRECT_DATA_1_, INDIRECT_DATA_0_, 
         MULDIV_OV, BIT_ADDRESS_2_, BIT_ADDRESS_1_, BIT_ADDRESS_0_, 
         CONDITION_MET, OVERFLOW_RESULT, AUX_CARRY_RESULT, CARRY_RESULT, 
         MULDIV_B_7_, MULDIV_B_6_, MULDIV_B_5_, MULDIV_B_4_, MULDIV_B_3_, 
         MULDIV_B_2_, MULDIV_B_1_, MULDIV_B_0_, MULDIV_A_7_, MULDIV_A_6_, 
         MULDIV_A_5_, MULDIV_A_4_, MULDIV_A_3_, MULDIV_A_2_, MULDIV_A_1_, 
         MULDIV_A_0_, OPERAND_B_7_, OPERAND_B_6_, OPERAND_B_5_, OPERAND_B_4_, 
         OPERAND_B_3_, OPERAND_B_2_, OPERAND_B_1_, OPERAND_B_0_, OPERAND_A_7_, 
         OPERAND_A_6_, OPERAND_A_5_, OPERAND_A_4_, OPERAND_A_3_, OPERAND_A_2_, 
         OPERAND_A_1_, OPERAND_A_0_, B_RESULT_7_, B_RESULT_6_, B_RESULT_5_, 
         B_RESULT_4_, B_RESULT_3_, B_RESULT_2_, B_RESULT_1_, B_RESULT_0_, 
         ACC_RESULT_7_, ACC_RESULT_6_, ACC_RESULT_5_, ACC_RESULT_4_, 
         ACC_RESULT_3_, ACC_RESULT_2_, ACC_RESULT_1_, ACC_RESULT_0_, PCON_6_, 
         nx1221, nx1223, nx1225, nx1227, nx1229, nx1231, nx1233, nx1235, nx1237, 
         nx1239, nx1241, nx1243, nx1245, nx1247, nx1249, nx1251, nx1253, nx1255, 
         nx1257, nx1259, nx1261, nx1263, nx1265, nx1267, nx1269, nx1271, nx1273, 
         nx1275, nx1277, nx1279, nx1281, nx1283, nx1285, nx1287, nx1289, nx1291, 
         nx1293, nx1295, nx1297, nx1299, nx1301, nx1303, nx1305, nx1307, nx1309, 
         nx1311, nx1313, nx1315, nx1317, nx1319, nx1321, nx1323, nx1325, nx1327, 
         nx1329, nx1331, nx1333, nx1335, nx1337, nx1339, nx1341, nx1343, nx1345, 
         nx1347, nx1349, nx1351, nx1353, nx1355, nx1357, nx1359, nx1361, nx1363, 
         nx1365, nx1367, nx1369, nx1371, nx1373, nx1375, nx1377, nx1379, nx1381, 
         nx1383, nx1385, nx1387, nx1389, nx1391, nx1393, nx1395, nx1397, nx1399, 
         nx1401, nx1403, nx1405, nx1407, nx1409, nx1411, nx1413, nx1415, nx1417, 
         nx1419, nx1421, nx1423, nx1425, nx1427, nx1429, nx1431, nx1433, nx1435, 
         nx1437, nx1439, nx1441, nx1443, nx1445, nx1447, nx1449, nx1451, nx1453, 
         nx1455, nx1457, nx1459, nx1461, nx1463, nx1465, nx1467, nx1469, nx1471, 
         nx1473, nx1475, nx1477, nx1479, nx1481, nx1483, nx1485, nx1491;
    wire [13:0] \$dummy ;




    block03 uALU (.REG_RESULT ({DESTIN_DO[7],DESTIN_DO[6],DESTIN_DO[5],
             DESTIN_DO[4],DESTIN_DO[3],DESTIN_DO[2],DESTIN_DO[1],DESTIN_DO[0]})
             , .ACC_RESULT ({ACC_RESULT_7_,ACC_RESULT_6_,ACC_RESULT_5_,
             ACC_RESULT_4_,ACC_RESULT_3_,ACC_RESULT_2_,ACC_RESULT_1_,
             ACC_RESULT_0_}), .B_RESULT ({B_RESULT_7_,B_RESULT_6_,B_RESULT_5_,
             B_RESULT_4_,B_RESULT_3_,B_RESULT_2_,B_RESULT_1_,B_RESULT_0_}), .CARRY_RESULT (
             CARRY_RESULT), .AUX_CARRY_RESULT (AUX_CARRY_RESULT), .OVERFLOW_RESULT (
             OVERFLOW_RESULT), .CONDITION_MET (CONDITION_MET), .OPERAND_A ({
             nx1471,nx1473,nx1475,nx1477,nx1479,nx1481,nx1483,nx1485}), .OPERAND_B (
             {nx1455,nx1457,nx1459,nx1461,nx1463,nx1465,nx1467,nx1469}), .SAVE_ADDR (
             {SAVE_ADDR_7_,SAVE_ADDR_6_,SAVE_ADDR_5_,SAVE_ADDR_4_,SAVE_ADDR_3_,
             SAVE_ADDR_2_,SAVE_ADDR_1_,SAVE_ADDR_0_}), .XRAMDI ({XRAMDI[7],
             XRAMDI[6],XRAMDI[5],XRAMDI[4],XRAMDI[3],XRAMDI[2],XRAMDI[1],
             XRAMDI[0]}), .PROGDI ({PROGDI[7],PROGDI[6],PROGDI[5],PROGDI[4],
             PROGDI[3],PROGDI[2],PROGDI[1],PROGDI[0]}), .MULDIV_A ({nx1439,
             nx1441,nx1443,nx1445,nx1447,nx1449,nx1451,nx1453}), .MULDIV_B ({
             MULDIV_B_7_,MULDIV_B_6_,MULDIV_B_5_,MULDIV_B_4_,MULDIV_B_3_,
             MULDIV_B_2_,MULDIV_B_1_,MULDIV_B_0_}), .MULDIV_OV (MULDIV_OV), .CARRY_FLAG (
             PSW_7_), .ALU_CON ({nx1371,ALU_CON_17_,ALU_CON_16_,nx1373,nx1375,
             nx1377,nx1379,nx1381,ALU_CON_10_,nx1383,nx1385,nx1387,nx1389,nx1391
             ,nx1393,nx1395,nx1397,nx1399,nx1401}), .OPCODE ({nx1403,OPCODE_6_,
             nx1407,nx1411}), .BIT_ADDRESS ({BIT_ADDRESS_2_,BIT_ADDRESS_1_,
             BIT_ADDRESS_0_})) ;
    block05 uMUL (.RESULT_A ({MULDIV_A_7_,MULDIV_A_6_,MULDIV_A_5_,MULDIV_A_4_,
             MULDIV_A_3_,MULDIV_A_2_,MULDIV_A_1_,MULDIV_A_0_}), .RESULT_B ({
             MULDIV_B_7_,MULDIV_B_6_,MULDIV_B_5_,MULDIV_B_4_,MULDIV_B_3_,
             MULDIV_B_2_,MULDIV_B_1_,MULDIV_B_0_}), .RESULT_OV (MULDIV_OV), .ACC (
             {XRAMDO[7],XRAMDO[6],XRAMDO[5],XRAMDO[4],XRAMDO[3],XRAMDO[2],
             XRAMDO[1],XRAMDO[0]}), .B ({B_7_,B_6_,B_5_,B_4_,B_3_,B_2_,B_1_,B_0_
             }), .STATE ({nx1313,nx1317,nx1321}), .CLK2 (CLK2), .MULNDIV (nx1409
             ), .INTERNAL_WAIT (nx1297)) ;
    block04 uAOM (.OPERAND_A ({OPERAND_A_7_,OPERAND_A_6_,OPERAND_A_5_,
             OPERAND_A_4_,OPERAND_A_3_,OPERAND_A_2_,OPERAND_A_1_,OPERAND_A_0_})
             , .OPERAND_B ({OPERAND_B_7_,OPERAND_B_6_,OPERAND_B_5_,OPERAND_B_4_,
             OPERAND_B_3_,OPERAND_B_2_,OPERAND_B_1_,OPERAND_B_0_}), .ACC ({
             XRAMDO[7],XRAMDO[6],XRAMDO[5],XRAMDO[4],XRAMDO[3],XRAMDO[2],
             XRAMDO[1],XRAMDO[0]}), .PSW ({PSW_7_,PSW_6_}), .SOURCE_DI ({
             SOURCE_DI[7],SOURCE_DI[6],SOURCE_DI[5],SOURCE_DI[4],SOURCE_DI[3],
             SOURCE_DI[2],SOURCE_DI[1],SOURCE_DI[0]}), .SFR_DATA ({SFR_DATA_7_,
             SFR_DATA_6_,SFR_DATA_5_,SFR_DATA_4_,SFR_DATA_3_,SFR_DATA_2_,
             SFR_DATA_1_,SFR_DATA_0_}), .IMMEDIATE ({IMMEDIATE_7_,IMMEDIATE_6_,
             IMMEDIATE_5_,IMMEDIATE_4_,IMMEDIATE_3_,IMMEDIATE_2_,IMMEDIATE_1_,
             IMMEDIATE_0_}), .SWITCH_CON ({nx1359,nx1361,nx1363,nx1365,nx1367,
             nx1369}), .SOURCE_IS_SFR (SOURCE_IS_SFR)) ;
    block06 uDMI (.SOURCE_A ({SOURCE_A[7],SOURCE_A[6],SOURCE_A[5],SOURCE_A[4],
             SOURCE_A[3],SOURCE_A[2],SOURCE_A[1],SOURCE_A[0]}), .DESTIN_A ({
             DESTIN_A[7],DESTIN_A[6],DESTIN_A[5],DESTIN_A[4],DESTIN_A[3],
             DESTIN_A[2],DESTIN_A[1],DESTIN_A[0]}), .SFRSA ({SFRSA[6],SFRSA[5],
             SFRSA[4],SFRSA[3],SFRSA[2],SFRSA[1],SFRSA[0]}), .INDIRECT_DATA ({
             INDIRECT_DATA_7_,INDIRECT_DATA_6_,INDIRECT_DATA_5_,INDIRECT_DATA_4_
             ,INDIRECT_DATA_3_,INDIRECT_DATA_2_,INDIRECT_DATA_1_,
             INDIRECT_DATA_0_}), .STACK_POINTER ({STACK_POINTER_7_,
             STACK_POINTER_6_,STACK_POINTER_5_,STACK_POINTER_4_,STACK_POINTER_3_
             ,STACK_POINTER_2_,STACK_POINTER_1_,STACK_POINTER_0_}), .NDESTIN_WE (
             NDESTIN_WE), .NSOURCE_RE (NSOURCE_RE), .SFR_WRITE (SFRWE), .SOURCE_IS_SFR (
             SOURCE_IS_SFR), .BIT_ADDRESS ({BIT_ADDRESS_2_,BIT_ADDRESS_1_,
             BIT_ADDRESS_0_}), .PROGDI ({PROGDI[7],PROGDI[6],PROGDI[5],PROGDI[4]
             ,PROGDI[3],PROGDI[2],PROGDI[1],PROGDI[0]}), .OPCODE ({OPCODE_2_,
             nx1413,OPCODE_0_}), .PSW ({PSW_4_,PSW_3_}), .SOURCE_DI ({
             SOURCE_DI[7],SOURCE_DI[6],SOURCE_DI[5],SOURCE_DI[4],SOURCE_DI[3],
             SOURCE_DI[2],SOURCE_DI[1],SOURCE_DI[0]}), .MEM_CON ({nx1341,
             MEM_CON_13_,nx1343,nx1345,MEM_CON_10_,nx1347,MEM_CON_8_,nx1349,
             nx1345,nx1351,nx1353,MEM_CON_3_,nx1355,MEM_CON_1_,nx1357}), .CONDITION_MET (
             CONDITION_MET), .REG_RESULT ({nx1233,nx1241,nx1245,nx1255,nx1259,
             nx1269,nx1273,nx1283}), .WRITE_PSW (PCON_6_), .SFR_WRITE_EN ({
             nx1431}), .STATE ({nx1313,nx1317,nx1321}), .LAST_CYC (nx1311), .INTERNAL_WAIT (
             nx1297), .INTERNAL_RESET (nx1303), .CLK2 (CLK2)) ;
    block07 uSDM (.SFR_DATA ({SFR_DATA_7_,SFR_DATA_6_,SFR_DATA_5_,SFR_DATA_4_,
             SFR_DATA_3_,SFR_DATA_2_,SFR_DATA_1_,SFR_DATA_0_}), .SFR_WRITE_EN ({
             SFR_WRITE_EN_14_,SFR_WRITE_EN_13_,SFR_WRITE_EN_12_,SFR_WRITE_EN_11_
             ,SFR_WRITE_EN_10_,SFR_WRITE_EN_9_,SFR_WRITE_EN_8_,SFR_WRITE_EN_7_,
             SFR_WRITE_EN_6_,SFR_WRITE_EN_5_,SFR_WRITE_EN_4_,SFR_WRITE_EN_3_,
             SFR_WRITE_EN_2_,SFR_WRITE_EN_1_,SFR_WRITE_EN_0_}), .SOURCE_ADDR ({
             SFRSA[6],SFRSA[5],SFRSA[4],SFRSA[3],nx1289,nx1291,SFRSA[0]}), .DESTIN_ADDR (
             {DESTIN_A[6],DESTIN_A[5],DESTIN_A[4],DESTIN_A[3],nx1221,nx1225,
             nx1227}), .SFR_WRITE (nx1287), .PORT_0 ({PORT_0_7_,PORT_0_6_,
             PORT_0_5_,PORT_0_4_,PORT_0_3_,PORT_0_2_,PORT_0_1_,PORT_0_0_}), .PORT_1 (
             {PORT_1_7_,PORT_1_6_,PORT_1_5_,PORT_1_4_,PORT_1_3_,PORT_1_2_,
             PORT_1_1_,PORT_1_0_}), .PORT_2 ({PORT_2_7_,PORT_2_6_,PORT_2_5_,
             PORT_2_4_,PORT_2_3_,PORT_2_2_,PORT_2_1_,PORT_2_0_}), .PORT_3 ({
             PORT_3_7_,PORT_3_6_,PORT_3_5_,PORT_3_4_,PORT_3_3_,PORT_3_2_,
             PORT_3_1_,PORT_3_0_}), .STACK_POINTER ({STACK_POINTER_7_,
             STACK_POINTER_6_,STACK_POINTER_5_,STACK_POINTER_4_,STACK_POINTER_3_
             ,STACK_POINTER_2_,STACK_POINTER_1_,STACK_POINTER_0_}), .DATA_POINTER (
             {DATA_POINTER_15_,DATA_POINTER_14_,DATA_POINTER_13_,
             DATA_POINTER_12_,DATA_POINTER_11_,DATA_POINTER_10_,DATA_POINTER_9_,
             DATA_POINTER_8_,DATA_POINTER_7_,DATA_POINTER_6_,DATA_POINTER_5_,
             DATA_POINTER_4_,DATA_POINTER_3_,DATA_POINTER_2_,DATA_POINTER_1_,
             DATA_POINTER_0_}), .INTR_EN0 ({INTR_EN0_7_,INTR_EN0_6_,INTR_EN0_5_,
             INTR_EN0_4_,INTR_EN0_3_,INTR_EN0_2_,INTR_EN0_1_,INTR_EN0_0_}), .INTR_EN1 (
             {INTR_EN1_7_,INTR_EN1_6_,INTR_EN1_5_,INTR_EN1_4_,INTR_EN1_3_,
             INTR_EN1_2_,INTR_EN1_1_,INTR_EN1_0_}), .INTR_PRI0 ({INTR_PRI0_7_,
             INTR_PRI0_6_,INTR_PRI0_5_,INTR_PRI0_4_,INTR_PRI0_3_,INTR_PRI0_2_,
             INTR_PRI0_1_,INTR_PRI0_0_}), .INTR_PRI1 ({INTR_PRI1_7_,INTR_PRI1_6_
             ,INTR_PRI1_5_,INTR_PRI1_4_,INTR_PRI1_3_,INTR_PRI1_2_,INTR_PRI1_1_,
             INTR_PRI1_0_}), .PSW ({PSW_7_,PSW_6_,PSW_5_,PSW_4_,PSW_3_,PSW_2_,
             PSW_1_,PSW_0_}), .ACC ({XRAMDO[7],XRAMDO[6],XRAMDO[5],XRAMDO[4],
             XRAMDO[3],XRAMDO[2],XRAMDO[1],XRAMDO[0]}), .B ({B_7_,B_6_,B_5_,B_4_
             ,B_3_,B_2_,B_1_,B_0_}), .PCON ({PCON_7_,PCON_6_,PCON_6_,PCON_6_,
             PCON_3_,PCON_2_,PDOWN,IDLE}), .TIMER_SFR_DATA ({TSFRDI_7_,TSFRDI_6_
             ,TSFRDI_5_,TSFRDI_4_,TSFRDI_3_,TSFRDI_2_,TSFRDI_1_,TSFRDI_0_}), .SERIAL_SFR_DATA (
             {SSFRDI_7_,SSFRDI_6_,SSFRDI_5_,SSFRDI_4_,SSFRDI_3_,SSFRDI_2_,
             SSFRDI_1_,SSFRDI_0_}), .ESFR_DATA ({ESFRDI[7],ESFRDI[6],ESFRDI[5],
             ESFRDI[4],ESFRDI[3],ESFRDI[2],ESFRDI[1],ESFRDI[0]})) ;
    block08 uCSFR (.ACC ({XRAMDO[7],XRAMDO[6],XRAMDO[5],XRAMDO[4],XRAMDO[3],
             XRAMDO[2],XRAMDO[1],XRAMDO[0]}), .B ({B_7_,B_6_,B_5_,B_4_,B_3_,B_2_
             ,B_1_,B_0_}), .PSW ({PSW_7_,PSW_6_,PSW_5_,PSW_4_,PSW_3_,PSW_2_,
             PSW_1_,PSW_0_}), .WRITE_PSW (\$dummy [0]), .REG_RESULT ({nx1233,
             nx1241,nx1245,nx1255,nx1259,nx1269,nx1273,PCON_6_}), .ACC_RESULT ({
             ACC_RESULT_7_,ACC_RESULT_6_,ACC_RESULT_5_,ACC_RESULT_4_,
             ACC_RESULT_3_,ACC_RESULT_2_,ACC_RESULT_1_,ACC_RESULT_0_}), .B_RESULT (
             {B_RESULT_7_,B_RESULT_6_,B_RESULT_5_,B_RESULT_4_,B_RESULT_3_,
             B_RESULT_2_,B_RESULT_1_,B_RESULT_0_}), .CARRY_RESULT (nx1437), .AUX_CARRY_RESULT (
             AUX_CARRY_RESULT), .OVERFLOW_RESULT (OVERFLOW_RESULT), .SFR_WRITE_EN (
             {SFR_WRITE_EN_7_,SFR_WRITE_EN_6_,nx1429}), .SFR_CON ({SFR_CON_6_,
             SFR_CON_5_,nx1337,SFR_CON_3_,SFR_CON_2_,nx1339,SFR_CON_0_}), .STATE (
             {nx1313,nx1317,nx1321}), .LAST_CYC (nx1309), .INTERNAL_WAIT (nx1299
             ), .CLK2 (CLK2), .INT_RESET (nx1303)) ;
    block09 uPMI (.PROGA ({PROGA[15],PROGA[14],PROGA[13],PROGA[12],PROGA[11],
             PROGA[10],PROGA[9],PROGA[8],PROGA[7],PROGA[6],PROGA[5],PROGA[4],
             PROGA[3],PROGA[2],PROGA[1],PROGA[0]}), .PROGA_EN (PROGA_EN), .SAVE_ADDR (
             {SAVE_ADDR_7_,SAVE_ADDR_6_,SAVE_ADDR_5_,SAVE_ADDR_4_,SAVE_ADDR_3_,
             SAVE_ADDR_2_,SAVE_ADDR_1_,SAVE_ADDR_0_}), .DATA_POINTER ({
             DATA_POINTER_15_,DATA_POINTER_14_,DATA_POINTER_13_,DATA_POINTER_12_
             ,DATA_POINTER_11_,DATA_POINTER_10_,DATA_POINTER_9_,DATA_POINTER_8_,
             DATA_POINTER_7_,DATA_POINTER_6_,DATA_POINTER_5_,DATA_POINTER_4_,
             DATA_POINTER_3_,DATA_POINTER_2_,DATA_POINTER_1_,DATA_POINTER_0_}), 
             .XRAMA ({XRAMA[15],XRAMA[14],XRAMA[13],XRAMA[12],XRAMA[11],
             XRAMA[10],XRAMA[9],XRAMA[8],XRAMA[7],XRAMA[6],XRAMA[5],XRAMA[4],
             XRAMA[3],XRAMA[2],XRAMA[1],XRAMA[0]}), .XRAMA_EN (XRAMA_EN), .NPSEN (
             NPSEN), .NXRAMW (NXRAMW), .NXRAMR (NXRAMR), .ACC ({XRAMDO[7],
             XRAMDO[6],XRAMDO[5],XRAMDO[4],XRAMDO[3],XRAMDO[2],XRAMDO[1],
             XRAMDO[0]}), .PORT_2 ({PORT_2_7_,PORT_2_6_,PORT_2_5_,PORT_2_4_,
             PORT_2_3_,PORT_2_2_,PORT_2_1_,PORT_2_0_}), .INDIRECT_DATA ({
             INDIRECT_DATA_7_,INDIRECT_DATA_6_,INDIRECT_DATA_5_,INDIRECT_DATA_4_
             ,INDIRECT_DATA_3_,INDIRECT_DATA_2_,INDIRECT_DATA_1_,
             INDIRECT_DATA_0_}), .INTR_VECTOR ({PCON_6_,INTR_VECTOR_6_,
             INTR_VECTOR_5_,INTR_VECTOR_4_,INTR_VECTOR_3_,PCON_6_,INTR_VECTOR_1_
             ,PCON_6_}), .IMMEDIATE ({IMMEDIATE_7_,IMMEDIATE_6_,IMMEDIATE_5_,
             IMMEDIATE_4_,IMMEDIATE_3_,IMMEDIATE_2_,IMMEDIATE_1_,IMMEDIATE_0_})
             , .IMMEDIATE_2 ({IMMEDIATE_2_7_,IMMEDIATE_2_6_,IMMEDIATE_2_5_,
             IMMEDIATE_2_4_,IMMEDIATE_2_3_,IMMEDIATE_2_2_,IMMEDIATE_2_1_,
             IMMEDIATE_2_0_}), .PROGDI ({PROGDI[7],PROGDI[6],PROGDI[5],PROGDI[4]
             ,PROGDI[3],PROGDI[2],PROGDI[1],PROGDI[0]}), .CONDITION_MET (
             CONDITION_MET), .EXCEPTION (nx1295), .INTR_LCALL (INTR_LCALL), .NEXT_STATE_IDLE (
             nx1301), .OPCODE ({nx1403,OPCODE_6_,nx1407,nx1411}), .INTERNAL_RESET (
             nx1303), .REG_RESULT ({nx1233,nx1241,nx1247,nx1255,nx1261,nx1269,
             nx1275,nx1283}), .SFR_WRITE_EN ({nx1427,SFR_WRITE_EN_8_}), .PC_CON (
             {PC_CON_17_,PC_CON_16_,nx1325,PC_CON_14_,nx1339,PC_CON_12_,nx1347,
             nx1327,nx1329,nx1331,PC_CON_7_,PC_CON_6_,nx1333,nx1335,PC_CON_3_,
             PC_CON_2_,PC_CON_1_,PC_CON_0_}), .STATE ({nx1315,nx1319,nx1321}), .LAST_CYC (
             nx1309), .INTERNAL_WAIT (nx1297), .CLK2 (CLK2)) ;
    block10 uSTM (.STATE ({STATE_2_,STATE_1_,STATE_0_}), .LAST_CYC (LAST_CYC), 
             .INTERNAL_WAIT (INTERNAL_WAIT), .INTERNAL_RESET (INTERNAL_RESET), .PCON (
             {PCON_7_,\$dummy [1],\$dummy [2],\$dummy [3],PCON_3_,PCON_2_,PDOWN,
             IDLE}), .NEXT_STATE_IDLE (NEXT_STATE_IDLE), .NCCLKE (NCCLKE), .NPCLKE (
             NPCLKE), .CLK3_EN (CLK3_EN), .REG_RESULT ({nx1233,PCON_6_,PCON_6_,
             PCON_6_,nx1261,nx1269,nx1275,nx1283}), .SFR_WRITE_EN ({nx1425}), .STATE_CON (
             {PCON_6_,nx1339,STATE_CON_3_,STATE_CON_2_,SFR_CON_2_,nx1323}), .RESET (
             RESET), .TEST_RESET (TRESET), .EXCEPTION (nx1295), .MWAIT (MWAIT), 
             .CLK1 (CLK1), .CLK2 (CLK2)) ;
    block12 uPDR (.OPCODE ({OPCODE_7_,OPCODE_6_,OPCODE_5_,OPCODE_4_,OPCODE_3_,
             OPCODE_2_,OPCODE_1_,OPCODE_0_}), .IMMEDIATE ({IMMEDIATE_7_,
             IMMEDIATE_6_,IMMEDIATE_5_,IMMEDIATE_4_,IMMEDIATE_3_,IMMEDIATE_2_,
             IMMEDIATE_1_,IMMEDIATE_0_}), .IMMEDIATE_2 ({IMMEDIATE_2_7_,
             IMMEDIATE_2_6_,IMMEDIATE_2_5_,IMMEDIATE_2_4_,IMMEDIATE_2_3_,
             IMMEDIATE_2_2_,IMMEDIATE_2_1_,IMMEDIATE_2_0_}), .PROGDI ({PROGDI[7]
             ,PROGDI[6],PROGDI[5],PROGDI[4],PROGDI[3],PROGDI[2],PROGDI[1],
             PROGDI[0]}), .EXCEPTION (nx1295), .NEXT_STATE_IDLE (nx1301), .IDLE (
             IDLE), .INTERNAL_RESET (nx1303), .STATE ({nx1313,nx1317,nx1321}), .LAST_CYC (
             nx1309), .IMM_CON (IMM_CON), .INTERNAL_WAIT (nx1297), .CLK3_EN (
             CLK3_EN), .CLK2 (CLK2), .CLK3 (CLK3)) ;
    block13 uOPD (.ALU_CON ({ALU_CON_18_,ALU_CON_17_,ALU_CON_16_,ALU_CON_15_,
             ALU_CON_14_,ALU_CON_13_,ALU_CON_12_,ALU_CON_11_,ALU_CON_10_,
             ALU_CON_9_,ALU_CON_8_,ALU_CON_7_,ALU_CON_6_,ALU_CON_5_,ALU_CON_4_,
             ALU_CON_3_,ALU_CON_2_,ALU_CON_1_,ALU_CON_0_}), .SWITCH_CON ({
             SWITCH_CON_5_,SWITCH_CON_4_,SWITCH_CON_3_,SWITCH_CON_2_,
             SWITCH_CON_1_,SWITCH_CON_0_}), .MEM_CON ({MEM_CON_14_,MEM_CON_13_,
             MEM_CON_12_,MEM_CON_11_,MEM_CON_10_,MEM_CON_9_,MEM_CON_8_,
             MEM_CON_7_,\$dummy [4],MEM_CON_5_,MEM_CON_4_,MEM_CON_3_,MEM_CON_2_,
             MEM_CON_1_,MEM_CON_0_}), .SFR_CON ({SFR_CON_6_,SFR_CON_5_,
             SFR_CON_4_,SFR_CON_3_,SFR_CON_2_,SFR_CON_1_,SFR_CON_0_}), .PC_CON (
             {PC_CON_17_,PC_CON_16_,PC_CON_15_,PC_CON_14_,\$dummy [5],PC_CON_12_
             ,\$dummy [6],PC_CON_10_,PC_CON_9_,PC_CON_8_,PC_CON_7_,PC_CON_6_,
             PC_CON_5_,PC_CON_4_,PC_CON_3_,PC_CON_2_,PC_CON_1_,PC_CON_0_}), .STATE_CON (
             {\$dummy [7],\$dummy [8],STATE_CON_3_,STATE_CON_2_,\$dummy [9],
             STATE_CON_0_}), .IMM_CON (IMM_CON), .PORT_CON (PORT_CON), .INTR_CON (
             INTR_CON), .OPCODE ({nx1405,OPCODE_6_,nx1407,nx1411,OPCODE_3_,
             OPCODE_2_,nx1415,OPCODE_0_})) ;
    block14 uPORT (.PORT_0 ({PORT_0_7_,PORT_0_6_,PORT_0_5_,PORT_0_4_,PORT_0_3_,
             PORT_0_2_,PORT_0_1_,PORT_0_0_}), .PORT_1 ({PORT_1_7_,PORT_1_6_,
             PORT_1_5_,PORT_1_4_,PORT_1_3_,PORT_1_2_,PORT_1_1_,PORT_1_0_}), .PORT_2 (
             {PORT_2_7_,PORT_2_6_,PORT_2_5_,PORT_2_4_,PORT_2_3_,PORT_2_2_,
             PORT_2_1_,PORT_2_0_}), .PORT_3 ({PORT_3_7_,PORT_3_6_,PORT_3_5_,
             PORT_3_4_,PORT_3_3_,PORT_3_2_,PORT_3_1_,PORT_3_0_}), .NPORT1E ({
             NPORT1E[7],NPORT1E[6],NPORT1E[5],NPORT1E[4],NPORT1E[3],NPORT1E[2],
             NPORT1E[1],NPORT1E[0]}), .NPORT2E ({NPORT2E[7],NPORT2E[6],
             NPORT2E[5],NPORT2E[4],NPORT2E[3],NPORT2E[2],NPORT2E[1],NPORT2E[0]})
             , .NPORT3E ({NPORT3E[7],NPORT3E[6],NPORT3E[5],NPORT3E[4],NPORT3E[3]
             ,NPORT3E[2],NPORT3E_I_1_,NPORT3E_I_0_}), .PORT0O ({PORT0O[7],
             PORT0O[6],PORT0O[5],PORT0O[4],PORT0O[3],PORT0O[2],PORT0O[1],
             PORT0O[0]}), .PORT1O ({PORT1O[7],PORT1O[6],PORT1O[5],PORT1O[4],
             PORT1O[3],PORT1O[2],PORT1O[1],PORT1O[0]}), .PORT2O ({PORT2O[7],
             PORT2O[6],PORT2O[5],PORT2O[4],PORT2O[3],PORT2O[2],PORT2O[1],
             PORT2O[0]}), .PORT3O ({PORT3O[7],PORT3O[6],PORT3O[5],PORT3O[4],
             PORT3O[3],PORT3O[2],PORT3O_I_1_,PORT3O_I_0_}), .PORT0I ({PORT0I[7],
             PORT0I[6],PORT0I[5],PORT0I[4],PORT0I[3],PORT0I[2],PORT0I[1],
             PORT0I[0]}), .PORT1I ({PORT1I[7],PORT1I[6],PORT1I[5],PORT1I[4],
             PORT1I[3],PORT1I[2],PORT1I[1],PORT1I[0]}), .PORT2I ({PORT2I[7],
             PORT2I[6],PORT2I[5],PORT2I[4],PORT2I[3],PORT2I[2],PORT2I[1],
             PORT2I[0]}), .PORT3I ({PORT3I[7],PORT3I[6],PORT3I[5],PORT3I[4],
             PORT3I[3],PORT3I[2],PORT3I[1],PORT3I[0]}), .SFR_WRITE_EN ({
             SFR_WRITE_EN_3_,SFR_WRITE_EN_2_,nx1433,nx1435}), .REG_RESULT ({
             nx1231,nx1239,nx1245,nx1253,nx1259,nx1267,nx1273,nx1281}), .PORT_CON (
             PORT_CON), .INTERNAL_RESET (nx1303), .STATE ({nx1321}), .CLK2 (CLK2
             )) ;
    block15 uINTR (.INTR_EN0 ({INTR_EN0_7_,INTR_EN0_6_,INTR_EN0_5_,INTR_EN0_4_,
             INTR_EN0_3_,INTR_EN0_2_,INTR_EN0_1_,INTR_EN0_0_}), .INTR_EN1 ({
             INTR_EN1_7_,INTR_EN1_6_,INTR_EN1_5_,INTR_EN1_4_,INTR_EN1_3_,
             INTR_EN1_2_,INTR_EN1_1_,INTR_EN1_0_}), .INTR_PRI0 ({INTR_PRI0_7_,
             INTR_PRI0_6_,INTR_PRI0_5_,INTR_PRI0_4_,INTR_PRI0_3_,INTR_PRI0_2_,
             INTR_PRI0_1_,INTR_PRI0_0_}), .INTR_PRI1 ({INTR_PRI1_7_,INTR_PRI1_6_
             ,INTR_PRI1_5_,INTR_PRI1_4_,INTR_PRI1_3_,INTR_PRI1_2_,INTR_PRI1_1_,
             INTR_PRI1_0_}), .INTR_VECTOR ({\$dummy [10],INTR_VECTOR_6_,
             INTR_VECTOR_5_,INTR_VECTOR_4_,INTR_VECTOR_3_,\$dummy [11],
             INTR_VECTOR_1_,\$dummy [12]}), .INTR_ACKNOW ({XINTR_ACK[13],
             XINTR_ACK[12],XINTR_ACK[11],XINTR_ACK[10],XINTR_ACK[9],XINTR_ACK[8]
             ,XINTR_ACK[7],XINTR_ACK[6],XINTR_ACK[5],\$dummy [13],INTR_ACKNOW_3_
             ,INTR_ACKNOW_2_,INTR_ACKNOW_1_,INTR_ACKNOW_0_}), .EXCEPTION (
             EXCEPTION), .INTR_LCALL (INTR_LCALL), .INTR_SOURCE ({XINTR_SRC[13],
             XINTR_SRC[12],XINTR_SRC[11],XINTR_SRC[10],XINTR_SRC[9],XINTR_SRC[8]
             ,XINTR_SRC[7],XINTR_SRC[6],XINTR_SRC[5],RITI,TF1,IE1,TF0,IE0}), .REG_RESULT (
             {nx1235,nx1243,nx1249,nx1257,nx1263,nx1271,nx1277,nx1285}), .SFR_WRITE_EN (
             {nx1417,nx1419,nx1421,nx1423}), .INTR_RET (INTR_CON), .STATE ({
             nx1321}), .LAST_CYC (nx1309), .CLK3_EN (CLK3_EN), .INTERNAL_WAIT (
             nx1299), .CLK1 (CLK1), .CLK2 (CLK2), .INTERNAL_RESET (nx1305)) ;
    block17 uCNTR (.TSFRDI ({TSFRDI_7_,TSFRDI_6_,TSFRDI_5_,TSFRDI_4_,TSFRDI_3_,
             TSFRDI_2_,TSFRDI_1_,TSFRDI_0_}), .IE0 (IE0), .TF0 (TF0), .IE1 (IE1)
             , .TF1 (TF1), .T1_OVERFLOW (T1_OVERFLOW), .SOURCE_ADDR ({nx1289,
             nx1291,SFRSA[0]}), .DESTIN_ADDR ({DESTIN_A[6],DESTIN_A[5],
             DESTIN_A[4],DESTIN_A[3],nx1221,nx1223,nx1227}), .SFRWE (nx1287), .REG_RESULT (
             {nx1231,nx1239,nx1247,nx1253,nx1261,nx1267,nx1275,nx1281}), .INTR_ACKNOW (
             {INTR_ACKNOW_3_,INTR_ACKNOW_2_,INTR_ACKNOW_1_,INTR_ACKNOW_0_}), .PORT3I (
             {PORT3I[5],PORT3I[4],PORT3I[3],PORT3I[2]}), .RMW (PORT_CON), .INTERNAL_RESET (
             nx1303), .INTERNAL_WAIT (nx1297), .CLK3_EN (CLK3_EN), .CLK1 (CLK1)
             , .CLK2 (CLK2), .CLK3 (CLK3)) ;
    block18 uUART (.SSFRDI ({SSFRDI_7_,SSFRDI_6_,SSFRDI_5_,SSFRDI_4_,SSFRDI_3_,
             SSFRDI_2_,SSFRDI_1_,SSFRDI_0_}), .RITI (RITI), .TXD (TXD), .RXD (
             RXD), .TXDNE (TXDNE), .RXDNE (RXDNE), .SOURCE_ADDR ({SFRSA[0]}), .DESTIN_ADDR (
             {DESTIN_A[6],DESTIN_A[5],DESTIN_A[4],DESTIN_A[3],nx1221,nx1223,
             nx1227}), .PORT3I ({PORT3I[0]}), .SMOD (PCON_7_), .SFRWE (nx1287), 
             .REG_RESULT ({nx1233,nx1241,nx1245,nx1255,nx1259,nx1269,nx1273,
             nx1283}), .RMW (PORT_CON), .INTERNAL_RESET (nx1303), .T1_OVERFLOW (
             nx1293), .CLK3_EN (CLK3_EN), .CLK1 (CLK1), .CLK2 (CLK2), .CLK3 (
             CLK3)) ;
    fake_gnd ix1197 (.Y (PCON_6_)) ;
    and02 ix1 (.Y (NPORT3E[0]), .A0 (RXDNE), .A1 (NPORT3E_I_0_)) ;
    and02 ix3 (.Y (NPORT3E[1]), .A0 (TXDNE), .A1 (NPORT3E_I_1_)) ;
    and02 ix5 (.Y (PORT3O[0]), .A0 (RXD), .A1 (PORT3O_I_0_)) ;
    and02 ix7 (.Y (PORT3O[1]), .A0 (TXD), .A1 (PORT3O_I_1_)) ;
    buf02 ix1220 (.Y (nx1221), .A (DESTIN_A[2])) ;
    buf02 ix1222 (.Y (nx1223), .A (DESTIN_A[1])) ;
    buf02 ix1224 (.Y (nx1225), .A (DESTIN_A[1])) ;
    buf02 ix1226 (.Y (nx1227), .A (DESTIN_A[0])) ;
    inv02 ix1228 (.Y (nx1229), .A (DESTIN_DO[7])) ;
    inv02 ix1230 (.Y (nx1231), .A (nx1229)) ;
    inv02 ix1232 (.Y (nx1233), .A (nx1229)) ;
    inv02 ix1234 (.Y (nx1235), .A (nx1229)) ;
    inv02 ix1236 (.Y (nx1237), .A (DESTIN_DO[6])) ;
    inv02 ix1238 (.Y (nx1239), .A (nx1237)) ;
    inv02 ix1240 (.Y (nx1241), .A (nx1237)) ;
    inv02 ix1242 (.Y (nx1243), .A (nx1237)) ;
    buf02 ix1244 (.Y (nx1245), .A (DESTIN_DO[5])) ;
    buf02 ix1246 (.Y (nx1247), .A (DESTIN_DO[5])) ;
    buf02 ix1248 (.Y (nx1249), .A (DESTIN_DO[5])) ;
    inv02 ix1250 (.Y (nx1251), .A (DESTIN_DO[4])) ;
    inv02 ix1252 (.Y (nx1253), .A (nx1251)) ;
    inv02 ix1254 (.Y (nx1255), .A (nx1251)) ;
    inv02 ix1256 (.Y (nx1257), .A (nx1251)) ;
    buf02 ix1258 (.Y (nx1259), .A (DESTIN_DO[3])) ;
    buf02 ix1260 (.Y (nx1261), .A (DESTIN_DO[3])) ;
    buf02 ix1262 (.Y (nx1263), .A (DESTIN_DO[3])) ;
    inv02 ix1264 (.Y (nx1265), .A (DESTIN_DO[2])) ;
    inv02 ix1266 (.Y (nx1267), .A (nx1265)) ;
    inv02 ix1268 (.Y (nx1269), .A (nx1265)) ;
    inv02 ix1270 (.Y (nx1271), .A (nx1265)) ;
    buf02 ix1272 (.Y (nx1273), .A (DESTIN_DO[1])) ;
    buf02 ix1274 (.Y (nx1275), .A (DESTIN_DO[1])) ;
    buf02 ix1276 (.Y (nx1277), .A (DESTIN_DO[1])) ;
    inv02 ix1278 (.Y (nx1279), .A (DESTIN_DO[0])) ;
    inv02 ix1280 (.Y (nx1281), .A (nx1279)) ;
    inv02 ix1282 (.Y (nx1283), .A (nx1279)) ;
    inv02 ix1284 (.Y (nx1285), .A (nx1279)) ;
    buf02 ix1286 (.Y (nx1287), .A (SFRWE)) ;
    buf02 ix1288 (.Y (nx1289), .A (SFRSA[2])) ;
    buf02 ix1290 (.Y (nx1291), .A (SFRSA[1])) ;
    buf02 ix1292 (.Y (nx1293), .A (T1_OVERFLOW)) ;
    buf02 ix1294 (.Y (nx1295), .A (EXCEPTION)) ;
    buf04 ix1296 (.Y (nx1297), .A (nx1491)) ;
    buf04 ix1298 (.Y (nx1299), .A (nx1491)) ;
    buf02 ix1300 (.Y (nx1301), .A (NEXT_STATE_IDLE)) ;
    buf04 ix1302 (.Y (nx1303), .A (INTERNAL_RESET)) ;
    buf04 ix1304 (.Y (nx1305), .A (INTERNAL_RESET)) ;
    inv02 ix1306 (.Y (nx1307), .A (LAST_CYC)) ;
    inv02 ix1308 (.Y (nx1309), .A (nx1307)) ;
    inv02 ix1310 (.Y (nx1311), .A (nx1307)) ;
    buf02 ix1312 (.Y (nx1313), .A (STATE_2_)) ;
    buf02 ix1314 (.Y (nx1315), .A (STATE_2_)) ;
    buf02 ix1316 (.Y (nx1317), .A (STATE_1_)) ;
    buf02 ix1318 (.Y (nx1319), .A (STATE_1_)) ;
    buf04 ix1320 (.Y (nx1321), .A (STATE_0_)) ;
    buf02 ix1322 (.Y (nx1323), .A (STATE_CON_0_)) ;
    buf02 ix1324 (.Y (nx1325), .A (PC_CON_15_)) ;
    buf02 ix1326 (.Y (nx1327), .A (PC_CON_10_)) ;
    buf02 ix1328 (.Y (nx1329), .A (PC_CON_9_)) ;
    buf02 ix1330 (.Y (nx1331), .A (PC_CON_8_)) ;
    buf02 ix1332 (.Y (nx1333), .A (PC_CON_5_)) ;
    buf02 ix1334 (.Y (nx1335), .A (PC_CON_4_)) ;
    buf02 ix1336 (.Y (nx1337), .A (SFR_CON_4_)) ;
    buf02 ix1338 (.Y (nx1339), .A (SFR_CON_1_)) ;
    buf02 ix1340 (.Y (nx1341), .A (MEM_CON_14_)) ;
    buf02 ix1342 (.Y (nx1343), .A (MEM_CON_12_)) ;
    buf02 ix1344 (.Y (nx1345), .A (MEM_CON_11_)) ;
    buf02 ix1346 (.Y (nx1347), .A (MEM_CON_9_)) ;
    buf02 ix1348 (.Y (nx1349), .A (MEM_CON_7_)) ;
    buf02 ix1350 (.Y (nx1351), .A (MEM_CON_5_)) ;
    buf02 ix1352 (.Y (nx1353), .A (MEM_CON_4_)) ;
    buf02 ix1354 (.Y (nx1355), .A (MEM_CON_2_)) ;
    buf02 ix1356 (.Y (nx1357), .A (MEM_CON_0_)) ;
    buf02 ix1358 (.Y (nx1359), .A (SWITCH_CON_5_)) ;
    buf02 ix1360 (.Y (nx1361), .A (SWITCH_CON_4_)) ;
    buf02 ix1362 (.Y (nx1363), .A (SWITCH_CON_3_)) ;
    buf02 ix1364 (.Y (nx1365), .A (SWITCH_CON_2_)) ;
    buf02 ix1366 (.Y (nx1367), .A (SWITCH_CON_1_)) ;
    buf02 ix1368 (.Y (nx1369), .A (SWITCH_CON_0_)) ;
    buf02 ix1370 (.Y (nx1371), .A (ALU_CON_18_)) ;
    buf02 ix1372 (.Y (nx1373), .A (ALU_CON_15_)) ;
    buf02 ix1374 (.Y (nx1375), .A (ALU_CON_14_)) ;
    buf02 ix1376 (.Y (nx1377), .A (ALU_CON_13_)) ;
    buf02 ix1378 (.Y (nx1379), .A (ALU_CON_12_)) ;
    buf02 ix1380 (.Y (nx1381), .A (ALU_CON_11_)) ;
    buf02 ix1382 (.Y (nx1383), .A (ALU_CON_9_)) ;
    buf02 ix1384 (.Y (nx1385), .A (ALU_CON_8_)) ;
    buf02 ix1386 (.Y (nx1387), .A (ALU_CON_7_)) ;
    buf02 ix1388 (.Y (nx1389), .A (ALU_CON_6_)) ;
    buf02 ix1390 (.Y (nx1391), .A (ALU_CON_5_)) ;
    buf02 ix1392 (.Y (nx1393), .A (ALU_CON_4_)) ;
    buf02 ix1394 (.Y (nx1395), .A (ALU_CON_3_)) ;
    buf02 ix1396 (.Y (nx1397), .A (ALU_CON_2_)) ;
    buf02 ix1398 (.Y (nx1399), .A (ALU_CON_1_)) ;
    buf02 ix1400 (.Y (nx1401), .A (ALU_CON_0_)) ;
    buf02 ix1402 (.Y (nx1403), .A (OPCODE_7_)) ;
    buf02 ix1404 (.Y (nx1405), .A (OPCODE_7_)) ;
    buf02 ix1406 (.Y (nx1407), .A (OPCODE_5_)) ;
    buf02 ix1408 (.Y (nx1409), .A (OPCODE_5_)) ;
    buf02 ix1410 (.Y (nx1411), .A (OPCODE_4_)) ;
    buf02 ix1412 (.Y (nx1413), .A (OPCODE_1_)) ;
    buf02 ix1414 (.Y (nx1415), .A (OPCODE_1_)) ;
    buf02 ix1416 (.Y (nx1417), .A (SFR_WRITE_EN_14_)) ;
    buf02 ix1418 (.Y (nx1419), .A (SFR_WRITE_EN_13_)) ;
    buf02 ix1420 (.Y (nx1421), .A (SFR_WRITE_EN_12_)) ;
    buf02 ix1422 (.Y (nx1423), .A (SFR_WRITE_EN_11_)) ;
    buf02 ix1424 (.Y (nx1425), .A (SFR_WRITE_EN_10_)) ;
    buf02 ix1426 (.Y (nx1427), .A (SFR_WRITE_EN_9_)) ;
    buf02 ix1428 (.Y (nx1429), .A (SFR_WRITE_EN_5_)) ;
    buf02 ix1430 (.Y (nx1431), .A (SFR_WRITE_EN_4_)) ;
    buf02 ix1432 (.Y (nx1433), .A (SFR_WRITE_EN_1_)) ;
    buf02 ix1434 (.Y (nx1435), .A (SFR_WRITE_EN_0_)) ;
    buf02 ix1436 (.Y (nx1437), .A (CARRY_RESULT)) ;
    buf02 ix1438 (.Y (nx1439), .A (MULDIV_A_7_)) ;
    buf02 ix1440 (.Y (nx1441), .A (MULDIV_A_6_)) ;
    buf02 ix1442 (.Y (nx1443), .A (MULDIV_A_5_)) ;
    buf02 ix1444 (.Y (nx1445), .A (MULDIV_A_4_)) ;
    buf02 ix1446 (.Y (nx1447), .A (MULDIV_A_3_)) ;
    buf02 ix1448 (.Y (nx1449), .A (MULDIV_A_2_)) ;
    buf02 ix1450 (.Y (nx1451), .A (MULDIV_A_1_)) ;
    buf02 ix1452 (.Y (nx1453), .A (MULDIV_A_0_)) ;
    buf02 ix1454 (.Y (nx1455), .A (OPERAND_B_7_)) ;
    buf02 ix1456 (.Y (nx1457), .A (OPERAND_B_6_)) ;
    buf02 ix1458 (.Y (nx1459), .A (OPERAND_B_5_)) ;
    buf02 ix1460 (.Y (nx1461), .A (OPERAND_B_4_)) ;
    buf02 ix1462 (.Y (nx1463), .A (OPERAND_B_3_)) ;
    buf02 ix1464 (.Y (nx1465), .A (OPERAND_B_2_)) ;
    buf02 ix1466 (.Y (nx1467), .A (OPERAND_B_1_)) ;
    buf02 ix1468 (.Y (nx1469), .A (OPERAND_B_0_)) ;
    buf02 ix1470 (.Y (nx1471), .A (OPERAND_A_7_)) ;
    buf02 ix1472 (.Y (nx1473), .A (OPERAND_A_6_)) ;
    buf02 ix1474 (.Y (nx1475), .A (OPERAND_A_5_)) ;
    buf02 ix1476 (.Y (nx1477), .A (OPERAND_A_4_)) ;
    buf02 ix1478 (.Y (nx1479), .A (OPERAND_A_3_)) ;
    buf02 ix1480 (.Y (nx1481), .A (OPERAND_A_2_)) ;
    buf02 ix1482 (.Y (nx1483), .A (OPERAND_A_1_)) ;
    buf02 ix1484 (.Y (nx1485), .A (OPERAND_A_0_)) ;
    buf02 ix1490 (.Y (nx1491), .A (INTERNAL_WAIT)) ;
endmodule


module block18 ( SSFRDI, RITI, TXD, RXD, TXDNE, RXDNE, SOURCE_ADDR, DESTIN_ADDR, 
                  PORT3I, SMOD, SFRWE, REG_RESULT, RMW, INTERNAL_RESET, 
                  T1_OVERFLOW, CLK3_EN, CLK1, CLK2, CLK3 ) ;

    output [7:0]SSFRDI ;
    output RITI ;
    output TXD ;
    output RXD ;
    output TXDNE ;
    output RXDNE ;
    input [0:0]SOURCE_ADDR ;
    input [6:0]DESTIN_ADDR ;
    input [0:0]PORT3I ;
    input SMOD ;
    input SFRWE ;
    input [7:0]REG_RESULT ;
    input RMW ;
    input INTERNAL_RESET ;
    input T1_OVERFLOW ;
    input CLK3_EN ;
    input CLK1 ;
    input CLK2 ;
    input CLK3 ;

    wire nx6, nx28, TX_SEND, SCON_7_, SCON_6_, nx50, nx54, TX_DIV16_1_, nx62, 
         CLK_ROOT_DIV2, nx64, nx80, TX_DIV16_0_, nx98, TX_DIV16_3_, TX_DIV16_2_, 
         nx114, nx150, nx162, TX_SHIFTER_8_, TX_BEGIN, nx170, nx178, nx182, 
         nx198, nx202, nx208, nx218, TX_SHIFTER_9_, TX_SHIFTER_10_, nx230, nx250, 
         SCON_3_, nx266, TX_SHIFTER_7_, TX_SHIFTER_6_, TX_SHIFTER_5_, 
         TX_SHIFTER_4_, TX_SHIFTER_3_, TX_SHIFTER_2_, nx404, nx426, nx434, 
         SCON_0_, RX_SHIFTER_0_, nx452, RX_STATE_1_, nx2069, RX_DIV16_1_, 
         RX_SAMPLE_0_, nx478, SCON_4_, nx2070, nx498, RX_DIV16_0_, nx504, 
         RX_DIV16_3_, RX_DIV16_2_, nx536, nx568, nx574, nx578, nx596, 
         RX_STATE_0_, RX_SAMP1, nx626, RX_SAMP2, nx640, nx648, nx662, RX_SAMP3, 
         nx676, nx700, nx726, RX_SHIFTER_1_, RX_SHIFTER_2_, RX_SHIFTER_3_, 
         RX_SHIFTER_4_, RX_SHIFTER_5_, RX_SHIFTER_6_, RX_SHIFTER_8_, SCON_5_, 
         nx848, nx854, nx858, nx862, OLD_RXD, TX_SHIFTER_0_, TX_SHIFTER_1_, 
         OLD_TXD, MODE0_CLK, nx920, nx948, SBUF_RX_0_, nx962, SBUF_RX_1_, nx1002, 
         SBUF_RX_2_, nx1016, SBUF_RX_3_, nx1030, SBUF_RX_4_, nx1044, SBUF_RX_5_, 
         nx1058, SBUF_RX_6_, nx1072, SBUF_RX_7_, nx2078, nx2088, nx2098, nx2106, 
         nx2108, nx2116, nx2118, nx2128, nx2138, nx2148, nx2158, nx2166, nx2168, 
         nx2178, nx2188, nx2198, nx2208, nx2218, nx2228, nx2238, nx2248, nx2258, 
         nx2268, nx2278, nx2288, nx2298, nx2306, nx2308, nx2316, nx2318, nx2328, 
         nx2338, nx2348, nx2358, nx2368, nx2378, nx2388, nx2398, nx2408, nx2416, 
         nx2418, nx2426, nx2428, nx2436, nx2438, nx2446, nx2448, nx2456, nx2458, 
         nx2466, nx2468, nx2476, nx2478, nx2486, nx2488, nx2498, nx2508, nx2518, 
         nx2526, nx2528, nx2536, nx2538, nx2548, nx2558, nx2568, nx2578, nx2588, 
         nx2598, nx2608, nx2618, nx2628, nx2641, nx2649, nx2652, nx2655, nx2657, 
         nx2659, nx2661, nx2669, nx2673, nx2676, nx2680, nx2682, nx2685, nx2690, 
         nx2692, nx2696, nx2698, nx2702, nx2704, nx2708, nx2710, nx2714, nx2716, 
         nx2720, nx2722, nx2726, nx2728, nx2732, nx2734, nx2737, nx2741, nx2746, 
         nx2748, nx2753, nx2757, nx2760, nx2765, nx2768, nx2774, nx2776, nx2780, 
         nx2785, nx2787, nx2789, nx2792, nx2795, nx2799, nx2814, nx2816, nx2818, 
         nx2821, nx2826, nx2829, nx2832, nx2849, nx2851, nx2854, nx2857, nx2860, 
         nx2863, nx2867, nx2869, nx2875, nx2881, nx2884, nx2888, nx2895, nx2900, 
         nx2904, nx2911, nx2913, nx2917, nx2925, nx2927, nx2932, nx2934, nx2936, 
         nx2938, nx2941, nx2945, nx2947, nx2952, nx2955, nx2957, nx2959, nx2969, 
         nx2974, nx2979, nx2984, nx2989, nx2994, nx2999, nx3002, nx3004, nx3008, 
         nx3010, nx3013, nx3015, nx3017, nx3025, nx3035, nx3038, nx3040, nx3042, 
         nx3047, nx3055, nx3061, nx3064, nx3067, nx3069, nx3071, nx3073, nx3078, 
         nx3084, nx3090, nx3096, nx3102, nx3104, nx3112, nx3114, nx3116, nx3118, 
         nx3120, nx3122, nx3124, nx3126, nx3128, nx3130, nx3132, nx3134, nx3136, 
         nx3138, nx3140, nx3142, nx3144, nx3146, nx3148, nx3150, nx3152, nx3154, 
         nx3156, nx3158, nx3160, nx3162, nx3164, nx3166, nx3168, nx3170, nx3172, 
         nx3174, nx3176, nx3178, nx3180, nx3182, nx3184, nx3186, nx3188, nx3190, 
         nx3192, nx3194, nx3196, nx3198, nx3200, nx3202, nx3204, nx3206, nx3208, 
         nx3210, nx3212, nx3214, nx3216, nx3218, nx3220, nx3222, nx3224, nx3226, 
         nx3228, nx3230, nx3232, nx3234, nx3236, nx3238, nx3240, nx3242, nx3244, 
         nx3246, nx3248, nx3250, nx3252, nx3254, nx3256, nx3258, nx3260, nx3262, 
         nx3264, nx3266, nx3268, nx3270, nx3272, nx3274, nx3276, nx3278, nx3280, 
         nx3284, nx3286, nx3288, nx3290, nx3292, nx3294, nx3296, nx3298, nx3300, 
         nx3302, nx3304, nx3306, nx3308, nx3310, nx3318, nx3320, nx3322, nx3324, 
         nx3326, nx3328, nx3330, nx3332, nx3334, nx3336, nx3338, nx3340, nx3342, 
         nx3344, nx3346, nx3348, nx3350, nx3352, nx3354, nx3356, nx3358, nx3360, 
         nx3362, nx3364, nx3366, nx3368, nx3370, nx3372, nx3374, nx3376, nx3378, 
         nx3380, nx3382, nx3384, nx3386, nx3388, nx3390, nx3392, nx3394, nx3396;
    wire [8:0] \$dummy ;




    and02 ix913 (.Y (RXDNE), .A0 (OLD_RXD), .A1 (RXD)) ;
    dff ix2531 (.Q (OLD_RXD), .QB (\$dummy [0]), .D (nx2528), .CLK (CLK3)) ;
    ao21 ix2529 (.Y (nx2528), .A0 (OLD_RXD), .A1 (nx3246), .B0 (nx2526)) ;
    nor02 ix2642 (.Y (nx2641), .A0 (nx3350), .A1 (nx3354)) ;
    ao21 ix2527 (.Y (nx2526), .A0 (RXD), .A1 (nx3350), .B0 (nx3354)) ;
    dff ix2091 (.Q (SCON_6_), .QB (nx2649), .D (nx3162), .CLK (CLK2)) ;
    nand04 ix2653 (.Y (nx2652), .A0 (nx3112), .A1 (nx3252), .A2 (nx2661), .A3 (
           SFRWE)) ;
    nor03 ix7 (.Y (nx6), .A0 (DESTIN_ADDR[1]), .A1 (nx2655), .A2 (DESTIN_ADDR[2]
          )) ;
    inv02 ix2656 (.Y (nx2655), .A (DESTIN_ADDR[3])) ;
    nor03 ix2658 (.Y (nx2657), .A0 (DESTIN_ADDR[6]), .A1 (nx2659), .A2 (
          DESTIN_ADDR[5])) ;
    inv02 ix2660 (.Y (nx2659), .A (DESTIN_ADDR[4])) ;
    inv02 ix2662 (.Y (nx2661), .A (DESTIN_ADDR[0])) ;
    dff ix2081 (.Q (SCON_7_), .QB (nx2669), .D (nx3160), .CLK (CLK2)) ;
    dff ix2521 (.Q (TX_SHIFTER_0_), .QB (nx2673), .D (nx3226), .CLK (CLK3)) ;
    mux21 ix2519 (.Y (nx2518), .A0 (nx3258), .A1 (nx2673), .S0 (nx2826)) ;
    aoi21 ix2677 (.Y (nx2676), .A0 (TX_SHIFTER_1_), .A1 (nx208), .B0 (nx3354)) ;
    mux21 ix2509 (.Y (nx2508), .A0 (nx2680), .A1 (nx3260), .S0 (nx3130)) ;
    dff ix2511 (.Q (TX_SHIFTER_1_), .QB (nx2680), .D (nx3224), .CLK (CLK3)) ;
    aoi222 ix2683 (.Y (nx2682), .A0 (REG_RESULT[0]), .A1 (nx3124), .B0 (
           TX_SHIFTER_2_), .B1 (nx3136), .C0 (TX_SHIFTER_1_), .C1 (nx3132)) ;
    nor02 ix183 (.Y (nx182), .A0 (nx3354), .A1 (nx3378)) ;
    nand04 ix2686 (.Y (nx2685), .A0 (nx3122), .A1 (nx3252), .A2 (DESTIN_ADDR[0])
           , .A3 (SFRWE)) ;
    nor03 ix171 (.Y (nx170), .A0 (DESTIN_ADDR[1]), .A1 (nx2655), .A2 (
          DESTIN_ADDR[2])) ;
    mux21 ix2249 (.Y (nx2248), .A0 (nx2690), .A1 (nx3262), .S0 (nx3130)) ;
    dff ix2251 (.Q (TX_SHIFTER_2_), .QB (nx2690), .D (nx3190), .CLK (CLK3)) ;
    aoi222 ix2693 (.Y (nx2692), .A0 (REG_RESULT[1]), .A1 (nx3124), .B0 (
           TX_SHIFTER_3_), .B1 (nx3136), .C0 (TX_SHIFTER_2_), .C1 (nx3132)) ;
    mux21 ix2239 (.Y (nx2238), .A0 (nx2696), .A1 (nx3264), .S0 (nx3130)) ;
    dff ix2241 (.Q (TX_SHIFTER_3_), .QB (nx2696), .D (nx3188), .CLK (CLK3)) ;
    aoi222 ix2699 (.Y (nx2698), .A0 (REG_RESULT[2]), .A1 (nx3124), .B0 (
           TX_SHIFTER_4_), .B1 (nx3136), .C0 (TX_SHIFTER_3_), .C1 (nx3132)) ;
    mux21 ix2229 (.Y (nx2228), .A0 (nx2702), .A1 (nx3266), .S0 (nx3130)) ;
    dff ix2231 (.Q (TX_SHIFTER_4_), .QB (nx2702), .D (nx3186), .CLK (CLK3)) ;
    aoi222 ix2705 (.Y (nx2704), .A0 (REG_RESULT[3]), .A1 (nx3124), .B0 (
           TX_SHIFTER_5_), .B1 (nx3136), .C0 (TX_SHIFTER_4_), .C1 (nx3132)) ;
    mux21 ix2219 (.Y (nx2218), .A0 (nx2708), .A1 (nx3268), .S0 (nx3130)) ;
    dff ix2221 (.Q (TX_SHIFTER_5_), .QB (nx2708), .D (nx3184), .CLK (CLK3)) ;
    aoi222 ix2711 (.Y (nx2710), .A0 (REG_RESULT[4]), .A1 (nx3124), .B0 (
           TX_SHIFTER_6_), .B1 (nx3136), .C0 (TX_SHIFTER_5_), .C1 (nx3132)) ;
    mux21 ix2209 (.Y (nx2208), .A0 (nx2714), .A1 (nx3270), .S0 (nx3130)) ;
    dff ix2211 (.Q (TX_SHIFTER_6_), .QB (nx2714), .D (nx3182), .CLK (CLK3)) ;
    aoi222 ix2717 (.Y (nx2716), .A0 (REG_RESULT[5]), .A1 (nx3124), .B0 (
           TX_SHIFTER_7_), .B1 (nx3136), .C0 (TX_SHIFTER_6_), .C1 (nx3132)) ;
    mux21 ix2199 (.Y (nx2198), .A0 (nx2720), .A1 (nx3272), .S0 (nx3130)) ;
    dff ix2201 (.Q (TX_SHIFTER_7_), .QB (nx2720), .D (nx3180), .CLK (CLK3)) ;
    aoi222 ix2723 (.Y (nx2722), .A0 (REG_RESULT[6]), .A1 (nx3124), .B0 (
           TX_SHIFTER_8_), .B1 (nx3136), .C0 (TX_SHIFTER_7_), .C1 (nx3132)) ;
    mux21 ix2189 (.Y (nx2188), .A0 (nx2726), .A1 (nx3274), .S0 (nx3130)) ;
    dff ix2191 (.Q (TX_SHIFTER_8_), .QB (nx2726), .D (nx3178), .CLK (CLK3)) ;
    aoi222 ix2729 (.Y (nx2728), .A0 (REG_RESULT[7]), .A1 (nx3124), .B0 (
           TX_SHIFTER_9_), .B1 (nx3136), .C0 (TX_SHIFTER_8_), .C1 (nx3132)) ;
    mux21 ix2179 (.Y (nx2178), .A0 (nx2732), .A1 (nx3276), .S0 (nx3130)) ;
    dff ix2181 (.Q (TX_SHIFTER_9_), .QB (nx2732), .D (nx3176), .CLK (CLK3)) ;
    aoi222 ix2735 (.Y (nx2734), .A0 (nx3124), .A1 (nx266), .B0 (TX_SHIFTER_10_)
           , .B1 (nx3136), .C0 (TX_SHIFTER_9_), .C1 (nx3132)) ;
    ao21 ix2169 (.Y (nx2168), .A0 (SCON_3_), .A1 (nx3380), .B0 (nx3374)) ;
    dff ix2171 (.Q (SCON_3_), .QB (nx2737), .D (nx2168), .CLK (CLK2)) ;
    mux21 ix2159 (.Y (nx2158), .A0 (nx2746), .A1 (nx3278), .S0 (nx3130)) ;
    dff ix2161 (.Q (TX_SHIFTER_10_), .QB (nx2746), .D (nx3174), .CLK (CLK3)) ;
    aoi32 ix2749 (.Y (nx2748), .A0 (nx3254), .A1 (TX_SHIFTER_10_), .A2 (nx3134)
          , .B0 (SCON_7_), .B1 (nx3126)) ;
    oai32 ix2259 (.Y (nx2258), .A0 (nx3354), .A1 (nx2753), .A2 (nx3280), .B0 (
          nx2818), .B1 (nx162)) ;
    dff ix2151 (.Q (TX_BEGIN), .QB (\$dummy [1]), .D (nx2148), .CLK (CLK3)) ;
    ao21 ix2149 (.Y (nx2148), .A0 (TX_BEGIN), .A1 (nx2757), .B0 (nx3126)) ;
    nor02 ix2758 (.Y (nx2757), .A0 (nx3124), .A1 (nx162)) ;
    nand02 ix163 (.Y (nx162), .A0 (nx3280), .A1 (nx3254)) ;
    aoi32 ix2761 (.Y (nx2760), .A0 (nx3118), .A1 (nx2785), .A2 (nx3120), .B0 (
          nx3350), .B1 (nx3248)) ;
    ao21 ix2119 (.Y (nx2118), .A0 (TX_DIV16_1_), .A1 (nx3384), .B0 (nx3168)) ;
    mux21 ix2099 (.Y (nx2098), .A0 (nx2774), .A1 (nx2776), .S0 (nx64)) ;
    dff ix2101 (.Q (CLK_ROOT_DIV2), .QB (nx2774), .D (nx3164), .CLK (CLK3)) ;
    nor04 ix2117 (.Y (nx2116), .A0 (nx2780), .A1 (nx3354), .A2 (nx98), .A3 (
          nx3384)) ;
    dff ix2111 (.Q (TX_DIV16_0_), .QB (nx2785), .D (nx2108), .CLK (CLK3)) ;
    ao21 ix2109 (.Y (nx2108), .A0 (TX_DIV16_0_), .A1 (nx3384), .B0 (nx3166)) ;
    nor03 ix2107 (.Y (nx2106), .A0 (nx3354), .A1 (TX_DIV16_0_), .A2 (nx3384)) ;
    dff ix2121 (.Q (TX_DIV16_1_), .QB (nx2787), .D (nx2118), .CLK (CLK3)) ;
    oai32 ix2139 (.Y (nx2138), .A0 (nx3354), .A1 (nx2792), .A2 (nx3286), .B0 (
          nx2789), .B1 (nx3116)) ;
    dff ix2141 (.Q (TX_DIV16_3_), .QB (nx2789), .D (nx3172), .CLK (CLK3)) ;
    dff ix2131 (.Q (TX_DIV16_2_), .QB (nx2799), .D (nx3170), .CLK (CLK3)) ;
    nand04 ix405 (.Y (nx404), .A0 (nx3288), .A1 (nx2714), .A2 (nx2720), .A3 (
           nx3290)) ;
    dff ix2261 (.Q (TX_SEND), .QB (nx2818), .D (nx3192), .CLK (CLK3)) ;
    nand02 ix203 (.Y (nx202), .A0 (nx2821), .A1 (nx2826)) ;
    nor02 ix2827 (.Y (nx2826), .A0 (nx3128), .A1 (nx3354)) ;
    nor03 ix199 (.Y (nx198), .A0 (nx2829), .A1 (nx3280), .A2 (nx178)) ;
    nor02 ix2830 (.Y (nx2829), .A0 (TX_SEND), .A1 (TX_BEGIN)) ;
    nor03 ix251 (.Y (nx250), .A0 (nx2832), .A1 (nx3354), .A2 (nx178)) ;
    and02 ix945 (.Y (TXDNE), .A0 (OLD_TXD), .A1 (TXD)) ;
    dff ix2541 (.Q (OLD_TXD), .QB (\$dummy [2]), .D (nx2538), .CLK (CLK3)) ;
    ao21 ix2539 (.Y (nx2538), .A0 (OLD_TXD), .A1 (nx3246), .B0 (nx2536)) ;
    ao21 ix2537 (.Y (nx2536), .A0 (TXD), .A1 (nx3350), .B0 (nx3356)) ;
    ao32 ix935 (.Y (TXD), .A0 (MODE0_CLK), .A1 (nx2649), .A2 (nx2669), .B0 (
         TX_SHIFTER_0_), .B1 (nx3360)) ;
    dff reg_MODE0_CLK (.Q (MODE0_CLK), .QB (\$dummy [3]), .D (nx920), .CLK (CLK1
        )) ;
    ao21 ix921 (.Y (nx920), .A0 (nx2818), .A1 (nx3292), .B0 (nx3350)) ;
    mux21 ix2349 (.Y (nx2348), .A0 (nx2849), .A1 (nx2851), .S0 (nx578)) ;
    dff ix2351 (.Q (RX_STATE_0_), .QB (nx2849), .D (nx3208), .CLK (CLK3)) ;
    nand03 ix2852 (.Y (nx2851), .A0 (nx3144), .A1 (nx3360), .A2 (nx3292)) ;
    nor02 ix499 (.Y (nx498), .A0 (nx3356), .A1 (nx2854)) ;
    nand03 ix2855 (.Y (nx2854), .A0 (nx3142), .A1 (SCON_4_), .A2 (nx3292)) ;
    oai33 ix479 (.Y (nx478), .A0 (nx3248), .A1 (nx2857), .A2 (RX_SAMPLE_0_), .B0 (
          SCON_0_), .B1 (SCON_6_), .B2 (SCON_7_)) ;
    dff ix2291 (.Q (\$dummy [4]), .QB (nx2857), .D (nx3198), .CLK (CLK3)) ;
    dff ix2281 (.Q (RX_SAMPLE_0_), .QB (nx2860), .D (nx3196), .CLK (CLK3)) ;
    inv02 ix2864 (.Y (nx2863), .A (PORT3I[0])) ;
    mux21 ix2499 (.Y (nx2498), .A0 (nx2867), .A1 (nx2869), .S0 (nx858)) ;
    dff ix2501 (.Q (SCON_0_), .QB (nx2867), .D (nx3222), .CLK (CLK3)) ;
    nand02 ix2870 (.Y (nx2869), .A0 (nx3256), .A1 (nx862)) ;
    ao21 ix863 (.Y (nx862), .A0 (nx3158), .A1 (nx426), .B0 (REG_RESULT[0])) ;
    nor04 ix849 (.Y (nx848), .A0 (RX_SHIFTER_0_), .A1 (nx2881), .A2 (RX_STATE_0_
          ), .A3 (nx3013)) ;
    dff ix2481 (.Q (RX_SHIFTER_0_), .QB (\$dummy [5]), .D (nx2478), .CLK (CLK3)
        ) ;
    ao21 ix2479 (.Y (nx2478), .A0 (RX_SHIFTER_0_), .A1 (nx3294), .B0 (nx2476)) ;
    ao21 ix453 (.Y (nx452), .A0 (nx3350), .A1 (nx3248), .B0 (nx3364)) ;
    dff ix2391 (.Q (RX_STATE_1_), .QB (nx2881), .D (nx3216), .CLK (CLK3)) ;
    mux21 ix2389 (.Y (nx2388), .A0 (nx2881), .A1 (nx3296), .S0 (nx578)) ;
    aoi32 ix2885 (.Y (nx2884), .A0 (nx3144), .A1 (nx3292), .A2 (nx3248), .B0 (
          SCON_4_), .B1 (nx700)) ;
    dff ix2301 (.Q (SCON_4_), .QB (nx2888), .D (nx3200), .CLK (CLK2)) ;
    ao32 ix701 (.Y (nx700), .A0 (nx3298), .A1 (nx2849), .A2 (RX_SHIFTER_0_), .B0 (
         nx2881), .B1 (nx2895)) ;
    nor02 ix2896 (.Y (nx2895), .A0 (nx596), .A1 (nx3154)) ;
    aoi22 ix2901 (.Y (nx2900), .A0 (RX_SAMP2), .A1 (RX_SAMP3), .B0 (RX_SAMP1), .B1 (
          nx676)) ;
    mux21 ix2369 (.Y (nx2368), .A0 (nx2904), .A1 (nx2863), .S0 (nx662)) ;
    dff ix2371 (.Q (RX_SAMP2), .QB (nx2904), .D (nx3212), .CLK (CLK3)) ;
    ao21 ix663 (.Y (nx662), .A0 (nx54), .A1 (nx3364), .B0 (nx3150)) ;
    oai33 ix2339 (.Y (nx2338), .A0 (nx2911), .A1 (nx2932), .A2 (nx3384), .B0 (
          nx2941), .B1 (nx3364), .B2 (nx3356)) ;
    dff ix2331 (.Q (RX_DIV16_2_), .QB (nx2917), .D (nx3204), .CLK (CLK3)) ;
    ao21 ix2319 (.Y (nx2318), .A0 (RX_DIV16_1_), .A1 (nx3384), .B0 (nx2316)) ;
    aoi21 ix2317 (.Y (nx2316), .A0 (nx2925), .A1 (nx2938), .B0 (nx3384)) ;
    ao21 ix2926 (.Y (nx2925), .A0 (nx2927), .A1 (nx2934), .B0 (nx2936)) ;
    ao21 ix2309 (.Y (nx2308), .A0 (RX_DIV16_0_), .A1 (nx3384), .B0 (nx3202)) ;
    dff ix2311 (.Q (RX_DIV16_0_), .QB (nx2927), .D (nx2308), .CLK (CLK3)) ;
    nor03 ix2307 (.Y (nx2306), .A0 (RX_DIV16_0_), .A1 (nx2932), .A2 (nx3384)) ;
    nand02 ix2933 (.Y (nx2932), .A0 (nx3256), .A1 (nx2854)) ;
    dff ix2321 (.Q (RX_DIV16_1_), .QB (nx2934), .D (nx2318), .CLK (CLK3)) ;
    ao21 ix2937 (.Y (nx2936), .A0 (RX_DIV16_1_), .A1 (RX_DIV16_0_), .B0 (nx3356)
         ) ;
    dff ix2341 (.Q (RX_DIV16_3_), .QB (nx2941), .D (nx3206), .CLK (CLK3)) ;
    mux21 ix2379 (.Y (nx2378), .A0 (nx2863), .A1 (nx2945), .S0 (nx3304)) ;
    dff ix2381 (.Q (RX_SAMP3), .QB (nx2945), .D (nx3214), .CLK (CLK3)) ;
    aoi33 ix2948 (.Y (nx2947), .A0 (nx3364), .A1 (nx3350), .A2 (nx3250), .B0 (
          nx3152), .B1 (nx2927), .B2 (nx3120)) ;
    mux21 ix2359 (.Y (nx2358), .A0 (nx2952), .A1 (nx2863), .S0 (nx3148)) ;
    dff ix2361 (.Q (RX_SAMP1), .QB (nx2952), .D (nx3210), .CLK (CLK3)) ;
    oai32 ix627 (.Y (nx626), .A0 (nx2955), .A1 (RX_DIV16_0_), .A2 (nx2957), .B0 (
          nx3286), .B1 (nx2959)) ;
    nand02 ix2960 (.Y (nx2959), .A0 (nx3350), .A1 (nx3250)) ;
    ao21 ix579 (.Y (nx578), .A0 (nx574), .A1 (nx452), .B0 (nx3140)) ;
    ao21 ix731 (.Y (nx2069), .A0 (nx452), .A1 (nx3156), .B0 (nx3356)) ;
    aoi21 ix2477 (.Y (nx2476), .A0 (nx3298), .A1 (nx2969), .B0 (nx2875)) ;
    ao21 ix2469 (.Y (nx2468), .A0 (RX_SHIFTER_1_), .A1 (nx3294), .B0 (nx2466)) ;
    dff ix2471 (.Q (RX_SHIFTER_1_), .QB (nx2969), .D (nx2468), .CLK (CLK3)) ;
    aoi21 ix2467 (.Y (nx2466), .A0 (nx3298), .A1 (nx2974), .B0 (nx2875)) ;
    ao21 ix2459 (.Y (nx2458), .A0 (RX_SHIFTER_2_), .A1 (nx3294), .B0 (nx2456)) ;
    dff ix2461 (.Q (RX_SHIFTER_2_), .QB (nx2974), .D (nx2458), .CLK (CLK3)) ;
    aoi21 ix2457 (.Y (nx2456), .A0 (nx3298), .A1 (nx2979), .B0 (nx2875)) ;
    ao21 ix2449 (.Y (nx2448), .A0 (RX_SHIFTER_3_), .A1 (nx3294), .B0 (nx2446)) ;
    dff ix2451 (.Q (RX_SHIFTER_3_), .QB (nx2979), .D (nx2448), .CLK (CLK3)) ;
    aoi21 ix2447 (.Y (nx2446), .A0 (nx3298), .A1 (nx2984), .B0 (nx2875)) ;
    ao21 ix2439 (.Y (nx2438), .A0 (RX_SHIFTER_4_), .A1 (nx3294), .B0 (nx2436)) ;
    dff ix2441 (.Q (RX_SHIFTER_4_), .QB (nx2984), .D (nx2438), .CLK (CLK3)) ;
    aoi21 ix2437 (.Y (nx2436), .A0 (nx3298), .A1 (nx2989), .B0 (nx3294)) ;
    ao21 ix2429 (.Y (nx2428), .A0 (RX_SHIFTER_5_), .A1 (nx3294), .B0 (nx2426)) ;
    dff ix2431 (.Q (RX_SHIFTER_5_), .QB (nx2989), .D (nx2428), .CLK (CLK3)) ;
    aoi21 ix2427 (.Y (nx2426), .A0 (nx3298), .A1 (nx2994), .B0 (nx3294)) ;
    ao21 ix2419 (.Y (nx2418), .A0 (RX_SHIFTER_6_), .A1 (nx3294), .B0 (nx2416)) ;
    dff ix2421 (.Q (RX_SHIFTER_6_), .QB (nx2994), .D (nx2418), .CLK (CLK3)) ;
    aoi21 ix2417 (.Y (nx2416), .A0 (nx3298), .A1 (nx2999), .B0 (nx3294)) ;
    dff ix2411 (.Q (\$dummy [6]), .QB (nx2999), .D (nx3220), .CLK (CLK3)) ;
    and03 ix3003 (.Y (nx3002), .A0 (nx3308), .A1 (nx3010), .A2 (nx3256)) ;
    dff ix2401 (.Q (RX_SHIFTER_8_), .QB (nx3008), .D (nx3218), .CLK (CLK3)) ;
    nand03 ix3011 (.Y (nx3010), .A0 (nx2070), .A1 (PORT3I[0]), .A2 (nx3250)) ;
    ao21 ix3014 (.Y (nx3013), .A0 (nx3015), .A1 (nx3360), .B0 (nx3306)) ;
    ao21 ix3016 (.Y (nx3015), .A0 (nx3390), .A1 (SCON_5_), .B0 (SCON_0_)) ;
    dff ix2491 (.Q (SCON_5_), .QB (nx3025), .D (nx2488), .CLK (CLK2)) ;
    ao21 ix2489 (.Y (nx2488), .A0 (SCON_5_), .A1 (nx3380), .B0 (nx3376)) ;
    ao21 ix859 (.Y (nx858), .A0 (nx3372), .A1 (nx426), .B0 (nx28)) ;
    nor02 ix29 (.Y (nx28), .A0 (nx3380), .A1 (nx3246)) ;
    mux21 ix2269 (.Y (nx2268), .A0 (nx3310), .A1 (nx3040), .S0 (nx3042)) ;
    oai21 ix3036 (.Y (nx3035), .A0 (nx3138), .A1 (REG_RESULT[1]), .B0 (nx3256)
          ) ;
    nor04 ix435 (.Y (nx434), .A0 (nx2818), .A1 (nx3038), .A2 (nx3368), .A3 (
          nx3280)) ;
    nor02 ix3039 (.Y (nx3038), .A0 (nx2652), .A1 (RMW)) ;
    dff ix2271 (.Q (\$dummy [7]), .QB (nx3040), .D (nx3194), .CLK (CLK3)) ;
    oai22 ix3043 (.Y (nx3042), .A0 (nx3138), .A1 (nx3114), .B0 (nx3350), .B1 (
          nx3356)) ;
    ao21 ix959 (.Y (SSFRDI[0]), .A0 (nx3346), .A1 (SBUF_RX_0_), .B0 (nx948)) ;
    dff ix2551 (.Q (SBUF_RX_0_), .QB (nx3047), .D (nx3228), .CLK (CLK3)) ;
    nor02 ix949 (.Y (nx948), .A0 (nx3346), .A1 (nx2867)) ;
    ao21 ix973 (.Y (SSFRDI[1]), .A0 (nx3346), .A1 (SBUF_RX_1_), .B0 (nx962)) ;
    dff ix2561 (.Q (SBUF_RX_1_), .QB (nx3055), .D (nx3230), .CLK (CLK3)) ;
    nor02 ix963 (.Y (nx962), .A0 (nx3346), .A1 (nx3040)) ;
    ao21 ix1013 (.Y (SSFRDI[2]), .A0 (nx3346), .A1 (SBUF_RX_2_), .B0 (nx1002)) ;
    dff ix2581 (.Q (SBUF_RX_2_), .QB (nx3061), .D (nx3234), .CLK (CLK3)) ;
    nor02 ix1003 (.Y (nx1002), .A0 (nx3346), .A1 (nx3064)) ;
    dff ix2571 (.Q (\$dummy [8]), .QB (nx3064), .D (nx3232), .CLK (CLK3)) ;
    mux21 ix2569 (.Y (nx2568), .A0 (nx3067), .A1 (nx3064), .S0 (nx3073)) ;
    or02 ix3068 (.Y (nx3067), .A0 (nx3356), .A1 (nx3069)) ;
    mux21 ix3070 (.Y (nx3069), .A0 (nx3154), .A1 (REG_RESULT[2]), .S0 (nx3071)
          ) ;
    nand03 ix3072 (.Y (nx3071), .A0 (nx426), .A1 (nx3360), .A2 (nx3158)) ;
    ao21 ix3074 (.Y (nx3073), .A0 (nx3071), .A1 (nx3380), .B0 (nx3246)) ;
    ao21 ix1027 (.Y (SSFRDI[3]), .A0 (nx3346), .A1 (SBUF_RX_3_), .B0 (nx1016)) ;
    dff ix2591 (.Q (SBUF_RX_3_), .QB (nx3078), .D (nx3236), .CLK (CLK3)) ;
    nor02 ix1017 (.Y (nx1016), .A0 (nx3346), .A1 (nx2737)) ;
    ao21 ix1041 (.Y (SSFRDI[4]), .A0 (nx3346), .A1 (SBUF_RX_4_), .B0 (nx1030)) ;
    dff ix2601 (.Q (SBUF_RX_4_), .QB (nx3084), .D (nx3238), .CLK (CLK3)) ;
    nor02 ix1031 (.Y (nx1030), .A0 (nx3346), .A1 (nx2888)) ;
    ao21 ix1055 (.Y (SSFRDI[5]), .A0 (nx3348), .A1 (SBUF_RX_5_), .B0 (nx1044)) ;
    dff ix2611 (.Q (SBUF_RX_5_), .QB (nx3090), .D (nx3240), .CLK (CLK3)) ;
    nor02 ix1045 (.Y (nx1044), .A0 (nx3348), .A1 (nx3025)) ;
    ao21 ix1069 (.Y (SSFRDI[6]), .A0 (nx3348), .A1 (SBUF_RX_6_), .B0 (nx1058)) ;
    dff ix2621 (.Q (SBUF_RX_6_), .QB (nx3096), .D (nx3242), .CLK (CLK3)) ;
    nor02 ix1059 (.Y (nx1058), .A0 (nx3348), .A1 (nx2649)) ;
    ao21 ix1091 (.Y (SSFRDI[7]), .A0 (nx3348), .A1 (SBUF_RX_7_), .B0 (nx1072)) ;
    dff ix2631 (.Q (SBUF_RX_7_), .QB (nx3104), .D (nx3244), .CLK (CLK3)) ;
    nor02 ix1073 (.Y (nx1072), .A0 (nx3348), .A1 (nx2669)) ;
    inv02 ix505 (.Y (nx504), .A (nx2932)) ;
    inv02 ix2939 (.Y (nx2938), .A (nx498)) ;
    inv02 ix2876 (.Y (nx2875), .A (nx2069)) ;
    inv02 ix427 (.Y (nx426), .A (nx3038)) ;
    inv02 ix209 (.Y (nx208), .A (nx2832)) ;
    inv02 ix2822 (.Y (nx2821), .A (nx182)) ;
    inv02 ix179 (.Y (nx178), .A (nx2685)) ;
    inv02 ix63 (.Y (nx62), .A (nx2768)) ;
    inv02 ix55 (.Y (nx54), .A (nx2959)) ;
    buf02 ix3111 (.Y (nx3112), .A (nx6)) ;
    inv04 ix3113 (.Y (nx3114), .A (nx2741)) ;
    inv02 ix3115 (.Y (nx3116), .A (nx2765)) ;
    buf02 ix3117 (.Y (nx3118), .A (nx150)) ;
    inv02 ix3119 (.Y (nx3120), .A (nx2957)) ;
    buf02 ix3121 (.Y (nx3122), .A (nx170)) ;
    inv04 ix3123 (.Y (nx3124), .A (nx2821)) ;
    inv04 ix3125 (.Y (nx3126), .A (nx2821)) ;
    buf02 ix3127 (.Y (nx3128), .A (nx198)) ;
    buf04 ix3129 (.Y (nx3130), .A (nx202)) ;
    buf02 ix3131 (.Y (nx3132), .A (nx218)) ;
    buf02 ix3133 (.Y (nx3134), .A (nx230)) ;
    buf02 ix3135 (.Y (nx3136), .A (nx250)) ;
    buf02 ix3137 (.Y (nx3138), .A (nx434)) ;
    inv02 ix3139 (.Y (nx3140), .A (nx2875)) ;
    buf02 ix3141 (.Y (nx3142), .A (nx478)) ;
    inv02 ix3143 (.Y (nx3144), .A (nx2938)) ;
    buf02 ix3145 (.Y (nx3146), .A (nx568)) ;
    buf02 ix3147 (.Y (nx3148), .A (nx626)) ;
    buf02 ix3149 (.Y (nx3150), .A (nx640)) ;
    buf02 ix3151 (.Y (nx3152), .A (nx648)) ;
    inv02 ix3153 (.Y (nx3154), .A (nx3017)) ;
    buf02 ix3155 (.Y (nx3156), .A (nx726)) ;
    buf02 ix3157 (.Y (nx3158), .A (nx848)) ;
    buf02 ix3159 (.Y (nx3160), .A (nx2078)) ;
    buf02 ix3161 (.Y (nx3162), .A (nx2088)) ;
    buf02 ix3163 (.Y (nx3164), .A (nx2098)) ;
    buf02 ix3165 (.Y (nx3166), .A (nx2106)) ;
    buf02 ix3167 (.Y (nx3168), .A (nx2116)) ;
    buf02 ix3169 (.Y (nx3170), .A (nx2128)) ;
    buf02 ix3171 (.Y (nx3172), .A (nx2138)) ;
    buf02 ix3173 (.Y (nx3174), .A (nx2158)) ;
    buf02 ix3175 (.Y (nx3176), .A (nx2178)) ;
    buf02 ix3177 (.Y (nx3178), .A (nx2188)) ;
    buf02 ix3179 (.Y (nx3180), .A (nx2198)) ;
    buf02 ix3181 (.Y (nx3182), .A (nx2208)) ;
    buf02 ix3183 (.Y (nx3184), .A (nx2218)) ;
    buf02 ix3185 (.Y (nx3186), .A (nx2228)) ;
    buf02 ix3187 (.Y (nx3188), .A (nx2238)) ;
    buf02 ix3189 (.Y (nx3190), .A (nx2248)) ;
    buf02 ix3191 (.Y (nx3192), .A (nx2258)) ;
    buf02 ix3193 (.Y (nx3194), .A (nx2268)) ;
    buf02 ix3195 (.Y (nx3196), .A (nx2278)) ;
    buf02 ix3197 (.Y (nx3198), .A (nx2288)) ;
    buf02 ix3199 (.Y (nx3200), .A (nx2298)) ;
    buf02 ix3201 (.Y (nx3202), .A (nx2306)) ;
    buf02 ix3203 (.Y (nx3204), .A (nx2328)) ;
    buf02 ix3205 (.Y (nx3206), .A (nx2338)) ;
    buf02 ix3207 (.Y (nx3208), .A (nx2348)) ;
    buf02 ix3209 (.Y (nx3210), .A (nx2358)) ;
    buf02 ix3211 (.Y (nx3212), .A (nx2368)) ;
    buf02 ix3213 (.Y (nx3214), .A (nx2378)) ;
    buf02 ix3215 (.Y (nx3216), .A (nx2388)) ;
    buf02 ix3217 (.Y (nx3218), .A (nx2398)) ;
    buf02 ix3219 (.Y (nx3220), .A (nx2408)) ;
    buf02 ix3221 (.Y (nx3222), .A (nx2498)) ;
    buf02 ix3223 (.Y (nx3224), .A (nx2508)) ;
    buf02 ix3225 (.Y (nx3226), .A (nx2518)) ;
    buf02 ix3227 (.Y (nx3228), .A (nx2548)) ;
    buf02 ix3229 (.Y (nx3230), .A (nx2558)) ;
    buf02 ix3231 (.Y (nx3232), .A (nx2568)) ;
    buf02 ix3233 (.Y (nx3234), .A (nx2578)) ;
    buf02 ix3235 (.Y (nx3236), .A (nx2588)) ;
    buf02 ix3237 (.Y (nx3238), .A (nx2598)) ;
    buf02 ix3239 (.Y (nx3240), .A (nx2608)) ;
    buf02 ix3241 (.Y (nx3242), .A (nx2618)) ;
    buf02 ix3243 (.Y (nx3244), .A (nx2628)) ;
    buf02 ix3245 (.Y (nx3246), .A (nx2641)) ;
    inv04 ix3247 (.Y (nx3248), .A (nx50)) ;
    inv04 ix3249 (.Y (nx3250), .A (nx3360)) ;
    buf02 ix3251 (.Y (nx3252), .A (nx2657)) ;
    inv04 ix3253 (.Y (nx3254), .A (INTERNAL_RESET)) ;
    inv04 ix3255 (.Y (nx3256), .A (nx3356)) ;
    buf02 ix3257 (.Y (nx3258), .A (nx2676)) ;
    buf02 ix3259 (.Y (nx3260), .A (nx2682)) ;
    buf02 ix3261 (.Y (nx3262), .A (nx2692)) ;
    buf02 ix3263 (.Y (nx3264), .A (nx2698)) ;
    buf02 ix3265 (.Y (nx3266), .A (nx2704)) ;
    buf02 ix3267 (.Y (nx3268), .A (nx2710)) ;
    buf02 ix3269 (.Y (nx3270), .A (nx2716)) ;
    buf02 ix3271 (.Y (nx3272), .A (nx2722)) ;
    buf02 ix3273 (.Y (nx3274), .A (nx2728)) ;
    buf02 ix3275 (.Y (nx3276), .A (nx2734)) ;
    buf02 ix3277 (.Y (nx3278), .A (nx2748)) ;
    buf02 ix3279 (.Y (nx3280), .A (nx2760)) ;
    buf02 ix3283 (.Y (nx3284), .A (nx2795)) ;
    inv02 ix3285 (.Y (nx3286), .A (nx80)) ;
    buf02 ix3287 (.Y (nx3288), .A (nx2814)) ;
    buf02 ix3289 (.Y (nx3290), .A (nx2816)) ;
    inv02 ix3291 (.Y (nx3292), .A (nx2070)) ;
    inv02 ix3293 (.Y (nx3294), .A (nx2069)) ;
    buf02 ix3295 (.Y (nx3296), .A (nx2884)) ;
    inv02 ix3297 (.Y (nx3298), .A (nx596)) ;
    buf02 ix3299 (.Y (nx3300), .A (nx2900)) ;
    buf02 ix3301 (.Y (nx3302), .A (nx2913)) ;
    buf02 ix3303 (.Y (nx3304), .A (nx2947)) ;
    inv02 ix3305 (.Y (nx3306), .A (nx574)) ;
    buf02 ix3307 (.Y (nx3308), .A (nx3004)) ;
    buf02 ix3309 (.Y (nx3310), .A (nx3035)) ;
    or02 ix903 (.Y (RXD), .A0 (nx3360), .A1 (TX_SHIFTER_0_)) ;
    nand02 ix2646 (.Y (nx50), .A0 (nx2649), .A1 (nx2669)) ;
    ao21 ix2089 (.Y (nx2088), .A0 (SCON_6_), .A1 (nx3380), .B0 (nx3392)) ;
    and02 ix25 (.Y (nx2741), .A0 (nx2652), .A1 (nx3254)) ;
    nor03 ix2666 (.Y (nx3318), .A0 (nx3320), .A1 (nx3356), .A2 (nx3380)) ;
    inv02 ix3319 (.Y (nx3320), .A (REG_RESULT[6])) ;
    ao21 ix2079 (.Y (nx2078), .A0 (SCON_7_), .A1 (nx3380), .B0 (nx3394)) ;
    nor03 ix2672 (.Y (nx3322), .A0 (nx3324), .A1 (nx3356), .A2 (nx3380)) ;
    inv02 ix3323 (.Y (nx3324), .A (REG_RESULT[7])) ;
    or02 ix267 (.Y (nx266), .A0 (SCON_3_), .A1 (nx2669)) ;
    nor03 ix2167 (.Y (nx2166), .A0 (nx3326), .A1 (nx3358), .A2 (nx3380)) ;
    inv02 ix3325 (.Y (nx3326), .A (REG_RESULT[3])) ;
    and03 ix231 (.Y (nx230), .A0 (nx3360), .A1 (nx2818), .A2 (nx2821)) ;
    mux21 ix2754 (.Y (nx2753), .A0 (nx3368), .A1 (TX_BEGIN), .S0 (nx2818)) ;
    and03 ix151 (.Y (nx150), .A0 (nx2787), .A1 (TX_DIV16_3_), .A2 (nx2799)) ;
    mux21 ix2769 (.Y (nx2768), .A0 (T1_OVERFLOW), .A1 (nx3350), .S0 (nx2649)) ;
    or02 ix2777 (.Y (nx2776), .A0 (nx3358), .A1 (CLK_ROOT_DIV2)) ;
    or02 ix65 (.Y (nx64), .A0 (nx62), .A1 (nx3358)) ;
    and02 ix2781 (.Y (nx2780), .A0 (nx2785), .A1 (nx2787)) ;
    and02 ix99 (.Y (nx98), .A0 (TX_DIV16_1_), .A1 (TX_DIV16_0_)) ;
    xnor2 ix2793 (.Y (nx2792), .A0 (nx2789), .A1 (nx3284)) ;
    or03 ix2796 (.Y (nx2795), .A0 (nx2799), .A1 (nx2787), .A2 (nx2785)) ;
    ao21 ix2129 (.Y (nx2128), .A0 (TX_DIV16_2_), .A1 (nx3384), .B0 (nx3328)) ;
    nor02 ix83 (.Y (nx2765), .A0 (nx3364), .A1 (nx3358)) ;
    aoi21 ix2803 (.Y (nx80), .A0 (nx2774), .A1 (nx3330), .B0 (nx3388)) ;
    inv02 ix3329 (.Y (nx3330), .A (SMOD)) ;
    and04 ix2809 (.Y (nx3328), .A0 (nx3366), .A1 (nx3254), .A2 (nx3284), .A3 (
          nx3116)) ;
    oai21 ix115 (.Y (nx114), .A0 (nx2787), .A1 (nx2785), .B0 (nx2799)) ;
    nand02 ix153 (.Y (nx2957), .A0 (nx3360), .A1 (nx3364)) ;
    and04 ix2815 (.Y (nx2814), .A0 (nx2690), .A1 (nx2696), .A2 (nx2702), .A3 (
          nx2708)) ;
    and03 ix2817 (.Y (nx2816), .A0 (nx2732), .A1 (nx2746), .A2 (nx2726)) ;
    and02 ix2833 (.Y (nx2832), .A0 (nx3360), .A1 (nx2818)) ;
    and04 ix219 (.Y (nx218), .A0 (nx3360), .A1 (nx2818), .A2 (nx3254), .A3 (
          nx3378)) ;
    nand02 ix2846 (.Y (nx2070), .A0 (nx2849), .A1 (nx2881)) ;
    mux21 ix2289 (.Y (nx2288), .A0 (nx2857), .A1 (nx2860), .S0 (nx3364)) ;
    mux21 ix2279 (.Y (nx2278), .A0 (nx2860), .A1 (nx2863), .S0 (nx3364)) ;
    ao32 ix727 (.Y (nx726), .A0 (nx3332), .A1 (SCON_4_), .A2 (nx574), .B0 (
         nx2849), .B1 (nx2881)) ;
    nand02 ix2880 (.Y (nx3332), .A0 (RX_STATE_0_), .A1 (RX_STATE_1_)) ;
    ao21 ix2299 (.Y (nx2298), .A0 (SCON_4_), .A1 (nx3380), .B0 (nx3396)) ;
    nor03 ix2891 (.Y (nx3334), .A0 (nx3336), .A1 (nx3358), .A2 (nx3382)) ;
    inv02 ix3335 (.Y (nx3336), .A (REG_RESULT[4])) ;
    or02 ix2894 (.Y (nx596), .A0 (nx3292), .A1 (nx3358)) ;
    aoi32 ix691 (.Y (nx3017), .A0 (PORT3I[0]), .A1 (nx2649), .A2 (nx2669), .B0 (
          nx3362), .B1 (nx3338)) ;
    inv02 ix3337 (.Y (nx3338), .A (nx3300)) ;
    and04 ix641 (.Y (nx640), .A0 (nx2941), .A1 (nx3362), .A2 (nx3364), .A3 (
          nx3340)) ;
    inv02 ix3339 (.Y (nx3340), .A (nx3302)) ;
    xnor2 ix2912 (.Y (nx2911), .A0 (nx2941), .A1 (nx3302)) ;
    or03 ix2914 (.Y (nx2913), .A0 (nx2917), .A1 (nx2934), .A2 (nx2927)) ;
    ao21 ix2329 (.Y (nx2328), .A0 (RX_DIV16_2_), .A1 (nx3386), .B0 (nx3342)) ;
    and04 ix2920 (.Y (nx3342), .A0 (nx3370), .A1 (nx3302), .A2 (nx504), .A3 (
          nx3116)) ;
    oai21 ix537 (.Y (nx536), .A0 (nx2934), .A1 (nx2927), .B0 (nx2917)) ;
    and03 ix649 (.Y (nx648), .A0 (nx2934), .A1 (RX_DIV16_3_), .A2 (nx2917)) ;
    or03 ix2956 (.Y (nx2955), .A0 (nx2934), .A1 (RX_DIV16_3_), .A2 (nx2917)) ;
    nand02 ix677 (.Y (nx676), .A0 (nx2945), .A1 (nx2904)) ;
    and03 ix569 (.Y (nx568), .A0 (nx2934), .A1 (RX_DIV16_3_), .A2 (nx2917)) ;
    ao32 ix2967 (.Y (nx574), .A0 (nx3146), .A1 (RX_DIV16_0_), .A2 (nx3120), .B0 (
         nx3352), .B1 (nx3250)) ;
    mux21 ix2409 (.Y (nx2408), .A0 (nx3002), .A1 (nx2999), .S0 (nx2875)) ;
    ao21 ix3005 (.Y (nx3004), .A0 (nx2070), .A1 (nx3008), .B0 (nx3248)) ;
    mux21 ix2399 (.Y (nx2398), .A0 (nx2895), .A1 (nx3008), .S0 (nx2875)) ;
    nor03 ix2487 (.Y (nx2486), .A0 (nx3344), .A1 (nx3358), .A2 (nx3382)) ;
    inv02 ix3343 (.Y (nx3344), .A (REG_RESULT[5])) ;
    nand02 ix875 (.Y (RITI), .A0 (nx2867), .A1 (nx3040)) ;
    mux21 ix2549 (.Y (nx2548), .A0 (nx3047), .A1 (nx2969), .S0 (nx3372)) ;
    and03 ix3050 (.Y (nx854), .A0 (nx3158), .A1 (nx3256), .A2 (nx3352)) ;
    mux21 ix2559 (.Y (nx2558), .A0 (nx3055), .A1 (nx2974), .S0 (nx3372)) ;
    mux21 ix2579 (.Y (nx2578), .A0 (nx3061), .A1 (nx2979), .S0 (nx3372)) ;
    mux21 ix2589 (.Y (nx2588), .A0 (nx3078), .A1 (nx2984), .S0 (nx3372)) ;
    mux21 ix2599 (.Y (nx2598), .A0 (nx3084), .A1 (nx2989), .S0 (nx3372)) ;
    mux21 ix2609 (.Y (nx2608), .A0 (nx3090), .A1 (nx2994), .S0 (nx3372)) ;
    mux21 ix2619 (.Y (nx2618), .A0 (nx3096), .A1 (nx2999), .S0 (nx3372)) ;
    mux21 ix2629 (.Y (nx2628), .A0 (nx3104), .A1 (nx3102), .S0 (nx3372)) ;
    mux21 ix3103 (.Y (nx3102), .A0 (PORT3I[0]), .A1 (RX_SHIFTER_8_), .S0 (nx3362
          )) ;
    buf02 ix3345 (.Y (nx3346), .A (SOURCE_ADDR[0])) ;
    buf02 ix3347 (.Y (nx3348), .A (SOURCE_ADDR[0])) ;
    buf02 ix3349 (.Y (nx3350), .A (CLK3_EN)) ;
    buf02 ix3351 (.Y (nx3352), .A (CLK3_EN)) ;
    inv04 ix3353 (.Y (nx3354), .A (nx3254)) ;
    inv04 ix3355 (.Y (nx3356), .A (nx3254)) ;
    inv04 ix3357 (.Y (nx3358), .A (nx3254)) ;
    inv04 ix3359 (.Y (nx3360), .A (nx3248)) ;
    inv04 ix3361 (.Y (nx3362), .A (nx3248)) ;
    inv04 ix3363 (.Y (nx3364), .A (nx3286)) ;
    buf02 ix3365 (.Y (nx3366), .A (nx114)) ;
    buf02 ix3367 (.Y (nx3368), .A (nx404)) ;
    buf02 ix3369 (.Y (nx3370), .A (nx536)) ;
    buf04 ix3371 (.Y (nx3372), .A (nx854)) ;
    buf02 ix3373 (.Y (nx3374), .A (nx2166)) ;
    buf02 ix3375 (.Y (nx3376), .A (nx2486)) ;
    inv02 ix3377 (.Y (nx3378), .A (nx178)) ;
    inv02 ix3379 (.Y (nx3380), .A (nx3114)) ;
    inv02 ix3381 (.Y (nx3382), .A (nx3114)) ;
    inv02 ix3383 (.Y (nx3384), .A (nx3116)) ;
    inv02 ix3385 (.Y (nx3386), .A (nx3116)) ;
    inv02 ix3387 (.Y (nx3388), .A (nx62)) ;
    inv02 ix3389 (.Y (nx3390), .A (nx3154)) ;
    buf02 ix3391 (.Y (nx3392), .A (nx3318)) ;
    buf02 ix3393 (.Y (nx3394), .A (nx3322)) ;
    buf02 ix3395 (.Y (nx3396), .A (nx3334)) ;
endmodule


module block17 ( TSFRDI, IE0, TF0, IE1, TF1, T1_OVERFLOW, SOURCE_ADDR, 
                  DESTIN_ADDR, SFRWE, REG_RESULT, INTR_ACKNOW, PORT3I, RMW, 
                  INTERNAL_RESET, INTERNAL_WAIT, CLK3_EN, CLK1, CLK2, CLK3 ) ;

    output [7:0]TSFRDI ;
    output IE0 ;
    output TF0 ;
    output IE1 ;
    output TF1 ;
    output T1_OVERFLOW ;
    input [2:0]SOURCE_ADDR ;
    input [6:0]DESTIN_ADDR ;
    input SFRWE ;
    input [7:0]REG_RESULT ;
    input [3:0]INTR_ACKNOW ;
    input [5:2]PORT3I ;
    input RMW ;
    input INTERNAL_RESET ;
    input INTERNAL_WAIT ;
    input CLK3_EN ;
    input CLK1 ;
    input CLK2 ;
    input CLK3 ;

    wire TH1_WRITE, TH0_WRITE, TL1_DATA_7_, TL1_DATA_6_, TL1_DATA_5_, 
         TL1_DATA_4_, TL1_DATA_3_, TL1_DATA_2_, TL1_DATA_1_, TL1_DATA_0_, 
         TL0_DATA_7_, TL0_DATA_6_, TL0_DATA_5_, TL0_DATA_4_, TL0_DATA_3_, 
         TL0_DATA_2_, TL0_DATA_1_, TL0_DATA_0_, T1_EN, TH0_EN, TL0_EN, TL1_LOAD, 
         TL0_LOAD, T1_MODE0, T0_MODE0, TH1_CARRY_IN, TH0_CARRY_IN, TL1_CARRY_IN, 
         TL0_CARRY_IN, TH1_7_, TH1_6_, TH1_5_, TH1_4_, TH1_3_, TH1_2_, TH1_1_, 
         TH1_0_, TL1_7_, TL1_6_, TL1_5_, TL1_4_, TL1_3_, TL1_2_, TL1_1_, TL1_0_, 
         TH0_7_, TH0_6_, TH0_5_, TH0_4_, TH0_3_, TH0_2_, TH0_1_, TH0_0_, TL0_7_, 
         TL0_6_, TL0_5_, TL0_4_, TL0_3_, TL0_2_, TL0_1_, TL0_0_, TH1_CARRY, 
         TH0_CARRY, TL1_CARRY, TL0_CARRY, GND, nx2, nx10, nx20, TMOD_0_, nx34, 
         nx44, nx50, nx70, TCON_0_, nx86, nx102, TMOD_1_, PORT_3_SAMPLE_P1_2_, 
         nx154, I_TCON_1_, nx158, nx162, nx168, nx174, nx178, TMOD_2_, TCON_2_, 
         TMOD_3_, PORT_3_SAMPLE_P1_3_, nx288, I_TCON_3_, nx294, nx300, nx304, 
         TMOD_4_, TCON_4_, TMOD_5_, PORT_3_SAMPLE_P1_4_, 
         LAST_PORT_3_SAMPLE_P2_4_, nx456, nx460, TMOD_6_, TCON_6_, TMOD_7_, 
         PORT_3_SAMPLE_P1_5_, LAST_PORT_3_SAMPLE_P2_5_, nx616, nx630, nx650, 
         nx654, nx662, nx670, nx678, nx686, nx694, nx702, nx710, nx720, nx724, 
         nx732, nx740, nx748, nx756, nx764, nx772, nx780, nx970, nx980, nx990, 
         nx996, nx1000, nx1010, nx1020, nx1030, nx1040, nx1046, nx1050, nx1060, 
         nx1070, nx1080, nx1090, nx1096, nx1100, nx1110, nx1120, nx1130, nx1140, 
         nx1150, nx1156, nx1160, nx1170, nx1180, nx1191, nx1199, nx1201, nx1203, 
         nx1205, nx1208, nx1210, nx1213, nx1215, nx1217, nx1219, nx1222, nx1225, 
         nx1228, nx1232, nx1240, nx1242, nx1244, nx1247, nx1253, nx1255, nx1259, 
         nx1261, nx1270, nx1272, nx1278, nx1281, nx1284, nx1286, nx1294, nx1298, 
         nx1300, nx1302, nx1307, nx1310, nx1312, nx1320, nx1324, nx1329, nx1366, 
         nx1370, nx1372, nx1374, nx1378, nx1381, nx1383, nx1386, nx1389, nx1397, 
         nx1401, nx1403, nx1406, nx1408, nx1416, nx1418, nx1420, nx1422, nx1424, 
         nx1426, nx1428, nx1436, nx1440, nx1442, nx1445, nx1451, nx1455, nx1457, 
         nx1460, nx1463, nx1467, nx1469, nx1472, nx1474, nx1477, nx1479, nx1482, 
         nx1484, nx1487, nx1489, nx1492, nx1494, nx1497, nx1499, nx1506, nx1508, 
         nx1510, nx1512, nx1514, nx1516, nx1518, nx1520, nx1522, nx1524, nx1526, 
         nx1528, nx1530, nx1532, nx1534, nx1536, nx1538, nx1540, nx1542, nx1544, 
         nx1546, nx1548, nx1550, nx1552, nx1554, nx1556, nx1558, nx1560, nx1562, 
         nx1564, nx1566, nx1568, nx1570, nx1572, nx1574, nx1576, nx1578, nx1580, 
         nx1582, nx1584, nx1586, nx1588, nx1590, nx1592, nx1594, nx1596, nx1598, 
         nx1600, nx1602, nx1604, nx1606, nx1608, nx1610, nx1612, nx1614, nx1616, 
         nx1618, nx1620, nx1622, nx1624, nx1626, nx1628, nx1630, nx1636, nx1642, 
         nx1648, nx1654, nx1660, nx1666, nx1668, nx1670, nx1672, nx1674, nx1676, 
         nx1678, nx1680, nx1682, nx1684, nx1686, nx1688, nx1690, nx1692, nx1694, 
         nx1696, nx1698, nx1700, nx1702, nx1708, nx1714, nx1720, nx1726, nx1732, 
         nx1738;
    wire [8:0] \$dummy ;




    block16 uTL0 (.CARRY_OUT (TL0_CARRY), .COUNT ({TL0_7_,TL0_6_,TL0_5_,TL0_4_,
             TL0_3_,TL0_2_,TL0_1_,TL0_0_}), .MODE0 (T0_MODE0), .LOAD (TL0_LOAD)
             , .CARRY_IN (nx1522), .COUNT_EN (nx1514), .DATA_IN ({TL0_DATA_7_,
             TL0_DATA_6_,TL0_DATA_5_,TL0_DATA_4_,TL0_DATA_3_,TL0_DATA_2_,
             TL0_DATA_1_,TL0_DATA_0_}), .INT_RESET (nx1684), .CLK3 (CLK3)) ;
    block16u uTH0 (.CARRY_OUT (TH0_CARRY), .COUNT ({TH0_7_,TH0_6_,
                       TH0_5_,TH0_4_,TH0_3_,TH0_2_,TH0_1_,TH0_0_}), .MODE0 (GND)
                       , .LOAD (nx1510), .CARRY_IN (nx1518), .COUNT_EN (TH0_EN)
                       , .DATA_IN ({REG_RESULT[7],REG_RESULT[6],REG_RESULT[5],
                       REG_RESULT[4],REG_RESULT[3],REG_RESULT[2],REG_RESULT[1],
                       REG_RESULT[0]}), .INT_RESET (nx1684), .CLK3 (CLK3)) ;
    block16 uTL1 (.CARRY_OUT (TL1_CARRY), .COUNT ({TL1_7_,TL1_6_,TL1_5_,TL1_4_,
             TL1_3_,TL1_2_,TL1_1_,TL1_0_}), .MODE0 (T1_MODE0), .LOAD (TL1_LOAD)
             , .CARRY_IN (nx1520), .COUNT_EN (nx1512), .DATA_IN ({TL1_DATA_7_,
             TL1_DATA_6_,TL1_DATA_5_,TL1_DATA_4_,TL1_DATA_3_,TL1_DATA_2_,
             TL1_DATA_1_,TL1_DATA_0_}), .INT_RESET (nx1684), .CLK3 (CLK3)) ;
    block16u uTH1 (.CARRY_OUT (TH1_CARRY), .COUNT ({TH1_7_,TH1_6_,
                       TH1_5_,TH1_4_,TH1_3_,TH1_2_,TH1_1_,TH1_0_}), .MODE0 (GND)
                       , .LOAD (nx1508), .CARRY_IN (nx1516), .COUNT_EN (nx1512)
                       , .DATA_IN ({REG_RESULT[7],REG_RESULT[6],REG_RESULT[5],
                       REG_RESULT[4],REG_RESULT[3],REG_RESULT[2],REG_RESULT[1],
                       REG_RESULT[0]}), .INT_RESET (nx1684), .CLK3 (CLK3)) ;
    fake_gnd ix893 (.Y (GND)) ;
    aoi21 ix837 (.Y (TL0_CARRY_IN), .A0 (nx1191), .A1 (TMOD_3_), .B0 (nx1219)) ;
    dff ix1003 (.Q (\$dummy [0]), .QB (nx1191), .D (nx1000), .CLK (CLK3)) ;
    ao21 ix1001 (.Y (nx1000), .A0 (PORT_3_SAMPLE_P1_2_), .A1 (nx1680), .B0 (
         nx996)) ;
    dff reg_PORT_3_SAMPLE_P1_2_ (.Q (PORT_3_SAMPLE_P1_2_), .QB (\$dummy [1]), .D (
        PORT3I[2]), .CLK (CLK1)) ;
    nor02 ix997 (.Y (nx996), .A0 (nx1191), .A1 (nx1680)) ;
    mux21 ix1041 (.Y (nx1040), .A0 (nx1199), .A1 (nx1203), .S0 (nx1586)) ;
    nand02 ix1200 (.Y (nx1199), .A0 (nx1700), .A1 (REG_RESULT[3])) ;
    inv02 ix1202 (.Y (nx1201), .A (INTERNAL_RESET)) ;
    dff ix1043 (.Q (TMOD_3_), .QB (nx1203), .D (nx1564), .CLK (CLK2)) ;
    nor02 ix1206 (.Y (nx1205), .A0 (nx50), .A1 (nx1684)) ;
    nand03 ix1211 (.Y (nx1210), .A0 (nx1530), .A1 (nx1215), .A2 (SFRWE)) ;
    nor03 ix35 (.Y (nx34), .A0 (DESTIN_ADDR[5]), .A1 (nx1213), .A2 (
          DESTIN_ADDR[6])) ;
    inv02 ix1214 (.Y (nx1213), .A (DESTIN_ADDR[3])) ;
    inv02 ix1216 (.Y (nx1215), .A (DESTIN_ADDR[4])) ;
    inv02 ix1218 (.Y (nx1217), .A (DESTIN_ADDR[0])) ;
    dff ix1083 (.Q (TCON_4_), .QB (nx1219), .D (nx1570), .CLK (CLK2)) ;
    mux21 ix1081 (.Y (nx1080), .A0 (nx1219), .A1 (nx1222), .S0 (nx1538)) ;
    nand02 ix1223 (.Y (nx1222), .A0 (nx1700), .A1 (REG_RESULT[4])) ;
    ao21 ix87 (.Y (nx86), .A0 (nx1225), .A1 (nx1536), .B0 (nx1684)) ;
    nor02 ix45 (.Y (nx44), .A0 (DESTIN_ADDR[2]), .A1 (nx1210)) ;
    inv02 ix1229 (.Y (nx1228), .A (DESTIN_ADDR[1])) ;
    aoi21 ix831 (.Y (TL1_CARRY_IN), .A0 (nx1232), .A1 (TMOD_7_), .B0 (nx1244)) ;
    dff ix1053 (.Q (\$dummy [2]), .QB (nx1232), .D (nx1050), .CLK (CLK3)) ;
    ao21 ix1051 (.Y (nx1050), .A0 (PORT_3_SAMPLE_P1_3_), .A1 (nx1680), .B0 (
         nx1046)) ;
    dff reg_PORT_3_SAMPLE_P1_3_ (.Q (PORT_3_SAMPLE_P1_3_), .QB (\$dummy [3]), .D (
        PORT3I[3]), .CLK (CLK1)) ;
    nor02 ix1047 (.Y (nx1046), .A0 (nx1232), .A1 (nx1680)) ;
    mux21 ix1151 (.Y (nx1150), .A0 (nx1240), .A1 (nx1242), .S0 (nx1586)) ;
    nand02 ix1241 (.Y (nx1240), .A0 (nx1700), .A1 (REG_RESULT[7])) ;
    dff ix1153 (.Q (TMOD_7_), .QB (nx1242), .D (nx1582), .CLK (CLK2)) ;
    dff ix1143 (.Q (TCON_6_), .QB (nx1244), .D (nx1580), .CLK (CLK2)) ;
    mux21 ix1141 (.Y (nx1140), .A0 (nx1244), .A1 (nx1247), .S0 (nx1538)) ;
    nand02 ix1248 (.Y (nx1247), .A0 (nx1700), .A1 (REG_RESULT[6])) ;
    mux21 ix971 (.Y (nx970), .A0 (nx1253), .A1 (nx1255), .S0 (nx1586)) ;
    nand02 ix1254 (.Y (nx1253), .A0 (nx1700), .A1 (REG_RESULT[0])) ;
    dff ix973 (.Q (TMOD_0_), .QB (nx1255), .D (nx1552), .CLK (CLK2)) ;
    mux21 ix991 (.Y (nx990), .A0 (nx1259), .A1 (nx1261), .S0 (nx1586)) ;
    nand02 ix1260 (.Y (nx1259), .A0 (nx1700), .A1 (REG_RESULT[1])) ;
    dff ix993 (.Q (TMOD_1_), .QB (nx1261), .D (nx1556), .CLK (CLK2)) ;
    mux21 ix1091 (.Y (nx1090), .A0 (nx1270), .A1 (nx1272), .S0 (nx1586)) ;
    nand02 ix1271 (.Y (nx1270), .A0 (nx1700), .A1 (REG_RESULT[5])) ;
    dff ix1093 (.Q (TMOD_5_), .QB (nx1272), .D (nx1572), .CLK (CLK2)) ;
    mux21 ix1071 (.Y (nx1070), .A0 (nx1222), .A1 (nx1278), .S0 (nx1586)) ;
    dff ix1073 (.Q (TMOD_4_), .QB (nx1278), .D (nx1568), .CLK (CLK2)) ;
    nand02 ix815 (.Y (TL0_LOAD), .A0 (nx1281), .A1 (nx1588)) ;
    nand04 ix1282 (.Y (nx1281), .A0 (TL0_CARRY), .A1 (nx1255), .A2 (nx1514), .A3 (
           TMOD_1_)) ;
    aoi21 ix425 (.Y (TL0_EN), .A0 (nx1284), .A1 (TMOD_2_), .B0 (nx1302)) ;
    nand02 ix1285 (.Y (nx1284), .A0 (nx1286), .A1 (LAST_PORT_3_SAMPLE_P2_4_)) ;
    dff ix1103 (.Q (\$dummy [4]), .QB (nx1286), .D (nx1100), .CLK (CLK3)) ;
    ao21 ix1101 (.Y (nx1100), .A0 (PORT_3_SAMPLE_P1_4_), .A1 (nx1680), .B0 (
         nx1096)) ;
    dff reg_PORT_3_SAMPLE_P1_4_ (.Q (PORT_3_SAMPLE_P1_4_), .QB (\$dummy [5]), .D (
        PORT3I[4]), .CLK (CLK1)) ;
    nor02 ix1097 (.Y (nx1096), .A0 (nx1286), .A1 (nx1680)) ;
    mux21 ix1111 (.Y (nx1110), .A0 (nx1294), .A1 (nx1286), .S0 (nx1680)) ;
    dff ix1113 (.Q (LAST_PORT_3_SAMPLE_P2_4_), .QB (nx1294), .D (nx1574), .CLK (
        CLK3)) ;
    mux21 ix1021 (.Y (nx1020), .A0 (nx1298), .A1 (nx1300), .S0 (nx1586)) ;
    nand02 ix1299 (.Y (nx1298), .A0 (nx1700), .A1 (REG_RESULT[2])) ;
    dff ix1023 (.Q (TMOD_2_), .QB (nx1300), .D (nx1560), .CLK (CLK2)) ;
    inv02 ix1303 (.Y (nx1302), .A (CLK3_EN)) ;
    nand02 ix797 (.Y (TL1_LOAD), .A0 (nx1307), .A1 (nx1590)) ;
    nand03 ix1308 (.Y (nx1307), .A0 (TL1_CARRY), .A1 (TMOD_5_), .A2 (nx1512)) ;
    aoi221 ix593 (.Y (T1_EN), .A0 (TMOD_4_), .A1 (TMOD_5_), .B0 (nx1310), .B1 (
           TMOD_6_), .C0 (nx1302)) ;
    nand02 ix1311 (.Y (nx1310), .A0 (nx1312), .A1 (LAST_PORT_3_SAMPLE_P2_5_)) ;
    dff ix1163 (.Q (\$dummy [6]), .QB (nx1312), .D (nx1160), .CLK (CLK3)) ;
    ao21 ix1161 (.Y (nx1160), .A0 (PORT_3_SAMPLE_P1_5_), .A1 (nx1680), .B0 (
         nx1156)) ;
    dff reg_PORT_3_SAMPLE_P1_5_ (.Q (PORT_3_SAMPLE_P1_5_), .QB (\$dummy [7]), .D (
        PORT3I[5]), .CLK (CLK1)) ;
    nor02 ix1157 (.Y (nx1156), .A0 (nx1312), .A1 (nx1680)) ;
    mux21 ix1171 (.Y (nx1170), .A0 (nx1320), .A1 (nx1312), .S0 (nx1680)) ;
    dff ix1173 (.Q (LAST_PORT_3_SAMPLE_P2_5_), .QB (nx1320), .D (nx1584), .CLK (
        CLK3)) ;
    mux21 ix1131 (.Y (nx1130), .A0 (nx1247), .A1 (nx1324), .S0 (nx1586)) ;
    dff ix1133 (.Q (TMOD_6_), .QB (nx1324), .D (nx1578), .CLK (CLK2)) ;
    ao21 ix441 (.Y (TH0_EN), .A0 (nx1682), .A1 (nx1702), .B0 (nx1514)) ;
    ao21 ix729 (.Y (TL0_DATA_0_), .A0 (REG_RESULT[0]), .A1 (nx1698), .B0 (nx724)
         ) ;
    and02 ix725 (.Y (nx724), .A0 (TH0_0_), .A1 (nx1588)) ;
    ao21 ix737 (.Y (TL0_DATA_1_), .A0 (REG_RESULT[1]), .A1 (nx1698), .B0 (nx732)
         ) ;
    and02 ix733 (.Y (nx732), .A0 (TH0_1_), .A1 (nx1588)) ;
    ao21 ix745 (.Y (TL0_DATA_2_), .A0 (REG_RESULT[2]), .A1 (nx1698), .B0 (nx740)
         ) ;
    and02 ix741 (.Y (nx740), .A0 (TH0_2_), .A1 (nx1588)) ;
    ao21 ix753 (.Y (TL0_DATA_3_), .A0 (REG_RESULT[3]), .A1 (nx1698), .B0 (nx748)
         ) ;
    and02 ix749 (.Y (nx748), .A0 (TH0_3_), .A1 (nx1588)) ;
    ao21 ix761 (.Y (TL0_DATA_4_), .A0 (REG_RESULT[4]), .A1 (nx1698), .B0 (nx756)
         ) ;
    and02 ix757 (.Y (nx756), .A0 (TH0_4_), .A1 (nx1588)) ;
    ao21 ix769 (.Y (TL0_DATA_5_), .A0 (REG_RESULT[5]), .A1 (nx1698), .B0 (nx764)
         ) ;
    and02 ix765 (.Y (nx764), .A0 (TH0_5_), .A1 (nx1588)) ;
    ao21 ix777 (.Y (TL0_DATA_6_), .A0 (REG_RESULT[6]), .A1 (nx1698), .B0 (nx772)
         ) ;
    and02 ix773 (.Y (nx772), .A0 (TH0_6_), .A1 (nx1588)) ;
    ao21 ix785 (.Y (TL0_DATA_7_), .A0 (REG_RESULT[7]), .A1 (nx1698), .B0 (nx780)
         ) ;
    and02 ix781 (.Y (nx780), .A0 (TH0_7_), .A1 (nx1588)) ;
    ao21 ix659 (.Y (TL1_DATA_0_), .A0 (REG_RESULT[0]), .A1 (nx1696), .B0 (nx654)
         ) ;
    and02 ix655 (.Y (nx654), .A0 (TH1_0_), .A1 (nx1590)) ;
    ao21 ix667 (.Y (TL1_DATA_1_), .A0 (REG_RESULT[1]), .A1 (nx1696), .B0 (nx662)
         ) ;
    and02 ix663 (.Y (nx662), .A0 (TH1_1_), .A1 (nx1590)) ;
    ao21 ix675 (.Y (TL1_DATA_2_), .A0 (REG_RESULT[2]), .A1 (nx1696), .B0 (nx670)
         ) ;
    and02 ix671 (.Y (nx670), .A0 (TH1_2_), .A1 (nx1590)) ;
    ao21 ix683 (.Y (TL1_DATA_3_), .A0 (REG_RESULT[3]), .A1 (nx1696), .B0 (nx678)
         ) ;
    and02 ix679 (.Y (nx678), .A0 (TH1_3_), .A1 (nx1590)) ;
    ao21 ix691 (.Y (TL1_DATA_4_), .A0 (REG_RESULT[4]), .A1 (nx1696), .B0 (nx686)
         ) ;
    and02 ix687 (.Y (nx686), .A0 (TH1_4_), .A1 (nx1590)) ;
    ao21 ix699 (.Y (TL1_DATA_5_), .A0 (REG_RESULT[5]), .A1 (nx1696), .B0 (nx694)
         ) ;
    and02 ix695 (.Y (nx694), .A0 (TH1_5_), .A1 (nx1590)) ;
    ao21 ix707 (.Y (TL1_DATA_6_), .A0 (REG_RESULT[6]), .A1 (nx1696), .B0 (nx702)
         ) ;
    and02 ix703 (.Y (nx702), .A0 (TH1_6_), .A1 (nx1590)) ;
    ao21 ix715 (.Y (TL1_DATA_7_), .A0 (REG_RESULT[7]), .A1 (nx1696), .B0 (nx710)
         ) ;
    and02 ix711 (.Y (nx710), .A0 (TH1_7_), .A1 (nx1590)) ;
    nor04 ix861 (.Y (TH0_WRITE), .A0 (nx1366), .A1 (DESTIN_ADDR[1]), .A2 (
          DESTIN_ADDR[0]), .A3 (nx1210)) ;
    inv02 ix1367 (.Y (nx1366), .A (DESTIN_ADDR[2])) ;
    nor04 ix851 (.Y (TH1_WRITE), .A0 (nx1366), .A1 (DESTIN_ADDR[1]), .A2 (nx1217
          ), .A3 (nx1210)) ;
    oai32 ix605 (.Y (T1_OVERFLOW), .A0 (nx1546), .A1 (nx1370), .A2 (nx1302), .B0 (
          nx1372), .B1 (nx1374)) ;
    inv02 ix1371 (.Y (nx1370), .A (TH0_CARRY)) ;
    nand02 ix1375 (.Y (nx1374), .A0 (nx1512), .A1 (nx1546)) ;
    dff ix1183 (.Q (TF1), .QB (\$dummy [8]), .D (nx1180), .CLK (CLK3)) ;
    inv02 ix1181 (.Y (nx1180), .A (nx1378)) ;
    mux21 ix1379 (.Y (nx1378), .A0 (TF1), .A1 (nx1550), .S0 (nx1548)) ;
    aoi22 ix631 (.Y (nx630), .A0 (nx1381), .A1 (INTR_ACKNOW[3]), .B0 (nx1383), .B1 (
          nx1240)) ;
    inv02 ix1382 (.Y (nx1381), .A (INTERNAL_WAIT)) ;
    nand03 ix1384 (.Y (nx1383), .A0 (nx162), .A1 (nx1700), .A2 (nx1506)) ;
    aoi22 ix1390 (.Y (nx1389), .A0 (INTR_ACKNOW[3]), .A1 (nx1381), .B0 (nx1506)
          , .B1 (nx162)) ;
    ao21 ix327 (.Y (IE1), .A0 (TCON_2_), .A1 (I_TCON_3_), .B0 (nx288)) ;
    mux21 ix1031 (.Y (nx1030), .A0 (nx1397), .A1 (nx1298), .S0 (nx1538)) ;
    dff ix1033 (.Q (TCON_2_), .QB (nx1397), .D (nx1562), .CLK (CLK2)) ;
    mux21 ix1061 (.Y (nx1060), .A0 (nx1401), .A1 (nx1594), .S0 (nx304)) ;
    dff ix1063 (.Q (I_TCON_3_), .QB (nx1401), .D (nx1566), .CLK (CLK3)) ;
    oai221 ix1404 (.Y (nx1403), .A0 (nx1544), .A1 (REG_RESULT[3]), .B0 (
           INTERNAL_WAIT), .B1 (nx1408), .C0 (nx1700)) ;
    nor03 ix295 (.Y (nx294), .A0 (nx1596), .A1 (PORT_3_SAMPLE_P1_3_), .A2 (
          nx1232)) ;
    nor02 ix1407 (.Y (nx1406), .A0 (nx1386), .A1 (RMW)) ;
    inv02 ix1409 (.Y (nx1408), .A (INTR_ACKNOW[2])) ;
    ao21 ix305 (.Y (nx304), .A0 (nx1682), .A1 (nx300), .B0 (nx158)) ;
    ao21 ix301 (.Y (nx300), .A0 (INTR_ACKNOW[2]), .A1 (nx1381), .B0 (nx1544)) ;
    ao21 ix159 (.Y (nx158), .A0 (nx1682), .A1 (nx1536), .B0 (nx1686)) ;
    mux21 ix1121 (.Y (nx1120), .A0 (nx1416), .A1 (nx1418), .S0 (nx460)) ;
    dff ix1123 (.Q (TF0), .QB (nx1416), .D (nx1576), .CLK (CLK3)) ;
    ao21 ix1419 (.Y (nx1418), .A0 (nx1381), .A1 (INTR_ACKNOW[1]), .B0 (nx1420)
         ) ;
    ao21 ix1421 (.Y (nx1420), .A0 (nx1422), .A1 (nx1428), .B0 (nx1686)) ;
    ao21 ix1423 (.Y (nx1422), .A0 (nx1424), .A1 (nx1426), .B0 (nx1596)) ;
    nand03 ix1425 (.Y (nx1424), .A0 (nx1261), .A1 (nx1514), .A2 (TH0_CARRY)) ;
    nand03 ix1427 (.Y (nx1426), .A0 (nx1514), .A1 (TL0_CARRY), .A2 (TMOD_1_)) ;
    inv02 ix1429 (.Y (nx1428), .A (REG_RESULT[5])) ;
    ao21 ix461 (.Y (nx460), .A0 (nx1682), .A1 (nx1694), .B0 (nx158)) ;
    ao21 ix201 (.Y (IE0), .A0 (TCON_0_), .A1 (I_TCON_1_), .B0 (nx154)) ;
    mux21 ix981 (.Y (nx980), .A0 (nx1436), .A1 (nx1253), .S0 (nx1538)) ;
    dff ix983 (.Q (TCON_0_), .QB (nx1436), .D (nx1554), .CLK (CLK2)) ;
    mux21 ix1011 (.Y (nx1010), .A0 (nx1440), .A1 (nx1598), .S0 (nx178)) ;
    dff ix1013 (.Q (I_TCON_1_), .QB (nx1440), .D (nx1558), .CLK (CLK3)) ;
    oai221 ix1443 (.Y (nx1442), .A0 (nx1542), .A1 (REG_RESULT[1]), .B0 (
           INTERNAL_WAIT), .B1 (nx1445), .C0 (nx1201)) ;
    nor03 ix169 (.Y (nx168), .A0 (nx1596), .A1 (PORT_3_SAMPLE_P1_2_), .A2 (
          nx1191)) ;
    inv02 ix1446 (.Y (nx1445), .A (INTR_ACKNOW[0])) ;
    ao21 ix179 (.Y (nx178), .A0 (nx1682), .A1 (nx174), .B0 (nx158)) ;
    ao21 ix175 (.Y (nx174), .A0 (INTR_ACKNOW[0]), .A1 (nx1381), .B0 (nx1542)) ;
    nand02 ix115 (.Y (TSFRDI[0]), .A0 (nx1600), .A1 (nx1602)) ;
    aoi322 ix1452 (.Y (nx1451), .A0 (TH1_0_), .A1 (nx1670), .A2 (nx1674), .B0 (
           TCON_0_), .B1 (nx1540), .C0 (TMOD_0_), .C1 (nx1534)) ;
    nor03 ix103 (.Y (nx102), .A0 (nx1674), .A1 (nx1670), .A2 (SOURCE_ADDR[1])) ;
    nor03 ix71 (.Y (nx70), .A0 (nx1455), .A1 (nx1670), .A2 (SOURCE_ADDR[1])) ;
    inv02 ix1456 (.Y (nx1455), .A (SOURCE_ADDR[0])) ;
    aoi222 ix1458 (.Y (nx1457), .A0 (TH0_0_), .A1 (nx1524), .B0 (TL0_0_), .B1 (
           nx1528), .C0 (TL1_0_), .C1 (nx1526)) ;
    nor02 ix3 (.Y (nx2), .A0 (nx1460), .A1 (nx1674)) ;
    inv02 ix1461 (.Y (nx1460), .A (SOURCE_ADDR[2])) ;
    nor03 ix21 (.Y (nx20), .A0 (nx1674), .A1 (nx1670), .A2 (nx1463)) ;
    inv02 ix1464 (.Y (nx1463), .A (SOURCE_ADDR[1])) ;
    nor03 ix11 (.Y (nx10), .A0 (nx1455), .A1 (nx1670), .A2 (nx1463)) ;
    nand02 ix211 (.Y (TSFRDI[1]), .A0 (nx1604), .A1 (nx1606)) ;
    aoi322 ix1468 (.Y (nx1467), .A0 (TH1_1_), .A1 (nx1670), .A2 (nx1674), .B0 (
           TMOD_1_), .B1 (nx1534), .C0 (IE0), .C1 (nx1540)) ;
    aoi222 ix1470 (.Y (nx1469), .A0 (TH0_1_), .A1 (nx1524), .B0 (TL0_1_), .B1 (
           nx1528), .C0 (TL1_1_), .C1 (nx1526)) ;
    nand02 ix249 (.Y (TSFRDI[2]), .A0 (nx1608), .A1 (nx1610)) ;
    aoi322 ix1473 (.Y (nx1472), .A0 (TH1_2_), .A1 (nx1670), .A2 (nx1674), .B0 (
           TCON_2_), .B1 (nx1540), .C0 (TMOD_2_), .C1 (nx1534)) ;
    aoi222 ix1475 (.Y (nx1474), .A0 (TH0_2_), .A1 (nx1524), .B0 (TL0_2_), .B1 (
           nx1528), .C0 (TL1_2_), .C1 (nx1526)) ;
    nand02 ix337 (.Y (TSFRDI[3]), .A0 (nx1612), .A1 (nx1614)) ;
    aoi322 ix1478 (.Y (nx1477), .A0 (TH1_3_), .A1 (nx1670), .A2 (nx1674), .B0 (
           TMOD_3_), .B1 (nx1534), .C0 (IE1), .C1 (nx1540)) ;
    aoi222 ix1480 (.Y (nx1479), .A0 (TH0_3_), .A1 (nx1524), .B0 (TL0_3_), .B1 (
           nx1528), .C0 (TL1_3_), .C1 (nx1526)) ;
    nand02 ix375 (.Y (TSFRDI[4]), .A0 (nx1616), .A1 (nx1618)) ;
    aoi322 ix1483 (.Y (nx1482), .A0 (TH1_4_), .A1 (nx1670), .A2 (nx1674), .B0 (
           TCON_4_), .B1 (nx1540), .C0 (TMOD_4_), .C1 (nx1534)) ;
    aoi222 ix1485 (.Y (nx1484), .A0 (TH0_4_), .A1 (nx1524), .B0 (TL0_4_), .B1 (
           nx1528), .C0 (TL1_4_), .C1 (nx1526)) ;
    nand02 ix489 (.Y (TSFRDI[5]), .A0 (nx1620), .A1 (nx1622)) ;
    aoi322 ix1488 (.Y (nx1487), .A0 (TH1_5_), .A1 (nx1672), .A2 (nx1674), .B0 (
           TF0), .B1 (nx1540), .C0 (TMOD_5_), .C1 (nx1534)) ;
    aoi222 ix1490 (.Y (nx1489), .A0 (TH0_5_), .A1 (nx1524), .B0 (TL0_5_), .B1 (
           nx1528), .C0 (TL1_5_), .C1 (nx1526)) ;
    nand02 ix527 (.Y (TSFRDI[6]), .A0 (nx1624), .A1 (nx1626)) ;
    aoi322 ix1493 (.Y (nx1492), .A0 (TH1_6_), .A1 (nx1672), .A2 (nx1674), .B0 (
           TCON_6_), .B1 (nx1540), .C0 (TMOD_6_), .C1 (nx1534)) ;
    aoi222 ix1495 (.Y (nx1494), .A0 (TH0_6_), .A1 (nx1524), .B0 (TL0_6_), .B1 (
           nx1528), .C0 (TL1_6_), .C1 (nx1526)) ;
    nand02 ix647 (.Y (TSFRDI[7]), .A0 (nx1628), .A1 (nx1630)) ;
    aoi322 ix1498 (.Y (nx1497), .A0 (TH1_7_), .A1 (nx1672), .A2 (nx1676), .B0 (
           TF1), .B1 (nx1540), .C0 (TMOD_7_), .C1 (nx1534)) ;
    aoi222 ix1500 (.Y (nx1499), .A0 (TH0_7_), .A1 (nx1524), .B0 (TL0_7_), .B1 (
           nx1528), .C0 (TL1_7_), .C1 (nx1526)) ;
    inv02 ix163 (.Y (nx162), .A (nx1406)) ;
    inv02 ix51 (.Y (nx50), .A (nx1225)) ;
    inv02 ix1209 (.Y (nx1208), .A (nx44)) ;
    buf02 ix1505 (.Y (nx1506), .A (nx1636)) ;
    buf02 ix1507 (.Y (nx1508), .A (TH1_WRITE)) ;
    buf02 ix1509 (.Y (nx1510), .A (TH0_WRITE)) ;
    buf02 ix1511 (.Y (nx1512), .A (T1_EN)) ;
    buf02 ix1513 (.Y (nx1514), .A (TL0_EN)) ;
    buf02 ix1515 (.Y (nx1516), .A (TH1_CARRY_IN)) ;
    buf02 ix1517 (.Y (nx1518), .A (TH0_CARRY_IN)) ;
    buf02 ix1519 (.Y (nx1520), .A (TL1_CARRY_IN)) ;
    buf02 ix1521 (.Y (nx1522), .A (TL0_CARRY_IN)) ;
    buf02 ix1523 (.Y (nx1524), .A (nx2)) ;
    buf02 ix1525 (.Y (nx1526), .A (nx10)) ;
    buf02 ix1527 (.Y (nx1528), .A (nx20)) ;
    buf02 ix1529 (.Y (nx1530), .A (nx34)) ;
    inv02 ix1531 (.Y (nx1532), .A (nx1208)) ;
    buf02 ix1533 (.Y (nx1534), .A (nx70)) ;
    inv02 ix1535 (.Y (nx1536), .A (nx1386)) ;
    buf02 ix1537 (.Y (nx1538), .A (nx86)) ;
    buf02 ix1539 (.Y (nx1540), .A (nx102)) ;
    buf02 ix1541 (.Y (nx1542), .A (nx168)) ;
    buf02 ix1543 (.Y (nx1544), .A (nx294)) ;
    inv02 ix1545 (.Y (nx1546), .A (nx1329)) ;
    buf02 ix1547 (.Y (nx1548), .A (nx616)) ;
    buf02 ix1549 (.Y (nx1550), .A (nx630)) ;
    buf02 ix1551 (.Y (nx1552), .A (nx970)) ;
    buf02 ix1553 (.Y (nx1554), .A (nx980)) ;
    buf02 ix1555 (.Y (nx1556), .A (nx990)) ;
    buf02 ix1557 (.Y (nx1558), .A (nx1010)) ;
    buf02 ix1559 (.Y (nx1560), .A (nx1020)) ;
    buf02 ix1561 (.Y (nx1562), .A (nx1030)) ;
    buf02 ix1563 (.Y (nx1564), .A (nx1040)) ;
    buf02 ix1565 (.Y (nx1566), .A (nx1060)) ;
    buf02 ix1567 (.Y (nx1568), .A (nx1070)) ;
    buf02 ix1569 (.Y (nx1570), .A (nx1080)) ;
    buf02 ix1571 (.Y (nx1572), .A (nx1090)) ;
    buf02 ix1573 (.Y (nx1574), .A (nx1110)) ;
    buf02 ix1575 (.Y (nx1576), .A (nx1120)) ;
    buf02 ix1577 (.Y (nx1578), .A (nx1130)) ;
    buf02 ix1579 (.Y (nx1580), .A (nx1140)) ;
    buf02 ix1581 (.Y (nx1582), .A (nx1150)) ;
    buf02 ix1583 (.Y (nx1584), .A (nx1170)) ;
    buf02 ix1585 (.Y (nx1586), .A (nx1205)) ;
    inv02 ix1587 (.Y (nx1588), .A (nx720)) ;
    inv02 ix1589 (.Y (nx1590), .A (nx650)) ;
    buf02 ix1591 (.Y (nx1592), .A (nx1389)) ;
    buf02 ix1593 (.Y (nx1594), .A (nx1403)) ;
    inv02 ix1595 (.Y (nx1596), .A (nx162)) ;
    buf02 ix1597 (.Y (nx1598), .A (nx1442)) ;
    buf02 ix1599 (.Y (nx1600), .A (nx1451)) ;
    buf02 ix1601 (.Y (nx1602), .A (nx1457)) ;
    buf02 ix1603 (.Y (nx1604), .A (nx1467)) ;
    buf02 ix1605 (.Y (nx1606), .A (nx1469)) ;
    buf02 ix1607 (.Y (nx1608), .A (nx1472)) ;
    buf02 ix1609 (.Y (nx1610), .A (nx1474)) ;
    buf02 ix1611 (.Y (nx1612), .A (nx1477)) ;
    buf02 ix1613 (.Y (nx1614), .A (nx1479)) ;
    buf02 ix1615 (.Y (nx1616), .A (nx1482)) ;
    buf02 ix1617 (.Y (nx1618), .A (nx1484)) ;
    buf02 ix1619 (.Y (nx1620), .A (nx1487)) ;
    buf02 ix1621 (.Y (nx1622), .A (nx1489)) ;
    buf02 ix1623 (.Y (nx1624), .A (nx1492)) ;
    buf02 ix1625 (.Y (nx1626), .A (nx1494)) ;
    buf02 ix1627 (.Y (nx1628), .A (nx1497)) ;
    buf02 ix1629 (.Y (nx1630), .A (nx1499)) ;
    buf02 ix1635 (.Y (nx1636), .A (nx1642)) ;
    buf02 ix1641 (.Y (nx1642), .A (nx1648)) ;
    buf02 ix1647 (.Y (nx1648), .A (nx1654)) ;
    buf02 ix1653 (.Y (nx1654), .A (nx1660)) ;
    buf02 ix1659 (.Y (nx1660), .A (nx1678)) ;
    or03 ix1226 (.Y (nx1225), .A0 (nx1208), .A1 (DESTIN_ADDR[1]), .A2 (nx1217)
         ) ;
    or03 ix81 (.Y (nx1386), .A0 (nx1208), .A1 (DESTIN_ADDR[1]), .A2 (
         DESTIN_ADDR[0])) ;
    ao22 ix825 (.Y (TH0_CARRY_IN), .A0 (TCON_6_), .A1 (nx1702), .B0 (TL0_CARRY)
         , .B1 (nx1261)) ;
    nor02 ix435 (.Y (nx1329), .A0 (nx1255), .A1 (nx1261)) ;
    and02 ix789 (.Y (TH1_CARRY_IN), .A0 (TL1_CARRY), .A1 (nx1272)) ;
    and02 ix807 (.Y (T0_MODE0), .A0 (nx1261), .A1 (nx1255)) ;
    and02 ix843 (.Y (T1_MODE0), .A0 (nx1272), .A1 (nx1278)) ;
    nor03 ix1305 (.Y (nx720), .A0 (nx1208), .A1 (nx1228), .A2 (DESTIN_ADDR[0])
          ) ;
    and03 ix1327 (.Y (nx650), .A0 (nx1532), .A1 (DESTIN_ADDR[1]), .A2 (
          DESTIN_ADDR[0])) ;
    mux21 ix1373 (.Y (nx1372), .A0 (TL1_CARRY), .A1 (TH1_CARRY), .S0 (nx1272)) ;
    ao21 ix617 (.Y (nx616), .A0 (nx1682), .A1 (nx1666), .B0 (nx158)) ;
    inv02 ix1665 (.Y (nx1666), .A (nx1592)) ;
    and02 ix289 (.Y (nx288), .A0 (nx1397), .A1 (nx1232)) ;
    oai21 ix457 (.Y (nx456), .A0 (nx1668), .A1 (INTERNAL_WAIT), .B0 (nx1422)) ;
    inv02 ix1667 (.Y (nx1668), .A (INTR_ACKNOW[1])) ;
    and02 ix155 (.Y (nx154), .A0 (nx1436), .A1 (nx1191)) ;
    inv02 ix1669 (.Y (nx1670), .A (nx1460)) ;
    inv02 ix1671 (.Y (nx1672), .A (nx1460)) ;
    inv04 ix1673 (.Y (nx1674), .A (nx1455)) ;
    inv04 ix1675 (.Y (nx1676), .A (nx1455)) ;
    buf02 ix1677 (.Y (nx1678), .A (nx1688)) ;
    inv02 ix1679 (.Y (nx1680), .A (nx1302)) ;
    inv02 ix1681 (.Y (nx1682), .A (nx1302)) ;
    inv02 ix1683 (.Y (nx1684), .A (nx1201)) ;
    inv02 ix1685 (.Y (nx1686), .A (nx1201)) ;
    buf02 ix1687 (.Y (nx1688), .A (nx1690)) ;
    buf02 ix1689 (.Y (nx1690), .A (nx1692)) ;
    buf02 ix1691 (.Y (nx1692), .A (nx1708)) ;
    buf02 ix1693 (.Y (nx1694), .A (nx456)) ;
    inv02 ix1695 (.Y (nx1696), .A (nx1590)) ;
    inv02 ix1697 (.Y (nx1698), .A (nx1588)) ;
    inv02 ix1699 (.Y (nx1700), .A (INTERNAL_RESET)) ;
    inv02 ix1701 (.Y (nx1702), .A (nx1546)) ;
    buf02 ix1707 (.Y (nx1708), .A (nx1714)) ;
    buf02 ix1713 (.Y (nx1714), .A (nx1720)) ;
    buf02 ix1719 (.Y (nx1720), .A (nx1726)) ;
    buf02 ix1725 (.Y (nx1726), .A (nx1732)) ;
    buf02 ix1731 (.Y (nx1732), .A (nx1738)) ;
    buf02 ix1737 (.Y (nx1738), .A (T1_OVERFLOW)) ;
endmodule


module block16u ( CARRY_OUT, COUNT, MODE0, LOAD, CARRY_IN, COUNT_EN, 
                            DATA_IN, INT_RESET, CLK3 ) ;

    output CARRY_OUT ;
    output [7:0]COUNT ;
    input MODE0 ;
    input LOAD ;
    input CARRY_IN ;
    input COUNT_EN ;
    input [7:0]DATA_IN ;
    input INT_RESET ;
    input CLK3 ;

    wire nx0, nx4, nx48, nx16, nx30, nx52, nx50, nx76, nx92, nx116, nx53, nx138, 
         nx54, nx160, nx59, nx61, nx69, nx71, nx79, nx81, nx89, nx91, nx99, 
         nx101, nx109, nx111, nx119, nx121, nx129, nx131, nx145, nx151, nx154, 
         nx156, nx159, nx167, nx171, nx177, nx181, nx187, nx194, nx198, nx204, 
         nx207, nx209, nx215, nx218, nx225, nx228, nx238, nx240, nx242, nx244, 
         nx246, nx248, nx250, nx252, nx254, nx256, nx258, nx260, nx262, nx268, 
         nx270, nx272;
    wire [6:0] \$dummy ;




    dff ix64 (.Q (COUNT[0]), .QB (\$dummy [0]), .D (nx61), .CLK (CLK3)) ;
    ao21 ix62 (.Y (nx61), .A0 (COUNT[0]), .A1 (nx240), .B0 (nx59)) ;
    nor02 ix146 (.Y (nx145), .A0 (nx0), .A1 (COUNT_EN)) ;
    nor02 ix60 (.Y (nx59), .A0 (nx244), .A1 (nx240)) ;
    aoi32 ix152 (.Y (nx151), .A0 (nx4), .A1 (nx154), .A2 (nx246), .B0 (
          DATA_IN[0]), .B1 (nx238)) ;
    or02 ix5 (.Y (nx4), .A0 (COUNT[0]), .A1 (CARRY_IN)) ;
    nand02 ix155 (.Y (nx154), .A0 (CARRY_IN), .A1 (COUNT[0])) ;
    nor02 ix157 (.Y (nx156), .A0 (LOAD), .A1 (INT_RESET)) ;
    nor02 ix17 (.Y (nx16), .A0 (INT_RESET), .A1 (nx159)) ;
    inv02 ix160 (.Y (nx159), .A (LOAD)) ;
    dff ix74 (.Q (COUNT[1]), .QB (\$dummy [1]), .D (nx71), .CLK (CLK3)) ;
    ao21 ix72 (.Y (nx71), .A0 (COUNT[1]), .A1 (nx240), .B0 (nx69)) ;
    nor02 ix70 (.Y (nx69), .A0 (nx248), .A1 (nx240)) ;
    aoi32 ix168 (.Y (nx167), .A0 (nx30), .A1 (nx246), .A2 (nx171), .B0 (
          DATA_IN[1]), .B1 (nx238)) ;
    ao21 ix31 (.Y (nx30), .A0 (CARRY_IN), .A1 (COUNT[0]), .B0 (COUNT[1])) ;
    nand03 ix172 (.Y (nx171), .A0 (COUNT[1]), .A1 (CARRY_IN), .A2 (COUNT[0])) ;
    dff ix84 (.Q (COUNT[2]), .QB (\$dummy [2]), .D (nx81), .CLK (CLK3)) ;
    ao21 ix82 (.Y (nx81), .A0 (COUNT[2]), .A1 (nx240), .B0 (nx79)) ;
    nor02 ix80 (.Y (nx79), .A0 (nx250), .A1 (nx240)) ;
    aoi32 ix178 (.Y (nx177), .A0 (nx52), .A1 (nx252), .A2 (nx246), .B0 (
          DATA_IN[2]), .B1 (nx238)) ;
    ao21 ix53 (.Y (nx52), .A0 (COUNT[1]), .A1 (nx48), .B0 (COUNT[2])) ;
    nand04 ix182 (.Y (nx181), .A0 (COUNT[2]), .A1 (COUNT[1]), .A2 (CARRY_IN), .A3 (
           COUNT[0])) ;
    dff ix94 (.Q (COUNT[3]), .QB (\$dummy [3]), .D (nx91), .CLK (CLK3)) ;
    ao21 ix92 (.Y (nx91), .A0 (COUNT[3]), .A1 (nx240), .B0 (nx89)) ;
    nor02 ix90 (.Y (nx89), .A0 (nx254), .A1 (nx240)) ;
    aoi22 ix188 (.Y (nx187), .A0 (DATA_IN[3]), .A1 (nx238), .B0 (nx76), .B1 (
          nx246)) ;
    dff ix104 (.Q (COUNT[4]), .QB (\$dummy [4]), .D (nx101), .CLK (CLK3)) ;
    ao21 ix102 (.Y (nx101), .A0 (COUNT[4]), .A1 (nx240), .B0 (nx99)) ;
    nor02 ix100 (.Y (nx99), .A0 (nx256), .A1 (nx240)) ;
    aoi32 ix195 (.Y (nx194), .A0 (nx92), .A1 (nx272), .A2 (nx246), .B0 (
          DATA_IN[4]), .B1 (nx238)) ;
    ao21 ix93 (.Y (nx92), .A0 (COUNT[3]), .A1 (nx50), .B0 (COUNT[4])) ;
    nand03 ix199 (.Y (nx198), .A0 (nx50), .A1 (COUNT[4]), .A2 (COUNT[3])) ;
    ao21 ix112 (.Y (nx111), .A0 (COUNT[5]), .A1 (nx242), .B0 (nx109)) ;
    nor02 ix110 (.Y (nx109), .A0 (nx258), .A1 (nx242)) ;
    aoi32 ix205 (.Y (nx204), .A0 (nx116), .A1 (nx209), .A2 (nx246), .B0 (
          DATA_IN[5]), .B1 (nx238)) ;
    nand02 ix117 (.Y (nx116), .A0 (nx272), .A1 (nx207)) ;
    dff ix114 (.Q (COUNT[5]), .QB (nx207), .D (nx111), .CLK (CLK3)) ;
    dff ix124 (.Q (COUNT[6]), .QB (\$dummy [5]), .D (nx121), .CLK (CLK3)) ;
    ao21 ix122 (.Y (nx121), .A0 (COUNT[6]), .A1 (nx242), .B0 (nx119)) ;
    nor02 ix120 (.Y (nx119), .A0 (nx260), .A1 (nx242)) ;
    aoi32 ix216 (.Y (nx215), .A0 (nx270), .A1 (nx218), .A2 (nx246), .B0 (
          DATA_IN[6]), .B1 (nx238)) ;
    nand02 ix219 (.Y (nx218), .A0 (COUNT[6]), .A1 (nx53)) ;
    dff ix134 (.Q (COUNT[7]), .QB (\$dummy [6]), .D (nx131), .CLK (CLK3)) ;
    ao21 ix132 (.Y (nx131), .A0 (COUNT[7]), .A1 (nx242), .B0 (nx129)) ;
    nor02 ix130 (.Y (nx129), .A0 (nx262), .A1 (nx242)) ;
    aoi32 ix226 (.Y (nx225), .A0 (nx160), .A1 (nx228), .A2 (nx246), .B0 (
          DATA_IN[7]), .B1 (nx238)) ;
    ao21 ix161 (.Y (nx160), .A0 (COUNT[6]), .A1 (nx53), .B0 (COUNT[7])) ;
    nand02 ix229 (.Y (nx228), .A0 (COUNT[7]), .A1 (nx54)) ;
    inv02 ix159 (.Y (nx54), .A (nx218)) ;
    inv02 ix137 (.Y (nx53), .A (nx209)) ;
    inv02 ix73 (.Y (nx50), .A (nx181)) ;
    inv02 ix29 (.Y (nx48), .A (nx154)) ;
    inv02 ix1 (.Y (nx0), .A (nx156)) ;
    inv02 ix181 (.Y (CARRY_OUT), .A (nx228)) ;
    buf02 ix237 (.Y (nx238), .A (nx16)) ;
    buf02 ix239 (.Y (nx240), .A (nx145)) ;
    buf02 ix241 (.Y (nx242), .A (nx145)) ;
    buf02 ix243 (.Y (nx244), .A (nx151)) ;
    inv02 ix245 (.Y (nx246), .A (nx0)) ;
    buf02 ix247 (.Y (nx248), .A (nx167)) ;
    buf02 ix249 (.Y (nx250), .A (nx177)) ;
    inv02 ix251 (.Y (nx252), .A (nx50)) ;
    buf02 ix253 (.Y (nx254), .A (nx187)) ;
    buf02 ix255 (.Y (nx256), .A (nx194)) ;
    buf02 ix257 (.Y (nx258), .A (nx204)) ;
    buf02 ix259 (.Y (nx260), .A (nx215)) ;
    buf02 ix261 (.Y (nx262), .A (nx225)) ;
    xor2 ix77 (.Y (nx76), .A0 (COUNT[3]), .A1 (nx50)) ;
    or02 ix210 (.Y (nx209), .A0 (nx207), .A1 (nx272)) ;
    oai21 ix139 (.Y (nx138), .A0 (nx207), .A1 (nx272), .B0 (nx268)) ;
    inv02 ix267 (.Y (nx268), .A (COUNT[6])) ;
    buf02 ix269 (.Y (nx270), .A (nx138)) ;
    buf02 ix271 (.Y (nx272), .A (nx198)) ;
endmodule


module block16 ( CARRY_OUT, COUNT, MODE0, LOAD, CARRY_IN, COUNT_EN, DATA_IN, 
                  INT_RESET, CLK3 ) ;

    output CARRY_OUT ;
    output [7:0]COUNT ;
    input MODE0 ;
    input LOAD ;
    input CARRY_IN ;
    input COUNT_EN ;
    input [7:0]DATA_IN ;
    input INT_RESET ;
    input CLK3 ;

    wire nx0, nx6, nx10, nx362, nx32, nx54, nx364, nx78, nx94, nx365, nx118, 
         nx140, nx367, nx162, nx372, nx374, nx382, nx384, nx392, nx394, nx402, 
         nx404, nx412, nx414, nx422, nx424, nx432, nx434, nx442, nx444, nx456, 
         nx460, nx463, nx465, nx468, nx474, nx477, nx483, nx487, nx493, nx500, 
         nx504, nx510, nx514, nx520, nx530, nx541, nx543, nx545, nx547, nx549, 
         nx551, nx553, nx555, nx557, nx559, nx561, nx563, nx565, nx567, nx573, 
         nx575;
    wire [7:0] \$dummy ;




    dff ix377 (.Q (COUNT[0]), .QB (\$dummy [0]), .D (nx374), .CLK (CLK3)) ;
    ao21 ix375 (.Y (nx374), .A0 (COUNT[0]), .A1 (nx543), .B0 (nx372)) ;
    nor02 ix457 (.Y (nx456), .A0 (nx0), .A1 (COUNT_EN)) ;
    nor02 ix373 (.Y (nx372), .A0 (nx547), .A1 (nx543)) ;
    aoi32 ix461 (.Y (nx460), .A0 (nx10), .A1 (nx463), .A2 (nx549), .B0 (
          DATA_IN[0]), .B1 (nx541)) ;
    or02 ix11 (.Y (nx10), .A0 (COUNT[0]), .A1 (CARRY_IN)) ;
    nand02 ix464 (.Y (nx463), .A0 (CARRY_IN), .A1 (COUNT[0])) ;
    nor02 ix466 (.Y (nx465), .A0 (LOAD), .A1 (INT_RESET)) ;
    nor02 ix7 (.Y (nx6), .A0 (INT_RESET), .A1 (nx468)) ;
    inv02 ix469 (.Y (nx468), .A (LOAD)) ;
    dff ix387 (.Q (COUNT[1]), .QB (\$dummy [1]), .D (nx384), .CLK (CLK3)) ;
    ao21 ix385 (.Y (nx384), .A0 (COUNT[1]), .A1 (nx543), .B0 (nx382)) ;
    nor02 ix383 (.Y (nx382), .A0 (nx551), .A1 (nx543)) ;
    aoi32 ix475 (.Y (nx474), .A0 (nx32), .A1 (nx549), .A2 (nx477), .B0 (
          DATA_IN[1]), .B1 (nx541)) ;
    ao21 ix33 (.Y (nx32), .A0 (CARRY_IN), .A1 (COUNT[0]), .B0 (COUNT[1])) ;
    nand03 ix478 (.Y (nx477), .A0 (COUNT[1]), .A1 (CARRY_IN), .A2 (COUNT[0])) ;
    dff ix397 (.Q (COUNT[2]), .QB (\$dummy [2]), .D (nx394), .CLK (CLK3)) ;
    ao21 ix395 (.Y (nx394), .A0 (COUNT[2]), .A1 (nx543), .B0 (nx392)) ;
    nor02 ix393 (.Y (nx392), .A0 (nx553), .A1 (nx543)) ;
    aoi32 ix484 (.Y (nx483), .A0 (nx54), .A1 (nx555), .A2 (nx549), .B0 (
          DATA_IN[2]), .B1 (nx541)) ;
    ao21 ix55 (.Y (nx54), .A0 (COUNT[1]), .A1 (nx362), .B0 (COUNT[2])) ;
    nand04 ix488 (.Y (nx487), .A0 (COUNT[2]), .A1 (COUNT[1]), .A2 (CARRY_IN), .A3 (
           COUNT[0])) ;
    dff ix407 (.Q (COUNT[3]), .QB (\$dummy [3]), .D (nx404), .CLK (CLK3)) ;
    ao21 ix405 (.Y (nx404), .A0 (COUNT[3]), .A1 (nx543), .B0 (nx402)) ;
    nor02 ix403 (.Y (nx402), .A0 (nx557), .A1 (nx543)) ;
    aoi22 ix494 (.Y (nx493), .A0 (DATA_IN[3]), .A1 (nx541), .B0 (nx78), .B1 (
          nx549)) ;
    dff ix417 (.Q (COUNT[4]), .QB (\$dummy [4]), .D (nx414), .CLK (CLK3)) ;
    ao21 ix415 (.Y (nx414), .A0 (COUNT[4]), .A1 (nx543), .B0 (nx412)) ;
    nor02 ix413 (.Y (nx412), .A0 (nx559), .A1 (nx543)) ;
    aoi32 ix501 (.Y (nx500), .A0 (nx94), .A1 (nx504), .A2 (nx549), .B0 (
          DATA_IN[4]), .B1 (nx541)) ;
    ao21 ix95 (.Y (nx94), .A0 (COUNT[3]), .A1 (nx364), .B0 (COUNT[4])) ;
    nand03 ix505 (.Y (nx504), .A0 (nx364), .A1 (COUNT[4]), .A2 (COUNT[3])) ;
    dff ix427 (.Q (COUNT[5]), .QB (\$dummy [5]), .D (nx424), .CLK (CLK3)) ;
    ao21 ix425 (.Y (nx424), .A0 (COUNT[5]), .A1 (nx545), .B0 (nx422)) ;
    nor02 ix423 (.Y (nx422), .A0 (nx561), .A1 (nx545)) ;
    aoi32 ix511 (.Y (nx510), .A0 (nx118), .A1 (nx514), .A2 (nx549), .B0 (
          DATA_IN[5]), .B1 (nx541)) ;
    or02 ix119 (.Y (nx118), .A0 (nx365), .A1 (COUNT[5])) ;
    nand02 ix515 (.Y (nx514), .A0 (COUNT[5]), .A1 (nx365)) ;
    dff ix437 (.Q (COUNT[6]), .QB (\$dummy [6]), .D (nx434), .CLK (CLK3)) ;
    ao21 ix435 (.Y (nx434), .A0 (COUNT[6]), .A1 (nx545), .B0 (nx432)) ;
    nor02 ix433 (.Y (nx432), .A0 (nx563), .A1 (nx545)) ;
    aoi32 ix521 (.Y (nx520), .A0 (nx140), .A1 (nx565), .A2 (nx549), .B0 (
          DATA_IN[6]), .B1 (nx541)) ;
    ao21 ix141 (.Y (nx140), .A0 (COUNT[5]), .A1 (nx365), .B0 (COUNT[6])) ;
    dff ix447 (.Q (COUNT[7]), .QB (\$dummy [7]), .D (nx444), .CLK (CLK3)) ;
    ao21 ix445 (.Y (nx444), .A0 (COUNT[7]), .A1 (nx545), .B0 (nx442)) ;
    nor02 ix443 (.Y (nx442), .A0 (nx567), .A1 (nx545)) ;
    aoi22 ix531 (.Y (nx530), .A0 (DATA_IN[7]), .A1 (nx541), .B0 (nx162), .B1 (
          nx549)) ;
    ao22 ix181 (.Y (CARRY_OUT), .A0 (MODE0), .A1 (nx365), .B0 (COUNT[7]), .B1 (
         nx575)) ;
    inv02 ix117 (.Y (nx365), .A (nx504)) ;
    inv02 ix75 (.Y (nx364), .A (nx487)) ;
    inv02 ix31 (.Y (nx362), .A (nx463)) ;
    inv02 ix1 (.Y (nx0), .A (nx465)) ;
    buf02 ix540 (.Y (nx541), .A (nx6)) ;
    buf02 ix542 (.Y (nx543), .A (nx456)) ;
    buf02 ix544 (.Y (nx545), .A (nx456)) ;
    buf02 ix546 (.Y (nx547), .A (nx460)) ;
    inv02 ix548 (.Y (nx549), .A (nx0)) ;
    buf02 ix550 (.Y (nx551), .A (nx474)) ;
    buf02 ix552 (.Y (nx553), .A (nx483)) ;
    inv02 ix554 (.Y (nx555), .A (nx364)) ;
    buf02 ix556 (.Y (nx557), .A (nx493)) ;
    buf02 ix558 (.Y (nx559), .A (nx500)) ;
    buf02 ix560 (.Y (nx561), .A (nx510)) ;
    buf02 ix562 (.Y (nx563), .A (nx520)) ;
    inv02 ix564 (.Y (nx565), .A (nx367)) ;
    buf02 ix566 (.Y (nx567), .A (nx530)) ;
    xor2 ix79 (.Y (nx78), .A0 (COUNT[3]), .A1 (nx364)) ;
    nor02 ix524 (.Y (nx367), .A0 (nx573), .A1 (nx514)) ;
    inv02 ix572 (.Y (nx573), .A (COUNT[6])) ;
    xor2 ix163 (.Y (nx162), .A0 (COUNT[7]), .A1 (nx575)) ;
    inv02 ix574 (.Y (nx575), .A (nx565)) ;
endmodule


module block15 ( INTR_EN0, INTR_EN1, INTR_PRI0, INTR_PRI1, INTR_VECTOR, 
                  INTR_ACKNOW, EXCEPTION, INTR_LCALL, INTR_SOURCE, REG_RESULT, 
                  SFR_WRITE_EN, INTR_RET, STATE, LAST_CYC, CLK3_EN, 
                  INTERNAL_WAIT, CLK1, CLK2, INTERNAL_RESET ) ;

    output [7:0]INTR_EN0 ;
    output [7:0]INTR_EN1 ;
    output [7:0]INTR_PRI0 ;
    output [7:0]INTR_PRI1 ;
    output [7:0]INTR_VECTOR ;
    output [13:0]INTR_ACKNOW ;
    output EXCEPTION ;
    output INTR_LCALL ;
    input [13:0]INTR_SOURCE ;
    input [7:0]REG_RESULT ;
    input [14:11]SFR_WRITE_EN ;
    input INTR_RET ;
    input [0:0]STATE ;
    input LAST_CYC ;
    input CLK3_EN ;
    input INTERNAL_WAIT ;
    input CLK1 ;
    input CLK2 ;
    input INTERNAL_RESET ;

    wire SOURCES_4_, nx2, nx8, nx24, SOURCES_0_, SOURCES_1_, SOURCES_2_, 
         SOURCES_3_, SOURCES_6_, SOURCES_5_, SOURCES_7_, SOURCES_8_, SOURCES_9_, 
         SOURCES_10_, SOURCES_13_, SOURCES_11_, SOURCES_12_, nx420, nx422, nx426, 
         nx428, nx430, nx434, nx436, nx438, nx440, nx444, nx454, nx456, nx458, 
         nx460, nx470, nx472, nx474, nx476, nx486, nx488, nx496, nx498, nx504, 
         nx514, nx516, nx526, nx532, nx546, nx560, nx570, nx572, nx576, nx578, 
         nx600, nx602, nx608, nx618, nx624, nx628, nx670, nx678, nx686, nx714, 
         nx726, nx744, nx778, nx816, nx826, nx836, SERVICE_LEVEL_1, nx854, 
         SERVICE_LEVEL_0, nx870, nx880, nx884, nx894, nx904, nx914, nx932, nx934, 
         nx944, nx954, nx972, nx976, nx992, nx998, nx83, nx93, nx101, nx103, 
         nx113, nx123, nx133, nx141, nx143, nx153, nx163, nx171, nx173, nx183, 
         nx193, nx201, nx203, nx213, nx223, nx231, nx233, nx243, nx253, nx261, 
         nx263, nx273, nx283, nx291, nx293, nx303, nx313, nx321, nx323, nx333, 
         nx343, nx351, nx353, nx363, nx373, nx381, nx383, nx393, nx403, nx411, 
         nx413, nx423, nx433, nx441, nx443, nx453, nx463, nx471, nx473, nx483, 
         nx493, nx501, nx503, nx513, nx523, nx533, nx543, nx553, nx563, nx573, 
         nx587, nx589, nx593, nx599, nx607, nx623, nx631, nx633, nx635, nx641, 
         nx645, nx647, nx653, nx665, nx669, nx685, nx700, nx701, nx716, nx729, 
         nx730, nx745, nx759, nx761, nx776, nx789, nx790, nx808, nx821, nx822, 
         nx838, nx855, nx856, nx859, nx861, nx867, nx871, nx875, nx879, nx883, 
         nx893, nx897, nx899, nx903, nx907, nx911, nx917, nx923, nx929, nx931, 
         nx935, nx951, nx957, nx969, nx983, nx988, nx991, nx993, nx995, nx997, 
         nx999, nx1003, nx1006, nx1008, nx1017, nx1023, nx1027, nx1029, nx1037, 
         nx1039, nx1045, nx1050, nx1052, nx1055, nx1057, nx1061, nx1064, nx1067, 
         nx1069, nx1073, nx1080, nx1082, nx1085, nx1088, nx1090, nx1095, nx1097, 
         nx1106, nx1113, nx1119, nx1122, nx1129, nx1134, nx1161, nx1163, nx1165, 
         nx1167, nx1169, nx1171, nx1173, nx1175, nx1177, nx1179, nx1181, nx1183, 
         nx1185, nx1189, nx1191, nx1193, nx1195, nx1197, nx1199, nx1201, nx1203, 
         nx1205, nx1207, nx1209, nx1211, nx1213, nx1215, nx1217, nx1219, nx1221, 
         nx1223, nx1225, nx1227, nx1229, nx1231, nx1233, nx1235, nx1237, nx1239, 
         nx1241, nx1243, nx1245, nx1247, nx1249, nx1251, nx1253, nx1255, nx1257, 
         nx1259, nx1261, nx1263, nx1265, nx1267, nx1269, nx1271, nx1273, nx1275, 
         nx1277, nx1279, nx1281, nx1285, nx1287, nx1289, nx1291, nx1293, nx1295, 
         nx1299, nx1301, nx1303, nx1309, nx1311, nx1317, nx1319, nx1321, nx1323, 
         nx1325, nx1327, nx1329, nx1331, nx1333;
    wire [33:0] \$dummy ;




    assign INTR_VECTOR[2] = INTR_VECTOR[7] ;
    assign INTR_VECTOR[0] = INTR_VECTOR[7] ;
    assign INTR_ACKNOW[4] = INTR_VECTOR[7] ;
    fake_gnd ix39 (.Y (INTR_VECTOR[7])) ;
    nand04 ix785 (.Y (INTR_VECTOR[6]), .A0 (nx587), .A1 (nx1201), .A2 (nx995), .A3 (
           nx999)) ;
    nand04 ix590 (.Y (nx589), .A0 (nx1177), .A1 (nx897), .A2 (nx1267), .A3 (
           nx1269)) ;
    nand03 ix594 (.Y (nx593), .A0 (nx470), .A1 (nx879), .A2 (nx883)) ;
    nand02 ix600 (.Y (nx599), .A0 (SOURCES_4_), .A1 (nx422)) ;
    dff ix106 (.Q (SOURCES_4_), .QB (nx635), .D (nx103), .CLK (CLK1)) ;
    ao21 ix104 (.Y (nx103), .A0 (SOURCES_4_), .A1 (nx1233), .B0 (nx101)) ;
    inv02 ix608 (.Y (nx607), .A (CLK3_EN)) ;
    and04 ix102 (.Y (nx101), .A0 (nx1165), .A1 (INTR_SOURCE[4]), .A2 (
          INTR_EN0[4]), .A3 (nx1161)) ;
    and02 ix25 (.Y (nx24), .A0 (nx1237), .A1 (INTR_EN0[7])) ;
    dff ix86 (.Q (INTR_EN0[7]), .QB (\$dummy [0]), .D (nx83), .CLK (CLK2)) ;
    ao32 ix84 (.Y (nx83), .A0 (REG_RESULT[7]), .A1 (nx1237), .A2 (
         SFR_WRITE_EN[11]), .B0 (INTR_EN0[7]), .B1 (nx1245)) ;
    nor02 ix624 (.Y (nx623), .A0 (SFR_WRITE_EN[11]), .A1 (INTERNAL_RESET)) ;
    dff ix96 (.Q (INTR_EN0[4]), .QB (\$dummy [1]), .D (nx93), .CLK (CLK2)) ;
    ao32 ix94 (.Y (nx93), .A0 (REG_RESULT[4]), .A1 (nx1237), .A2 (
         SFR_WRITE_EN[11]), .B0 (INTR_EN0[4]), .B1 (nx1245)) ;
    oai21 ix9 (.Y (nx8), .A0 (CLK3_EN), .A1 (nx631), .B0 (nx1237)) ;
    nand02 ix632 (.Y (nx631), .A0 (nx633), .A1 (LAST_CYC)) ;
    inv02 ix634 (.Y (nx633), .A (INTERNAL_WAIT)) ;
    xnor2 ix423 (.Y (nx422), .A0 (INTR_PRI0[4]), .A1 (nx1169)) ;
    dff ix116 (.Q (INTR_PRI0[4]), .QB (\$dummy [2]), .D (nx113), .CLK (CLK2)) ;
    ao32 ix114 (.Y (nx113), .A0 (REG_RESULT[4]), .A1 (nx1237), .A2 (
         SFR_WRITE_EN[12]), .B0 (INTR_PRI0[4]), .B1 (nx1247)) ;
    nor02 ix642 (.Y (nx641), .A0 (SFR_WRITE_EN[12]), .A1 (INTERNAL_RESET)) ;
    nand04 ix421 (.Y (nx420), .A0 (nx645), .A1 (nx1259), .A2 (nx1261), .A3 (
           nx1263)) ;
    and03 ix646 (.Y (nx645), .A0 (nx1249), .A1 (nx1255), .A2 (nx1257)) ;
    aoi222 ix648 (.Y (nx647), .A0 (INTR_PRI1[6]), .A1 (SOURCES_12_), .B0 (
           INTR_PRI1[5]), .B1 (SOURCES_11_), .C0 (INTR_PRI1[7]), .C1 (
           SOURCES_13_)) ;
    dff ix486 (.Q (INTR_PRI1[6]), .QB (\$dummy [3]), .D (nx483), .CLK (CLK2)) ;
    ao32 ix484 (.Y (nx483), .A0 (REG_RESULT[6]), .A1 (nx1237), .A2 (
         SFR_WRITE_EN[14]), .B0 (INTR_PRI1[6]), .B1 (nx1251)) ;
    nor02 ix654 (.Y (nx653), .A0 (SFR_WRITE_EN[14]), .A1 (INTERNAL_RESET)) ;
    dff ix506 (.Q (SOURCES_12_), .QB (nx669), .D (nx503), .CLK (CLK1)) ;
    ao21 ix504 (.Y (nx503), .A0 (SOURCES_12_), .A1 (nx1233), .B0 (nx501)) ;
    and04 ix502 (.Y (nx501), .A0 (nx1165), .A1 (INTR_SOURCE[12]), .A2 (
          INTR_EN1[6]), .A3 (nx1161)) ;
    dff ix496 (.Q (INTR_EN1[6]), .QB (\$dummy [4]), .D (nx493), .CLK (CLK2)) ;
    ao32 ix494 (.Y (nx493), .A0 (REG_RESULT[6]), .A1 (nx1237), .A2 (
         SFR_WRITE_EN[13]), .B0 (INTR_EN1[6]), .B1 (nx1253)) ;
    nor02 ix666 (.Y (nx665), .A0 (SFR_WRITE_EN[13]), .A1 (INTERNAL_RESET)) ;
    dff ix456 (.Q (INTR_PRI1[5]), .QB (\$dummy [5]), .D (nx453), .CLK (CLK2)) ;
    ao32 ix454 (.Y (nx453), .A0 (REG_RESULT[5]), .A1 (nx1237), .A2 (
         SFR_WRITE_EN[14]), .B0 (INTR_PRI1[5]), .B1 (nx1251)) ;
    dff ix476 (.Q (SOURCES_11_), .QB (nx685), .D (nx473), .CLK (CLK1)) ;
    ao21 ix474 (.Y (nx473), .A0 (SOURCES_11_), .A1 (nx1233), .B0 (nx471)) ;
    and04 ix472 (.Y (nx471), .A0 (nx1165), .A1 (INTR_SOURCE[11]), .A2 (
          INTR_EN1[5]), .A3 (nx1161)) ;
    dff ix466 (.Q (INTR_EN1[5]), .QB (\$dummy [6]), .D (nx463), .CLK (CLK2)) ;
    ao32 ix464 (.Y (nx463), .A0 (REG_RESULT[5]), .A1 (nx1237), .A2 (
         SFR_WRITE_EN[13]), .B0 (INTR_EN1[5]), .B1 (nx1253)) ;
    dff ix426 (.Q (INTR_PRI1[7]), .QB (\$dummy [7]), .D (nx423), .CLK (CLK2)) ;
    ao32 ix424 (.Y (nx423), .A0 (REG_RESULT[7]), .A1 (nx1237), .A2 (
         SFR_WRITE_EN[14]), .B0 (INTR_PRI1[7]), .B1 (nx1251)) ;
    dff ix446 (.Q (SOURCES_13_), .QB (nx700), .D (nx443), .CLK (CLK1)) ;
    ao21 ix444 (.Y (nx443), .A0 (SOURCES_13_), .A1 (nx1233), .B0 (nx441)) ;
    and04 ix442 (.Y (nx441), .A0 (nx1165), .A1 (INTR_SOURCE[13]), .A2 (
          INTR_EN1[7]), .A3 (nx1161)) ;
    dff ix436 (.Q (INTR_EN1[7]), .QB (\$dummy [8]), .D (nx433), .CLK (CLK2)) ;
    ao32 ix434 (.Y (nx433), .A0 (REG_RESULT[7]), .A1 (nx1239), .A2 (
         SFR_WRITE_EN[13]), .B0 (INTR_EN1[7]), .B1 (nx1253)) ;
    aoi22 ix702 (.Y (nx701), .A0 (INTR_PRI1[4]), .A1 (SOURCES_10_), .B0 (
          INTR_PRI1[3]), .B1 (SOURCES_9_)) ;
    dff ix396 (.Q (INTR_PRI1[4]), .QB (\$dummy [9]), .D (nx393), .CLK (CLK2)) ;
    ao32 ix394 (.Y (nx393), .A0 (REG_RESULT[4]), .A1 (nx1239), .A2 (
         SFR_WRITE_EN[14]), .B0 (INTR_PRI1[4]), .B1 (nx1251)) ;
    dff ix416 (.Q (SOURCES_10_), .QB (nx716), .D (nx413), .CLK (CLK1)) ;
    ao21 ix414 (.Y (nx413), .A0 (SOURCES_10_), .A1 (nx1233), .B0 (nx411)) ;
    and04 ix412 (.Y (nx411), .A0 (nx1165), .A1 (INTR_SOURCE[10]), .A2 (
          INTR_EN1[4]), .A3 (nx1161)) ;
    dff ix406 (.Q (INTR_EN1[4]), .QB (\$dummy [10]), .D (nx403), .CLK (CLK2)) ;
    ao32 ix404 (.Y (nx403), .A0 (REG_RESULT[4]), .A1 (nx1239), .A2 (
         SFR_WRITE_EN[13]), .B0 (INTR_EN1[4]), .B1 (nx1253)) ;
    dff ix366 (.Q (INTR_PRI1[3]), .QB (\$dummy [11]), .D (nx363), .CLK (CLK2)) ;
    ao32 ix364 (.Y (nx363), .A0 (REG_RESULT[3]), .A1 (nx1239), .A2 (
         SFR_WRITE_EN[14]), .B0 (INTR_PRI1[3]), .B1 (nx1251)) ;
    dff ix386 (.Q (SOURCES_9_), .QB (nx729), .D (nx383), .CLK (CLK1)) ;
    ao21 ix384 (.Y (nx383), .A0 (SOURCES_9_), .A1 (nx1233), .B0 (nx381)) ;
    and04 ix382 (.Y (nx381), .A0 (nx1165), .A1 (INTR_SOURCE[9]), .A2 (
          INTR_EN1[3]), .A3 (nx1161)) ;
    dff ix376 (.Q (INTR_EN1[3]), .QB (\$dummy [12]), .D (nx373), .CLK (CLK2)) ;
    ao32 ix374 (.Y (nx373), .A0 (REG_RESULT[3]), .A1 (nx1239), .A2 (
         SFR_WRITE_EN[13]), .B0 (INTR_EN1[3]), .B1 (nx1253)) ;
    aoi22 ix731 (.Y (nx730), .A0 (INTR_PRI1[2]), .A1 (SOURCES_8_), .B0 (
          INTR_PRI1[1]), .B1 (SOURCES_7_)) ;
    dff ix336 (.Q (INTR_PRI1[2]), .QB (\$dummy [13]), .D (nx333), .CLK (CLK2)) ;
    ao32 ix334 (.Y (nx333), .A0 (REG_RESULT[2]), .A1 (nx1239), .A2 (
         SFR_WRITE_EN[14]), .B0 (INTR_PRI1[2]), .B1 (nx1251)) ;
    dff ix356 (.Q (SOURCES_8_), .QB (nx745), .D (nx353), .CLK (CLK1)) ;
    ao21 ix354 (.Y (nx353), .A0 (SOURCES_8_), .A1 (nx1233), .B0 (nx351)) ;
    and04 ix352 (.Y (nx351), .A0 (nx1165), .A1 (INTR_SOURCE[8]), .A2 (
          INTR_EN1[2]), .A3 (nx1161)) ;
    dff ix346 (.Q (INTR_EN1[2]), .QB (\$dummy [14]), .D (nx343), .CLK (CLK2)) ;
    ao32 ix344 (.Y (nx343), .A0 (REG_RESULT[2]), .A1 (nx1239), .A2 (
         SFR_WRITE_EN[13]), .B0 (INTR_EN1[2]), .B1 (nx1253)) ;
    dff ix306 (.Q (INTR_PRI1[1]), .QB (\$dummy [15]), .D (nx303), .CLK (CLK2)) ;
    ao32 ix304 (.Y (nx303), .A0 (REG_RESULT[1]), .A1 (nx1239), .A2 (
         SFR_WRITE_EN[14]), .B0 (INTR_PRI1[1]), .B1 (nx1251)) ;
    dff ix326 (.Q (SOURCES_7_), .QB (nx759), .D (nx323), .CLK (CLK1)) ;
    ao21 ix324 (.Y (nx323), .A0 (SOURCES_7_), .A1 (nx1233), .B0 (nx321)) ;
    and04 ix322 (.Y (nx321), .A0 (nx1165), .A1 (INTR_SOURCE[7]), .A2 (
          INTR_EN1[1]), .A3 (nx1161)) ;
    dff ix316 (.Q (INTR_EN1[1]), .QB (\$dummy [16]), .D (nx313), .CLK (CLK2)) ;
    ao32 ix314 (.Y (nx313), .A0 (REG_RESULT[1]), .A1 (nx1239), .A2 (
         SFR_WRITE_EN[13]), .B0 (INTR_EN1[1]), .B1 (nx1253)) ;
    aoi222 ix762 (.Y (nx761), .A0 (INTR_PRI0[5]), .A1 (SOURCES_5_), .B0 (
           INTR_PRI0[4]), .B1 (SOURCES_4_), .C0 (INTR_PRI1[0]), .C1 (SOURCES_6_)
           ) ;
    dff ix276 (.Q (INTR_PRI0[5]), .QB (\$dummy [17]), .D (nx273), .CLK (CLK2)) ;
    ao32 ix274 (.Y (nx273), .A0 (REG_RESULT[5]), .A1 (nx1241), .A2 (
         SFR_WRITE_EN[12]), .B0 (INTR_PRI0[5]), .B1 (nx1247)) ;
    dff ix296 (.Q (SOURCES_5_), .QB (nx776), .D (nx293), .CLK (CLK1)) ;
    ao21 ix294 (.Y (nx293), .A0 (SOURCES_5_), .A1 (nx1233), .B0 (nx291)) ;
    and04 ix292 (.Y (nx291), .A0 (nx1167), .A1 (INTR_SOURCE[5]), .A2 (
          INTR_EN0[5]), .A3 (nx1161)) ;
    dff ix286 (.Q (INTR_EN0[5]), .QB (\$dummy [18]), .D (nx283), .CLK (CLK2)) ;
    ao32 ix284 (.Y (nx283), .A0 (REG_RESULT[5]), .A1 (nx1241), .A2 (
         SFR_WRITE_EN[11]), .B0 (INTR_EN0[5]), .B1 (nx1245)) ;
    dff ix246 (.Q (INTR_PRI1[0]), .QB (\$dummy [19]), .D (nx243), .CLK (CLK2)) ;
    ao32 ix244 (.Y (nx243), .A0 (REG_RESULT[0]), .A1 (nx1241), .A2 (
         SFR_WRITE_EN[14]), .B0 (INTR_PRI1[0]), .B1 (nx1251)) ;
    dff ix266 (.Q (SOURCES_6_), .QB (nx789), .D (nx263), .CLK (CLK1)) ;
    ao21 ix264 (.Y (nx263), .A0 (SOURCES_6_), .A1 (nx1233), .B0 (nx261)) ;
    and04 ix262 (.Y (nx261), .A0 (nx1167), .A1 (INTR_SOURCE[6]), .A2 (
          INTR_EN1[0]), .A3 (nx1161)) ;
    dff ix256 (.Q (INTR_EN1[0]), .QB (\$dummy [20]), .D (nx253), .CLK (CLK2)) ;
    ao32 ix254 (.Y (nx253), .A0 (REG_RESULT[0]), .A1 (nx1241), .A2 (
         SFR_WRITE_EN[13]), .B0 (INTR_EN1[0]), .B1 (nx1253)) ;
    aoi22 ix792 (.Y (nx790), .A0 (INTR_PRI0[3]), .A1 (SOURCES_3_), .B0 (
          INTR_PRI0[2]), .B1 (SOURCES_2_)) ;
    dff ix216 (.Q (INTR_PRI0[3]), .QB (\$dummy [21]), .D (nx213), .CLK (CLK2)) ;
    ao32 ix214 (.Y (nx213), .A0 (REG_RESULT[3]), .A1 (nx1241), .A2 (
         SFR_WRITE_EN[12]), .B0 (INTR_PRI0[3]), .B1 (nx1247)) ;
    dff ix236 (.Q (SOURCES_3_), .QB (nx808), .D (nx233), .CLK (CLK1)) ;
    ao21 ix234 (.Y (nx233), .A0 (SOURCES_3_), .A1 (nx1235), .B0 (nx231)) ;
    and04 ix232 (.Y (nx231), .A0 (nx1167), .A1 (INTR_SOURCE[3]), .A2 (
          INTR_EN0[3]), .A3 (nx1163)) ;
    dff ix226 (.Q (INTR_EN0[3]), .QB (\$dummy [22]), .D (nx223), .CLK (CLK2)) ;
    ao32 ix224 (.Y (nx223), .A0 (REG_RESULT[3]), .A1 (nx1241), .A2 (
         SFR_WRITE_EN[11]), .B0 (INTR_EN0[3]), .B1 (nx1245)) ;
    dff ix186 (.Q (INTR_PRI0[2]), .QB (\$dummy [23]), .D (nx183), .CLK (CLK2)) ;
    ao32 ix184 (.Y (nx183), .A0 (REG_RESULT[2]), .A1 (nx1241), .A2 (
         SFR_WRITE_EN[12]), .B0 (INTR_PRI0[2]), .B1 (nx1247)) ;
    dff ix206 (.Q (SOURCES_2_), .QB (nx821), .D (nx203), .CLK (CLK1)) ;
    ao21 ix204 (.Y (nx203), .A0 (SOURCES_2_), .A1 (nx1235), .B0 (nx201)) ;
    and04 ix202 (.Y (nx201), .A0 (nx1167), .A1 (INTR_SOURCE[2]), .A2 (
          INTR_EN0[2]), .A3 (nx1163)) ;
    dff ix196 (.Q (INTR_EN0[2]), .QB (\$dummy [24]), .D (nx193), .CLK (CLK2)) ;
    ao32 ix194 (.Y (nx193), .A0 (REG_RESULT[2]), .A1 (nx1241), .A2 (
         SFR_WRITE_EN[11]), .B0 (INTR_EN0[2]), .B1 (nx1245)) ;
    aoi22 ix824 (.Y (nx822), .A0 (INTR_PRI0[1]), .A1 (SOURCES_1_), .B0 (
          INTR_PRI0[0]), .B1 (SOURCES_0_)) ;
    dff ix156 (.Q (INTR_PRI0[1]), .QB (\$dummy [25]), .D (nx153), .CLK (CLK2)) ;
    ao32 ix154 (.Y (nx153), .A0 (REG_RESULT[1]), .A1 (nx1241), .A2 (
         SFR_WRITE_EN[12]), .B0 (INTR_PRI0[1]), .B1 (nx1247)) ;
    dff ix176 (.Q (SOURCES_1_), .QB (nx838), .D (nx173), .CLK (CLK1)) ;
    ao21 ix174 (.Y (nx173), .A0 (SOURCES_1_), .A1 (nx1235), .B0 (nx171)) ;
    and04 ix172 (.Y (nx171), .A0 (nx1167), .A1 (INTR_SOURCE[1]), .A2 (
          INTR_EN0[1]), .A3 (nx1163)) ;
    dff ix166 (.Q (INTR_EN0[1]), .QB (\$dummy [26]), .D (nx163), .CLK (CLK2)) ;
    ao32 ix164 (.Y (nx163), .A0 (REG_RESULT[1]), .A1 (nx1243), .A2 (
         SFR_WRITE_EN[11]), .B0 (INTR_EN0[1]), .B1 (nx1245)) ;
    dff ix126 (.Q (INTR_PRI0[0]), .QB (\$dummy [27]), .D (nx123), .CLK (CLK2)) ;
    ao32 ix124 (.Y (nx123), .A0 (REG_RESULT[0]), .A1 (nx1243), .A2 (
         SFR_WRITE_EN[12]), .B0 (INTR_PRI0[0]), .B1 (nx1247)) ;
    dff ix146 (.Q (SOURCES_0_), .QB (nx855), .D (nx143), .CLK (CLK1)) ;
    ao21 ix144 (.Y (nx143), .A0 (SOURCES_0_), .A1 (nx1235), .B0 (nx141)) ;
    and04 ix142 (.Y (nx141), .A0 (nx1167), .A1 (INTR_SOURCE[0]), .A2 (
          INTR_EN0[0]), .A3 (nx1163)) ;
    dff ix136 (.Q (INTR_EN0[0]), .QB (\$dummy [28]), .D (nx133), .CLK (CLK2)) ;
    ao32 ix134 (.Y (nx133), .A0 (REG_RESULT[0]), .A1 (nx1243), .A2 (
         SFR_WRITE_EN[11]), .B0 (INTR_EN0[0]), .B1 (nx1245)) ;
    nand02 ix857 (.Y (nx856), .A0 (SOURCES_3_), .A1 (nx426)) ;
    xnor2 ix427 (.Y (nx426), .A0 (INTR_PRI0[3]), .A1 (nx1169)) ;
    nand02 ix862 (.Y (nx861), .A0 (SOURCES_1_), .A1 (nx438)) ;
    xnor2 ix439 (.Y (nx438), .A0 (INTR_PRI0[1]), .A1 (nx1169)) ;
    xnor2 ix435 (.Y (nx434), .A0 (INTR_PRI0[0]), .A1 (nx1169)) ;
    nand02 ix868 (.Y (nx867), .A0 (SOURCES_2_), .A1 (nx430)) ;
    xnor2 ix431 (.Y (nx430), .A0 (INTR_PRI0[2]), .A1 (nx1169)) ;
    nand02 ix872 (.Y (nx871), .A0 (SOURCES_5_), .A1 (nx456)) ;
    xnor2 ix457 (.Y (nx456), .A0 (INTR_PRI0[5]), .A1 (nx1169)) ;
    nand02 ix876 (.Y (nx875), .A0 (SOURCES_6_), .A1 (nx460)) ;
    xnor2 ix461 (.Y (nx460), .A0 (INTR_PRI1[0]), .A1 (nx1169)) ;
    nand02 ix880 (.Y (nx879), .A0 (SOURCES_7_), .A1 (nx472)) ;
    xnor2 ix473 (.Y (nx472), .A0 (INTR_PRI1[1]), .A1 (nx1169)) ;
    nand02 ix884 (.Y (nx883), .A0 (SOURCES_8_), .A1 (nx476)) ;
    xnor2 ix477 (.Y (nx476), .A0 (INTR_PRI1[2]), .A1 (nx1169)) ;
    nand02 ix894 (.Y (nx893), .A0 (SOURCES_10_), .A1 (nx504)) ;
    xnor2 ix505 (.Y (nx504), .A0 (INTR_PRI1[4]), .A1 (nx1171)) ;
    nand02 ix900 (.Y (nx899), .A0 (SOURCES_11_), .A1 (nx514)) ;
    xnor2 ix515 (.Y (nx514), .A0 (INTR_PRI1[5]), .A1 (nx1171)) ;
    nand03 ix904 (.Y (nx903), .A0 (nx496), .A1 (nx907), .A2 (nx893)) ;
    nand02 ix908 (.Y (nx907), .A0 (SOURCES_9_), .A1 (nx486)) ;
    xnor2 ix487 (.Y (nx486), .A0 (INTR_PRI1[3]), .A1 (nx1171)) ;
    nor02 ix499 (.Y (nx498), .A0 (nx907), .A1 (nx593)) ;
    nand03 ix918 (.Y (nx917), .A0 (nx454), .A1 (nx871), .A2 (nx875)) ;
    nor02 ix924 (.Y (nx923), .A0 (nx602), .A1 (nx1195)) ;
    nor03 ix601 (.Y (nx600), .A0 (nx929), .A1 (nx935), .A2 (nx903)) ;
    nand03 ix930 (.Y (nx929), .A0 (nx931), .A1 (SOURCES_13_), .A2 (nx899)) ;
    nand02 ix932 (.Y (nx931), .A0 (SOURCES_12_), .A1 (nx578)) ;
    xnor2 ix579 (.Y (nx578), .A0 (INTR_PRI1[6]), .A1 (nx1171)) ;
    xor2 ix936 (.Y (nx935), .A0 (nx1171), .A1 (INTR_PRI1[7])) ;
    nand04 ix577 (.Y (nx576), .A0 (nx1271), .A1 (nx1273), .A2 (nx1275), .A3 (
           nx1277)) ;
    nor02 ix571 (.Y (nx570), .A0 (nx879), .A1 (nx917)) ;
    nand03 ix952 (.Y (nx951), .A0 (nx599), .A1 (nx856), .A2 (nx859)) ;
    nor02 ix561 (.Y (nx560), .A0 (nx871), .A1 (nx951)) ;
    nand03 ix445 (.Y (nx444), .A0 (nx861), .A1 (nx1265), .A2 (nx867)) ;
    nor02 ix547 (.Y (nx546), .A0 (nx856), .A1 (nx444)) ;
    nor02 ix984 (.Y (nx983), .A0 (nx1181), .A1 (nx436)) ;
    nor02 ix533 (.Y (nx532), .A0 (nx436), .A1 (nx861)) ;
    nand04 ix619 (.Y (nx618), .A0 (nx1269), .A1 (nx1267), .A2 (nx1179), .A3 (
           nx1325)) ;
    nor02 ix527 (.Y (nx526), .A0 (nx899), .A1 (nx903)) ;
    nand04 ix609 (.Y (nx608), .A0 (nx1269), .A1 (nx1279), .A2 (nx1175), .A3 (
           nx1327)) ;
    nand04 ix996 (.Y (nx995), .A0 (nx1173), .A1 (nx997), .A2 (nx1279), .A3 (
           nx1269)) ;
    nor02 ix1000 (.Y (nx999), .A0 (nx1213), .A1 (nx1281)) ;
    nor04 ix745 (.Y (nx744), .A0 (nx1195), .A1 (nx1003), .A2 (nx1199), .A3 (
          nx628)) ;
    nand02 ix629 (.Y (nx628), .A0 (nx1267), .A1 (nx1279)) ;
    nor04 ix1007 (.Y (nx1006), .A0 (nx628), .A1 (nx1008), .A2 (nx1197), .A3 (
          nx1195)) ;
    nand04 ix699 (.Y (INTR_VECTOR[3]), .A0 (nx1209), .A1 (nx1207), .A2 (nx1205)
           , .A3 (nx1287)) ;
    nand04 ix687 (.Y (nx686), .A0 (nx1329), .A1 (nx1193), .A2 (nx1331), .A3 (
           nx1273)) ;
    nand04 ix679 (.Y (nx678), .A0 (nx1285), .A1 (nx1185), .A2 (nx1333), .A3 (
           nx1277)) ;
    nand04 ix671 (.Y (nx670), .A0 (nx1285), .A1 (nx1275), .A2 (nx1181), .A3 (
           nx1265)) ;
    nor03 ix1038 (.Y (nx1037), .A0 (nx1289), .A1 (nx1281), .A2 (nx624)) ;
    nand02 ix625 (.Y (nx624), .A0 (nx618), .A1 (nx1201)) ;
    or03 ix1037 (.Y (INTR_VECTOR[4]), .A0 (nx714), .A1 (nx816), .A2 (nx778)) ;
    nand02 ix715 (.Y (nx714), .A0 (nx1050), .A1 (nx1209)) ;
    nand04 ix1051 (.Y (nx1050), .A0 (nx1273), .A1 (nx1191), .A2 (nx1052), .A3 (
           nx1329)) ;
    nand02 ix817 (.Y (nx816), .A0 (nx1055), .A1 (nx1207)) ;
    nand04 ix1056 (.Y (nx1055), .A0 (nx1277), .A1 (nx1183), .A2 (nx1057), .A3 (
           nx1285)) ;
    nand02 ix779 (.Y (nx778), .A0 (nx589), .A1 (nx618)) ;
    nand02 ix1039 (.Y (INTR_VECTOR[5]), .A0 (nx999), .A1 (nx1291)) ;
    nor03 ix1062 (.Y (nx1061), .A0 (nx1211), .A1 (nx714), .A2 (nx1289)) ;
    nor04 ix727 (.Y (nx726), .A0 (nx1064), .A1 (nx1189), .A2 (nx572), .A3 (
          nx1203)) ;
    nand04 ix823 (.Y (INTR_VECTOR[1]), .A0 (nx1067), .A1 (nx1205), .A2 (nx1293)
           , .A3 (nx1291)) ;
    aoi21 ix1070 (.Y (nx1069), .A0 (nx436), .A1 (nx1285), .B0 (INTR_VECTOR[6])
          ) ;
    dff ix546 (.Q (INTR_LCALL), .QB (\$dummy [29]), .D (nx543), .CLK (CLK1)) ;
    ao21 ix544 (.Y (nx543), .A0 (INTR_LCALL), .A1 (nx1295), .B0 (nx870)) ;
    aoi22 ix1074 (.Y (nx1073), .A0 (STATE[0]), .A1 (nx2), .B0 (nx633), .B1 (
          EXCEPTION)) ;
    inv02 ix1081 (.Y (nx1080), .A (INTR_RET)) ;
    dff ix516 (.Q (SERVICE_LEVEL_1), .QB (nx1082), .D (nx1227), .CLK (CLK1)) ;
    mux21 ix514 (.Y (nx513), .A0 (nx1082), .A1 (nx1085), .S0 (nx1217)) ;
    nand03 ix1086 (.Y (nx1085), .A0 (EXCEPTION), .A1 (nx1243), .A2 (nx1169)) ;
    oai21 ix855 (.Y (nx854), .A0 (nx1088), .A1 (nx1090), .B0 (nx1243)) ;
    nor02 ix1089 (.Y (nx1088), .A0 (EXCEPTION), .A1 (INTR_RET)) ;
    nand03 ix1091 (.Y (nx1090), .A0 (CLK3_EN), .A1 (nx633), .A2 (LAST_CYC)) ;
    mux21 ix524 (.Y (nx523), .A0 (nx1095), .A1 (nx1097), .S0 (nx884)) ;
    dff ix526 (.Q (SERVICE_LEVEL_0), .QB (nx1095), .D (nx1229), .CLK (CLK1)) ;
    nand03 ix1098 (.Y (nx1097), .A0 (nx1219), .A1 (nx976), .A2 (EXCEPTION)) ;
    nor03 ix895 (.Y (nx894), .A0 (nx1171), .A1 (INTERNAL_RESET), .A2 (
          SERVICE_LEVEL_0)) ;
    oai222 ix973 (.Y (nx972), .A0 (INTR_PRI1[6]), .A1 (nx669), .B0 (INTR_PRI1[5]
           ), .B1 (nx685), .C0 (INTR_PRI1[7]), .C1 (nx700)) ;
    oai22 ix955 (.Y (nx954), .A0 (INTR_PRI1[4]), .A1 (nx716), .B0 (INTR_PRI1[3])
          , .B1 (nx729)) ;
    oai22 ix945 (.Y (nx944), .A0 (INTR_PRI1[2]), .A1 (nx745), .B0 (INTR_PRI1[1])
          , .B1 (nx759)) ;
    nor03 ix1107 (.Y (nx1106), .A0 (nx1221), .A1 (nx914), .A2 (nx904)) ;
    oai222 ix933 (.Y (nx932), .A0 (INTR_PRI0[5]), .A1 (nx776), .B0 (INTR_PRI0[4]
           ), .B1 (nx635), .C0 (INTR_PRI1[0]), .C1 (nx789)) ;
    oai22 ix915 (.Y (nx914), .A0 (INTR_PRI0[3]), .A1 (nx808), .B0 (INTR_PRI0[2])
          , .B1 (nx821)) ;
    oai22 ix905 (.Y (nx904), .A0 (INTR_PRI0[1]), .A1 (nx838), .B0 (INTR_PRI0[0])
          , .B1 (nx855)) ;
    ao21 ix885 (.Y (nx884), .A0 (nx1217), .A1 (nx880), .B0 (INTERNAL_RESET)) ;
    oai22 ix881 (.Y (nx880), .A0 (SERVICE_LEVEL_0), .A1 (nx1113), .B0 (nx1080), 
          .B1 (SERVICE_LEVEL_1)) ;
    nand04 ix1120 (.Y (nx1119), .A0 (nx1215), .A1 (nx1122), .A2 (LAST_CYC), .A3 (
           nx998)) ;
    nor03 ix837 (.Y (nx836), .A0 (SFR_WRITE_EN[12]), .A1 (SFR_WRITE_EN[14]), .A2 (
          SFR_WRITE_EN[13])) ;
    inv02 ix1123 (.Y (nx1122), .A (SFR_WRITE_EN[11])) ;
    nor02 ix1009 (.Y (INTR_ACKNOW[0]), .A0 (nx1301), .A1 (nx1265)) ;
    dff ix536 (.Q (\$dummy [30]), .QB (nx1129), .D (nx1231), .CLK (CLK1)) ;
    mux21 ix534 (.Y (nx533), .A0 (nx1301), .A1 (nx1299), .S0 (nx826)) ;
    nor02 ix827 (.Y (nx826), .A0 (INTERNAL_WAIT), .A1 (nx607)) ;
    nor02 ix1011 (.Y (INTR_ACKNOW[1]), .A0 (nx1301), .A1 (nx1134)) ;
    nor02 ix1013 (.Y (INTR_ACKNOW[2]), .A0 (nx1301), .A1 (nx1333)) ;
    nor02 ix1015 (.Y (INTR_ACKNOW[3]), .A0 (nx1301), .A1 (nx1057)) ;
    nor02 ix1017 (.Y (INTR_ACKNOW[5]), .A0 (nx1301), .A1 (nx1045)) ;
    nor02 ix1019 (.Y (INTR_ACKNOW[6]), .A0 (nx1301), .A1 (nx1331)) ;
    nor02 ix1021 (.Y (INTR_ACKNOW[7]), .A0 (nx1301), .A1 (nx1052)) ;
    nor02 ix1023 (.Y (INTR_ACKNOW[8]), .A0 (nx1301), .A1 (nx1327)) ;
    nor02 ix1025 (.Y (INTR_ACKNOW[9]), .A0 (nx1301), .A1 (nx997)) ;
    nor02 ix1027 (.Y (INTR_ACKNOW[10]), .A0 (nx1303), .A1 (nx1325)) ;
    nor02 ix1029 (.Y (INTR_ACKNOW[11]), .A0 (nx1303), .A1 (nx897)) ;
    nor02 ix1031 (.Y (INTR_ACKNOW[12]), .A0 (nx1303), .A1 (nx1003)) ;
    nor02 ix1033 (.Y (INTR_ACKNOW[13]), .A0 (nx1303), .A1 (nx1008)) ;
    dff ix556 (.Q (INTR_PRI0[6]), .QB (\$dummy [31]), .D (nx553), .CLK (CLK2)) ;
    ao32 ix554 (.Y (nx553), .A0 (REG_RESULT[6]), .A1 (nx1243), .A2 (
         SFR_WRITE_EN[12]), .B0 (INTR_PRI0[6]), .B1 (nx1247)) ;
    dff ix566 (.Q (INTR_PRI0[7]), .QB (\$dummy [32]), .D (nx563), .CLK (CLK2)) ;
    ao32 ix564 (.Y (nx563), .A0 (REG_RESULT[7]), .A1 (nx1243), .A2 (
         SFR_WRITE_EN[12]), .B0 (INTR_PRI0[7]), .B1 (nx1247)) ;
    dff ix576 (.Q (INTR_EN0[6]), .QB (\$dummy [33]), .D (nx573), .CLK (CLK2)) ;
    ao32 ix574 (.Y (nx573), .A0 (REG_RESULT[6]), .A1 (nx1243), .A2 (
         SFR_WRITE_EN[11]), .B0 (INTR_EN0[6]), .B1 (nx1245)) ;
    inv02 ix935 (.Y (nx934), .A (nx1106)) ;
    inv02 ix871 (.Y (nx870), .A (nx1113)) ;
    inv02 ix1068 (.Y (nx1067), .A (nx816)) ;
    inv02 ix588 (.Y (nx587), .A (nx778)) ;
    inv02 ix1010 (.Y (nx1008), .A (nx600)) ;
    inv02 ix1053 (.Y (nx1052), .A (nx570)) ;
    inv02 ix1046 (.Y (nx1045), .A (nx560)) ;
    inv02 ix1058 (.Y (nx1057), .A (nx546)) ;
    inv02 ix1135 (.Y (nx1134), .A (nx532)) ;
    inv02 ix898 (.Y (nx897), .A (nx526)) ;
    inv02 ix517 (.Y (nx516), .A (nx899)) ;
    inv02 ix998 (.Y (nx997), .A (nx498)) ;
    inv02 ix497 (.Y (nx496), .A (nx593)) ;
    inv02 ix489 (.Y (nx488), .A (nx907)) ;
    inv02 ix475 (.Y (nx474), .A (nx879)) ;
    inv02 ix471 (.Y (nx470), .A (nx917)) ;
    inv02 ix459 (.Y (nx458), .A (nx871)) ;
    inv02 ix455 (.Y (nx454), .A (nx951)) ;
    inv02 ix860 (.Y (nx859), .A (nx444)) ;
    inv02 ix441 (.Y (nx440), .A (nx861)) ;
    inv02 ix429 (.Y (nx428), .A (nx856)) ;
    inv02 ix3 (.Y (nx2), .A (nx631)) ;
    inv02 ix1001 (.Y (EXCEPTION), .A (nx1119)) ;
    inv04 ix1160 (.Y (nx1161), .A (nx1235)) ;
    inv04 ix1162 (.Y (nx1163), .A (nx1235)) ;
    buf02 ix1164 (.Y (nx1165), .A (nx24)) ;
    buf02 ix1166 (.Y (nx1167), .A (nx24)) ;
    buf04 ix1168 (.Y (nx1169), .A (nx1311)) ;
    buf04 ix1170 (.Y (nx1171), .A (nx1311)) ;
    inv02 ix1172 (.Y (nx1173), .A (nx993)) ;
    inv02 ix1174 (.Y (nx1175), .A (nx997)) ;
    inv02 ix1176 (.Y (nx1177), .A (nx988)) ;
    inv02 ix1178 (.Y (nx1179), .A (nx897)) ;
    inv02 ix1180 (.Y (nx1181), .A (nx1134)) ;
    inv02 ix1182 (.Y (nx1183), .A (nx1029)) ;
    inv02 ix1184 (.Y (nx1185), .A (nx1057)) ;
    inv02 ix1188 (.Y (nx1189), .A (nx1045)) ;
    inv02 ix1190 (.Y (nx1191), .A (nx1023)) ;
    inv02 ix1192 (.Y (nx1193), .A (nx1052)) ;
    buf02 ix1194 (.Y (nx1195), .A (nx576)) ;
    inv02 ix1196 (.Y (nx1197), .A (nx1003)) ;
    inv02 ix1198 (.Y (nx1199), .A (nx1008)) ;
    buf02 ix1200 (.Y (nx1201), .A (nx608)) ;
    inv02 ix1202 (.Y (nx1203), .A (nx1017)) ;
    buf02 ix1204 (.Y (nx1205), .A (nx670)) ;
    buf02 ix1206 (.Y (nx1207), .A (nx678)) ;
    buf02 ix1208 (.Y (nx1209), .A (nx686)) ;
    buf02 ix1210 (.Y (nx1211), .A (nx726)) ;
    buf02 ix1212 (.Y (nx1213), .A (nx744)) ;
    buf02 ix1214 (.Y (nx1215), .A (nx836)) ;
    buf02 ix1216 (.Y (nx1217), .A (nx854)) ;
    buf02 ix1218 (.Y (nx1219), .A (nx894)) ;
    buf02 ix1220 (.Y (nx1221), .A (nx932)) ;
    buf02 ix1222 (.Y (nx1223), .A (nx972)) ;
    buf02 ix1224 (.Y (nx1225), .A (nx992)) ;
    buf02 ix1226 (.Y (nx1227), .A (nx513)) ;
    buf02 ix1228 (.Y (nx1229), .A (nx523)) ;
    buf02 ix1230 (.Y (nx1231), .A (nx533)) ;
    inv04 ix1232 (.Y (nx1233), .A (nx8)) ;
    inv04 ix1234 (.Y (nx1235), .A (nx1309)) ;
    inv02 ix1236 (.Y (nx1237), .A (INTERNAL_RESET)) ;
    inv02 ix1238 (.Y (nx1239), .A (INTERNAL_RESET)) ;
    inv02 ix1240 (.Y (nx1241), .A (INTERNAL_RESET)) ;
    inv02 ix1242 (.Y (nx1243), .A (INTERNAL_RESET)) ;
    buf02 ix1244 (.Y (nx1245), .A (nx623)) ;
    buf02 ix1246 (.Y (nx1247), .A (nx641)) ;
    buf02 ix1248 (.Y (nx1249), .A (nx647)) ;
    buf02 ix1250 (.Y (nx1251), .A (nx653)) ;
    buf02 ix1252 (.Y (nx1253), .A (nx665)) ;
    buf02 ix1254 (.Y (nx1255), .A (nx701)) ;
    buf02 ix1256 (.Y (nx1257), .A (nx730)) ;
    buf02 ix1258 (.Y (nx1259), .A (nx761)) ;
    buf02 ix1260 (.Y (nx1261), .A (nx790)) ;
    buf02 ix1262 (.Y (nx1263), .A (nx822)) ;
    inv02 ix1264 (.Y (nx1265), .A (nx436)) ;
    buf02 ix1266 (.Y (nx1267), .A (nx911)) ;
    buf02 ix1268 (.Y (nx1269), .A (nx923)) ;
    inv02 ix1270 (.Y (nx1271), .A (nx572)) ;
    buf02 ix1272 (.Y (nx1273), .A (nx957)) ;
    buf02 ix1274 (.Y (nx1275), .A (nx969)) ;
    buf02 ix1276 (.Y (nx1277), .A (nx983)) ;
    buf02 ix1278 (.Y (nx1279), .A (nx991)) ;
    buf02 ix1280 (.Y (nx1281), .A (nx1006)) ;
    buf02 ix1284 (.Y (nx1285), .A (nx1027)) ;
    buf02 ix1286 (.Y (nx1287), .A (nx1037)) ;
    buf02 ix1288 (.Y (nx1289), .A (nx1039)) ;
    buf02 ix1290 (.Y (nx1291), .A (nx1061)) ;
    buf02 ix1292 (.Y (nx1293), .A (nx1069)) ;
    buf02 ix1294 (.Y (nx1295), .A (nx1073)) ;
    inv02 ix1298 (.Y (nx1299), .A (EXCEPTION)) ;
    buf02 ix1300 (.Y (nx1301), .A (nx1129)) ;
    buf02 ix1302 (.Y (nx1303), .A (nx1129)) ;
    inv02 ix1308 (.Y (nx1309), .A (nx1233)) ;
    buf02 ix1310 (.Y (nx1311), .A (nx420)) ;
    or03 ix513 (.Y (nx988), .A0 (nx593), .A1 (nx488), .A2 (nx893)) ;
    and02 ix865 (.Y (nx436), .A0 (SOURCES_0_), .A1 (nx434)) ;
    and02 ix912 (.Y (nx911), .A0 (nx997), .A1 (nx1327)) ;
    or03 ix485 (.Y (nx993), .A0 (nx917), .A1 (nx474), .A2 (nx883)) ;
    or03 ix587 (.Y (nx1003), .A0 (nx903), .A1 (nx516), .A2 (nx931)) ;
    nand02 ix946 (.Y (nx572), .A0 (nx1052), .A1 (nx1331)) ;
    or03 ix569 (.Y (nx1023), .A0 (nx951), .A1 (nx458), .A2 (nx875)) ;
    and02 ix958 (.Y (nx957), .A0 (nx1045), .A1 (nx1064)) ;
    or03 ix559 (.Y (nx1064), .A0 (nx599), .A1 (nx428), .A2 (nx444)) ;
    and02 ix970 (.Y (nx969), .A0 (nx1057), .A1 (nx1333)) ;
    or03 ix543 (.Y (nx1029), .A0 (nx867), .A1 (nx436), .A2 (nx440)) ;
    and02 ix992 (.Y (nx991), .A0 (nx897), .A1 (nx1325)) ;
    nand02 ix1022 (.Y (nx602), .A0 (nx1008), .A1 (nx1003)) ;
    nor04 ix1028 (.Y (nx1027), .A0 (nx628), .A1 (nx602), .A2 (nx572), .A3 (
          nx1317)) ;
    inv02 ix1316 (.Y (nx1317), .A (nx1273)) ;
    and04 ix1040 (.Y (nx1039), .A0 (nx1329), .A1 (nx1271), .A2 (nx1323), .A3 (
          nx1064)) ;
    nor04 ix645 (.Y (nx1017), .A0 (nx628), .A1 (nx602), .A2 (nx1319), .A3 (
          nx1321)) ;
    inv02 ix1318 (.Y (nx1319), .A (nx1275)) ;
    inv02 ix1320 (.Y (nx1321), .A (nx1277)) ;
    and04 ix1079 (.Y (nx998), .A0 (CLK3_EN), .A1 (nx1080), .A2 (nx1082), .A3 (
          nx1225)) ;
    ao21 ix993 (.Y (nx992), .A0 (nx1095), .A1 (nx976), .B0 (nx1171)) ;
    or02 ix1114 (.Y (nx1113), .A0 (INTERNAL_WAIT), .A1 (nx1119)) ;
    or04 ix1116 (.Y (nx976), .A0 (nx1223), .A1 (nx954), .A2 (nx944), .A3 (nx934)
         ) ;
    inv02 ix1322 (.Y (nx1323), .A (nx1045)) ;
    inv02 ix1324 (.Y (nx1325), .A (nx1177)) ;
    inv02 ix1326 (.Y (nx1327), .A (nx1173)) ;
    inv02 ix1328 (.Y (nx1329), .A (nx1203)) ;
    inv02 ix1330 (.Y (nx1331), .A (nx1191)) ;
    inv02 ix1332 (.Y (nx1333), .A (nx1183)) ;
endmodule


module block14 ( PORT_0, PORT_1, PORT_2, PORT_3, NPORT1E, NPORT2E, NPORT3E, 
                  PORT0O, PORT1O, PORT2O, PORT3O, PORT0I, PORT1I, PORT2I, PORT3I, 
                  SFR_WRITE_EN, REG_RESULT, PORT_CON, INTERNAL_RESET, STATE, 
                  CLK2 ) ;

    output [7:0]PORT_0 ;
    output [7:0]PORT_1 ;
    output [7:0]PORT_2 ;
    output [7:0]PORT_3 ;
    output [7:0]NPORT1E ;
    output [7:0]NPORT2E ;
    output [7:0]NPORT3E ;
    output [7:0]PORT0O ;
    output [7:0]PORT1O ;
    output [7:0]PORT2O ;
    output [7:0]PORT3O ;
    input [7:0]PORT0I ;
    input [7:0]PORT1I ;
    input [7:0]PORT2I ;
    input [7:0]PORT3I ;
    input [3:0]SFR_WRITE_EN ;
    input [7:0]REG_RESULT ;
    input PORT_CON ;
    input INTERNAL_RESET ;
    input [0:0]STATE ;
    input CLK2 ;

    wire nx8, nx32, nx54, nx76, nx98, nx120, nx142, nx164, nx186, nx208, nx228, 
         nx248, nx268, nx288, nx308, nx328, nx348, nx370, nx390, nx410, nx430, 
         nx450, nx470, nx490, nx510, nx532, nx552, nx572, nx592, nx612, nx632, 
         nx652, nx666, nx670, nx680, nx684, nx694, nx698, nx708, nx712, nx722, 
         nx726, nx736, nx740, nx750, nx754, nx764, nx768, nx778, nx782, nx792, 
         nx796, nx806, nx810, nx820, nx824, nx834, nx838, nx848, nx852, nx862, 
         nx866, nx876, nx880, nx890, nx894, nx904, nx908, nx918, nx922, nx932, 
         nx936, nx946, nx950, nx960, nx964, nx974, nx978, nx988, nx992, nx1217, 
         nx1221, nx1229, nx1231, nx1237, nx1241, nx1249, nx1251, nx1257, nx1261, 
         nx1269, nx1271, nx1277, nx1281, nx1289, nx1291, nx1297, nx1301, nx1309, 
         nx1311, nx1317, nx1321, nx1329, nx1331, nx1337, nx1341, nx1349, nx1351, 
         nx1357, nx1361, nx1369, nx1371, nx1377, nx1381, nx1389, nx1391, nx1397, 
         nx1401, nx1409, nx1411, nx1417, nx1421, nx1429, nx1431, nx1437, nx1441, 
         nx1449, nx1451, nx1457, nx1461, nx1469, nx1471, nx1477, nx1481, nx1489, 
         nx1491, nx1497, nx1501, nx1509, nx1511, nx1517, nx1521, nx1529, nx1531, 
         nx1537, nx1541, nx1549, nx1551, nx1557, nx1561, nx1569, nx1571, nx1577, 
         nx1581, nx1589, nx1591, nx1597, nx1601, nx1609, nx1611, nx1617, nx1621, 
         nx1629, nx1631, nx1637, nx1641, nx1649, nx1651, nx1657, nx1661, nx1669, 
         nx1671, nx1677, nx1681, nx1689, nx1691, nx1697, nx1701, nx1709, nx1711, 
         nx1717, nx1721, nx1729, nx1731, nx1737, nx1741, nx1749, nx1751, nx1757, 
         nx1761, nx1769, nx1771, nx1777, nx1781, nx1789, nx1791, nx1797, nx1801, 
         nx1809, nx1811, nx1817, nx1821, nx1829, nx1831, nx1837, nx1841, nx1849, 
         nx1851, nx1863, nx1897, nx1931, nx1965, nx2000, nx2006, nx2012, nx2018, 
         nx2024, nx2030, nx2036, nx2042, nx2111, nx2117, nx2123, nx2129, nx2135, 
         nx2141, nx2147, nx2153, nx2159, nx2165, nx2171, nx2177, nx2183, nx2189, 
         nx2195, nx2201, nx2207, nx2213, nx2219, nx2225, nx2231, nx2237, nx2243, 
         nx2249, nx2255, nx2261, nx2267, nx2273, nx2279, nx2285, nx2291, nx2297, 
         nx2306, nx2308, nx2310, nx2312, nx2318, nx2320, nx2322, nx2324, nx2326, 
         nx2328, nx2330, nx2332, nx2334, nx2336, nx2338, nx2340, nx2342, nx2344, 
         nx2346, nx2348, nx2350, nx2352, nx2354, nx2356, nx2358, nx2360, nx2362, 
         nx2364, nx2366, nx2368, nx2370, nx2372, nx2374;
    wire [87:0] \$dummy ;




    dff ix1714 (.Q (PORT3O[0]), .QB (\$dummy [0]), .D (nx1711), .CLK (CLK2)) ;
    ao21 ix1712 (.Y (nx1711), .A0 (PORT3O[0]), .A1 (nx2306), .B0 (nx1709)) ;
    nor02 ix1864 (.Y (nx1863), .A0 (nx2364), .A1 (nx2320)) ;
    ao21 ix1710 (.Y (nx1709), .A0 (REG_RESULT[0]), .A1 (nx2364), .B0 (nx2320)) ;
    dff ix1734 (.Q (PORT3O[1]), .QB (\$dummy [1]), .D (nx1731), .CLK (CLK2)) ;
    ao21 ix1732 (.Y (nx1731), .A0 (PORT3O[1]), .A1 (nx2306), .B0 (nx1729)) ;
    ao21 ix1730 (.Y (nx1729), .A0 (REG_RESULT[1]), .A1 (nx2364), .B0 (nx2320)) ;
    dff ix1754 (.Q (PORT3O[2]), .QB (\$dummy [2]), .D (nx1751), .CLK (CLK2)) ;
    ao21 ix1752 (.Y (nx1751), .A0 (PORT3O[2]), .A1 (nx2306), .B0 (nx1749)) ;
    ao21 ix1750 (.Y (nx1749), .A0 (REG_RESULT[2]), .A1 (nx2364), .B0 (nx2320)) ;
    dff ix1774 (.Q (PORT3O[3]), .QB (\$dummy [3]), .D (nx1771), .CLK (CLK2)) ;
    ao21 ix1772 (.Y (nx1771), .A0 (PORT3O[3]), .A1 (nx2306), .B0 (nx1769)) ;
    ao21 ix1770 (.Y (nx1769), .A0 (REG_RESULT[3]), .A1 (nx2364), .B0 (nx2320)) ;
    dff ix1794 (.Q (PORT3O[4]), .QB (\$dummy [4]), .D (nx1791), .CLK (CLK2)) ;
    ao21 ix1792 (.Y (nx1791), .A0 (PORT3O[4]), .A1 (nx2306), .B0 (nx1789)) ;
    ao21 ix1790 (.Y (nx1789), .A0 (REG_RESULT[4]), .A1 (nx2364), .B0 (nx2320)) ;
    dff ix1814 (.Q (PORT3O[5]), .QB (\$dummy [5]), .D (nx1811), .CLK (CLK2)) ;
    ao21 ix1812 (.Y (nx1811), .A0 (PORT3O[5]), .A1 (nx2306), .B0 (nx1809)) ;
    ao21 ix1810 (.Y (nx1809), .A0 (REG_RESULT[5]), .A1 (nx2364), .B0 (nx2320)) ;
    dff ix1834 (.Q (PORT3O[6]), .QB (\$dummy [6]), .D (nx1831), .CLK (CLK2)) ;
    ao21 ix1832 (.Y (nx1831), .A0 (PORT3O[6]), .A1 (nx2306), .B0 (nx1829)) ;
    ao21 ix1830 (.Y (nx1829), .A0 (REG_RESULT[6]), .A1 (nx2364), .B0 (nx2320)) ;
    dff ix1854 (.Q (PORT3O[7]), .QB (\$dummy [7]), .D (nx1851), .CLK (CLK2)) ;
    ao21 ix1852 (.Y (nx1851), .A0 (PORT3O[7]), .A1 (nx2306), .B0 (nx1849)) ;
    ao21 ix1850 (.Y (nx1849), .A0 (REG_RESULT[7]), .A1 (nx2364), .B0 (nx2320)) ;
    dff ix1554 (.Q (PORT2O[0]), .QB (\$dummy [8]), .D (nx1551), .CLK (CLK2)) ;
    ao21 ix1552 (.Y (nx1551), .A0 (PORT2O[0]), .A1 (nx2308), .B0 (nx1549)) ;
    nor02 ix1898 (.Y (nx1897), .A0 (nx2368), .A1 (nx2320)) ;
    ao21 ix1550 (.Y (nx1549), .A0 (REG_RESULT[0]), .A1 (nx2368), .B0 (nx2322)) ;
    dff ix1574 (.Q (PORT2O[1]), .QB (\$dummy [9]), .D (nx1571), .CLK (CLK2)) ;
    ao21 ix1572 (.Y (nx1571), .A0 (PORT2O[1]), .A1 (nx2308), .B0 (nx1569)) ;
    ao21 ix1570 (.Y (nx1569), .A0 (REG_RESULT[1]), .A1 (nx2368), .B0 (nx2322)) ;
    dff ix1594 (.Q (PORT2O[2]), .QB (\$dummy [10]), .D (nx1591), .CLK (CLK2)) ;
    ao21 ix1592 (.Y (nx1591), .A0 (PORT2O[2]), .A1 (nx2308), .B0 (nx1589)) ;
    ao21 ix1590 (.Y (nx1589), .A0 (REG_RESULT[2]), .A1 (nx2368), .B0 (nx2322)) ;
    dff ix1614 (.Q (PORT2O[3]), .QB (\$dummy [11]), .D (nx1611), .CLK (CLK2)) ;
    ao21 ix1612 (.Y (nx1611), .A0 (PORT2O[3]), .A1 (nx2308), .B0 (nx1609)) ;
    ao21 ix1610 (.Y (nx1609), .A0 (REG_RESULT[3]), .A1 (nx2368), .B0 (nx2322)) ;
    dff ix1634 (.Q (PORT2O[4]), .QB (\$dummy [12]), .D (nx1631), .CLK (CLK2)) ;
    ao21 ix1632 (.Y (nx1631), .A0 (PORT2O[4]), .A1 (nx2308), .B0 (nx1629)) ;
    ao21 ix1630 (.Y (nx1629), .A0 (REG_RESULT[4]), .A1 (nx2368), .B0 (nx2322)) ;
    dff ix1654 (.Q (PORT2O[5]), .QB (\$dummy [13]), .D (nx1651), .CLK (CLK2)) ;
    ao21 ix1652 (.Y (nx1651), .A0 (PORT2O[5]), .A1 (nx2308), .B0 (nx1649)) ;
    ao21 ix1650 (.Y (nx1649), .A0 (REG_RESULT[5]), .A1 (nx2368), .B0 (nx2322)) ;
    dff ix1674 (.Q (PORT2O[6]), .QB (\$dummy [14]), .D (nx1671), .CLK (CLK2)) ;
    ao21 ix1672 (.Y (nx1671), .A0 (PORT2O[6]), .A1 (nx2308), .B0 (nx1669)) ;
    ao21 ix1670 (.Y (nx1669), .A0 (REG_RESULT[6]), .A1 (nx2368), .B0 (nx2322)) ;
    dff ix1694 (.Q (PORT2O[7]), .QB (\$dummy [15]), .D (nx1691), .CLK (CLK2)) ;
    ao21 ix1692 (.Y (nx1691), .A0 (PORT2O[7]), .A1 (nx2308), .B0 (nx1689)) ;
    ao21 ix1690 (.Y (nx1689), .A0 (REG_RESULT[7]), .A1 (nx2368), .B0 (nx2322)) ;
    dff ix1394 (.Q (PORT1O[0]), .QB (\$dummy [16]), .D (nx1391), .CLK (CLK2)) ;
    ao21 ix1392 (.Y (nx1391), .A0 (PORT1O[0]), .A1 (nx2310), .B0 (nx1389)) ;
    nor02 ix1932 (.Y (nx1931), .A0 (nx2372), .A1 (nx2322)) ;
    ao21 ix1390 (.Y (nx1389), .A0 (REG_RESULT[0]), .A1 (nx2372), .B0 (nx2322)) ;
    dff ix1414 (.Q (PORT1O[1]), .QB (\$dummy [17]), .D (nx1411), .CLK (CLK2)) ;
    ao21 ix1412 (.Y (nx1411), .A0 (PORT1O[1]), .A1 (nx2310), .B0 (nx1409)) ;
    ao21 ix1410 (.Y (nx1409), .A0 (REG_RESULT[1]), .A1 (nx2372), .B0 (nx2324)) ;
    dff ix1434 (.Q (PORT1O[2]), .QB (\$dummy [18]), .D (nx1431), .CLK (CLK2)) ;
    ao21 ix1432 (.Y (nx1431), .A0 (PORT1O[2]), .A1 (nx2310), .B0 (nx1429)) ;
    ao21 ix1430 (.Y (nx1429), .A0 (REG_RESULT[2]), .A1 (nx2372), .B0 (nx2324)) ;
    dff ix1454 (.Q (PORT1O[3]), .QB (\$dummy [19]), .D (nx1451), .CLK (CLK2)) ;
    ao21 ix1452 (.Y (nx1451), .A0 (PORT1O[3]), .A1 (nx2310), .B0 (nx1449)) ;
    ao21 ix1450 (.Y (nx1449), .A0 (REG_RESULT[3]), .A1 (nx2372), .B0 (nx2324)) ;
    dff ix1474 (.Q (PORT1O[4]), .QB (\$dummy [20]), .D (nx1471), .CLK (CLK2)) ;
    ao21 ix1472 (.Y (nx1471), .A0 (PORT1O[4]), .A1 (nx2310), .B0 (nx1469)) ;
    ao21 ix1470 (.Y (nx1469), .A0 (REG_RESULT[4]), .A1 (nx2372), .B0 (nx2324)) ;
    dff ix1494 (.Q (PORT1O[5]), .QB (\$dummy [21]), .D (nx1491), .CLK (CLK2)) ;
    ao21 ix1492 (.Y (nx1491), .A0 (PORT1O[5]), .A1 (nx2310), .B0 (nx1489)) ;
    ao21 ix1490 (.Y (nx1489), .A0 (REG_RESULT[5]), .A1 (nx2372), .B0 (nx2324)) ;
    dff ix1514 (.Q (PORT1O[6]), .QB (\$dummy [22]), .D (nx1511), .CLK (CLK2)) ;
    ao21 ix1512 (.Y (nx1511), .A0 (PORT1O[6]), .A1 (nx2310), .B0 (nx1509)) ;
    ao21 ix1510 (.Y (nx1509), .A0 (REG_RESULT[6]), .A1 (nx2372), .B0 (nx2324)) ;
    dff ix1534 (.Q (PORT1O[7]), .QB (\$dummy [23]), .D (nx1531), .CLK (CLK2)) ;
    ao21 ix1532 (.Y (nx1531), .A0 (PORT1O[7]), .A1 (nx2310), .B0 (nx1529)) ;
    ao21 ix1530 (.Y (nx1529), .A0 (REG_RESULT[7]), .A1 (nx2372), .B0 (nx2324)) ;
    dff ix1234 (.Q (PORT0O[0]), .QB (\$dummy [24]), .D (nx1231), .CLK (CLK2)) ;
    ao21 ix1232 (.Y (nx1231), .A0 (PORT0O[0]), .A1 (nx2312), .B0 (nx1229)) ;
    nor02 ix1966 (.Y (nx1965), .A0 (SFR_WRITE_EN[0]), .A1 (nx2324)) ;
    ao21 ix1230 (.Y (nx1229), .A0 (REG_RESULT[0]), .A1 (SFR_WRITE_EN[0]), .B0 (
         nx2324)) ;
    dff ix1254 (.Q (PORT0O[1]), .QB (\$dummy [25]), .D (nx1251), .CLK (CLK2)) ;
    ao21 ix1252 (.Y (nx1251), .A0 (PORT0O[1]), .A1 (nx2312), .B0 (nx1249)) ;
    ao21 ix1250 (.Y (nx1249), .A0 (REG_RESULT[1]), .A1 (SFR_WRITE_EN[0]), .B0 (
         nx2324)) ;
    dff ix1274 (.Q (PORT0O[2]), .QB (\$dummy [26]), .D (nx1271), .CLK (CLK2)) ;
    ao21 ix1272 (.Y (nx1271), .A0 (PORT0O[2]), .A1 (nx2312), .B0 (nx1269)) ;
    ao21 ix1270 (.Y (nx1269), .A0 (REG_RESULT[2]), .A1 (SFR_WRITE_EN[0]), .B0 (
         nx2326)) ;
    dff ix1294 (.Q (PORT0O[3]), .QB (\$dummy [27]), .D (nx1291), .CLK (CLK2)) ;
    ao21 ix1292 (.Y (nx1291), .A0 (PORT0O[3]), .A1 (nx2312), .B0 (nx1289)) ;
    ao21 ix1290 (.Y (nx1289), .A0 (REG_RESULT[3]), .A1 (SFR_WRITE_EN[0]), .B0 (
         nx2326)) ;
    dff ix1314 (.Q (PORT0O[4]), .QB (\$dummy [28]), .D (nx1311), .CLK (CLK2)) ;
    ao21 ix1312 (.Y (nx1311), .A0 (PORT0O[4]), .A1 (nx2312), .B0 (nx1309)) ;
    ao21 ix1310 (.Y (nx1309), .A0 (REG_RESULT[4]), .A1 (SFR_WRITE_EN[0]), .B0 (
         nx2326)) ;
    dff ix1334 (.Q (PORT0O[5]), .QB (\$dummy [29]), .D (nx1331), .CLK (CLK2)) ;
    ao21 ix1332 (.Y (nx1331), .A0 (PORT0O[5]), .A1 (nx2312), .B0 (nx1329)) ;
    ao21 ix1330 (.Y (nx1329), .A0 (REG_RESULT[5]), .A1 (SFR_WRITE_EN[0]), .B0 (
         nx2326)) ;
    dff ix1354 (.Q (PORT0O[6]), .QB (\$dummy [30]), .D (nx1351), .CLK (CLK2)) ;
    ao21 ix1352 (.Y (nx1351), .A0 (PORT0O[6]), .A1 (nx2312), .B0 (nx1349)) ;
    ao21 ix1350 (.Y (nx1349), .A0 (REG_RESULT[6]), .A1 (SFR_WRITE_EN[0]), .B0 (
         nx2326)) ;
    dff ix1374 (.Q (PORT0O[7]), .QB (\$dummy [31]), .D (nx1371), .CLK (CLK2)) ;
    ao21 ix1372 (.Y (nx1371), .A0 (PORT0O[7]), .A1 (nx2312), .B0 (nx1369)) ;
    ao21 ix1370 (.Y (nx1369), .A0 (REG_RESULT[7]), .A1 (SFR_WRITE_EN[0]), .B0 (
         nx2326)) ;
    dff ix673 (.Q (NPORT3E[0]), .QB (\$dummy [32]), .D (nx670), .CLK (CLK2)) ;
    ao21 ix671 (.Y (nx670), .A0 (PORT3O[0]), .A1 (nx666), .B0 (nx2326)) ;
    nand02 ix667 (.Y (nx666), .A0 (nx2000), .A1 (nx2364)) ;
    inv02 ix2001 (.Y (nx2000), .A (REG_RESULT[0])) ;
    dff ix687 (.Q (NPORT3E[1]), .QB (\$dummy [33]), .D (nx684), .CLK (CLK2)) ;
    ao21 ix685 (.Y (nx684), .A0 (PORT3O[1]), .A1 (nx680), .B0 (nx2326)) ;
    nand02 ix681 (.Y (nx680), .A0 (nx2006), .A1 (nx2366)) ;
    inv02 ix2007 (.Y (nx2006), .A (REG_RESULT[1])) ;
    dff ix701 (.Q (NPORT3E[2]), .QB (\$dummy [34]), .D (nx698), .CLK (CLK2)) ;
    ao21 ix699 (.Y (nx698), .A0 (PORT3O[2]), .A1 (nx694), .B0 (nx2326)) ;
    nand02 ix695 (.Y (nx694), .A0 (nx2012), .A1 (nx2366)) ;
    inv02 ix2013 (.Y (nx2012), .A (REG_RESULT[2])) ;
    dff ix715 (.Q (NPORT3E[3]), .QB (\$dummy [35]), .D (nx712), .CLK (CLK2)) ;
    ao21 ix713 (.Y (nx712), .A0 (PORT3O[3]), .A1 (nx708), .B0 (nx2326)) ;
    nand02 ix709 (.Y (nx708), .A0 (nx2018), .A1 (nx2366)) ;
    inv02 ix2019 (.Y (nx2018), .A (REG_RESULT[3])) ;
    dff ix729 (.Q (NPORT3E[4]), .QB (\$dummy [36]), .D (nx726), .CLK (CLK2)) ;
    ao21 ix727 (.Y (nx726), .A0 (PORT3O[4]), .A1 (nx722), .B0 (nx2328)) ;
    nand02 ix723 (.Y (nx722), .A0 (nx2024), .A1 (nx2366)) ;
    inv02 ix2025 (.Y (nx2024), .A (REG_RESULT[4])) ;
    dff ix743 (.Q (NPORT3E[5]), .QB (\$dummy [37]), .D (nx740), .CLK (CLK2)) ;
    ao21 ix741 (.Y (nx740), .A0 (PORT3O[5]), .A1 (nx736), .B0 (nx2328)) ;
    nand02 ix737 (.Y (nx736), .A0 (nx2030), .A1 (nx2366)) ;
    inv02 ix2031 (.Y (nx2030), .A (REG_RESULT[5])) ;
    dff ix757 (.Q (NPORT3E[6]), .QB (\$dummy [38]), .D (nx754), .CLK (CLK2)) ;
    ao21 ix755 (.Y (nx754), .A0 (PORT3O[6]), .A1 (nx750), .B0 (nx2328)) ;
    nand02 ix751 (.Y (nx750), .A0 (nx2036), .A1 (nx2366)) ;
    inv02 ix2037 (.Y (nx2036), .A (REG_RESULT[6])) ;
    dff ix771 (.Q (NPORT3E[7]), .QB (\$dummy [39]), .D (nx768), .CLK (CLK2)) ;
    ao21 ix769 (.Y (nx768), .A0 (PORT3O[7]), .A1 (nx764), .B0 (nx2328)) ;
    nand02 ix765 (.Y (nx764), .A0 (nx2042), .A1 (nx2366)) ;
    inv02 ix2043 (.Y (nx2042), .A (REG_RESULT[7])) ;
    dff ix785 (.Q (NPORT2E[0]), .QB (\$dummy [40]), .D (nx782), .CLK (CLK2)) ;
    ao21 ix783 (.Y (nx782), .A0 (PORT2O[0]), .A1 (nx778), .B0 (nx2328)) ;
    nand02 ix779 (.Y (nx778), .A0 (nx2000), .A1 (nx2368)) ;
    dff ix799 (.Q (NPORT2E[1]), .QB (\$dummy [41]), .D (nx796), .CLK (CLK2)) ;
    ao21 ix797 (.Y (nx796), .A0 (PORT2O[1]), .A1 (nx792), .B0 (nx2328)) ;
    nand02 ix793 (.Y (nx792), .A0 (nx2006), .A1 (nx2370)) ;
    dff ix813 (.Q (NPORT2E[2]), .QB (\$dummy [42]), .D (nx810), .CLK (CLK2)) ;
    ao21 ix811 (.Y (nx810), .A0 (PORT2O[2]), .A1 (nx806), .B0 (nx2328)) ;
    nand02 ix807 (.Y (nx806), .A0 (nx2012), .A1 (nx2370)) ;
    dff ix827 (.Q (NPORT2E[3]), .QB (\$dummy [43]), .D (nx824), .CLK (CLK2)) ;
    ao21 ix825 (.Y (nx824), .A0 (PORT2O[3]), .A1 (nx820), .B0 (nx2328)) ;
    nand02 ix821 (.Y (nx820), .A0 (nx2018), .A1 (nx2370)) ;
    dff ix841 (.Q (NPORT2E[4]), .QB (\$dummy [44]), .D (nx838), .CLK (CLK2)) ;
    ao21 ix839 (.Y (nx838), .A0 (PORT2O[4]), .A1 (nx834), .B0 (nx2328)) ;
    nand02 ix835 (.Y (nx834), .A0 (nx2024), .A1 (nx2370)) ;
    dff ix855 (.Q (NPORT2E[5]), .QB (\$dummy [45]), .D (nx852), .CLK (CLK2)) ;
    ao21 ix853 (.Y (nx852), .A0 (PORT2O[5]), .A1 (nx848), .B0 (nx2328)) ;
    nand02 ix849 (.Y (nx848), .A0 (nx2030), .A1 (nx2370)) ;
    dff ix869 (.Q (NPORT2E[6]), .QB (\$dummy [46]), .D (nx866), .CLK (CLK2)) ;
    ao21 ix867 (.Y (nx866), .A0 (PORT2O[6]), .A1 (nx862), .B0 (nx2330)) ;
    nand02 ix863 (.Y (nx862), .A0 (nx2036), .A1 (nx2370)) ;
    dff ix883 (.Q (NPORT2E[7]), .QB (\$dummy [47]), .D (nx880), .CLK (CLK2)) ;
    ao21 ix881 (.Y (nx880), .A0 (PORT2O[7]), .A1 (nx876), .B0 (nx2330)) ;
    nand02 ix877 (.Y (nx876), .A0 (nx2042), .A1 (nx2370)) ;
    dff ix897 (.Q (NPORT1E[0]), .QB (\$dummy [48]), .D (nx894), .CLK (CLK2)) ;
    ao21 ix895 (.Y (nx894), .A0 (PORT1O[0]), .A1 (nx890), .B0 (nx2330)) ;
    nand02 ix891 (.Y (nx890), .A0 (nx2000), .A1 (nx2372)) ;
    dff ix911 (.Q (NPORT1E[1]), .QB (\$dummy [49]), .D (nx908), .CLK (CLK2)) ;
    ao21 ix909 (.Y (nx908), .A0 (PORT1O[1]), .A1 (nx904), .B0 (nx2330)) ;
    nand02 ix905 (.Y (nx904), .A0 (nx2006), .A1 (nx2374)) ;
    dff ix925 (.Q (NPORT1E[2]), .QB (\$dummy [50]), .D (nx922), .CLK (CLK2)) ;
    ao21 ix923 (.Y (nx922), .A0 (PORT1O[2]), .A1 (nx918), .B0 (nx2330)) ;
    nand02 ix919 (.Y (nx918), .A0 (nx2012), .A1 (nx2374)) ;
    dff ix939 (.Q (NPORT1E[3]), .QB (\$dummy [51]), .D (nx936), .CLK (CLK2)) ;
    ao21 ix937 (.Y (nx936), .A0 (PORT1O[3]), .A1 (nx932), .B0 (nx2330)) ;
    nand02 ix933 (.Y (nx932), .A0 (nx2018), .A1 (nx2374)) ;
    dff ix953 (.Q (NPORT1E[4]), .QB (\$dummy [52]), .D (nx950), .CLK (CLK2)) ;
    ao21 ix951 (.Y (nx950), .A0 (PORT1O[4]), .A1 (nx946), .B0 (nx2330)) ;
    nand02 ix947 (.Y (nx946), .A0 (nx2024), .A1 (nx2374)) ;
    dff ix967 (.Q (NPORT1E[5]), .QB (\$dummy [53]), .D (nx964), .CLK (CLK2)) ;
    ao21 ix965 (.Y (nx964), .A0 (PORT1O[5]), .A1 (nx960), .B0 (nx2330)) ;
    nand02 ix961 (.Y (nx960), .A0 (nx2030), .A1 (nx2374)) ;
    dff ix981 (.Q (NPORT1E[6]), .QB (\$dummy [54]), .D (nx978), .CLK (CLK2)) ;
    ao21 ix979 (.Y (nx978), .A0 (PORT1O[6]), .A1 (nx974), .B0 (nx2330)) ;
    nand02 ix975 (.Y (nx974), .A0 (nx2036), .A1 (nx2374)) ;
    dff ix995 (.Q (NPORT1E[7]), .QB (\$dummy [55]), .D (nx992), .CLK (CLK2)) ;
    ao21 ix993 (.Y (nx992), .A0 (PORT1O[7]), .A1 (nx988), .B0 (nx2330)) ;
    nand02 ix989 (.Y (nx988), .A0 (nx2042), .A1 (nx2374)) ;
    ao21 ix523 (.Y (PORT_3[0]), .A0 (nx2350), .A1 (PORT3O[0]), .B0 (nx510)) ;
    nor02 ix511 (.Y (nx510), .A0 (nx2350), .A1 (nx2111)) ;
    dff ix1704 (.Q (\$dummy [56]), .QB (nx2111), .D (nx1701), .CLK (CLK2)) ;
    ao21 ix1702 (.Y (nx1701), .A0 (PORT3I[0]), .A1 (nx2334), .B0 (nx1697)) ;
    nor02 ix1698 (.Y (nx1697), .A0 (nx2111), .A1 (nx2334)) ;
    ao21 ix543 (.Y (PORT_3[1]), .A0 (nx2350), .A1 (PORT3O[1]), .B0 (nx532)) ;
    nor02 ix533 (.Y (nx532), .A0 (nx2350), .A1 (nx2117)) ;
    dff ix1724 (.Q (\$dummy [57]), .QB (nx2117), .D (nx1721), .CLK (CLK2)) ;
    ao21 ix1722 (.Y (nx1721), .A0 (PORT3I[1]), .A1 (nx2334), .B0 (nx1717)) ;
    nor02 ix1718 (.Y (nx1717), .A0 (nx2117), .A1 (nx2334)) ;
    ao21 ix563 (.Y (PORT_3[2]), .A0 (nx2350), .A1 (PORT3O[2]), .B0 (nx552)) ;
    nor02 ix553 (.Y (nx552), .A0 (nx2350), .A1 (nx2123)) ;
    dff ix1744 (.Q (\$dummy [58]), .QB (nx2123), .D (nx1741), .CLK (CLK2)) ;
    ao21 ix1742 (.Y (nx1741), .A0 (PORT3I[2]), .A1 (nx2334), .B0 (nx1737)) ;
    nor02 ix1738 (.Y (nx1737), .A0 (nx2123), .A1 (nx2334)) ;
    ao21 ix583 (.Y (PORT_3[3]), .A0 (nx2350), .A1 (PORT3O[3]), .B0 (nx572)) ;
    nor02 ix573 (.Y (nx572), .A0 (nx2350), .A1 (nx2129)) ;
    dff ix1764 (.Q (\$dummy [59]), .QB (nx2129), .D (nx1761), .CLK (CLK2)) ;
    ao21 ix1762 (.Y (nx1761), .A0 (PORT3I[3]), .A1 (nx2334), .B0 (nx1757)) ;
    nor02 ix1758 (.Y (nx1757), .A0 (nx2129), .A1 (nx2334)) ;
    ao21 ix603 (.Y (PORT_3[4]), .A0 (nx2350), .A1 (PORT3O[4]), .B0 (nx592)) ;
    nor02 ix593 (.Y (nx592), .A0 (nx2350), .A1 (nx2135)) ;
    dff ix1784 (.Q (\$dummy [60]), .QB (nx2135), .D (nx1781), .CLK (CLK2)) ;
    ao21 ix1782 (.Y (nx1781), .A0 (PORT3I[4]), .A1 (nx2334), .B0 (nx1777)) ;
    nor02 ix1778 (.Y (nx1777), .A0 (nx2135), .A1 (nx2334)) ;
    ao21 ix623 (.Y (PORT_3[5]), .A0 (nx2352), .A1 (PORT3O[5]), .B0 (nx612)) ;
    nor02 ix613 (.Y (nx612), .A0 (nx2352), .A1 (nx2141)) ;
    dff ix1804 (.Q (\$dummy [61]), .QB (nx2141), .D (nx1801), .CLK (CLK2)) ;
    ao21 ix1802 (.Y (nx1801), .A0 (PORT3I[5]), .A1 (nx2336), .B0 (nx1797)) ;
    nor02 ix1798 (.Y (nx1797), .A0 (nx2141), .A1 (nx2336)) ;
    ao21 ix643 (.Y (PORT_3[6]), .A0 (nx2352), .A1 (PORT3O[6]), .B0 (nx632)) ;
    nor02 ix633 (.Y (nx632), .A0 (nx2352), .A1 (nx2147)) ;
    dff ix1824 (.Q (\$dummy [62]), .QB (nx2147), .D (nx1821), .CLK (CLK2)) ;
    ao21 ix1822 (.Y (nx1821), .A0 (PORT3I[6]), .A1 (nx2336), .B0 (nx1817)) ;
    nor02 ix1818 (.Y (nx1817), .A0 (nx2147), .A1 (nx2336)) ;
    ao21 ix663 (.Y (PORT_3[7]), .A0 (nx2352), .A1 (PORT3O[7]), .B0 (nx652)) ;
    nor02 ix653 (.Y (nx652), .A0 (nx2352), .A1 (nx2153)) ;
    dff ix1844 (.Q (\$dummy [63]), .QB (nx2153), .D (nx1841), .CLK (CLK2)) ;
    ao21 ix1842 (.Y (nx1841), .A0 (PORT3I[7]), .A1 (nx2336), .B0 (nx1837)) ;
    nor02 ix1838 (.Y (nx1837), .A0 (nx2153), .A1 (nx2336)) ;
    ao21 ix361 (.Y (PORT_2[0]), .A0 (nx2352), .A1 (PORT2O[0]), .B0 (nx348)) ;
    nor02 ix349 (.Y (nx348), .A0 (nx2352), .A1 (nx2159)) ;
    dff ix1544 (.Q (\$dummy [64]), .QB (nx2159), .D (nx1541), .CLK (CLK2)) ;
    ao21 ix1542 (.Y (nx1541), .A0 (PORT2I[0]), .A1 (nx2336), .B0 (nx1537)) ;
    nor02 ix1538 (.Y (nx1537), .A0 (nx2159), .A1 (nx2336)) ;
    ao21 ix381 (.Y (PORT_2[1]), .A0 (nx2352), .A1 (PORT2O[1]), .B0 (nx370)) ;
    nor02 ix371 (.Y (nx370), .A0 (nx2352), .A1 (nx2165)) ;
    dff ix1564 (.Q (\$dummy [65]), .QB (nx2165), .D (nx1561), .CLK (CLK2)) ;
    ao21 ix1562 (.Y (nx1561), .A0 (PORT2I[1]), .A1 (nx2336), .B0 (nx1557)) ;
    nor02 ix1558 (.Y (nx1557), .A0 (nx2165), .A1 (nx2336)) ;
    ao21 ix401 (.Y (PORT_2[2]), .A0 (nx2354), .A1 (PORT2O[2]), .B0 (nx390)) ;
    nor02 ix391 (.Y (nx390), .A0 (nx2354), .A1 (nx2171)) ;
    dff ix1584 (.Q (\$dummy [66]), .QB (nx2171), .D (nx1581), .CLK (CLK2)) ;
    ao21 ix1582 (.Y (nx1581), .A0 (PORT2I[2]), .A1 (nx2338), .B0 (nx1577)) ;
    nor02 ix1578 (.Y (nx1577), .A0 (nx2171), .A1 (nx2338)) ;
    ao21 ix421 (.Y (PORT_2[3]), .A0 (nx2354), .A1 (PORT2O[3]), .B0 (nx410)) ;
    nor02 ix411 (.Y (nx410), .A0 (nx2354), .A1 (nx2177)) ;
    dff ix1604 (.Q (\$dummy [67]), .QB (nx2177), .D (nx1601), .CLK (CLK2)) ;
    ao21 ix1602 (.Y (nx1601), .A0 (PORT2I[3]), .A1 (nx2338), .B0 (nx1597)) ;
    nor02 ix1598 (.Y (nx1597), .A0 (nx2177), .A1 (nx2338)) ;
    ao21 ix441 (.Y (PORT_2[4]), .A0 (nx2354), .A1 (PORT2O[4]), .B0 (nx430)) ;
    nor02 ix431 (.Y (nx430), .A0 (nx2354), .A1 (nx2183)) ;
    dff ix1624 (.Q (\$dummy [68]), .QB (nx2183), .D (nx1621), .CLK (CLK2)) ;
    ao21 ix1622 (.Y (nx1621), .A0 (PORT2I[4]), .A1 (nx2338), .B0 (nx1617)) ;
    nor02 ix1618 (.Y (nx1617), .A0 (nx2183), .A1 (nx2338)) ;
    ao21 ix461 (.Y (PORT_2[5]), .A0 (nx2354), .A1 (PORT2O[5]), .B0 (nx450)) ;
    nor02 ix451 (.Y (nx450), .A0 (nx2354), .A1 (nx2189)) ;
    dff ix1644 (.Q (\$dummy [69]), .QB (nx2189), .D (nx1641), .CLK (CLK2)) ;
    ao21 ix1642 (.Y (nx1641), .A0 (PORT2I[5]), .A1 (nx2338), .B0 (nx1637)) ;
    nor02 ix1638 (.Y (nx1637), .A0 (nx2189), .A1 (nx2338)) ;
    ao21 ix481 (.Y (PORT_2[6]), .A0 (nx2354), .A1 (PORT2O[6]), .B0 (nx470)) ;
    nor02 ix471 (.Y (nx470), .A0 (nx2354), .A1 (nx2195)) ;
    dff ix1664 (.Q (\$dummy [70]), .QB (nx2195), .D (nx1661), .CLK (CLK2)) ;
    ao21 ix1662 (.Y (nx1661), .A0 (PORT2I[6]), .A1 (nx2338), .B0 (nx1657)) ;
    nor02 ix1658 (.Y (nx1657), .A0 (nx2195), .A1 (nx2338)) ;
    ao21 ix501 (.Y (PORT_2[7]), .A0 (nx2356), .A1 (PORT2O[7]), .B0 (nx490)) ;
    nor02 ix491 (.Y (nx490), .A0 (nx2356), .A1 (nx2201)) ;
    dff ix1684 (.Q (\$dummy [71]), .QB (nx2201), .D (nx1681), .CLK (CLK2)) ;
    ao21 ix1682 (.Y (nx1681), .A0 (PORT2I[7]), .A1 (nx2340), .B0 (nx1677)) ;
    nor02 ix1678 (.Y (nx1677), .A0 (nx2201), .A1 (nx2340)) ;
    ao21 ix199 (.Y (PORT_1[0]), .A0 (nx2356), .A1 (PORT1O[0]), .B0 (nx186)) ;
    nor02 ix187 (.Y (nx186), .A0 (nx2356), .A1 (nx2207)) ;
    dff ix1384 (.Q (\$dummy [72]), .QB (nx2207), .D (nx1381), .CLK (CLK2)) ;
    ao21 ix1382 (.Y (nx1381), .A0 (PORT1I[0]), .A1 (nx2340), .B0 (nx1377)) ;
    nor02 ix1378 (.Y (nx1377), .A0 (nx2207), .A1 (nx2340)) ;
    ao21 ix219 (.Y (PORT_1[1]), .A0 (nx2356), .A1 (PORT1O[1]), .B0 (nx208)) ;
    nor02 ix209 (.Y (nx208), .A0 (nx2356), .A1 (nx2213)) ;
    dff ix1404 (.Q (\$dummy [73]), .QB (nx2213), .D (nx1401), .CLK (CLK2)) ;
    ao21 ix1402 (.Y (nx1401), .A0 (PORT1I[1]), .A1 (nx2340), .B0 (nx1397)) ;
    nor02 ix1398 (.Y (nx1397), .A0 (nx2213), .A1 (nx2340)) ;
    ao21 ix239 (.Y (PORT_1[2]), .A0 (nx2356), .A1 (PORT1O[2]), .B0 (nx228)) ;
    nor02 ix229 (.Y (nx228), .A0 (nx2356), .A1 (nx2219)) ;
    dff ix1424 (.Q (\$dummy [74]), .QB (nx2219), .D (nx1421), .CLK (CLK2)) ;
    ao21 ix1422 (.Y (nx1421), .A0 (PORT1I[2]), .A1 (nx2340), .B0 (nx1417)) ;
    nor02 ix1418 (.Y (nx1417), .A0 (nx2219), .A1 (nx2340)) ;
    ao21 ix259 (.Y (PORT_1[3]), .A0 (nx2356), .A1 (PORT1O[3]), .B0 (nx248)) ;
    nor02 ix249 (.Y (nx248), .A0 (nx2356), .A1 (nx2225)) ;
    dff ix1444 (.Q (\$dummy [75]), .QB (nx2225), .D (nx1441), .CLK (CLK2)) ;
    ao21 ix1442 (.Y (nx1441), .A0 (PORT1I[3]), .A1 (nx2340), .B0 (nx1437)) ;
    nor02 ix1438 (.Y (nx1437), .A0 (nx2225), .A1 (nx2340)) ;
    ao21 ix279 (.Y (PORT_1[4]), .A0 (nx2358), .A1 (PORT1O[4]), .B0 (nx268)) ;
    nor02 ix269 (.Y (nx268), .A0 (nx2358), .A1 (nx2231)) ;
    dff ix1464 (.Q (\$dummy [76]), .QB (nx2231), .D (nx1461), .CLK (CLK2)) ;
    ao21 ix1462 (.Y (nx1461), .A0 (PORT1I[4]), .A1 (nx2342), .B0 (nx1457)) ;
    nor02 ix1458 (.Y (nx1457), .A0 (nx2231), .A1 (nx2342)) ;
    ao21 ix299 (.Y (PORT_1[5]), .A0 (nx2358), .A1 (PORT1O[5]), .B0 (nx288)) ;
    nor02 ix289 (.Y (nx288), .A0 (nx2358), .A1 (nx2237)) ;
    dff ix1484 (.Q (\$dummy [77]), .QB (nx2237), .D (nx1481), .CLK (CLK2)) ;
    ao21 ix1482 (.Y (nx1481), .A0 (PORT1I[5]), .A1 (nx2342), .B0 (nx1477)) ;
    nor02 ix1478 (.Y (nx1477), .A0 (nx2237), .A1 (nx2342)) ;
    ao21 ix319 (.Y (PORT_1[6]), .A0 (nx2358), .A1 (PORT1O[6]), .B0 (nx308)) ;
    nor02 ix309 (.Y (nx308), .A0 (nx2358), .A1 (nx2243)) ;
    dff ix1504 (.Q (\$dummy [78]), .QB (nx2243), .D (nx1501), .CLK (CLK2)) ;
    ao21 ix1502 (.Y (nx1501), .A0 (PORT1I[6]), .A1 (nx2342), .B0 (nx1497)) ;
    nor02 ix1498 (.Y (nx1497), .A0 (nx2243), .A1 (nx2342)) ;
    ao21 ix339 (.Y (PORT_1[7]), .A0 (nx2358), .A1 (PORT1O[7]), .B0 (nx328)) ;
    nor02 ix329 (.Y (nx328), .A0 (nx2358), .A1 (nx2249)) ;
    dff ix1524 (.Q (\$dummy [79]), .QB (nx2249), .D (nx1521), .CLK (CLK2)) ;
    ao21 ix1522 (.Y (nx1521), .A0 (PORT1I[7]), .A1 (nx2342), .B0 (nx1517)) ;
    nor02 ix1518 (.Y (nx1517), .A0 (nx2249), .A1 (nx2342)) ;
    ao21 ix23 (.Y (PORT_0[0]), .A0 (nx2358), .A1 (PORT0O[0]), .B0 (nx8)) ;
    nor02 ix9 (.Y (nx8), .A0 (nx2358), .A1 (nx2255)) ;
    dff ix1224 (.Q (\$dummy [80]), .QB (nx2255), .D (nx1221), .CLK (CLK2)) ;
    ao21 ix1222 (.Y (nx1221), .A0 (PORT0I[0]), .A1 (nx2342), .B0 (nx1217)) ;
    nor02 ix1218 (.Y (nx1217), .A0 (nx2255), .A1 (nx2342)) ;
    ao21 ix45 (.Y (PORT_0[1]), .A0 (nx2360), .A1 (PORT0O[1]), .B0 (nx32)) ;
    nor02 ix33 (.Y (nx32), .A0 (nx2360), .A1 (nx2261)) ;
    dff ix1244 (.Q (\$dummy [81]), .QB (nx2261), .D (nx1241), .CLK (CLK2)) ;
    ao21 ix1242 (.Y (nx1241), .A0 (PORT0I[1]), .A1 (nx2344), .B0 (nx1237)) ;
    nor02 ix1238 (.Y (nx1237), .A0 (nx2261), .A1 (nx2344)) ;
    ao21 ix67 (.Y (PORT_0[2]), .A0 (nx2360), .A1 (PORT0O[2]), .B0 (nx54)) ;
    nor02 ix55 (.Y (nx54), .A0 (nx2360), .A1 (nx2267)) ;
    dff ix1264 (.Q (\$dummy [82]), .QB (nx2267), .D (nx1261), .CLK (CLK2)) ;
    ao21 ix1262 (.Y (nx1261), .A0 (PORT0I[2]), .A1 (nx2344), .B0 (nx1257)) ;
    nor02 ix1258 (.Y (nx1257), .A0 (nx2267), .A1 (nx2344)) ;
    ao21 ix89 (.Y (PORT_0[3]), .A0 (nx2360), .A1 (PORT0O[3]), .B0 (nx76)) ;
    nor02 ix77 (.Y (nx76), .A0 (nx2360), .A1 (nx2273)) ;
    dff ix1284 (.Q (\$dummy [83]), .QB (nx2273), .D (nx1281), .CLK (CLK2)) ;
    ao21 ix1282 (.Y (nx1281), .A0 (PORT0I[3]), .A1 (nx2344), .B0 (nx1277)) ;
    nor02 ix1278 (.Y (nx1277), .A0 (nx2273), .A1 (nx2344)) ;
    ao21 ix111 (.Y (PORT_0[4]), .A0 (nx2360), .A1 (PORT0O[4]), .B0 (nx98)) ;
    nor02 ix99 (.Y (nx98), .A0 (nx2360), .A1 (nx2279)) ;
    dff ix1304 (.Q (\$dummy [84]), .QB (nx2279), .D (nx1301), .CLK (CLK2)) ;
    ao21 ix1302 (.Y (nx1301), .A0 (PORT0I[4]), .A1 (nx2344), .B0 (nx1297)) ;
    nor02 ix1298 (.Y (nx1297), .A0 (nx2279), .A1 (nx2344)) ;
    ao21 ix133 (.Y (PORT_0[5]), .A0 (nx2360), .A1 (PORT0O[5]), .B0 (nx120)) ;
    nor02 ix121 (.Y (nx120), .A0 (nx2360), .A1 (nx2285)) ;
    dff ix1324 (.Q (\$dummy [85]), .QB (nx2285), .D (nx1321), .CLK (CLK2)) ;
    ao21 ix1322 (.Y (nx1321), .A0 (PORT0I[5]), .A1 (nx2344), .B0 (nx1317)) ;
    nor02 ix1318 (.Y (nx1317), .A0 (nx2285), .A1 (nx2344)) ;
    ao21 ix155 (.Y (PORT_0[6]), .A0 (nx2362), .A1 (PORT0O[6]), .B0 (nx142)) ;
    nor02 ix143 (.Y (nx142), .A0 (nx2362), .A1 (nx2291)) ;
    dff ix1344 (.Q (\$dummy [86]), .QB (nx2291), .D (nx1341), .CLK (CLK2)) ;
    ao21 ix1342 (.Y (nx1341), .A0 (PORT0I[6]), .A1 (nx2346), .B0 (nx1337)) ;
    nor02 ix1338 (.Y (nx1337), .A0 (nx2291), .A1 (nx2346)) ;
    ao21 ix177 (.Y (PORT_0[7]), .A0 (nx2362), .A1 (PORT0O[7]), .B0 (nx164)) ;
    nor02 ix165 (.Y (nx164), .A0 (nx2362), .A1 (nx2297)) ;
    dff ix1364 (.Q (\$dummy [87]), .QB (nx2297), .D (nx1361), .CLK (CLK2)) ;
    ao21 ix1362 (.Y (nx1361), .A0 (PORT0I[7]), .A1 (nx2346), .B0 (nx1357)) ;
    nor02 ix1358 (.Y (nx1357), .A0 (nx2297), .A1 (nx2346)) ;
    buf02 ix2305 (.Y (nx2306), .A (nx1863)) ;
    buf02 ix2307 (.Y (nx2308), .A (nx1897)) ;
    buf02 ix2309 (.Y (nx2310), .A (nx1931)) ;
    buf02 ix2311 (.Y (nx2312), .A (nx1965)) ;
    inv02 ix2317 (.Y (nx2318), .A (INTERNAL_RESET)) ;
    inv02 ix2319 (.Y (nx2320), .A (nx2318)) ;
    inv02 ix2321 (.Y (nx2322), .A (nx2318)) ;
    inv02 ix2323 (.Y (nx2324), .A (nx2318)) ;
    inv02 ix2325 (.Y (nx2326), .A (nx2318)) ;
    inv02 ix2327 (.Y (nx2328), .A (nx2318)) ;
    inv02 ix2329 (.Y (nx2330), .A (nx2318)) ;
    inv02 ix2331 (.Y (nx2332), .A (STATE[0])) ;
    inv02 ix2333 (.Y (nx2334), .A (nx2332)) ;
    inv02 ix2335 (.Y (nx2336), .A (nx2332)) ;
    inv02 ix2337 (.Y (nx2338), .A (nx2332)) ;
    inv02 ix2339 (.Y (nx2340), .A (nx2332)) ;
    inv02 ix2341 (.Y (nx2342), .A (nx2332)) ;
    inv02 ix2343 (.Y (nx2344), .A (nx2332)) ;
    inv02 ix2345 (.Y (nx2346), .A (nx2332)) ;
    inv02 ix2347 (.Y (nx2348), .A (PORT_CON)) ;
    inv02 ix2349 (.Y (nx2350), .A (nx2348)) ;
    inv02 ix2351 (.Y (nx2352), .A (nx2348)) ;
    inv02 ix2353 (.Y (nx2354), .A (nx2348)) ;
    inv02 ix2355 (.Y (nx2356), .A (nx2348)) ;
    inv02 ix2357 (.Y (nx2358), .A (nx2348)) ;
    inv02 ix2359 (.Y (nx2360), .A (nx2348)) ;
    inv02 ix2361 (.Y (nx2362), .A (nx2348)) ;
    buf02 ix2363 (.Y (nx2364), .A (SFR_WRITE_EN[3])) ;
    buf02 ix2365 (.Y (nx2366), .A (SFR_WRITE_EN[3])) ;
    buf02 ix2367 (.Y (nx2368), .A (SFR_WRITE_EN[2])) ;
    buf02 ix2369 (.Y (nx2370), .A (SFR_WRITE_EN[2])) ;
    buf02 ix2371 (.Y (nx2372), .A (SFR_WRITE_EN[1])) ;
    buf02 ix2373 (.Y (nx2374), .A (SFR_WRITE_EN[1])) ;
endmodule


module block13 ( ALU_CON, SWITCH_CON, MEM_CON, SFR_CON, PC_CON, STATE_CON, 
                  IMM_CON, PORT_CON, INTR_CON, OPCODE ) ;

    output [18:0]ALU_CON ;
    output [5:0]SWITCH_CON ;
    output [14:0]MEM_CON ;
    output [6:0]SFR_CON ;
    output [17:0]PC_CON ;
    output [5:0]STATE_CON ;
    output IMM_CON ;
    output PORT_CON ;
    output INTR_CON ;
    input [7:0]OPCODE ;

    wire nx4, nx10, nx12, nx16, nx24, nx28, nx42, nx58, nx64, nx66, nx74, nx82, 
         nx88, nx94, nx102, nx104, nx124, nx126, nx148, nx158, nx162, nx170, 
         nx174, nx180, nx188, nx190, nx214, nx216, nx274, nx280, nx282, nx292, 
         nx296, nx302, nx356, nx372, nx412, nx420, nx448, nx462, nx474, nx500, 
         nx504, nx512, nx524, nx552, nx560, nx574, nx596, nx612, nx642, nx672, 
         nx680, nx692, nx718, nx724, nx766, nx770, nx776, nx856, nx1008, nx1062, 
         nx1130, nx1158, nx1172, nx1182, nx1186, nx1222, nx187, nx189, nx195, 
         nx197, nx201, nx203, nx209, nx213, nx215, nx219, nx225, nx229, nx245, 
         nx253, nx261, nx279, nx281, nx293, nx303, nx307, nx311, nx319, nx323, 
         nx328, nx335, nx340, nx345, nx355, nx357, nx359, nx361, nx363, nx367, 
         nx369, nx373, nx377, nx379, nx381, nx383, nx387, nx389, nx393, nx397, 
         nx400, nx405, nx411, nx413, nx425, nx427, nx433, nx437, nx445, nx447, 
         nx449, nx451, nx459, nx465, nx469, nx473, nx477, nx487, nx489, nx493, 
         nx499, nx509, nx511, nx521, nx523, nx525, nx531, nx537, nx539, nx542, 
         nx549, nx553, nx561, nx567, nx571, nx573, nx575, nx577, nx581, nx591, 
         nx595, nx599, nx603, nx611, nx617, nx626, nx628, nx630, nx632, nx634, 
         nx636, nx638, nx640, nx643, nx645, nx647, nx649, nx651, nx653, nx655, 
         nx657, nx659, nx661, nx663, nx665, nx667, nx669, nx671, nx673, nx675, 
         nx677, nx679, nx681, nx683, nx685, nx687, nx689, nx691, nx693, nx695, 
         nx699, nx701, nx703, nx705, nx707, nx709, nx711, nx713, nx715, nx717, 
         nx719, nx721, nx723, nx725, nx727, nx729, nx731, nx733, nx735, nx737, 
         nx739, nx741, nx743, nx745, nx747, nx749, nx751, nx753, nx755, nx757, 
         nx759, nx761, nx763, nx765, nx767, nx769, nx771, nx773, nx775, nx777, 
         nx779, nx781, nx783, nx785, nx787, nx789, nx791, nx798, nx800, nx802, 
         nx804, nx810, nx812, nx814, nx816, nx822, nx824, nx827, nx829, nx835, 
         nx837, nx839, nx841, nx847, nx849, nx851, nx853, nx861, nx863, nx865, 
         nx867, nx869, nx871, nx873, nx875, nx877, nx879, nx881, nx883, nx885, 
         nx887, nx889, nx891, nx893, nx895, nx897, nx899, nx901, nx903, nx905, 
         nx907, nx909, nx911, nx913, nx915, nx917, nx919, nx921, nx923, nx925, 
         nx927, nx929, nx931, nx933, nx935, nx937, nx939, nx941, nx943, nx945, 
         nx947, nx949, nx951, nx953, nx955, nx957, nx963, nx965, nx967, nx973, 
         nx975, nx977, nx983, nx985, nx987, nx995, nx997, nx999, nx1006, nx1009, 
         nx1011, nx1018, nx1020, nx1022;



    assign MEM_CON[6] = MEM_CON[11] ;
    assign PC_CON[11] = PC_CON[13] ;
    assign STATE_CON[5] = PC_CON[13] ;
    assign STATE_CON[4] = PC_CON[13] ;
    assign STATE_CON[1] = PC_CON[13] ;
    fake_gnd ix163 (.Y (PC_CON[13])) ;
    nor02 ix619 (.Y (MEM_CON[14]), .A0 (nx659), .A1 (nx933)) ;
    nor02 ix23 (.Y (ALU_CON[18]), .A0 (OPCODE[3]), .A1 (OPCODE[2])) ;
    inv02 ix188 (.Y (nx187), .A (OPCODE[1])) ;
    inv02 ix190 (.Y (nx189), .A (OPCODE[0])) ;
    inv02 ix196 (.Y (nx195), .A (OPCODE[4])) ;
    nor02 ix198 (.Y (nx197), .A0 (OPCODE[7]), .A1 (nx883)) ;
    nor02 ix137 (.Y (PC_CON[9]), .A0 (nx887), .A1 (nx201)) ;
    inv02 ix210 (.Y (nx209), .A (OPCODE[3])) ;
    nor02 ix214 (.Y (nx213), .A0 (nx215), .A1 (nx883)) ;
    inv02 ix216 (.Y (nx215), .A (OPCODE[7])) ;
    aoi21 ix535 (.Y (SFR_CON[4]), .A0 (nx219), .A1 (nx667), .B0 (nx638)) ;
    nand02 ix220 (.Y (nx219), .A0 (nx699), .A1 (nx887)) ;
    inv02 ix230 (.Y (nx229), .A (OPCODE[6])) ;
    ao21 ix829 (.Y (MEM_CON[12]), .A0 (nx893), .A1 (nx634), .B0 (nx766)) ;
    nor02 ix309 (.Y (PC_CON[10]), .A0 (nx189), .A1 (nx102)) ;
    nor02 ix767 (.Y (nx766), .A0 (nx661), .A1 (nx933)) ;
    nand03 ix125 (.Y (nx124), .A0 (nx189), .A1 (OPCODE[1]), .A2 (nx638)) ;
    nor02 ix907 (.Y (MEM_CON[3]), .A0 (nx939), .A1 (nx651)) ;
    nand02 ix165 (.Y (nx162), .A0 (nx195), .A1 (nx887)) ;
    nor02 ix883 (.Y (MEM_CON[2]), .A0 (nx209), .A1 (nx939)) ;
    ao21 ix893 (.Y (MEM_CON[1]), .A0 (nx705), .A1 (nx709), .B0 (MEM_CON[9])) ;
    nor02 ix254 (.Y (nx253), .A0 (nx102), .A1 (OPCODE[0])) ;
    nand02 ix65 (.Y (nx64), .A0 (OPCODE[7]), .A1 (nx883)) ;
    nor02 ix885 (.Y (MEM_CON[9]), .A0 (nx261), .A1 (nx201)) ;
    inv02 ix262 (.Y (nx261), .A (OPCODE[5])) ;
    nor02 ix543 (.Y (SWITCH_CON[5]), .A0 (nx915), .A1 (nx917)) ;
    ao21 ix17 (.Y (nx16), .A0 (OPCODE[2]), .A1 (nx12), .B0 (OPCODE[3])) ;
    or02 ix13 (.Y (nx12), .A0 (OPCODE[0]), .A1 (OPCODE[1])) ;
    nor02 ix709 (.Y (INTR_CON), .A0 (nx661), .A1 (nx190)) ;
    nand03 ix191 (.Y (nx190), .A0 (nx893), .A1 (nx887), .A2 (nx699)) ;
    or03 ix729 (.Y (PORT_CON), .A0 (nx689), .A1 (nx174), .A2 (nx724)) ;
    nand03 ix11 (.Y (nx10), .A0 (nx703), .A1 (nx893), .A2 (nx887)) ;
    ao21 ix725 (.Y (nx724), .A0 (nx945), .A1 (nx935), .B0 (nx643)) ;
    nand02 ix29 (.Y (nx28), .A0 (OPCODE[2]), .A1 (nx209)) ;
    ao21 ix335 (.Y (IMM_CON), .A0 (nx945), .A1 (nx715), .B0 (nx947)) ;
    nand02 ix5 (.Y (nx4), .A0 (nx893), .A1 (nx887)) ;
    nand04 ix425 (.Y (STATE_CON[0]), .A0 (nx717), .A1 (nx201), .A2 (nx723), .A3 (
           nx727)) ;
    nor04 ix308 (.Y (nx307), .A0 (nx420), .A1 (nx679), .A2 (nx636), .A3 (
          SFR_CON[2])) ;
    ao21 ix421 (.Y (nx420), .A0 (nx703), .A1 (nx719), .B0 (nx634)) ;
    nor02 ix312 (.Y (nx311), .A0 (nx893), .A1 (nx887)) ;
    nor03 ix405 (.Y (PC_CON[5]), .A0 (nx721), .A1 (nx655), .A2 (nx261)) ;
    nand02 ix320 (.Y (nx319), .A0 (OPCODE[1]), .A1 (nx638)) ;
    aoi22 ix324 (.Y (nx323), .A0 (nx945), .A1 (nx927), .B0 (nx203), .B1 (nx372)
          ) ;
    nand02 ix83 (.Y (nx82), .A0 (nx703), .A1 (nx719)) ;
    aoi222 ix336 (.Y (nx335), .A0 (nx705), .A1 (nx675), .B0 (nx653), .B1 (nx939)
           , .C0 (IMM_CON), .C1 (nx356)) ;
    ao21 ix43 (.Y (nx42), .A0 (OPCODE[2]), .A1 (OPCODE[1]), .B0 (OPCODE[3])) ;
    or03 ix357 (.Y (nx356), .A0 (nx951), .A1 (nx949), .A2 (PC_CON[14])) ;
    ao21 ix349 (.Y (PC_CON[14]), .A0 (nx947), .A1 (nx939), .B0 (PC_CON[17])) ;
    nand04 ix321 (.Y (STATE_CON[2]), .A0 (nx729), .A1 (nx733), .A2 (nx735), .A3 (
           nx367)) ;
    nor04 ix346 (.Y (nx345), .A0 (nx632), .A1 (nx634), .A2 (nx302), .A3 (nx671)
          ) ;
    ao21 ix303 (.Y (nx302), .A0 (nx705), .A1 (nx296), .B0 (nx280)) ;
    ao21 ix281 (.Y (nx280), .A0 (nx653), .A1 (nx939), .B0 (nx174)) ;
    oai32 ix275 (.Y (nx274), .A0 (nx915), .A1 (OPCODE[7]), .A2 (nx731), .B0 (
          nx645), .B1 (nx357)) ;
    nor02 ix356 (.Y (nx355), .A0 (nx883), .A1 (nx887)) ;
    aoi22 ix360 (.Y (nx359), .A0 (nx945), .A1 (nx669), .B0 (nx927), .B1 (nx653)
          ) ;
    aoi33 ix362 (.Y (nx361), .A0 (nx363), .A1 (nx203), .A2 (nx219), .B0 (nx737)
          , .B1 (nx703), .B2 (nx893)) ;
    nand03 ix364 (.Y (nx363), .A0 (OPCODE[7]), .A1 (nx883), .A2 (nx887)) ;
    ao21 ix368 (.Y (nx367), .A0 (nx739), .A1 (nx148), .B0 (nx659)) ;
    oai21 ix370 (.Y (nx369), .A0 (nx887), .A1 (nx893), .B0 (nx699)) ;
    nand02 ix149 (.Y (nx148), .A0 (nx719), .A1 (nx949)) ;
    nand04 ix187 (.Y (STATE_CON[3]), .A0 (nx741), .A1 (nx743), .A2 (nx379), .A3 (
           nx745)) ;
    nor03 ix374 (.Y (nx373), .A0 (nx180), .A1 (nx174), .A2 (nx867)) ;
    nor02 ix181 (.Y (nx180), .A0 (OPCODE[7]), .A1 (nx659)) ;
    aoi22 ix378 (.Y (nx377), .A0 (nx705), .A1 (nx731), .B0 (nx945), .B1 (nx927)
          ) ;
    ao21 ix380 (.Y (nx379), .A0 (nx649), .A1 (nx209), .B0 (nx917)) ;
    oai21 ix382 (.Y (nx381), .A0 (OPCODE[2]), .A1 (OPCODE[3]), .B0 (nx383)) ;
    nand04 ix489 (.Y (PC_CON[0]), .A0 (nx649), .A1 (nx387), .A2 (nx747), .A3 (
           nx393)) ;
    nor03 ix390 (.Y (nx389), .A0 (nx677), .A1 (nx632), .A2 (nx634)) ;
    nor02 ix394 (.Y (nx393), .A0 (nx474), .A1 (nx681)) ;
    oai22 ix475 (.Y (nx474), .A0 (nx925), .A1 (nx638), .B0 (nx659), .B1 (nx739)
          ) ;
    oai221 ix463 (.Y (nx462), .A0 (nx661), .A1 (nx397), .B0 (nx711), .B1 (nx721)
           , .C0 (nx749)) ;
    nor02 ix398 (.Y (nx397), .A0 (nx673), .A1 (nx939)) ;
    oai21 ix401 (.Y (nx400), .A0 (nx949), .A1 (nx448), .B0 (nx737)) ;
    ao21 ix449 (.Y (nx448), .A0 (nx699), .A1 (nx889), .B0 (nx951)) ;
    ao21 ix779 (.Y (PC_CON[1]), .A0 (nx203), .A1 (nx405), .B0 (nx776)) ;
    ao21 ix777 (.Y (nx776), .A0 (nx705), .A1 (nx770), .B0 (nx679)) ;
    nand03 ix771 (.Y (nx770), .A0 (nx657), .A1 (nx923), .A2 (nx739)) ;
    nand03 ix435 (.Y (PC_CON[2]), .A0 (nx723), .A1 (nx411), .A2 (nx751)) ;
    aoi21 ix414 (.Y (nx413), .A0 (nx225), .A1 (nx653), .B0 (nx302)) ;
    ao21 ix761 (.Y (PC_CON[3]), .A0 (nx947), .A1 (nx951), .B0 (PC_CON[14])) ;
    nor02 ix753 (.Y (PC_CON[4]), .A0 (nx665), .A1 (nx925)) ;
    aoi21 ix747 (.Y (PC_CON[6]), .A0 (nx667), .A1 (nx725), .B0 (nx665)) ;
    ao21 ix743 (.Y (PC_CON[7]), .A0 (nx675), .A1 (nx180), .B0 (nx679)) ;
    nor02 ix739 (.Y (PC_CON[8]), .A0 (nx659), .A1 (nx923)) ;
    nand02 ix426 (.Y (nx425), .A0 (nx889), .A1 (nx883)) ;
    nand04 ix819 (.Y (SFR_CON[0]), .A0 (nx433), .A1 (nx755), .A2 (nx953), .A3 (
           nx447)) ;
    nand04 ix448 (.Y (nx447), .A0 (nx893), .A1 (nx449), .A2 (nx955), .A3 (nx504)
           ) ;
    nor04 ix1003 (.Y (SFR_CON[1]), .A0 (nx665), .A1 (nx215), .A2 (nx883), .A3 (
          nx889)) ;
    nand03 ix567 (.Y (SFR_CON[3]), .A0 (nx759), .A1 (nx761), .A2 (nx763)) ;
    nor03 ix460 (.Y (nx459), .A0 (nx687), .A1 (nx875), .A2 (SFR_CON[5])) ;
    oai21 ix561 (.Y (nx560), .A0 (nx659), .A1 (nx685), .B0 (nx465)) ;
    nand03 ix553 (.Y (nx552), .A0 (nx229), .A1 (nx889), .A2 (OPCODE[7])) ;
    or02 ix537 (.Y (SFR_CON[5]), .A0 (nx871), .A1 (SFR_CON[2])) ;
    aoi21 ix470 (.Y (nx469), .A0 (nx893), .A1 (nx524), .B0 (nx677)) ;
    aoi32 ix474 (.Y (nx473), .A0 (nx703), .A1 (nx195), .A2 (nx203), .B0 (nx947)
          , .B1 (nx683)) ;
    ao21 ix478 (.Y (nx477), .A0 (nx889), .A1 (nx883), .B0 (nx731)) ;
    and02 ix793 (.Y (SFR_CON[6]), .A0 (nx195), .A1 (nx630)) ;
    nor04 ix915 (.Y (MEM_CON[0]), .A0 (MEM_CON[2]), .A1 (MEM_CON[4]), .A2 (
          MEM_CON[1]), .A3 (nx487)) ;
    or02 ix859 (.Y (MEM_CON[4]), .A0 (nx695), .A1 (nx687)) ;
    oai33 ix857 (.Y (nx856), .A0 (nx500), .A1 (nx215), .A2 (nx661), .B0 (nx719)
          , .B1 (nx659), .B2 (nx126)) ;
    ao21 ix488 (.Y (nx487), .A0 (nx489), .A1 (nx705), .B0 (MEM_CON[3])) ;
    nor04 ix881 (.Y (MEM_CON[5]), .A0 (MEM_CON[7]), .A1 (MEM_CON[11]), .A2 (
          MEM_CON[4]), .A3 (nx493)) ;
    ao21 ix837 (.Y (MEM_CON[11]), .A0 (nx705), .A1 (nx713), .B0 (MEM_CON[12])) ;
    ao21 ix494 (.Y (nx493), .A0 (nx489), .A1 (nx705), .B0 (MEM_CON[8])) ;
    or04 ix623 (.Y (MEM_CON[10]), .A0 (nx643), .A1 (nx689), .A2 (nx596), .A3 (
         nx280)) ;
    oai22 ix597 (.Y (nx596), .A0 (nx445), .A1 (nx765), .B0 (nx104), .B1 (nx917)
          ) ;
    nor04 ix500 (.Y (nx499), .A0 (nx767), .A1 (nx713), .A2 (nx489), .A3 (nx574)
          ) ;
    nand03 ix575 (.Y (nx574), .A0 (nx725), .A1 (nx917), .A2 (nx933)) ;
    nor02 ix825 (.Y (MEM_CON[13]), .A0 (nx649), .A1 (nx923)) ;
    nand04 ix703 (.Y (SWITCH_CON[0]), .A0 (nx509), .A1 (nx755), .A2 (nx915), .A3 (
           nx769)) ;
    nand02 ix510 (.Y (nx509), .A0 (nx709), .A1 (nx955)) ;
    nor03 ix512 (.Y (nx511), .A0 (nx693), .A1 (nx680), .A2 (nx691)) ;
    aoi21 ix681 (.Y (nx680), .A0 (nx757), .A1 (nx214), .B0 (nx638)) ;
    nor04 ix673 (.Y (nx672), .A0 (nx195), .A1 (nx685), .A2 (nx28), .A3 (
          OPCODE[1])) ;
    oai221 ix987 (.Y (SWITCH_CON[1]), .A0 (nx357), .A1 (nx685), .B0 (nx445), .B1 (
           nx771), .C0 (nx775)) ;
    nor02 ix524 (.Y (nx523), .A0 (nx655), .A1 (nx162)) ;
    aoi21 ix526 (.Y (nx525), .A0 (nx947), .A1 (nx949), .B0 (nx921)) ;
    oai221 ix663 (.Y (SWITCH_CON[2]), .A0 (nx661), .A1 (nx699), .B0 (nx917), .B1 (
           nx651), .C0 (nx777)) ;
    aoi322 ix532 (.Y (nx531), .A0 (nx753), .A1 (nx705), .A2 (nx675), .B0 (nx383)
           , .B1 (nx945), .C0 (nx647), .C1 (nx642)) ;
    nand02 ix955 (.Y (SWITCH_CON[3]), .A0 (nx537), .A1 (nx779)) ;
    aoi21 ix538 (.Y (nx537), .A0 (nx947), .A1 (nx949), .B0 (nx671)) ;
    aoi32 ix540 (.Y (nx539), .A0 (nx737), .A1 (nx893), .A2 (nx703), .B0 (nx715)
          , .B1 (nx647)) ;
    nor02 ix931 (.Y (SWITCH_CON[4]), .A0 (nx640), .A1 (nx781)) ;
    aoi22 ix544 (.Y (nx542), .A0 (nx215), .A1 (nx731), .B0 (nx709), .B1 (nx651)
          ) ;
    ao21 ix1247 (.Y (ALU_CON[0]), .A0 (nx737), .A1 (nx767), .B0 (nx626)) ;
    oai321 ix1207 (.Y (ALU_CON[5]), .A0 (nx640), .A1 (nx58), .A2 (nx883), .B0 (
           nx917), .B1 (nx445), .C0 (nx549)) ;
    nand02 ix1239 (.Y (ALU_CON[1]), .A0 (nx553), .A1 (nx561)) ;
    aoi21 ix554 (.Y (nx553), .A0 (nx737), .A1 (nx767), .B0 (nx1186)) ;
    ao21 ix1187 (.Y (nx1186), .A0 (nx102), .A1 (nx1182), .B0 (ALU_CON[4])) ;
    nor02 ix1183 (.Y (nx1182), .A0 (nx657), .A1 (nx895)) ;
    or02 ix1133 (.Y (ALU_CON[4]), .A0 (nx1130), .A1 (nx875)) ;
    aoi21 ix1131 (.Y (nx1130), .A0 (nx219), .A1 (nx675), .B0 (nx640)) ;
    nor02 ix562 (.Y (nx561), .A0 (nx1222), .A1 (ALU_CON[11])) ;
    oai22 ix1223 (.Y (nx1222), .A0 (nx104), .A1 (nx477), .B0 (nx925), .B1 (nx640
          )) ;
    nand02 ix1033 (.Y (ALU_CON[11]), .A0 (nx943), .A1 (nx567)) ;
    nand03 ix1229 (.Y (ALU_CON[2]), .A0 (nx561), .A1 (nx571), .A2 (nx787)) ;
    nand03 ix574 (.Y (nx573), .A0 (nx705), .A1 (nx889), .A2 (nx885)) ;
    nor02 ix576 (.Y (nx575), .A0 (nx766), .A1 (nx634)) ;
    aoi332 ix578 (.Y (nx577), .A0 (nx773), .A1 (OPCODE[1]), .A2 (nx640), .B0 (
           nx947), .B1 (nx703), .B2 (nx261), .C0 (nx647), .C1 (nx1158)) ;
    ao21 ix1159 (.Y (nx1158), .A0 (OPCODE[7]), .A1 (nx195), .B0 (nx767)) ;
    aoi21 ix582 (.Y (nx581), .A0 (nx102), .A1 (nx158), .B0 (nx626)) ;
    nor02 ix159 (.Y (nx158), .A0 (nx657), .A1 (nx889)) ;
    or02 ix1189 (.Y (ALU_CON[3]), .A0 (nx1186), .A1 (nx1172)) ;
    nand03 ix1173 (.Y (nx1172), .A0 (nx573), .A1 (nx783), .A2 (nx785)) ;
    oai22 ix1053 (.Y (ALU_CON[6]), .A0 (nx591), .A1 (nx721), .B0 (nx104), .B1 (
          nx669)) ;
    oai221 ix1123 (.Y (ALU_CON[7]), .A0 (nx665), .A1 (nx591), .B0 (nx661), .B1 (
           nx925), .C0 (nx595)) ;
    ao21 ix596 (.Y (nx595), .A0 (nx669), .A1 (nx917), .B0 (nx661)) ;
    oai222 ix1105 (.Y (ALU_CON[8]), .A0 (nx663), .A1 (nx599), .B0 (nx919), .B1 (
           nx721), .C0 (nx104), .C1 (nx669)) ;
    nor02 ix600 (.Y (nx599), .A0 (nx372), .A1 (nx939)) ;
    oai221 ix1083 (.Y (ALU_CON[9]), .A0 (nx104), .A1 (nx645), .B0 (nx663), .B1 (
           nx925), .C0 (nx789)) ;
    aoi22 ix604 (.Y (nx603), .A0 (nx203), .A1 (nx951), .B0 (nx879), .B1 (nx937)
          ) ;
    aoi21 ix1043 (.Y (ALU_CON[10]), .A0 (nx190), .A1 (nx667), .B0 (nx640)) ;
    or03 ix1013 (.Y (ALU_CON[12]), .A0 (nx1008), .A1 (nx628), .A2 (nx630)) ;
    nor02 ix1009 (.Y (nx1008), .A0 (nx282), .A1 (nx640)) ;
    nand03 ix1025 (.Y (ALU_CON[13]), .A0 (nx509), .A1 (nx755), .A2 (nx791)) ;
    aoi21 ix612 (.Y (nx611), .A0 (nx737), .A1 (nx713), .B0 (nx630)) ;
    or04 ix1031 (.Y (ALU_CON[14]), .A0 (nx628), .A1 (nx630), .A2 (nx524), .A3 (
         SFR_CON[2])) ;
    nand02 ix993 (.Y (ALU_CON[15]), .A0 (nx783), .A1 (nx509)) ;
    nand02 ix995 (.Y (ALU_CON[16]), .A0 (nx783), .A1 (nx617)) ;
    nand03 ix618 (.Y (nx617), .A0 (nx737), .A1 (nx195), .A2 (nx703)) ;
    ao21 ix989 (.Y (ALU_CON[17]), .A0 (nx701), .A1 (nx947), .B0 (nx875)) ;
    inv02 ix572 (.Y (nx571), .A (nx1172)) ;
    inv02 ix505 (.Y (nx504), .A (nx477)) ;
    inv02 ix501 (.Y (nx500), .A (nx425)) ;
    inv02 ix282 (.Y (nx281), .A (nx292)) ;
    inv02 ix217 (.Y (nx216), .A (nx523)) ;
    inv02 ix406 (.Y (nx405), .A (nx188)) ;
    inv02 ix127 (.Y (nx126), .A (nx197)) ;
    inv04 ix204 (.Y (nx203), .A (nx124)) ;
    inv04 ix105 (.Y (nx104), .A (nx253)) ;
    inv02 ix226 (.Y (nx225), .A (nx82)) ;
    inv02 ix450 (.Y (nx449), .A (nx64)) ;
    inv02 ix358 (.Y (nx357), .A (nx42)) ;
    inv02 ix446 (.Y (nx445), .A (nx16)) ;
    inv02 ix384 (.Y (nx383), .A (nx10)) ;
    inv02 ix568 (.Y (nx567), .A (MEM_CON[14])) ;
    inv02 ix388 (.Y (nx387), .A (PC_CON[9])) ;
    inv02 ix428 (.Y (nx427), .A (ALU_CON[18])) ;
    inv02 ix412 (.Y (nx411), .A (PC_CON[12])) ;
    inv02 ix397 (.Y (SFR_CON[2]), .A (nx617)) ;
    buf02 ix625 (.Y (nx626), .A (nx798)) ;
    buf02 ix627 (.Y (nx628), .A (nx800)) ;
    buf02 ix629 (.Y (nx630), .A (nx802)) ;
    inv02 ix631 (.Y (nx632), .A (nx411)) ;
    buf02 ix633 (.Y (nx634), .A (PC_CON[10])) ;
    buf02 ix635 (.Y (nx636), .A (nx804)) ;
    inv04 ix637 (.Y (nx638), .A (nx427)) ;
    inv04 ix639 (.Y (nx640), .A (nx427)) ;
    inv02 ix641 (.Y (nx643), .A (nx567)) ;
    inv02 ix644 (.Y (nx645), .A (nx383)) ;
    inv02 ix646 (.Y (nx647), .A (nx445)) ;
    inv02 ix648 (.Y (nx649), .A (nx293)) ;
    inv02 ix650 (.Y (nx651), .A (nx451)) ;
    inv02 ix652 (.Y (nx653), .A (nx357)) ;
    inv02 ix654 (.Y (nx655), .A (nx449)) ;
    inv02 ix656 (.Y (nx657), .A (nx328)) ;
    inv02 ix658 (.Y (nx659), .A (nx707)) ;
    inv04 ix660 (.Y (nx661), .A (nx203)) ;
    inv04 ix662 (.Y (nx663), .A (nx203)) ;
    inv02 ix664 (.Y (nx665), .A (nx303)) ;
    inv02 ix666 (.Y (nx667), .A (nx340)) ;
    inv02 ix668 (.Y (nx669), .A (nx245)) ;
    buf02 ix670 (.Y (nx671), .A (nx274)) ;
    inv02 ix672 (.Y (nx673), .A (nx281)) ;
    inv02 ix674 (.Y (nx675), .A (nx489)) ;
    inv02 ix676 (.Y (nx677), .A (nx549)) ;
    buf02 ix678 (.Y (nx679), .A (nx412)) ;
    buf02 ix680 (.Y (nx681), .A (nx462)) ;
    buf02 ix682 (.Y (nx683), .A (nx512)) ;
    buf02 ix684 (.Y (nx685), .A (nx552)) ;
    buf02 ix686 (.Y (nx687), .A (nx560)) ;
    buf02 ix688 (.Y (nx689), .A (nx612)) ;
    buf02 ix690 (.Y (nx691), .A (nx672)) ;
    buf02 ix692 (.Y (nx693), .A (nx692)) ;
    buf02 ix694 (.Y (nx695), .A (nx856)) ;
    inv02 ix698 (.Y (nx699), .A (nx126)) ;
    inv02 ix700 (.Y (nx701), .A (nx126)) ;
    buf02 ix702 (.Y (nx703), .A (nx213)) ;
    inv02 ix704 (.Y (nx705), .A (nx104)) ;
    inv02 ix706 (.Y (nx707), .A (nx104)) ;
    inv02 ix708 (.Y (nx709), .A (nx66)) ;
    inv02 ix710 (.Y (nx711), .A (nx170)) ;
    inv02 ix712 (.Y (nx713), .A (nx282)) ;
    inv02 ix714 (.Y (nx715), .A (nx88)) ;
    buf02 ix716 (.Y (nx717), .A (nx307)) ;
    buf02 ix718 (.Y (nx719), .A (nx311)) ;
    buf02 ix720 (.Y (nx721), .A (nx319)) ;
    buf02 ix722 (.Y (nx723), .A (nx323)) ;
    inv02 ix724 (.Y (nx725), .A (nx94)) ;
    buf02 ix726 (.Y (nx727), .A (nx335)) ;
    buf02 ix728 (.Y (nx729), .A (nx345)) ;
    buf02 ix730 (.Y (nx731), .A (nx355)) ;
    buf02 ix732 (.Y (nx733), .A (nx359)) ;
    buf02 ix734 (.Y (nx735), .A (nx361)) ;
    inv02 ix736 (.Y (nx737), .A (nx24)) ;
    buf02 ix738 (.Y (nx739), .A (nx369)) ;
    buf02 ix740 (.Y (nx741), .A (nx373)) ;
    buf02 ix742 (.Y (nx743), .A (nx377)) ;
    buf02 ix744 (.Y (nx745), .A (nx381)) ;
    buf02 ix746 (.Y (nx747), .A (nx389)) ;
    buf02 ix748 (.Y (nx749), .A (nx400)) ;
    buf02 ix750 (.Y (nx751), .A (nx413)) ;
    inv02 ix752 (.Y (nx753), .A (nx500)) ;
    inv02 ix754 (.Y (nx755), .A (nx524)) ;
    inv02 ix756 (.Y (nx757), .A (nx642)) ;
    buf02 ix758 (.Y (nx759), .A (nx459)) ;
    buf02 ix760 (.Y (nx761), .A (nx469)) ;
    buf02 ix762 (.Y (nx763), .A (nx473)) ;
    buf02 ix764 (.Y (nx765), .A (nx499)) ;
    inv02 ix766 (.Y (nx767), .A (nx214)) ;
    buf02 ix768 (.Y (nx769), .A (nx511)) ;
    buf02 ix770 (.Y (nx771), .A (nx521)) ;
    inv02 ix772 (.Y (nx773), .A (nx216)) ;
    buf02 ix774 (.Y (nx775), .A (nx525)) ;
    buf02 ix776 (.Y (nx777), .A (nx531)) ;
    buf02 ix778 (.Y (nx779), .A (nx539)) ;
    buf02 ix780 (.Y (nx781), .A (nx542)) ;
    buf02 ix782 (.Y (nx783), .A (nx575)) ;
    buf02 ix784 (.Y (nx785), .A (nx577)) ;
    buf02 ix786 (.Y (nx787), .A (nx581)) ;
    buf02 ix788 (.Y (nx789), .A (nx603)) ;
    buf02 ix790 (.Y (nx791), .A (nx611)) ;
    buf02 ix797 (.Y (nx798), .A (nx810)) ;
    buf02 ix799 (.Y (nx800), .A (nx812)) ;
    buf02 ix801 (.Y (nx802), .A (nx814)) ;
    buf02 ix803 (.Y (nx804), .A (nx816)) ;
    buf02 ix809 (.Y (nx810), .A (nx822)) ;
    buf02 ix811 (.Y (nx812), .A (nx824)) ;
    buf02 ix813 (.Y (nx814), .A (nx827)) ;
    buf02 ix815 (.Y (nx816), .A (nx829)) ;
    buf02 ix821 (.Y (nx822), .A (nx835)) ;
    buf02 ix823 (.Y (nx824), .A (nx837)) ;
    buf02 ix826 (.Y (nx827), .A (nx839)) ;
    buf02 ix828 (.Y (nx829), .A (nx841)) ;
    buf02 ix834 (.Y (nx835), .A (nx847)) ;
    buf02 ix836 (.Y (nx837), .A (nx849)) ;
    buf02 ix838 (.Y (nx839), .A (nx851)) ;
    buf02 ix840 (.Y (nx841), .A (nx853)) ;
    buf02 ix846 (.Y (nx847), .A (nx881)) ;
    buf02 ix848 (.Y (nx849), .A (nx873)) ;
    buf02 ix850 (.Y (nx851), .A (PC_CON[15])) ;
    buf02 ix852 (.Y (nx853), .A (nx869)) ;
    or02 ix189 (.Y (nx188), .A0 (nx58), .A1 (nx126)) ;
    or02 ix194 (.Y (nx58), .A0 (nx195), .A1 (nx889)) ;
    or02 ix202 (.Y (nx201), .A0 (nx929), .A1 (nx126)) ;
    and02 ix341 (.Y (PC_CON[17]), .A0 (nx945), .A1 (nx939)) ;
    and04 ix35 (.Y (nx293), .A0 (OPCODE[0]), .A1 (nx187), .A2 (OPCODE[2]), .A3 (
          nx209)) ;
    and03 ix251 (.Y (nx245), .A0 (nx703), .A1 (nx195), .A2 (nx889)) ;
    nor02 ix235 (.Y (nx340), .A0 (nx861), .A1 (nx58)) ;
    inv02 ix860 (.Y (nx861), .A (nx703)) ;
    and02 ix873 (.Y (MEM_CON[8]), .A0 (nx923), .A1 (nx955)) ;
    and03 ix39 (.Y (nx451), .A0 (OPCODE[2]), .A1 (nx209), .A2 (OPCODE[1])) ;
    and02 ix839 (.Y (MEM_CON[7]), .A0 (OPCODE[3]), .A1 (nx923)) ;
    or02 ix103 (.Y (nx102), .A0 (nx427), .A1 (OPCODE[1])) ;
    nand03 ix256 (.Y (nx66), .A0 (nx449), .A1 (nx895), .A2 (nx261)) ;
    ao21 ix613 (.Y (nx612), .A0 (nx203), .A1 (nx931), .B0 (nx863)) ;
    inv02 ix862 (.Y (nx863), .A (nx279)) ;
    aoi21 ix276 (.Y (nx170), .A0 (nx895), .A1 (nx889), .B0 (nx657)) ;
    and02 ix87 (.Y (nx328), .A0 (nx215), .A1 (nx883)) ;
    oai21 ix280 (.Y (nx279), .A0 (nx292), .A1 (nx951), .B0 (nx203)) ;
    and02 ix289 (.Y (nx591), .A0 (nx917), .A1 (nx645)) ;
    or03 ix287 (.Y (nx282), .A0 (nx655), .A1 (nx895), .A2 (nx891)) ;
    and02 ix175 (.Y (nx174), .A0 (nx947), .A1 (nx931)) ;
    and03 ix147 (.Y (nx303), .A0 (OPCODE[0]), .A1 (OPCODE[1]), .A2 (nx638)) ;
    oai21 ix719 (.Y (nx718), .A0 (nx891), .A1 (nx126), .B0 (nx919)) ;
    or02 ix300 (.Y (nx88), .A0 (nx4), .A1 (nx657)) ;
    ao21 ix413 (.Y (nx412), .A0 (nx383), .A1 (nx427), .B0 (nx921)) ;
    aoi21 ix316 (.Y (nx74), .A0 (nx649), .A1 (nx209), .B0 (nx917)) ;
    or02 ix373 (.Y (nx372), .A0 (nx951), .A1 (nx927)) ;
    nand02 ix334 (.Y (nx94), .A0 (nx925), .A1 (nx923)) ;
    and02 ix361 (.Y (nx489), .A0 (nx719), .A1 (nx699)) ;
    and02 ix315 (.Y (PC_CON[12]), .A0 (nx707), .A1 (nx951)) ;
    or02 ix297 (.Y (nx296), .A0 (nx292), .A1 (nx939)) ;
    nand02 ix366 (.Y (nx24), .A0 (nx427), .A1 (nx445)) ;
    nand02 ix411 (.Y (nx549), .A0 (nx383), .A1 (nx427)) ;
    ao21 ix293 (.Y (nx292), .A0 (nx449), .A1 (nx261), .B0 (nx383)) ;
    and04 ix789 (.Y (PC_CON[15]), .A0 (nx449), .A1 (nx865), .A2 (nx500), .A3 (
          nx877)) ;
    inv02 ix864 (.Y (nx865), .A (nx634)) ;
    and03 ix733 (.Y (PC_CON[16]), .A0 (nx707), .A1 (nx449), .A2 (nx891)) ;
    or02 ix434 (.Y (nx433), .A0 (nx383), .A1 (nx915)) ;
    and02 ix436 (.Y (nx524), .A0 (nx699), .A1 (nx947)) ;
    oai21 ix438 (.Y (nx437), .A0 (nx642), .A1 (nx957), .B0 (nx16)) ;
    or03 ix440 (.Y (nx642), .A0 (nx713), .A1 (nx931), .A2 (nx448)) ;
    or02 ix466 (.Y (nx465), .A0 (nx929), .A1 (nx925)) ;
    ao21 ix513 (.Y (nx512), .A0 (nx449), .A1 (nx504), .B0 (nx383)) ;
    or02 ix502 (.Y (nx214), .A0 (nx655), .A1 (nx4)) ;
    ao32 ix693 (.Y (nx692), .A0 (nx500), .A1 (nx215), .A2 (nx941), .B0 (nx203), 
         .B1 (nx949)) ;
    and04 ix522 (.Y (nx521), .A0 (nx675), .A1 (nx216), .A2 (nx933), .A3 (nx923)
          ) ;
    oai21 ix1063 (.Y (nx1062), .A0 (OPCODE[0]), .A1 (nx427), .B0 (nx919)) ;
    inv02 ix866 (.Y (nx867), .A (nx387)) ;
    buf02 ix868 (.Y (nx869), .A (nx897)) ;
    buf02 ix870 (.Y (nx871), .A (SFR_CON[4])) ;
    buf02 ix872 (.Y (nx873), .A (nx899)) ;
    buf02 ix874 (.Y (nx875), .A (SWITCH_CON[5])) ;
    inv02 ix876 (.Y (nx877), .A (nx427)) ;
    buf02 ix878 (.Y (nx879), .A (ALU_CON[6])) ;
    buf02 ix880 (.Y (nx881), .A (nx901)) ;
    inv02 ix882 (.Y (nx883), .A (nx229)) ;
    inv02 ix884 (.Y (nx885), .A (nx229)) ;
    inv02 ix886 (.Y (nx887), .A (nx261)) ;
    inv02 ix888 (.Y (nx889), .A (nx261)) ;
    inv02 ix890 (.Y (nx891), .A (nx261)) ;
    inv02 ix892 (.Y (nx893), .A (nx195)) ;
    inv02 ix894 (.Y (nx895), .A (nx195)) ;
    buf02 ix896 (.Y (nx897), .A (nx903)) ;
    buf02 ix898 (.Y (nx899), .A (nx905)) ;
    buf02 ix900 (.Y (nx901), .A (nx907)) ;
    buf02 ix902 (.Y (nx903), .A (nx913)) ;
    buf02 ix904 (.Y (nx905), .A (nx911)) ;
    buf02 ix906 (.Y (nx907), .A (nx909)) ;
    buf02 ix908 (.Y (nx909), .A (nx963)) ;
    buf02 ix910 (.Y (nx911), .A (nx965)) ;
    buf02 ix912 (.Y (nx913), .A (nx967)) ;
    inv02 ix914 (.Y (nx915), .A (nx737)) ;
    inv02 ix916 (.Y (nx917), .A (nx709)) ;
    inv02 ix918 (.Y (nx919), .A (nx709)) ;
    buf02 ix920 (.Y (nx921), .A (nx74)) ;
    inv02 ix922 (.Y (nx923), .A (nx225)) ;
    inv02 ix924 (.Y (nx925), .A (nx715)) ;
    inv02 ix926 (.Y (nx927), .A (nx725)) ;
    inv02 ix928 (.Y (nx929), .A (nx203)) ;
    inv02 ix930 (.Y (nx931), .A (nx711)) ;
    inv02 ix932 (.Y (nx933), .A (nx405)) ;
    buf02 ix934 (.Y (nx935), .A (nx718)) ;
    buf02 ix936 (.Y (nx937), .A (nx1062)) ;
    inv02 ix938 (.Y (nx939), .A (nx669)) ;
    inv02 ix940 (.Y (nx941), .A (nx104)) ;
    inv02 ix942 (.Y (nx943), .A (nx863)) ;
    inv02 ix944 (.Y (nx945), .A (nx649)) ;
    inv02 ix946 (.Y (nx947), .A (nx665)) ;
    inv02 ix948 (.Y (nx949), .A (nx657)) ;
    inv02 ix950 (.Y (nx951), .A (nx667)) ;
    buf02 ix952 (.Y (nx953), .A (nx437)) ;
    inv02 ix954 (.Y (nx955), .A (nx651)) ;
    inv02 ix956 (.Y (nx957), .A (nx216)) ;
    buf02 ix962 (.Y (nx963), .A (nx973)) ;
    buf02 ix964 (.Y (nx965), .A (nx975)) ;
    buf02 ix966 (.Y (nx967), .A (nx977)) ;
    buf02 ix972 (.Y (nx973), .A (nx983)) ;
    buf02 ix974 (.Y (nx975), .A (nx985)) ;
    buf02 ix976 (.Y (nx977), .A (nx987)) ;
    buf02 ix982 (.Y (nx983), .A (nx995)) ;
    buf02 ix984 (.Y (nx985), .A (nx997)) ;
    buf02 ix986 (.Y (nx987), .A (nx999)) ;
    buf02 ix994 (.Y (nx995), .A (nx1006)) ;
    buf02 ix996 (.Y (nx997), .A (nx1009)) ;
    buf02 ix998 (.Y (nx999), .A (nx1011)) ;
    buf02 ix1005 (.Y (nx1006), .A (nx1022)) ;
    buf02 ix1007 (.Y (nx1009), .A (nx1020)) ;
    buf02 ix1010 (.Y (nx1011), .A (nx1018)) ;
    buf02 ix1017 (.Y (nx1018), .A (PC_CON[5])) ;
    buf02 ix1019 (.Y (nx1020), .A (SFR_CON[1])) ;
    buf02 ix1021 (.Y (nx1022), .A (ALU_CON[5])) ;
endmodule


module block12 ( OPCODE, IMMEDIATE, IMMEDIATE_2, PROGDI, EXCEPTION, 
                  NEXT_STATE_IDLE, IDLE, INTERNAL_RESET, STATE, LAST_CYC, 
                  IMM_CON, INTERNAL_WAIT, CLK3_EN, CLK2, CLK3 ) ;

    output [7:0]OPCODE ;
    output [7:0]IMMEDIATE ;
    output [7:0]IMMEDIATE_2 ;
    input [7:0]PROGDI ;
    input EXCEPTION ;
    input NEXT_STATE_IDLE ;
    input IDLE ;
    input INTERNAL_RESET ;
    input [2:0]STATE ;
    input LAST_CYC ;
    input IMM_CON ;
    input INTERNAL_WAIT ;
    input CLK3_EN ;
    input CLK2 ;
    input CLK3 ;

    wire nx12, nx140, nx152, nx463, nx467, nx473, nx477, nx483, nx487, nx493, 
         nx497, nx503, nx507, nx513, nx517, nx523, nx527, nx533, nx537, nx545, 
         nx547, nx555, nx557, nx565, nx567, nx575, nx577, nx585, nx587, nx595, 
         nx597, nx605, nx607, nx615, nx617, nx625, nx627, nx635, nx637, nx645, 
         nx647, nx655, nx657, nx665, nx667, nx675, nx677, nx685, nx687, nx695, 
         nx697, nx709, nx711, nx749, nx782, nx784, nx787, nx789, nx792, nx799, 
         nx801, nx807, nx813, nx819, nx825, nx831, nx837, nx845, nx847, nx849, 
         nx851, nx853, nx855, nx857, nx859, nx861, nx863, nx865, nx867, nx869, 
         nx871, nx873, nx879, nx881;
    wire [23:0] \$dummy ;




    dff ix550 (.Q (IMMEDIATE_2[0]), .QB (\$dummy [0]), .D (nx547), .CLK (CLK2)
        ) ;
    ao21 ix548 (.Y (nx547), .A0 (IMMEDIATE_2[0]), .A1 (nx879), .B0 (nx545)) ;
    inv02 ix712 (.Y (nx711), .A (STATE[0])) ;
    and02 ix546 (.Y (nx545), .A0 (PROGDI[0]), .A1 (nx847)) ;
    dff ix560 (.Q (IMMEDIATE_2[1]), .QB (\$dummy [1]), .D (nx557), .CLK (CLK2)
        ) ;
    ao21 ix558 (.Y (nx557), .A0 (IMMEDIATE_2[1]), .A1 (nx879), .B0 (nx555)) ;
    and02 ix556 (.Y (nx555), .A0 (PROGDI[1]), .A1 (nx847)) ;
    dff ix570 (.Q (IMMEDIATE_2[2]), .QB (\$dummy [2]), .D (nx567), .CLK (CLK2)
        ) ;
    ao21 ix568 (.Y (nx567), .A0 (IMMEDIATE_2[2]), .A1 (nx879), .B0 (nx565)) ;
    and02 ix566 (.Y (nx565), .A0 (PROGDI[2]), .A1 (nx847)) ;
    dff ix580 (.Q (IMMEDIATE_2[3]), .QB (\$dummy [3]), .D (nx577), .CLK (CLK2)
        ) ;
    ao21 ix578 (.Y (nx577), .A0 (IMMEDIATE_2[3]), .A1 (nx879), .B0 (nx575)) ;
    and02 ix576 (.Y (nx575), .A0 (PROGDI[3]), .A1 (nx847)) ;
    dff ix590 (.Q (IMMEDIATE_2[4]), .QB (\$dummy [4]), .D (nx587), .CLK (CLK2)
        ) ;
    ao21 ix588 (.Y (nx587), .A0 (IMMEDIATE_2[4]), .A1 (nx879), .B0 (nx585)) ;
    and02 ix586 (.Y (nx585), .A0 (PROGDI[4]), .A1 (nx847)) ;
    dff ix600 (.Q (IMMEDIATE_2[5]), .QB (\$dummy [5]), .D (nx597), .CLK (CLK2)
        ) ;
    ao21 ix598 (.Y (nx597), .A0 (IMMEDIATE_2[5]), .A1 (nx879), .B0 (nx595)) ;
    and02 ix596 (.Y (nx595), .A0 (PROGDI[5]), .A1 (nx847)) ;
    dff ix610 (.Q (IMMEDIATE_2[6]), .QB (\$dummy [6]), .D (nx607), .CLK (CLK2)
        ) ;
    ao21 ix608 (.Y (nx607), .A0 (IMMEDIATE_2[6]), .A1 (nx879), .B0 (nx605)) ;
    and02 ix606 (.Y (nx605), .A0 (PROGDI[6]), .A1 (nx847)) ;
    dff ix620 (.Q (IMMEDIATE_2[7]), .QB (\$dummy [7]), .D (nx617), .CLK (CLK2)
        ) ;
    ao21 ix618 (.Y (nx617), .A0 (IMMEDIATE_2[7]), .A1 (nx879), .B0 (nx615)) ;
    and02 ix616 (.Y (nx615), .A0 (PROGDI[7]), .A1 (nx847)) ;
    dff ix470 (.Q (IMMEDIATE[0]), .QB (\$dummy [8]), .D (nx467), .CLK (CLK2)) ;
    ao21 ix468 (.Y (nx467), .A0 (PROGDI[0]), .A1 (nx849), .B0 (nx463)) ;
    nor04 ix13 (.Y (nx12), .A0 (STATE[2]), .A1 (STATE[1]), .A2 (STATE[0]), .A3 (
          INTERNAL_WAIT)) ;
    and02 ix464 (.Y (nx463), .A0 (IMMEDIATE[0]), .A1 (nx881)) ;
    dff ix480 (.Q (IMMEDIATE[1]), .QB (\$dummy [9]), .D (nx477), .CLK (CLK2)) ;
    ao21 ix478 (.Y (nx477), .A0 (PROGDI[1]), .A1 (nx849), .B0 (nx473)) ;
    and02 ix474 (.Y (nx473), .A0 (IMMEDIATE[1]), .A1 (nx881)) ;
    dff ix490 (.Q (IMMEDIATE[2]), .QB (\$dummy [10]), .D (nx487), .CLK (CLK2)) ;
    ao21 ix488 (.Y (nx487), .A0 (PROGDI[2]), .A1 (nx849), .B0 (nx483)) ;
    and02 ix484 (.Y (nx483), .A0 (IMMEDIATE[2]), .A1 (nx881)) ;
    dff ix500 (.Q (IMMEDIATE[3]), .QB (\$dummy [11]), .D (nx497), .CLK (CLK2)) ;
    ao21 ix498 (.Y (nx497), .A0 (PROGDI[3]), .A1 (nx849), .B0 (nx493)) ;
    and02 ix494 (.Y (nx493), .A0 (IMMEDIATE[3]), .A1 (nx881)) ;
    dff ix510 (.Q (IMMEDIATE[4]), .QB (\$dummy [12]), .D (nx507), .CLK (CLK2)) ;
    ao21 ix508 (.Y (nx507), .A0 (PROGDI[4]), .A1 (nx849), .B0 (nx503)) ;
    and02 ix504 (.Y (nx503), .A0 (IMMEDIATE[4]), .A1 (nx881)) ;
    dff ix520 (.Q (IMMEDIATE[5]), .QB (\$dummy [13]), .D (nx517), .CLK (CLK2)) ;
    ao21 ix518 (.Y (nx517), .A0 (PROGDI[5]), .A1 (nx849), .B0 (nx513)) ;
    and02 ix514 (.Y (nx513), .A0 (IMMEDIATE[5]), .A1 (nx881)) ;
    dff ix530 (.Q (IMMEDIATE[6]), .QB (\$dummy [14]), .D (nx527), .CLK (CLK2)) ;
    ao21 ix528 (.Y (nx527), .A0 (PROGDI[6]), .A1 (nx849), .B0 (nx523)) ;
    and02 ix524 (.Y (nx523), .A0 (IMMEDIATE[6]), .A1 (nx881)) ;
    dff ix540 (.Q (IMMEDIATE[7]), .QB (\$dummy [15]), .D (nx537), .CLK (CLK2)) ;
    ao21 ix538 (.Y (nx537), .A0 (PROGDI[7]), .A1 (nx849), .B0 (nx533)) ;
    and02 ix534 (.Y (nx533), .A0 (IMMEDIATE[7]), .A1 (nx881)) ;
    dff ix630 (.Q (OPCODE[0]), .QB (\$dummy [16]), .D (nx627), .CLK (CLK3)) ;
    ao21 ix628 (.Y (nx627), .A0 (OPCODE[0]), .A1 (nx853), .B0 (nx625)) ;
    nand02 ix783 (.Y (nx782), .A0 (CLK3_EN), .A1 (nx784)) ;
    inv02 ix785 (.Y (nx784), .A (INTERNAL_WAIT)) ;
    nor02 ix626 (.Y (nx625), .A0 (nx857), .A1 (nx853)) ;
    aoi22 ix788 (.Y (nx787), .A0 (OPCODE[0]), .A1 (nx859), .B0 (PROGDI[0]), .B1 (
          nx851)) ;
    nor03 ix790 (.Y (nx789), .A0 (EXCEPTION), .A1 (NEXT_STATE_IDLE), .A2 (nx140)
          ) ;
    ao21 ix141 (.Y (nx140), .A0 (LAST_CYC), .A1 (nx792), .B0 (INTERNAL_RESET)) ;
    inv02 ix793 (.Y (nx792), .A (IDLE)) ;
    nor04 ix153 (.Y (nx152), .A0 (NEXT_STATE_IDLE), .A1 (EXCEPTION), .A2 (nx859)
          , .A3 (INTERNAL_RESET)) ;
    dff ix640 (.Q (OPCODE[1]), .QB (\$dummy [17]), .D (nx637), .CLK (CLK3)) ;
    ao21 ix638 (.Y (nx637), .A0 (OPCODE[1]), .A1 (nx853), .B0 (nx635)) ;
    nor02 ix636 (.Y (nx635), .A0 (nx861), .A1 (nx853)) ;
    aoi222 ix800 (.Y (nx799), .A0 (EXCEPTION), .A1 (nx801), .B0 (OPCODE[1]), .B1 (
           nx859), .C0 (PROGDI[1]), .C1 (nx851)) ;
    inv02 ix802 (.Y (nx801), .A (INTERNAL_RESET)) ;
    dff ix650 (.Q (OPCODE[2]), .QB (\$dummy [18]), .D (nx647), .CLK (CLK3)) ;
    ao21 ix648 (.Y (nx647), .A0 (OPCODE[2]), .A1 (nx853), .B0 (nx645)) ;
    nor02 ix646 (.Y (nx645), .A0 (nx863), .A1 (nx853)) ;
    aoi22 ix808 (.Y (nx807), .A0 (OPCODE[2]), .A1 (nx859), .B0 (PROGDI[2]), .B1 (
          nx851)) ;
    dff ix660 (.Q (OPCODE[3]), .QB (\$dummy [19]), .D (nx657), .CLK (CLK3)) ;
    ao21 ix658 (.Y (nx657), .A0 (OPCODE[3]), .A1 (nx853), .B0 (nx655)) ;
    nor02 ix656 (.Y (nx655), .A0 (nx865), .A1 (nx853)) ;
    aoi22 ix814 (.Y (nx813), .A0 (OPCODE[3]), .A1 (nx859), .B0 (PROGDI[3]), .B1 (
          nx851)) ;
    dff ix670 (.Q (OPCODE[4]), .QB (\$dummy [20]), .D (nx667), .CLK (CLK3)) ;
    ao21 ix668 (.Y (nx667), .A0 (OPCODE[4]), .A1 (nx853), .B0 (nx665)) ;
    nor02 ix666 (.Y (nx665), .A0 (nx867), .A1 (nx853)) ;
    aoi222 ix820 (.Y (nx819), .A0 (EXCEPTION), .A1 (nx801), .B0 (OPCODE[4]), .B1 (
           nx859), .C0 (PROGDI[4]), .C1 (nx851)) ;
    dff ix680 (.Q (OPCODE[5]), .QB (\$dummy [21]), .D (nx677), .CLK (CLK3)) ;
    ao21 ix678 (.Y (nx677), .A0 (OPCODE[5]), .A1 (nx855), .B0 (nx675)) ;
    nor02 ix676 (.Y (nx675), .A0 (nx869), .A1 (nx855)) ;
    aoi22 ix826 (.Y (nx825), .A0 (OPCODE[5]), .A1 (nx859), .B0 (PROGDI[5]), .B1 (
          nx851)) ;
    dff ix690 (.Q (OPCODE[6]), .QB (\$dummy [22]), .D (nx687), .CLK (CLK3)) ;
    ao21 ix688 (.Y (nx687), .A0 (OPCODE[6]), .A1 (nx855), .B0 (nx685)) ;
    nor02 ix686 (.Y (nx685), .A0 (nx871), .A1 (nx855)) ;
    aoi22 ix832 (.Y (nx831), .A0 (OPCODE[6]), .A1 (nx859), .B0 (PROGDI[6]), .B1 (
          nx851)) ;
    dff ix700 (.Q (OPCODE[7]), .QB (\$dummy [23]), .D (nx697), .CLK (CLK3)) ;
    ao21 ix698 (.Y (nx697), .A0 (OPCODE[7]), .A1 (nx855), .B0 (nx695)) ;
    nor02 ix696 (.Y (nx695), .A0 (nx873), .A1 (nx855)) ;
    aoi22 ix838 (.Y (nx837), .A0 (OPCODE[7]), .A1 (nx859), .B0 (PROGDI[7]), .B1 (
          nx851)) ;
    buf02 ix844 (.Y (nx845), .A (nx12)) ;
    inv02 ix846 (.Y (nx847), .A (nx709)) ;
    inv02 ix848 (.Y (nx849), .A (nx749)) ;
    buf02 ix850 (.Y (nx851), .A (nx152)) ;
    buf02 ix852 (.Y (nx853), .A (nx782)) ;
    buf02 ix854 (.Y (nx855), .A (nx782)) ;
    buf02 ix856 (.Y (nx857), .A (nx787)) ;
    buf02 ix858 (.Y (nx859), .A (nx789)) ;
    buf02 ix860 (.Y (nx861), .A (nx799)) ;
    buf02 ix862 (.Y (nx863), .A (nx807)) ;
    buf02 ix864 (.Y (nx865), .A (nx813)) ;
    buf02 ix866 (.Y (nx867), .A (nx819)) ;
    buf02 ix868 (.Y (nx869), .A (nx825)) ;
    buf02 ix870 (.Y (nx871), .A (nx831)) ;
    buf02 ix872 (.Y (nx873), .A (nx837)) ;
    or04 ix25 (.Y (nx709), .A0 (STATE[2]), .A1 (STATE[1]), .A2 (nx711), .A3 (
         INTERNAL_WAIT)) ;
    aoi21 ix29 (.Y (nx749), .A0 (IMM_CON), .A1 (nx847), .B0 (nx845)) ;
    inv02 ix878 (.Y (nx879), .A (nx847)) ;
    inv02 ix880 (.Y (nx881), .A (nx849)) ;
endmodule


module block10 ( STATE, LAST_CYC, INTERNAL_WAIT, INTERNAL_RESET, PCON, 
                  NEXT_STATE_IDLE, NCCLKE, NPCLKE, CLK3_EN, REG_RESULT, 
                  SFR_WRITE_EN, STATE_CON, RESET, TEST_RESET, EXCEPTION, MWAIT, 
                  CLK1, CLK2 ) ;

    output [2:0]STATE ;
    output LAST_CYC ;
    output INTERNAL_WAIT ;
    output INTERNAL_RESET ;
    output [7:0]PCON ;
    output NEXT_STATE_IDLE ;
    output NCCLKE ;
    output NPCLKE ;
    output CLK3_EN ;
    input [7:0]REG_RESULT ;
    input [10:10]SFR_WRITE_EN ;
    input [5:0]STATE_CON ;
    input RESET ;
    input TEST_RESET ;
    input EXCEPTION ;
    input MWAIT ;
    input CLK1 ;
    input CLK2 ;

    wire NOT__848810_, RESET_SAMPLE, nx18, nx30, nx96, nx108, nx130, nx138, nx29, 
         nx33, nx43, nx53, nx61, nx63, nx71, nx73, nx81, nx83, nx93, nx103, 
         nx113, nx123, nx139, nx143, nx146, nx159, nx165, nx170, nx172, nx175, 
         nx177, nx182, nx185, nx190, nx192, nx198, nx199, nx202, nx204, nx208, 
         nx210, nx213, nx220, nx236, nx238, nx240, nx242, nx244, nx246, nx248, 
         nx250, nx252, nx254, nx260, nx266, nx272, nx278, nx284, nx290, nx292, 
         nx294, nx296, nx298, nx300, nx302, nx308, nx314, nx320, nx326, nx332, 
         nx338;
    wire [4:0] \$dummy ;




    assign PCON[5] = PCON[6] ;
    assign PCON[4] = PCON[6] ;
    fake_gnd ix8 (.Y (PCON[6])) ;
    dffs ix3 (.Q (CLK3_EN), .QB (NOT__848810_), .D (NOT__848810_), .CLK (CLK1), 
         .S (nx139)) ;
    inv02 ix140 (.Y (nx139), .A (TEST_RESET)) ;
    ao32 ix54 (.Y (nx53), .A0 (REG_RESULT[1]), .A1 (nx146), .A2 (
         SFR_WRITE_EN[10]), .B0 (PCON[1]), .B1 (nx248)) ;
    dffs ix46 (.Q (INTERNAL_RESET), .QB (nx146), .D (nx240), .CLK (CLK1), .S (
         nx139)) ;
    ao21 ix34 (.Y (nx33), .A0 (RESET), .A1 (CLK3_EN), .B0 (nx29)) ;
    dffs ix36 (.Q (RESET_SAMPLE), .QB (nx159), .D (nx33), .CLK (CLK1), .S (nx139
         )) ;
    dffr ix56 (.Q (PCON[1]), .QB (nx143), .D (nx53), .CLK (CLK1), .R (nx18)) ;
    or02 ix19 (.Y (nx18), .A0 (RESET), .A1 (TEST_RESET)) ;
    nor02 ix166 (.Y (nx165), .A0 (INTERNAL_RESET), .A1 (SFR_WRITE_EN[10])) ;
    mux21 ix94 (.Y (nx93), .A0 (nx170), .A1 (nx250), .S0 (nx238)) ;
    dffr ix96 (.Q (PCON[0]), .QB (nx170), .D (nx246), .CLK (CLK1), .R (nx18)) ;
    oai21 ix173 (.Y (nx172), .A0 (nx236), .A1 (nx213), .B0 (nx138)) ;
    oai21 ix125 (.Y (INTERNAL_WAIT), .A0 (nx252), .A1 (nx208), .B0 (nx210)) ;
    aoi22 ix176 (.Y (nx175), .A0 (nx177), .A1 (nx96), .B0 (STATE[0]), .B1 (
          LAST_CYC)) ;
    ao21 ix84 (.Y (nx83), .A0 (STATE[2]), .A1 (nx236), .B0 (nx244)) ;
    dff ix86 (.Q (STATE[2]), .QB (nx177), .D (nx83), .CLK (CLK2)) ;
    nor04 ix82 (.Y (nx81), .A0 (nx182), .A1 (nx199), .A2 (INTERNAL_RESET), .A3 (
          nx236)) ;
    nand02 ix186 (.Y (nx185), .A0 (STATE[1]), .A1 (STATE[0])) ;
    dff ix76 (.Q (STATE[1]), .QB (nx198), .D (nx73), .CLK (CLK2)) ;
    ao21 ix74 (.Y (nx73), .A0 (STATE[1]), .A1 (nx236), .B0 (nx242)) ;
    nor04 ix72 (.Y (nx71), .A0 (nx190), .A1 (INTERNAL_RESET), .A2 (nx254), .A3 (
          nx236)) ;
    inv02 ix191 (.Y (nx190), .A (STATE_CON[0])) ;
    oai21 ix193 (.Y (nx192), .A0 (STATE[0]), .A1 (STATE[1]), .B0 (nx185)) ;
    dff ix66 (.Q (STATE[0]), .QB (\$dummy [0]), .D (nx63), .CLK (CLK2)) ;
    ao21 ix64 (.Y (nx63), .A0 (STATE[0]), .A1 (nx236), .B0 (nx61)) ;
    nor02 ix62 (.Y (nx61), .A0 (CLK3_EN), .A1 (nx236)) ;
    inv02 ix200 (.Y (nx199), .A (STATE_CON[1])) ;
    oai22 ix97 (.Y (nx96), .A0 (STATE[1]), .A1 (nx202), .B0 (STATE[0]), .B1 (
          nx204)) ;
    mux21 ix203 (.Y (nx202), .A0 (STATE_CON[2]), .A1 (STATE_CON[3]), .S0 (
          STATE[0])) ;
    nand02 ix205 (.Y (nx204), .A0 (STATE_CON[4]), .A1 (STATE[1])) ;
    ao21 ix113 (.Y (LAST_CYC), .A0 (STATE[2]), .A1 (STATE[1]), .B0 (nx108)) ;
    aoi21 ix109 (.Y (nx108), .A0 (nx198), .A1 (STATE_CON[0]), .B0 (STATE_CON[1])
          ) ;
    nand02 ix209 (.Y (nx208), .A0 (MWAIT), .A1 (nx146)) ;
    dffr reg_WAIT_SYNC (.Q (\$dummy [1]), .QB (nx210), .D (nx30), .CLK (CLK1), .R (
         TEST_RESET)) ;
    and02 ix31 (.Y (nx30), .A0 (nx210), .A1 (nx236)) ;
    inv02 ix214 (.Y (nx213), .A (EXCEPTION)) ;
    oai21 ix131 (.Y (nx130), .A0 (nx213), .A1 (nx236), .B0 (nx248)) ;
    aoi21 ix161 (.Y (NEXT_STATE_IDLE), .A0 (nx220), .A1 (nx170), .B0 (EXCEPTION)
          ) ;
    nand03 ix221 (.Y (nx220), .A0 (LAST_CYC), .A1 (REG_RESULT[0]), .A2 (
           SFR_WRITE_EN[10])) ;
    dff ix106 (.Q (PCON[2]), .QB (\$dummy [2]), .D (nx103), .CLK (CLK2)) ;
    ao32 ix104 (.Y (nx103), .A0 (REG_RESULT[2]), .A1 (nx146), .A2 (
         SFR_WRITE_EN[10]), .B0 (PCON[2]), .B1 (nx248)) ;
    dff ix116 (.Q (PCON[3]), .QB (\$dummy [3]), .D (nx113), .CLK (CLK2)) ;
    ao32 ix114 (.Y (nx113), .A0 (REG_RESULT[3]), .A1 (nx146), .A2 (
         SFR_WRITE_EN[10]), .B0 (PCON[3]), .B1 (nx248)) ;
    dff ix126 (.Q (PCON[7]), .QB (\$dummy [4]), .D (nx123), .CLK (CLK2)) ;
    ao32 ix124 (.Y (nx123), .A0 (REG_RESULT[7]), .A1 (nx146), .A2 (
         SFR_WRITE_EN[10]), .B0 (PCON[7]), .B1 (nx248)) ;
    buf02 ix235 (.Y (nx236), .A (nx260)) ;
    buf02 ix237 (.Y (nx238), .A (nx130)) ;
    buf02 ix239 (.Y (nx240), .A (nx43)) ;
    buf02 ix241 (.Y (nx242), .A (nx71)) ;
    buf02 ix243 (.Y (nx244), .A (nx81)) ;
    buf02 ix245 (.Y (nx246), .A (nx93)) ;
    buf02 ix247 (.Y (nx248), .A (nx165)) ;
    buf02 ix249 (.Y (nx250), .A (nx172)) ;
    buf02 ix251 (.Y (nx252), .A (nx175)) ;
    buf02 ix253 (.Y (nx254), .A (nx192)) ;
    buf02 ix259 (.Y (nx260), .A (nx266)) ;
    buf02 ix265 (.Y (nx266), .A (nx272)) ;
    buf02 ix271 (.Y (nx272), .A (nx278)) ;
    buf02 ix277 (.Y (nx278), .A (nx284)) ;
    buf02 ix283 (.Y (nx284), .A (nx294)) ;
    or02 ix151 (.Y (NPCLKE), .A0 (PCON[1]), .A1 (NOT__848810_)) ;
    ao21 ix44 (.Y (nx43), .A0 (INTERNAL_RESET), .A1 (NOT__848810_), .B0 (nx302)
         ) ;
    nor03 ix152 (.Y (nx290), .A0 (nx292), .A1 (nx159), .A2 (NOT__848810_)) ;
    inv02 ix291 (.Y (nx292), .A (RESET)) ;
    and02 ix30 (.Y (nx29), .A0 (RESET_SAMPLE), .A1 (NOT__848810_)) ;
    nand02 ix147 (.Y (NCCLKE), .A0 (nx170), .A1 (nx143)) ;
    xnor2 ix183 (.Y (nx182), .A0 (nx177), .A1 (nx185)) ;
    and02 ix139 (.Y (nx138), .A0 (REG_RESULT[0]), .A1 (nx146)) ;
    buf02 ix293 (.Y (nx294), .A (nx296)) ;
    buf02 ix295 (.Y (nx296), .A (nx298)) ;
    buf02 ix297 (.Y (nx298), .A (nx300)) ;
    buf02 ix299 (.Y (nx300), .A (nx308)) ;
    buf02 ix301 (.Y (nx302), .A (nx290)) ;
    buf02 ix307 (.Y (nx308), .A (nx314)) ;
    buf02 ix313 (.Y (nx314), .A (nx320)) ;
    buf02 ix319 (.Y (nx320), .A (nx326)) ;
    buf02 ix325 (.Y (nx326), .A (nx332)) ;
    buf02 ix331 (.Y (nx332), .A (nx338)) ;
    buf02 ix337 (.Y (nx338), .A (INTERNAL_WAIT)) ;
endmodule


module block09 ( PROGA, PROGA_EN, SAVE_ADDR, DATA_POINTER, XRAMA, XRAMA_EN, 
                  NPSEN, NXRAMW, NXRAMR, ACC, PORT_2, INDIRECT_DATA, INTR_VECTOR, 
                  IMMEDIATE, IMMEDIATE_2, PROGDI, CONDITION_MET, EXCEPTION, 
                  INTR_LCALL, NEXT_STATE_IDLE, OPCODE, INTERNAL_RESET, 
                  REG_RESULT, SFR_WRITE_EN, PC_CON, STATE, LAST_CYC, 
                  INTERNAL_WAIT, CLK2 ) ;

    output [15:0]PROGA ;
    output PROGA_EN ;
    output [7:0]SAVE_ADDR ;
    output [15:0]DATA_POINTER ;
    output [15:0]XRAMA ;
    output XRAMA_EN ;
    output NPSEN ;
    output NXRAMW ;
    output NXRAMR ;
    input [7:0]ACC ;
    input [7:0]PORT_2 ;
    input [7:0]INDIRECT_DATA ;
    input [7:0]INTR_VECTOR ;
    input [7:0]IMMEDIATE ;
    input [7:0]IMMEDIATE_2 ;
    input [7:0]PROGDI ;
    input CONDITION_MET ;
    input EXCEPTION ;
    input INTR_LCALL ;
    input NEXT_STATE_IDLE ;
    input [7:4]OPCODE ;
    input INTERNAL_RESET ;
    input [7:0]REG_RESULT ;
    input [9:8]SFR_WRITE_EN ;
    input [17:0]PC_CON ;
    input [2:0]STATE ;
    input LAST_CYC ;
    input INTERNAL_WAIT ;
    input CLK2 ;

    wire PC_SUM_15_, PC_SUM_14_, PC_SUM_13_, PC_SUM_12_, PC_SUM_11_, PC_SUM_10_, 
         PC_SUM_9_, PC_SUM_8_, PC_SUM_7_, PC_SUM_6_, PC_SUM_5_, PC_SUM_4_, 
         PC_SUM_3_, PC_SUM_2_, PC_SUM_1_, PC_SUM_0_, JUMP_RELATIVE, INCREMENT, 
         OPERAND_8_7_, OPERAND_8_6_, OPERAND_8_5_, OPERAND_8_4_, OPERAND_8_3_, 
         OPERAND_8_2_, OPERAND_8_1_, OPERAND_8_0_, OPERAND_16_15_, 
         OPERAND_16_14_, OPERAND_16_13_, OPERAND_16_12_, OPERAND_16_11_, 
         OPERAND_16_10_, OPERAND_16_9_, OPERAND_16_8_, OPERAND_16_7_, 
         OPERAND_16_6_, OPERAND_16_5_, OPERAND_16_4_, OPERAND_16_3_, 
         OPERAND_16_2_, OPERAND_16_1_, OPERAND_16_0_, nx10, nx14, nx24, nx32, 
         nx50, nx62, nx72, nx78, PROGRAM_COUNT_8_, nx104, nx112, nx118, nx132, 
         nx144, nx156, nx170, nx174, nx190, nx192, nx216, nx228, nx234, nx240, 
         nx244, nx248, nx258, nx271, nx272, nx320, PROGRAM_COUNT_9_, nx273, 
         nx378, PROGRAM_COUNT_10_, nx275, nx436, PROGRAM_COUNT_11_, nx277, nx468, 
         nx492, PROGRAM_COUNT_12_, nx278, nx546, PROGRAM_COUNT_13_, nx279, nx600, 
         PROGRAM_COUNT_14_, nx280, nx654, PROGRAM_COUNT_15_, nx281, nx708, nx726, 
         nx744, nx768, nx786, nx282, nx806, nx283, nx285, nx287, nx289, nx291, 
         nx293, nx295, SELECT_ACC, nx1440, nx1454, nx1468, nx1482, nx1496, 
         nx1510, nx1524, nx1538, nx1546, nx1554, nx1562, nx1570, nx1578, nx1586, 
         nx1594, nx1602, nx1608, nx301, nx303, nx313, nx321, nx323, nx333, nx341, 
         nx343, nx353, nx361, nx363, nx373, nx381, nx383, nx393, nx401, nx403, 
         nx413, nx421, nx423, nx433, nx441, nx443, nx453, nx463, nx473, nx481, 
         nx483, nx493, nx501, nx503, nx513, nx521, nx523, nx533, nx541, nx543, 
         nx553, nx561, nx563, nx573, nx581, nx583, nx593, nx601, nx603, nx613, 
         nx621, nx623, nx633, nx641, nx643, nx651, nx653, nx661, nx663, nx671, 
         nx673, nx681, nx683, nx691, nx693, nx701, nx703, nx711, nx713, nx721, 
         nx723, nx733, nx743, nx753, nx763, nx773, nx783, nx793, nx803, nx813, 
         nx823, nx833, nx843, nx853, nx863, nx873, nx883, nx891, nx893, nx903, 
         nx913, nx923, nx933, nx943, nx953, nx963, nx973, nx983, nx993, nx1001, 
         nx1003, nx1017, nx1019, nx1023, nx1025, nx1031, nx1033, nx1041, nx1044, 
         nx1047, nx1055, nx1057, nx1061, nx1064, nx1067, nx1073, nx1075, nx1079, 
         nx1083, nx1085, nx1092, nx1095, nx1111, nx1114, nx1117, nx1119, nx1123, 
         nx1125, nx1127, nx1129, nx1133, nx1135, nx1143, nx1145, nx1149, nx1151, 
         nx1153, nx1156, nx1159, nx1165, nx1167, nx1171, nx1173, nx1177, nx1181, 
         nx1187, nx1189, nx1192, nx1194, nx1196, nx1199, nx1202, nx1207, nx1209, 
         nx1212, nx1214, nx1216, nx1219, nx1222, nx1227, nx1229, nx1232, nx1234, 
         nx1236, nx1239, nx1243, nx1248, nx1250, nx1253, nx1255, nx1257, nx1260, 
         nx1263, nx1268, nx1270, nx1273, nx1275, nx1278, nx1281, nx1286, nx1288, 
         nx1290, nx1293, nx1296, nx1299, nx1303, nx1305, nx1307, nx1309, nx1318, 
         nx1321, nx1325, nx1327, nx1329, nx1331, nx1339, nx1343, nx1348, nx1350, 
         nx1353, nx1355, nx1365, nx1368, nx1373, nx1375, nx1379, nx1381, nx1393, 
         nx1397, nx1403, nx1405, nx1407, nx1419, nx1423, nx1428, nx1430, nx1432, 
         nx1441, nx1445, nx1449, nx1451, nx1453, nx1463, nx1466, nx1471, nx1473, 
         nx1475, nx1483, nx1485, nx1491, nx1507, nx1519, nx1521, nx1523, nx1532, 
         nx1536, nx1557, nx1655, nx1657, nx1665, nx1667, nx1672, nx1674, nx1684, 
         nx1688, nx1692, nx1696, nx1700, nx1704, nx1708, nx1712, nx1716, nx1720, 
         nx1724, nx1728, nx1732, nx1736, nx1740, nx1744, nx1751, nx1753, nx1755, 
         nx1757, nx1759, nx1761, nx1763, nx1765, nx1767, nx1769, nx1771, nx1773, 
         nx1775, nx1777, nx1779, nx1781, nx1783, nx1785, nx1787, nx1789, nx1791, 
         nx1793, nx1795, nx1797, nx1799, nx1801, nx1803, nx1805, nx1807, nx1809, 
         nx1811, nx1813, nx1815, nx1817, nx1819, nx1821, nx1823, nx1825, nx1827, 
         nx1829, nx1831, nx1833, nx1835, nx1837, nx1839, nx1841, nx1843, nx1845, 
         nx1847, nx1849, nx1851, nx1853, nx1855, nx1857, nx1859, nx1861, nx1863, 
         nx1865, nx1867, nx1869, nx1871, nx1873, nx1875, nx1877, nx1879, nx1881, 
         nx1883, nx1885, nx1887, nx1889, nx1891, nx1893, nx1895, nx1897, nx1899, 
         nx1901, nx1903, nx1905, nx1907, nx1909, nx1911, nx1913, nx1915, nx1917, 
         nx1919, nx1921, nx1923, nx1925, nx1927, nx1929, nx1931, nx1933, nx1935, 
         nx1937, nx1939, nx1941, nx1943, nx1945, nx1947, nx1949, nx1951, nx1953, 
         nx1955, nx1957, nx1959, nx1961, nx1963, nx1965, nx1967, nx1969, nx1971, 
         nx1973, nx1975, nx1977, nx1979, nx1981, nx1983, nx1985, nx1987, nx1989, 
         nx1991, nx1993, nx1995, nx1997, nx1999, nx2001, nx2003, nx2005, nx2007, 
         nx2009, nx2011, nx2013, nx2015, nx2017, nx2019, nx2021, nx2023, nx2025, 
         nx2027, nx2029, nx2031, nx2033, nx2035, nx2037, nx2039, nx2041, nx2043, 
         nx2045, nx2047, nx2049, nx2051, nx2053, nx2055, nx2057, nx2059, nx2061, 
         nx2067, nx2069, nx2071, nx2077, nx2079, nx2081, nx2083, nx2085, nx2087, 
         nx2089, nx2091, nx2093, nx2095, nx2097, nx2099, nx2101, nx2103, nx2105, 
         nx2107, nx2109, nx2111, nx2113, nx2115, nx2117, nx2119, nx2121, nx2123, 
         nx2125;
    wire [37:0] \$dummy ;




    block11 u1 (.PC_SUM ({PC_SUM_15_,PC_SUM_14_,PC_SUM_13_,PC_SUM_12_,
             PC_SUM_11_,PC_SUM_10_,PC_SUM_9_,PC_SUM_8_,PC_SUM_7_,PC_SUM_6_,
             PC_SUM_5_,PC_SUM_4_,PC_SUM_3_,PC_SUM_2_,PC_SUM_1_,PC_SUM_0_}), .OPERAND_16 (
             {OPERAND_16_15_,OPERAND_16_14_,OPERAND_16_13_,OPERAND_16_12_,
             OPERAND_16_11_,OPERAND_16_10_,OPERAND_16_9_,OPERAND_16_8_,
             OPERAND_16_7_,OPERAND_16_6_,OPERAND_16_5_,OPERAND_16_4_,
             OPERAND_16_3_,OPERAND_16_2_,OPERAND_16_1_,OPERAND_16_0_}), .OPERAND_8 (
             {nx1751,OPERAND_8_6_,OPERAND_8_5_,OPERAND_8_4_,OPERAND_8_3_,
             OPERAND_8_2_,OPERAND_8_1_,OPERAND_8_0_}), .INCREMENT (INCREMENT), .SIGN_EXTEND (
             JUMP_RELATIVE)) ;
    ao21 ix1445 (.Y (OPERAND_16_0_), .A0 (nx2123), .A1 (DATA_POINTER[0]), .B0 (
         nx1440)) ;
    mux21 ix914 (.Y (nx913), .A0 (nx1887), .A1 (nx2107), .S0 (nx2089)) ;
    aoi22 ix1018 (.Y (nx1017), .A0 (PC_CON[3]), .A1 (nx1889), .B0 (PC_CON[4]), .B1 (
          nx1891)) ;
    nor03 ix1020 (.Y (nx1019), .A0 (STATE[2]), .A1 (STATE[1]), .A2 (nx2097)) ;
    inv02 ix1024 (.Y (nx1023), .A (STATE[0])) ;
    dff ix916 (.Q (\$dummy [0]), .QB (nx1025), .D (nx1869), .CLK (CLK2)) ;
    mux21 ix494 (.Y (nx493), .A0 (nx1031), .A1 (nx1893), .S0 (nx1777)) ;
    dff ix496 (.Q (DATA_POINTER[0]), .QB (nx1031), .D (nx1819), .CLK (CLK2)) ;
    aoi22 ix1034 (.Y (nx1033), .A0 (REG_RESULT[0]), .A1 (nx248), .B0 (nx282), .B1 (
          nx1789)) ;
    nand03 ix839 (.Y (nx282), .A0 (nx1895), .A1 (nx1897), .A2 (nx1899)) ;
    aoi222 ix1042 (.Y (nx1041), .A0 (INTR_VECTOR[1]), .A1 (nx1767), .B0 (
           IMMEDIATE_2[0]), .B1 (nx1763), .C0 (PROGDI[0]), .C1 (nx156)) ;
    inv02 ix1045 (.Y (nx1044), .A (INTR_LCALL)) ;
    inv02 ix1048 (.Y (nx1047), .A (STATE[2])) ;
    nand02 ix1056 (.Y (nx1055), .A0 (PC_CON[11]), .A1 (nx1891)) ;
    aoi22 ix1058 (.Y (nx1057), .A0 (DATA_POINTER[0]), .A1 (nx1775), .B0 (
          IMMEDIATE[0]), .B1 (nx1771)) ;
    nand02 ix1062 (.Y (nx1061), .A0 (PC_CON[5]), .A1 (nx1889)) ;
    nand02 ix1065 (.Y (nx1064), .A0 (PC_CON[10]), .A1 (nx2111)) ;
    inv02 ix1074 (.Y (nx1073), .A (PC_CON[11])) ;
    aoi22 ix1076 (.Y (nx1075), .A0 (INDIRECT_DATA[0]), .A1 (nx2103), .B0 (
          PC_SUM_0_), .B1 (nx1901)) ;
    and04 ix1080 (.Y (nx1079), .A0 (nx1905), .A1 (nx2113), .A2 (nx1907), .A3 (
          nx1909)) ;
    nor04 ix1093 (.Y (nx1092), .A0 (nx1767), .A1 (nx1765), .A2 (nx132), .A3 (
          NEXT_STATE_IDLE)) ;
    nand02 ix171 (.Y (nx170), .A0 (nx2115), .A1 (nx1095)) ;
    nand03 ix1096 (.Y (nx1095), .A0 (nx1055), .A1 (PC_CON[12]), .A2 (nx1891)) ;
    nor02 ix807 (.Y (nx806), .A0 (SFR_WRITE_EN[8]), .A1 (nx2093)) ;
    ao21 ix245 (.Y (nx244), .A0 (nx234), .A1 (nx240), .B0 (nx2093)) ;
    ao21 ix235 (.Y (nx234), .A0 (nx1891), .A1 (nx228), .B0 (SFR_WRITE_EN[8])) ;
    or02 ix229 (.Y (nx228), .A0 (PC_CON[14]), .A1 (PC_CON[12])) ;
    nor02 ix241 (.Y (nx240), .A0 (SFR_WRITE_EN[9]), .A1 (nx2089)) ;
    nor02 ix1441 (.Y (nx1440), .A0 (nx2123), .A1 (nx1111)) ;
    dff ix926 (.Q (\$dummy [1]), .QB (nx1111), .D (nx1871), .CLK (CLK2)) ;
    mux21 ix924 (.Y (nx923), .A0 (nx1114), .A1 (nx1111), .S0 (nx1913)) ;
    nand02 ix1115 (.Y (nx1114), .A0 (nx1911), .A1 (nx282)) ;
    inv02 ix1118 (.Y (nx1117), .A (INTERNAL_RESET)) ;
    nor02 ix1120 (.Y (nx1119), .A0 (nx1761), .A1 (nx1759)) ;
    oai33 ix145 (.Y (nx144), .A0 (nx1123), .A1 (INTR_LCALL), .A2 (nx2089), .B0 (
          EXCEPTION), .B1 (NEXT_STATE_IDLE), .B2 (nx1127)) ;
    and02 ix1124 (.Y (nx1123), .A0 (nx1917), .A1 (nx1055)) ;
    aoi22 ix1126 (.Y (nx1125), .A0 (PC_CON[0]), .A1 (nx1889), .B0 (PC_CON[1]), .B1 (
          nx1891)) ;
    nand03 ix1128 (.Y (nx1127), .A0 (LAST_CYC), .A1 (nx2097), .A2 (nx1129)) ;
    inv02 ix1130 (.Y (nx1129), .A (INTERNAL_WAIT)) ;
    nor04 ix1136 (.Y (nx1135), .A0 (nx112), .A1 (PC_CON[2]), .A2 (PC_CON[8]), .A3 (
          nx104)) ;
    or03 ix113 (.Y (nx112), .A0 (PC_CON[11]), .A1 (PC_CON[9]), .A2 (PC_CON[10])
         ) ;
    ao21 ix105 (.Y (nx104), .A0 (CONDITION_MET), .A1 (PC_CON[7]), .B0 (PC_CON[4]
         )) ;
    ao21 ix1459 (.Y (OPERAND_16_1_), .A0 (nx2123), .A1 (DATA_POINTER[1]), .B0 (
         nx1454)) ;
    mux21 ix514 (.Y (nx513), .A0 (nx1143), .A1 (nx1921), .S0 (nx1777)) ;
    dff ix516 (.Q (DATA_POINTER[1]), .QB (nx1143), .D (nx1821), .CLK (CLK2)) ;
    aoi22 ix1146 (.Y (nx1145), .A0 (REG_RESULT[1]), .A1 (nx248), .B0 (nx283), .B1 (
          nx1789)) ;
    nand03 ix889 (.Y (nx283), .A0 (nx1923), .A1 (nx1925), .A2 (nx1927)) ;
    aoi222 ix1150 (.Y (nx1149), .A0 (INTR_VECTOR[1]), .A1 (nx1767), .B0 (
           IMMEDIATE_2[1]), .B1 (nx1763), .C0 (PROGDI[1]), .C1 (nx156)) ;
    aoi22 ix1152 (.Y (nx1151), .A0 (DATA_POINTER[1]), .A1 (nx1775), .B0 (
          IMMEDIATE[1]), .B1 (nx1771)) ;
    aoi22 ix1154 (.Y (nx1153), .A0 (INDIRECT_DATA[1]), .A1 (nx2103), .B0 (
          PC_SUM_1_), .B1 (nx1901)) ;
    nor02 ix1455 (.Y (nx1454), .A0 (nx2123), .A1 (nx1156)) ;
    dff ix936 (.Q (\$dummy [2]), .QB (nx1156), .D (nx1873), .CLK (CLK2)) ;
    mux21 ix934 (.Y (nx933), .A0 (nx1159), .A1 (nx1156), .S0 (nx1913)) ;
    nand02 ix1160 (.Y (nx1159), .A0 (nx1911), .A1 (nx283)) ;
    ao21 ix1473 (.Y (OPERAND_16_2_), .A0 (nx2123), .A1 (DATA_POINTER[2]), .B0 (
         nx1468)) ;
    mux21 ix534 (.Y (nx533), .A0 (nx1165), .A1 (nx1929), .S0 (nx1777)) ;
    dff ix536 (.Q (DATA_POINTER[2]), .QB (nx1165), .D (nx1823), .CLK (CLK2)) ;
    aoi22 ix1168 (.Y (nx1167), .A0 (REG_RESULT[2]), .A1 (nx248), .B0 (nx285), .B1 (
          nx1789)) ;
    nand02 ix935 (.Y (nx285), .A0 (nx1931), .A1 (nx1933)) ;
    aoi222 ix1172 (.Y (nx1171), .A0 (IMMEDIATE_2[2]), .A1 (nx1763), .B0 (
           PROGDI[2]), .B1 (nx156), .C0 (IMMEDIATE[2]), .C1 (nx1771)) ;
    aoi222 ix1174 (.Y (nx1173), .A0 (INDIRECT_DATA[2]), .A1 (nx2103), .B0 (
           DATA_POINTER[2]), .B1 (nx1775), .C0 (PC_SUM_2_), .C1 (nx1901)) ;
    nor02 ix1469 (.Y (nx1468), .A0 (nx2123), .A1 (nx1177)) ;
    dff ix946 (.Q (\$dummy [3]), .QB (nx1177), .D (nx1875), .CLK (CLK2)) ;
    mux21 ix944 (.Y (nx943), .A0 (nx1181), .A1 (nx1177), .S0 (nx1913)) ;
    nand02 ix1182 (.Y (nx1181), .A0 (nx1911), .A1 (nx285)) ;
    ao21 ix1487 (.Y (OPERAND_16_3_), .A0 (nx2123), .A1 (DATA_POINTER[3]), .B0 (
         nx1482)) ;
    mux21 ix554 (.Y (nx553), .A0 (nx1187), .A1 (nx1935), .S0 (nx1777)) ;
    dff ix556 (.Q (DATA_POINTER[3]), .QB (nx1187), .D (nx1825), .CLK (CLK2)) ;
    aoi22 ix1190 (.Y (nx1189), .A0 (REG_RESULT[3]), .A1 (nx248), .B0 (nx287), .B1 (
          nx1789)) ;
    nand03 ix985 (.Y (nx287), .A0 (nx1937), .A1 (nx1939), .A2 (nx1941)) ;
    aoi222 ix1193 (.Y (nx1192), .A0 (INTR_VECTOR[3]), .A1 (nx1767), .B0 (
           IMMEDIATE_2[3]), .B1 (nx1763), .C0 (PROGDI[3]), .C1 (nx156)) ;
    aoi22 ix1195 (.Y (nx1194), .A0 (DATA_POINTER[3]), .A1 (nx1775), .B0 (
          IMMEDIATE[3]), .B1 (nx1771)) ;
    aoi22 ix1197 (.Y (nx1196), .A0 (INDIRECT_DATA[3]), .A1 (nx2103), .B0 (
          PC_SUM_3_), .B1 (nx1901)) ;
    nor02 ix1483 (.Y (nx1482), .A0 (nx2123), .A1 (nx1199)) ;
    dff ix956 (.Q (\$dummy [4]), .QB (nx1199), .D (nx1877), .CLK (CLK2)) ;
    mux21 ix954 (.Y (nx953), .A0 (nx1202), .A1 (nx1199), .S0 (nx1913)) ;
    nand02 ix1203 (.Y (nx1202), .A0 (nx1911), .A1 (nx287)) ;
    ao21 ix1501 (.Y (OPERAND_16_4_), .A0 (nx2123), .A1 (DATA_POINTER[4]), .B0 (
         nx1496)) ;
    mux21 ix574 (.Y (nx573), .A0 (nx1207), .A1 (nx1943), .S0 (nx1777)) ;
    dff ix576 (.Q (DATA_POINTER[4]), .QB (nx1207), .D (nx1827), .CLK (CLK2)) ;
    aoi22 ix1210 (.Y (nx1209), .A0 (REG_RESULT[4]), .A1 (nx248), .B0 (nx289), .B1 (
          nx1789)) ;
    nand03 ix1035 (.Y (nx289), .A0 (nx1945), .A1 (nx1947), .A2 (nx1949)) ;
    aoi222 ix1213 (.Y (nx1212), .A0 (INTR_VECTOR[4]), .A1 (nx1767), .B0 (
           IMMEDIATE_2[4]), .B1 (nx1763), .C0 (PROGDI[4]), .C1 (nx156)) ;
    aoi22 ix1215 (.Y (nx1214), .A0 (DATA_POINTER[4]), .A1 (nx1775), .B0 (
          IMMEDIATE[4]), .B1 (nx1771)) ;
    aoi22 ix1217 (.Y (nx1216), .A0 (INDIRECT_DATA[4]), .A1 (nx2103), .B0 (
          PC_SUM_4_), .B1 (nx1901)) ;
    nor02 ix1497 (.Y (nx1496), .A0 (nx2123), .A1 (nx1219)) ;
    dff ix966 (.Q (\$dummy [5]), .QB (nx1219), .D (nx1879), .CLK (CLK2)) ;
    mux21 ix964 (.Y (nx963), .A0 (nx1222), .A1 (nx1219), .S0 (nx1913)) ;
    nand02 ix1223 (.Y (nx1222), .A0 (nx1911), .A1 (nx289)) ;
    ao21 ix1515 (.Y (OPERAND_16_5_), .A0 (nx1793), .A1 (DATA_POINTER[5]), .B0 (
         nx1510)) ;
    mux21 ix594 (.Y (nx593), .A0 (nx1227), .A1 (nx1951), .S0 (nx1777)) ;
    dff ix596 (.Q (DATA_POINTER[5]), .QB (nx1227), .D (nx1829), .CLK (CLK2)) ;
    aoi22 ix1230 (.Y (nx1229), .A0 (REG_RESULT[5]), .A1 (nx248), .B0 (nx291), .B1 (
          nx1789)) ;
    nand03 ix1085 (.Y (nx291), .A0 (nx1953), .A1 (nx1955), .A2 (nx1957)) ;
    aoi222 ix1233 (.Y (nx1232), .A0 (INTR_VECTOR[5]), .A1 (nx1767), .B0 (
           IMMEDIATE_2[5]), .B1 (nx1763), .C0 (PROGDI[5]), .C1 (nx156)) ;
    aoi22 ix1235 (.Y (nx1234), .A0 (DATA_POINTER[5]), .A1 (nx1775), .B0 (
          IMMEDIATE[5]), .B1 (nx1771)) ;
    aoi22 ix1237 (.Y (nx1236), .A0 (INDIRECT_DATA[5]), .A1 (nx2103), .B0 (
          PC_SUM_5_), .B1 (nx1901)) ;
    nor02 ix1511 (.Y (nx1510), .A0 (nx1793), .A1 (nx1239)) ;
    dff ix976 (.Q (\$dummy [6]), .QB (nx1239), .D (nx1881), .CLK (CLK2)) ;
    mux21 ix974 (.Y (nx973), .A0 (nx1243), .A1 (nx1239), .S0 (nx1913)) ;
    nand02 ix1244 (.Y (nx1243), .A0 (nx1911), .A1 (nx291)) ;
    ao21 ix1529 (.Y (OPERAND_16_6_), .A0 (nx1793), .A1 (DATA_POINTER[6]), .B0 (
         nx1524)) ;
    mux21 ix614 (.Y (nx613), .A0 (nx1248), .A1 (nx1959), .S0 (nx1777)) ;
    dff ix616 (.Q (DATA_POINTER[6]), .QB (nx1248), .D (nx1831), .CLK (CLK2)) ;
    aoi22 ix1251 (.Y (nx1250), .A0 (REG_RESULT[6]), .A1 (nx248), .B0 (nx293), .B1 (
          nx1789)) ;
    nand03 ix1135 (.Y (nx293), .A0 (nx1961), .A1 (nx1963), .A2 (nx1965)) ;
    aoi222 ix1254 (.Y (nx1253), .A0 (INTR_VECTOR[6]), .A1 (nx1767), .B0 (
           IMMEDIATE_2[6]), .B1 (nx1763), .C0 (PROGDI[6]), .C1 (nx156)) ;
    aoi22 ix1256 (.Y (nx1255), .A0 (DATA_POINTER[6]), .A1 (nx1775), .B0 (
          IMMEDIATE[6]), .B1 (nx1771)) ;
    aoi22 ix1258 (.Y (nx1257), .A0 (INDIRECT_DATA[6]), .A1 (nx2103), .B0 (
          PC_SUM_6_), .B1 (nx1901)) ;
    nor02 ix1525 (.Y (nx1524), .A0 (nx1793), .A1 (nx1260)) ;
    dff ix986 (.Q (\$dummy [7]), .QB (nx1260), .D (nx1883), .CLK (CLK2)) ;
    mux21 ix984 (.Y (nx983), .A0 (nx1263), .A1 (nx1260), .S0 (nx1913)) ;
    nand02 ix1264 (.Y (nx1263), .A0 (nx1911), .A1 (nx293)) ;
    ao21 ix1543 (.Y (OPERAND_16_7_), .A0 (nx1793), .A1 (DATA_POINTER[7]), .B0 (
         nx1538)) ;
    mux21 ix634 (.Y (nx633), .A0 (nx1268), .A1 (nx1967), .S0 (nx1777)) ;
    dff ix636 (.Q (DATA_POINTER[7]), .QB (nx1268), .D (nx1833), .CLK (CLK2)) ;
    aoi22 ix1271 (.Y (nx1270), .A0 (REG_RESULT[7]), .A1 (nx248), .B0 (nx295), .B1 (
          nx1789)) ;
    nand02 ix1181 (.Y (nx295), .A0 (nx1969), .A1 (nx1971)) ;
    aoi222 ix1274 (.Y (nx1273), .A0 (IMMEDIATE_2[7]), .A1 (nx1763), .B0 (
           PROGDI[7]), .B1 (nx156), .C0 (IMMEDIATE[7]), .C1 (nx1771)) ;
    aoi222 ix1276 (.Y (nx1275), .A0 (INDIRECT_DATA[7]), .A1 (nx2103), .B0 (
           DATA_POINTER[7]), .B1 (nx1775), .C0 (PC_SUM_7_), .C1 (nx1901)) ;
    nor02 ix1539 (.Y (nx1538), .A0 (nx1793), .A1 (nx1278)) ;
    dff ix996 (.Q (\$dummy [8]), .QB (nx1278), .D (nx1885), .CLK (CLK2)) ;
    mux21 ix994 (.Y (nx993), .A0 (nx1281), .A1 (nx1278), .S0 (nx1913)) ;
    nand02 ix1282 (.Y (nx1281), .A0 (nx1911), .A1 (nx295)) ;
    ao21 ix1551 (.Y (OPERAND_16_8_), .A0 (nx1793), .A1 (DATA_POINTER[8]), .B0 (
         nx1546)) ;
    dff ix306 (.Q (DATA_POINTER[8]), .QB (\$dummy [9]), .D (nx303), .CLK (CLK2)
        ) ;
    ao21 ix304 (.Y (nx303), .A0 (DATA_POINTER[8]), .A1 (nx1973), .B0 (nx301)) ;
    aoi22 ix1287 (.Y (nx1286), .A0 (nx1129), .A1 (nx1288), .B0 (nx1777), .B1 (
          nx1290)) ;
    nand02 ix1291 (.Y (nx1290), .A0 (SFR_WRITE_EN[8]), .A1 (nx1911)) ;
    nor02 ix302 (.Y (nx301), .A0 (nx1977), .A1 (nx1973)) ;
    aoi22 ix1294 (.Y (nx1293), .A0 (REG_RESULT[0]), .A1 (nx1781), .B0 (nx271), .B1 (
          nx1779)) ;
    nor02 ix273 (.Y (nx272), .A0 (nx1296), .A1 (nx2093)) ;
    inv02 ix1297 (.Y (nx1296), .A (SFR_WRITE_EN[9])) ;
    nand03 ix307 (.Y (nx271), .A0 (nx1979), .A1 (nx1981), .A2 (nx1983)) ;
    aoi222 ix1300 (.Y (nx1299), .A0 (PROGRAM_COUNT_8_), .A1 (nx1769), .B0 (
           INDIRECT_DATA[0]), .B1 (nx132), .C0 (IMMEDIATE[0]), .C1 (nx1765)) ;
    mux21 ix314 (.Y (nx313), .A0 (nx1303), .A1 (nx1305), .S0 (nx1913)) ;
    nand02 ix1304 (.Y (nx1303), .A0 (nx2117), .A1 (nx271)) ;
    dff ix316 (.Q (PROGRAM_COUNT_8_), .QB (nx1305), .D (nx1799), .CLK (CLK2)) ;
    aoi22 ix1308 (.Y (nx1307), .A0 (PORT_2[0]), .A1 (nx190), .B0 (OPCODE[5]), .B1 (
          nx1771)) ;
    aoi22 ix1310 (.Y (nx1309), .A0 (DATA_POINTER[8]), .A1 (nx1775), .B0 (
          PC_SUM_8_), .B1 (nx1901)) ;
    nor02 ix259 (.Y (nx258), .A0 (SFR_WRITE_EN[9]), .A1 (nx2093)) ;
    ao21 ix1559 (.Y (OPERAND_16_9_), .A0 (nx1793), .A1 (DATA_POINTER[9]), .B0 (
         nx1554)) ;
    dff ix326 (.Q (DATA_POINTER[9]), .QB (\$dummy [10]), .D (nx323), .CLK (CLK2)
        ) ;
    ao21 ix324 (.Y (nx323), .A0 (DATA_POINTER[9]), .A1 (nx1973), .B0 (nx321)) ;
    nor02 ix322 (.Y (nx321), .A0 (nx1985), .A1 (nx1973)) ;
    aoi22 ix1319 (.Y (nx1318), .A0 (REG_RESULT[1]), .A1 (nx1781), .B0 (nx273), .B1 (
          nx1779)) ;
    nand03 ix365 (.Y (nx273), .A0 (nx1987), .A1 (nx1989), .A2 (nx1991)) ;
    aoi222 ix1322 (.Y (nx1321), .A0 (PROGRAM_COUNT_9_), .A1 (nx1769), .B0 (
           INDIRECT_DATA[1]), .B1 (nx132), .C0 (IMMEDIATE[1]), .C1 (nx1765)) ;
    mux21 ix334 (.Y (nx333), .A0 (nx1325), .A1 (nx1327), .S0 (nx1913)) ;
    nand02 ix1326 (.Y (nx1325), .A0 (nx2117), .A1 (nx273)) ;
    dff ix336 (.Q (PROGRAM_COUNT_9_), .QB (nx1327), .D (nx1801), .CLK (CLK2)) ;
    aoi22 ix1330 (.Y (nx1329), .A0 (PORT_2[1]), .A1 (nx190), .B0 (OPCODE[6]), .B1 (
          nx1771)) ;
    aoi22 ix1332 (.Y (nx1331), .A0 (DATA_POINTER[9]), .A1 (nx1775), .B0 (
          PC_SUM_9_), .B1 (nx1901)) ;
    ao21 ix1567 (.Y (OPERAND_16_10_), .A0 (nx1795), .A1 (DATA_POINTER[10]), .B0 (
         nx1562)) ;
    dff ix346 (.Q (DATA_POINTER[10]), .QB (\$dummy [11]), .D (nx343), .CLK (CLK2
        )) ;
    ao21 ix344 (.Y (nx343), .A0 (DATA_POINTER[10]), .A1 (nx1973), .B0 (nx341)) ;
    nor02 ix342 (.Y (nx341), .A0 (nx1993), .A1 (nx1973)) ;
    aoi22 ix1340 (.Y (nx1339), .A0 (REG_RESULT[2]), .A1 (nx1781), .B0 (nx275), .B1 (
          nx1779)) ;
    nand03 ix423 (.Y (nx275), .A0 (nx1995), .A1 (nx1997), .A2 (nx1999)) ;
    aoi222 ix1344 (.Y (nx1343), .A0 (PROGRAM_COUNT_10_), .A1 (nx1769), .B0 (
           INDIRECT_DATA[2]), .B1 (nx132), .C0 (IMMEDIATE[2]), .C1 (nx1765)) ;
    mux21 ix354 (.Y (nx353), .A0 (nx1348), .A1 (nx1350), .S0 (nx1915)) ;
    nand02 ix1349 (.Y (nx1348), .A0 (nx2117), .A1 (nx275)) ;
    dff ix356 (.Q (PROGRAM_COUNT_10_), .QB (nx1350), .D (nx1803), .CLK (CLK2)) ;
    aoi22 ix1354 (.Y (nx1353), .A0 (PORT_2[2]), .A1 (nx190), .B0 (OPCODE[7]), .B1 (
          nx1773)) ;
    aoi22 ix1356 (.Y (nx1355), .A0 (DATA_POINTER[10]), .A1 (nx2105), .B0 (
          PC_SUM_10_), .B1 (nx1903)) ;
    ao21 ix1575 (.Y (OPERAND_16_11_), .A0 (nx1795), .A1 (DATA_POINTER[11]), .B0 (
         nx1570)) ;
    dff ix366 (.Q (DATA_POINTER[11]), .QB (\$dummy [12]), .D (nx363), .CLK (CLK2
        )) ;
    ao21 ix364 (.Y (nx363), .A0 (DATA_POINTER[11]), .A1 (nx1973), .B0 (nx361)) ;
    nor02 ix362 (.Y (nx361), .A0 (nx2001), .A1 (nx1973)) ;
    aoi22 ix1366 (.Y (nx1365), .A0 (REG_RESULT[3]), .A1 (nx1781), .B0 (nx277), .B1 (
          nx1779)) ;
    nand02 ix479 (.Y (nx277), .A0 (nx2003), .A1 (nx2005)) ;
    aoi222 ix1369 (.Y (nx1368), .A0 (INDIRECT_DATA[3]), .A1 (nx132), .B0 (
           IMMEDIATE[3]), .B1 (nx1765), .C0 (PROGRAM_COUNT_11_), .C1 (nx1783)) ;
    mux21 ix374 (.Y (nx373), .A0 (nx1373), .A1 (nx1375), .S0 (nx1915)) ;
    nand02 ix1374 (.Y (nx1373), .A0 (nx2117), .A1 (nx277)) ;
    dff ix376 (.Q (PROGRAM_COUNT_11_), .QB (nx1375), .D (nx1805), .CLK (CLK2)) ;
    nand02 ix469 (.Y (nx468), .A0 (nx2113), .A1 (nx1379)) ;
    aoi222 ix1382 (.Y (nx1381), .A0 (DATA_POINTER[11]), .A1 (nx2105), .B0 (
           PORT_2[3]), .B1 (nx190), .C0 (PC_SUM_11_), .C1 (nx1903)) ;
    ao21 ix1583 (.Y (OPERAND_16_12_), .A0 (nx1795), .A1 (DATA_POINTER[12]), .B0 (
         nx1578)) ;
    dff ix386 (.Q (DATA_POINTER[12]), .QB (\$dummy [13]), .D (nx383), .CLK (CLK2
        )) ;
    ao21 ix384 (.Y (nx383), .A0 (DATA_POINTER[12]), .A1 (nx1973), .B0 (nx381)) ;
    nor02 ix382 (.Y (nx381), .A0 (nx2007), .A1 (nx1973)) ;
    aoi22 ix1394 (.Y (nx1393), .A0 (REG_RESULT[4]), .A1 (nx1781), .B0 (nx278), .B1 (
          nx1779)) ;
    nand02 ix533 (.Y (nx278), .A0 (nx2009), .A1 (nx2011)) ;
    aoi222 ix1398 (.Y (nx1397), .A0 (INDIRECT_DATA[4]), .A1 (nx132), .B0 (
           IMMEDIATE[4]), .B1 (nx1765), .C0 (PROGRAM_COUNT_12_), .C1 (nx1783)) ;
    mux21 ix394 (.Y (nx393), .A0 (nx1403), .A1 (nx1405), .S0 (nx1915)) ;
    nand02 ix1404 (.Y (nx1403), .A0 (nx2117), .A1 (nx278)) ;
    dff ix396 (.Q (PROGRAM_COUNT_12_), .QB (nx1405), .D (nx1807), .CLK (CLK2)) ;
    aoi222 ix1408 (.Y (nx1407), .A0 (DATA_POINTER[12]), .A1 (nx2105), .B0 (
           PORT_2[4]), .B1 (nx190), .C0 (PC_SUM_12_), .C1 (nx1903)) ;
    ao21 ix1591 (.Y (OPERAND_16_13_), .A0 (nx1795), .A1 (DATA_POINTER[13]), .B0 (
         nx1586)) ;
    dff ix406 (.Q (DATA_POINTER[13]), .QB (\$dummy [14]), .D (nx403), .CLK (CLK2
        )) ;
    ao21 ix404 (.Y (nx403), .A0 (DATA_POINTER[13]), .A1 (nx1975), .B0 (nx401)) ;
    nor02 ix402 (.Y (nx401), .A0 (nx2013), .A1 (nx1975)) ;
    aoi22 ix1420 (.Y (nx1419), .A0 (REG_RESULT[5]), .A1 (nx1781), .B0 (nx279), .B1 (
          nx1779)) ;
    nand02 ix587 (.Y (nx279), .A0 (nx2015), .A1 (nx2017)) ;
    aoi222 ix1424 (.Y (nx1423), .A0 (INDIRECT_DATA[5]), .A1 (nx132), .B0 (
           IMMEDIATE[5]), .B1 (nx1765), .C0 (PROGRAM_COUNT_13_), .C1 (nx1783)) ;
    mux21 ix414 (.Y (nx413), .A0 (nx1428), .A1 (nx1430), .S0 (nx1915)) ;
    nand02 ix1429 (.Y (nx1428), .A0 (nx2117), .A1 (nx279)) ;
    dff ix416 (.Q (PROGRAM_COUNT_13_), .QB (nx1430), .D (nx1809), .CLK (CLK2)) ;
    aoi222 ix1433 (.Y (nx1432), .A0 (DATA_POINTER[13]), .A1 (nx2105), .B0 (
           PORT_2[5]), .B1 (nx190), .C0 (PC_SUM_13_), .C1 (nx1903)) ;
    ao21 ix1599 (.Y (OPERAND_16_14_), .A0 (nx1795), .A1 (DATA_POINTER[14]), .B0 (
         nx1594)) ;
    dff ix426 (.Q (DATA_POINTER[14]), .QB (\$dummy [15]), .D (nx423), .CLK (CLK2
        )) ;
    ao21 ix424 (.Y (nx423), .A0 (DATA_POINTER[14]), .A1 (nx1975), .B0 (nx421)) ;
    nor02 ix422 (.Y (nx421), .A0 (nx2019), .A1 (nx1975)) ;
    aoi22 ix1442 (.Y (nx1441), .A0 (REG_RESULT[6]), .A1 (nx1781), .B0 (nx280), .B1 (
          nx1779)) ;
    nand02 ix641 (.Y (nx280), .A0 (nx2021), .A1 (nx2023)) ;
    aoi222 ix1446 (.Y (nx1445), .A0 (INDIRECT_DATA[6]), .A1 (nx132), .B0 (
           IMMEDIATE[6]), .B1 (nx1765), .C0 (PROGRAM_COUNT_14_), .C1 (nx1783)) ;
    mux21 ix434 (.Y (nx433), .A0 (nx1449), .A1 (nx1451), .S0 (nx1915)) ;
    nand02 ix1450 (.Y (nx1449), .A0 (nx2117), .A1 (nx280)) ;
    dff ix436 (.Q (PROGRAM_COUNT_14_), .QB (nx1451), .D (nx1811), .CLK (CLK2)) ;
    aoi222 ix1454 (.Y (nx1453), .A0 (DATA_POINTER[14]), .A1 (nx2105), .B0 (
           PORT_2[6]), .B1 (nx190), .C0 (PC_SUM_14_), .C1 (nx1903)) ;
    ao21 ix1607 (.Y (OPERAND_16_15_), .A0 (nx1797), .A1 (DATA_POINTER[15]), .B0 (
         nx1602)) ;
    dff ix446 (.Q (DATA_POINTER[15]), .QB (\$dummy [16]), .D (nx443), .CLK (CLK2
        )) ;
    ao21 ix444 (.Y (nx443), .A0 (DATA_POINTER[15]), .A1 (nx1975), .B0 (nx441)) ;
    nor02 ix442 (.Y (nx441), .A0 (nx2025), .A1 (nx1975)) ;
    aoi22 ix1464 (.Y (nx1463), .A0 (REG_RESULT[7]), .A1 (nx1781), .B0 (nx281), .B1 (
          nx1779)) ;
    nand02 ix695 (.Y (nx281), .A0 (nx2027), .A1 (nx2029)) ;
    aoi222 ix1467 (.Y (nx1466), .A0 (INDIRECT_DATA[7]), .A1 (nx132), .B0 (
           IMMEDIATE[7]), .B1 (nx1765), .C0 (PROGRAM_COUNT_15_), .C1 (nx1783)) ;
    mux21 ix454 (.Y (nx453), .A0 (nx1471), .A1 (nx1473), .S0 (nx1915)) ;
    nand02 ix1472 (.Y (nx1471), .A0 (nx2117), .A1 (nx281)) ;
    dff ix456 (.Q (PROGRAM_COUNT_15_), .QB (nx1473), .D (nx1813), .CLK (CLK2)) ;
    aoi222 ix1476 (.Y (nx1475), .A0 (DATA_POINTER[15]), .A1 (nx2105), .B0 (
           PORT_2[7]), .B1 (nx190), .C0 (PC_SUM_15_), .C1 (nx1903)) ;
    ao22 ix1373 (.Y (OPERAND_8_0_), .A0 (ACC[0]), .A1 (SELECT_ACC), .B0 (
         IMMEDIATE_2[0]), .B1 (JUMP_RELATIVE)) ;
    mux21 ix904 (.Y (nx903), .A0 (nx2031), .A1 (nx1485), .S0 (nx2089)) ;
    aoi22 ix1484 (.Y (nx1483), .A0 (PC_CON[6]), .A1 (nx1889), .B0 (PC_CON[4]), .B1 (
          nx1891)) ;
    dff ix906 (.Q (SELECT_ACC), .QB (nx1485), .D (nx1867), .CLK (CLK2)) ;
    dff ix896 (.Q (JUMP_RELATIVE), .QB (\$dummy [17]), .D (nx893), .CLK (CLK2)
        ) ;
    ao21 ix894 (.Y (nx893), .A0 (JUMP_RELATIVE), .A1 (nx2089), .B0 (nx891)) ;
    nor02 ix892 (.Y (nx891), .A0 (nx2033), .A1 (nx2089)) ;
    oai21 ix1492 (.Y (nx1491), .A0 (PC_CON[8]), .A1 (PC_CON[7]), .B0 (nx1891)) ;
    ao22 ix1379 (.Y (OPERAND_8_1_), .A0 (ACC[1]), .A1 (SELECT_ACC), .B0 (
         IMMEDIATE_2[1]), .B1 (JUMP_RELATIVE)) ;
    ao22 ix1385 (.Y (OPERAND_8_2_), .A0 (ACC[2]), .A1 (SELECT_ACC), .B0 (
         IMMEDIATE_2[2]), .B1 (JUMP_RELATIVE)) ;
    ao22 ix1391 (.Y (OPERAND_8_3_), .A0 (ACC[3]), .A1 (SELECT_ACC), .B0 (
         IMMEDIATE_2[3]), .B1 (JUMP_RELATIVE)) ;
    ao22 ix1397 (.Y (OPERAND_8_4_), .A0 (ACC[4]), .A1 (SELECT_ACC), .B0 (
         IMMEDIATE_2[4]), .B1 (JUMP_RELATIVE)) ;
    ao22 ix1403 (.Y (OPERAND_8_5_), .A0 (ACC[5]), .A1 (SELECT_ACC), .B0 (
         IMMEDIATE_2[5]), .B1 (JUMP_RELATIVE)) ;
    ao22 ix1409 (.Y (OPERAND_8_6_), .A0 (ACC[6]), .A1 (SELECT_ACC), .B0 (
         IMMEDIATE_2[6]), .B1 (JUMP_RELATIVE)) ;
    ao22 ix1415 (.Y (OPERAND_8_7_), .A0 (ACC[7]), .A1 (SELECT_ACC), .B0 (
         IMMEDIATE_2[7]), .B1 (JUMP_RELATIVE)) ;
    dff ix1006 (.Q (INCREMENT), .QB (\$dummy [18]), .D (nx1003), .CLK (CLK2)) ;
    ao21 ix1004 (.Y (nx1003), .A0 (INCREMENT), .A1 (nx2089), .B0 (nx1001)) ;
    nor02 ix1002 (.Y (nx1001), .A0 (nx2035), .A1 (nx2089)) ;
    aoi321 ix1508 (.Y (nx1507), .A0 (nx1608), .A1 (nx1044), .A2 (nx1889), .B0 (
           PC_CON[2]), .B1 (nx1891), .C0 (LAST_CYC)) ;
    or02 ix1609 (.Y (nx1608), .A0 (PC_CON[1]), .A1 (PC_CON[14])) ;
    dff ix476 (.Q (NXRAMR), .QB (\$dummy [19]), .D (nx1817), .CLK (CLK2)) ;
    nor02 ix63 (.Y (nx62), .A0 (nx1023), .A1 (nx2089)) ;
    oai21 ix1520 (.Y (nx1519), .A0 (nx2039), .A1 (nx744), .B0 (nx1785)) ;
    nor03 ix1522 (.Y (nx1521), .A0 (nx2119), .A1 (nx24), .A2 (nx726)) ;
    nand03 ix727 (.Y (nx726), .A0 (nx2117), .A1 (OPCODE[4]), .A2 (PC_CON[15])) ;
    nand03 ix745 (.Y (nx744), .A0 (PC_CON[15]), .A1 (nx2117), .A2 (nx1891)) ;
    dff ix466 (.Q (NXRAMW), .QB (nx1532), .D (nx1815), .CLK (CLK2)) ;
    dff ix486 (.Q (NPSEN), .QB (\$dummy [20]), .D (nx483), .CLK (CLK2)) ;
    ao21 ix484 (.Y (nx483), .A0 (NPSEN), .A1 (nx2041), .B0 (nx481)) ;
    nor03 ix1537 (.Y (nx1536), .A0 (nx1787), .A1 (nx2093), .A2 (nx1755)) ;
    nor03 ix769 (.Y (nx768), .A0 (nx1785), .A1 (nx2089), .A2 (nx32)) ;
    nor02 ix11 (.Y (nx10), .A0 (nx2091), .A1 (nx1753)) ;
    ao21 ix482 (.Y (nx481), .A0 (nx1787), .A1 (nx14), .B0 (nx2093)) ;
    and02 ix13 (.Y (XRAMA_EN), .A0 (PC_CON[15]), .A1 (nx1755)) ;
    dff ix506 (.Q (XRAMA[0]), .QB (\$dummy [21]), .D (nx503), .CLK (CLK2)) ;
    ao21 ix504 (.Y (nx503), .A0 (XRAMA[0]), .A1 (nx2045), .B0 (nx501)) ;
    nor02 ix787 (.Y (nx786), .A0 (nx1557), .A1 (nx2091)) ;
    inv02 ix1558 (.Y (nx1557), .A (PC_CON[15])) ;
    nor02 ix502 (.Y (nx501), .A0 (nx1114), .A1 (nx2045)) ;
    dff ix526 (.Q (XRAMA[1]), .QB (\$dummy [22]), .D (nx523), .CLK (CLK2)) ;
    ao21 ix524 (.Y (nx523), .A0 (XRAMA[1]), .A1 (nx2045), .B0 (nx521)) ;
    nor02 ix522 (.Y (nx521), .A0 (nx1159), .A1 (nx2045)) ;
    dff ix546 (.Q (XRAMA[2]), .QB (\$dummy [23]), .D (nx543), .CLK (CLK2)) ;
    ao21 ix544 (.Y (nx543), .A0 (XRAMA[2]), .A1 (nx2045), .B0 (nx541)) ;
    nor02 ix542 (.Y (nx541), .A0 (nx1181), .A1 (nx2045)) ;
    dff ix566 (.Q (XRAMA[3]), .QB (\$dummy [24]), .D (nx563), .CLK (CLK2)) ;
    ao21 ix564 (.Y (nx563), .A0 (XRAMA[3]), .A1 (nx2045), .B0 (nx561)) ;
    nor02 ix562 (.Y (nx561), .A0 (nx1202), .A1 (nx2045)) ;
    dff ix586 (.Q (XRAMA[4]), .QB (\$dummy [25]), .D (nx583), .CLK (CLK2)) ;
    ao21 ix584 (.Y (nx583), .A0 (XRAMA[4]), .A1 (nx2045), .B0 (nx581)) ;
    nor02 ix582 (.Y (nx581), .A0 (nx1222), .A1 (nx2045)) ;
    dff ix606 (.Q (XRAMA[5]), .QB (\$dummy [26]), .D (nx603), .CLK (CLK2)) ;
    ao21 ix604 (.Y (nx603), .A0 (XRAMA[5]), .A1 (nx2047), .B0 (nx601)) ;
    nor02 ix602 (.Y (nx601), .A0 (nx1243), .A1 (nx2047)) ;
    dff ix626 (.Q (XRAMA[6]), .QB (\$dummy [27]), .D (nx623), .CLK (CLK2)) ;
    ao21 ix624 (.Y (nx623), .A0 (XRAMA[6]), .A1 (nx2047), .B0 (nx621)) ;
    nor02 ix622 (.Y (nx621), .A0 (nx1263), .A1 (nx2047)) ;
    dff ix646 (.Q (XRAMA[7]), .QB (\$dummy [28]), .D (nx643), .CLK (CLK2)) ;
    ao21 ix644 (.Y (nx643), .A0 (XRAMA[7]), .A1 (nx2047), .B0 (nx641)) ;
    nor02 ix642 (.Y (nx641), .A0 (nx1281), .A1 (nx2047)) ;
    dff ix656 (.Q (XRAMA[8]), .QB (\$dummy [29]), .D (nx653), .CLK (CLK2)) ;
    ao21 ix654 (.Y (nx653), .A0 (XRAMA[8]), .A1 (nx2047), .B0 (nx651)) ;
    nor02 ix652 (.Y (nx651), .A0 (nx1303), .A1 (nx2047)) ;
    dff ix666 (.Q (XRAMA[9]), .QB (\$dummy [30]), .D (nx663), .CLK (CLK2)) ;
    ao21 ix664 (.Y (nx663), .A0 (XRAMA[9]), .A1 (nx2047), .B0 (nx661)) ;
    nor02 ix662 (.Y (nx661), .A0 (nx1325), .A1 (nx2047)) ;
    dff ix676 (.Q (XRAMA[10]), .QB (\$dummy [31]), .D (nx673), .CLK (CLK2)) ;
    ao21 ix674 (.Y (nx673), .A0 (XRAMA[10]), .A1 (nx2049), .B0 (nx671)) ;
    nor02 ix672 (.Y (nx671), .A0 (nx1348), .A1 (nx2049)) ;
    dff ix686 (.Q (XRAMA[11]), .QB (\$dummy [32]), .D (nx683), .CLK (CLK2)) ;
    ao21 ix684 (.Y (nx683), .A0 (XRAMA[11]), .A1 (nx2049), .B0 (nx681)) ;
    nor02 ix682 (.Y (nx681), .A0 (nx1373), .A1 (nx2049)) ;
    dff ix696 (.Q (XRAMA[12]), .QB (\$dummy [33]), .D (nx693), .CLK (CLK2)) ;
    ao21 ix694 (.Y (nx693), .A0 (XRAMA[12]), .A1 (nx2049), .B0 (nx691)) ;
    nor02 ix692 (.Y (nx691), .A0 (nx1403), .A1 (nx2049)) ;
    dff ix706 (.Q (XRAMA[13]), .QB (\$dummy [34]), .D (nx703), .CLK (CLK2)) ;
    ao21 ix704 (.Y (nx703), .A0 (XRAMA[13]), .A1 (nx2049), .B0 (nx701)) ;
    nor02 ix702 (.Y (nx701), .A0 (nx1428), .A1 (nx2049)) ;
    dff ix716 (.Q (XRAMA[14]), .QB (\$dummy [35]), .D (nx713), .CLK (CLK2)) ;
    ao21 ix714 (.Y (nx713), .A0 (XRAMA[14]), .A1 (nx2049), .B0 (nx711)) ;
    nor02 ix712 (.Y (nx711), .A0 (nx1449), .A1 (nx2049)) ;
    dff ix726 (.Q (XRAMA[15]), .QB (\$dummy [36]), .D (nx723), .CLK (CLK2)) ;
    ao21 ix724 (.Y (nx723), .A0 (XRAMA[15]), .A1 (nx2051), .B0 (nx721)) ;
    nor02 ix722 (.Y (nx721), .A0 (nx1471), .A1 (nx2051)) ;
    ao21 ix325 (.Y (SAVE_ADDR[0]), .A0 (PC_SUM_0_), .A1 (nx2097), .B0 (nx320)) ;
    nor02 ix321 (.Y (nx320), .A0 (nx2097), .A1 (nx1305)) ;
    ao21 ix383 (.Y (SAVE_ADDR[1]), .A0 (PC_SUM_1_), .A1 (nx2097), .B0 (nx378)) ;
    nor02 ix379 (.Y (nx378), .A0 (nx2097), .A1 (nx1327)) ;
    ao21 ix441 (.Y (SAVE_ADDR[2]), .A0 (PC_SUM_2_), .A1 (nx2097), .B0 (nx436)) ;
    nor02 ix437 (.Y (nx436), .A0 (nx2097), .A1 (nx1350)) ;
    ao21 ix497 (.Y (SAVE_ADDR[3]), .A0 (PC_SUM_3_), .A1 (nx2097), .B0 (nx492)) ;
    nor02 ix493 (.Y (nx492), .A0 (nx2097), .A1 (nx1375)) ;
    ao21 ix551 (.Y (SAVE_ADDR[4]), .A0 (PC_SUM_4_), .A1 (nx2099), .B0 (nx546)) ;
    nor02 ix547 (.Y (nx546), .A0 (nx2099), .A1 (nx1405)) ;
    ao21 ix605 (.Y (SAVE_ADDR[5]), .A0 (PC_SUM_5_), .A1 (nx2099), .B0 (nx600)) ;
    nor02 ix601 (.Y (nx600), .A0 (nx2099), .A1 (nx1430)) ;
    ao21 ix659 (.Y (SAVE_ADDR[6]), .A0 (PC_SUM_6_), .A1 (nx2099), .B0 (nx654)) ;
    nor02 ix655 (.Y (nx654), .A0 (nx2099), .A1 (nx1451)) ;
    ao21 ix713 (.Y (SAVE_ADDR[7]), .A0 (PC_SUM_7_), .A1 (nx2099), .B0 (nx708)) ;
    nor02 ix709 (.Y (nx708), .A0 (nx2099), .A1 (nx1473)) ;
    oai221 ix101 (.Y (PROGA_EN), .A0 (nx2093), .A1 (nx1655), .B0 (nx1133), .B1 (
           nx2053), .C0 (nx2055)) ;
    dff reg_LAST_RESET (.Q (\$dummy [37]), .QB (nx1655), .D (nx2093), .CLK (CLK2
        )) ;
    nor04 ix1658 (.Y (nx1657), .A0 (PC_CON[2]), .A1 (PC_CON[8]), .A2 (PC_CON[4])
          , .A3 (nx78)) ;
    or04 ix79 (.Y (nx78), .A0 (PC_CON[7]), .A1 (PC_CON[11]), .A2 (PC_CON[9]), .A3 (
         PC_CON[10])) ;
    oai221 ix51 (.Y (nx50), .A0 (nx1665), .A1 (nx24), .B0 (nx32), .B1 (nx2057), 
           .C0 (nx1917)) ;
    inv02 ix1666 (.Y (nx1665), .A (PC_CON[13])) ;
    nor02 ix1668 (.Y (nx1667), .A0 (PC_CON[15]), .A1 (PC_CON[17])) ;
    mux21 ix734 (.Y (nx733), .A0 (nx1114), .A1 (nx1672), .S0 (nx2059)) ;
    dff ix736 (.Q (PROGA[0]), .QB (nx1672), .D (nx1835), .CLK (CLK2)) ;
    nor02 ix1675 (.Y (nx1674), .A0 (nx2101), .A1 (nx1759)) ;
    nor03 ix1685 (.Y (nx1684), .A0 (PC_CON[15]), .A1 (PC_CON[17]), .A2 (
          PC_CON[13])) ;
    mux21 ix744 (.Y (nx743), .A0 (nx1159), .A1 (nx1688), .S0 (nx2059)) ;
    dff ix746 (.Q (PROGA[1]), .QB (nx1688), .D (nx1837), .CLK (CLK2)) ;
    mux21 ix754 (.Y (nx753), .A0 (nx1181), .A1 (nx1692), .S0 (nx2059)) ;
    dff ix756 (.Q (PROGA[2]), .QB (nx1692), .D (nx1839), .CLK (CLK2)) ;
    mux21 ix764 (.Y (nx763), .A0 (nx1202), .A1 (nx1696), .S0 (nx2059)) ;
    dff ix766 (.Q (PROGA[3]), .QB (nx1696), .D (nx1841), .CLK (CLK2)) ;
    mux21 ix774 (.Y (nx773), .A0 (nx1222), .A1 (nx1700), .S0 (nx2059)) ;
    dff ix776 (.Q (PROGA[4]), .QB (nx1700), .D (nx1843), .CLK (CLK2)) ;
    mux21 ix784 (.Y (nx783), .A0 (nx1243), .A1 (nx1704), .S0 (nx2059)) ;
    dff ix786 (.Q (PROGA[5]), .QB (nx1704), .D (nx1845), .CLK (CLK2)) ;
    mux21 ix794 (.Y (nx793), .A0 (nx1263), .A1 (nx1708), .S0 (nx2059)) ;
    dff ix796 (.Q (PROGA[6]), .QB (nx1708), .D (nx1847), .CLK (CLK2)) ;
    mux21 ix804 (.Y (nx803), .A0 (nx1281), .A1 (nx1712), .S0 (nx2059)) ;
    dff ix806 (.Q (PROGA[7]), .QB (nx1712), .D (nx1849), .CLK (CLK2)) ;
    mux21 ix814 (.Y (nx813), .A0 (nx1303), .A1 (nx1716), .S0 (nx2059)) ;
    dff ix816 (.Q (PROGA[8]), .QB (nx1716), .D (nx1851), .CLK (CLK2)) ;
    mux21 ix824 (.Y (nx823), .A0 (nx1325), .A1 (nx1720), .S0 (nx2059)) ;
    dff ix826 (.Q (PROGA[9]), .QB (nx1720), .D (nx1853), .CLK (CLK2)) ;
    mux21 ix834 (.Y (nx833), .A0 (nx1348), .A1 (nx1724), .S0 (nx2061)) ;
    dff ix836 (.Q (PROGA[10]), .QB (nx1724), .D (nx1855), .CLK (CLK2)) ;
    mux21 ix844 (.Y (nx843), .A0 (nx1373), .A1 (nx1728), .S0 (nx2061)) ;
    dff ix846 (.Q (PROGA[11]), .QB (nx1728), .D (nx1857), .CLK (CLK2)) ;
    mux21 ix854 (.Y (nx853), .A0 (nx1403), .A1 (nx1732), .S0 (nx2061)) ;
    dff ix856 (.Q (PROGA[12]), .QB (nx1732), .D (nx1859), .CLK (CLK2)) ;
    mux21 ix864 (.Y (nx863), .A0 (nx1428), .A1 (nx1736), .S0 (nx2061)) ;
    dff ix866 (.Q (PROGA[13]), .QB (nx1736), .D (nx1861), .CLK (CLK2)) ;
    mux21 ix874 (.Y (nx873), .A0 (nx1449), .A1 (nx1740), .S0 (nx2061)) ;
    dff ix876 (.Q (PROGA[14]), .QB (nx1740), .D (nx1863), .CLK (CLK2)) ;
    mux21 ix884 (.Y (nx883), .A0 (nx1471), .A1 (nx1744), .S0 (nx2061)) ;
    dff ix886 (.Q (PROGA[15]), .QB (nx1744), .D (nx1865), .CLK (CLK2)) ;
    inv02 ix1289 (.Y (nx1288), .A (nx258)) ;
    inv02 ix249 (.Y (nx248), .A (nx1290)) ;
    inv02 ix191 (.Y (nx190), .A (nx1061)) ;
    inv02 ix157 (.Y (nx156), .A (nx1095)) ;
    inv02 ix133 (.Y (nx132), .A (nx1055)) ;
    inv02 ix33 (.Y (nx32), .A (nx1019)) ;
    inv02 ix15 (.Y (nx14), .A (nx1667)) ;
    inv02 ix1134 (.Y (nx1133), .A (nx10)) ;
    buf02 ix1750 (.Y (nx1751), .A (OPERAND_8_7_)) ;
    inv02 ix1752 (.Y (nx1753), .A (nx1067)) ;
    inv02 ix1754 (.Y (nx1755), .A (nx1133)) ;
    buf02 ix1756 (.Y (nx1757), .A (nx50)) ;
    buf02 ix1758 (.Y (nx1759), .A (nx118)) ;
    buf02 ix1760 (.Y (nx1761), .A (nx144)) ;
    inv04 ix1762 (.Y (nx1763), .A (nx1085)) ;
    buf02 ix1764 (.Y (nx1765), .A (nx170)) ;
    buf02 ix1766 (.Y (nx1767), .A (nx174)) ;
    inv02 ix1768 (.Y (nx1769), .A (nx1379)) ;
    inv02 ix1770 (.Y (nx1771), .A (nx1083)) ;
    inv02 ix1772 (.Y (nx1773), .A (nx2113)) ;
    inv02 ix1774 (.Y (nx1775), .A (nx1905)) ;
    buf04 ix1776 (.Y (nx1777), .A (nx244)) ;
    inv02 ix1778 (.Y (nx1779), .A (nx1288)) ;
    buf02 ix1780 (.Y (nx1781), .A (nx272)) ;
    buf02 ix1782 (.Y (nx1783), .A (nx468)) ;
    inv02 ix1784 (.Y (nx1785), .A (nx1523)) ;
    buf02 ix1786 (.Y (nx1787), .A (nx768)) ;
    buf02 ix1788 (.Y (nx1789), .A (nx806)) ;
    inv02 ix1790 (.Y (nx1791), .A (nx1025)) ;
    inv02 ix1792 (.Y (nx1793), .A (nx2107)) ;
    inv02 ix1794 (.Y (nx1795), .A (nx2107)) ;
    inv02 ix1796 (.Y (nx1797), .A (nx2107)) ;
    buf02 ix1798 (.Y (nx1799), .A (nx313)) ;
    buf02 ix1800 (.Y (nx1801), .A (nx333)) ;
    buf02 ix1802 (.Y (nx1803), .A (nx353)) ;
    buf02 ix1804 (.Y (nx1805), .A (nx373)) ;
    buf02 ix1806 (.Y (nx1807), .A (nx393)) ;
    buf02 ix1808 (.Y (nx1809), .A (nx413)) ;
    buf02 ix1810 (.Y (nx1811), .A (nx433)) ;
    buf02 ix1812 (.Y (nx1813), .A (nx453)) ;
    buf02 ix1814 (.Y (nx1815), .A (nx463)) ;
    buf02 ix1816 (.Y (nx1817), .A (nx473)) ;
    buf02 ix1818 (.Y (nx1819), .A (nx493)) ;
    buf02 ix1820 (.Y (nx1821), .A (nx513)) ;
    buf02 ix1822 (.Y (nx1823), .A (nx533)) ;
    buf02 ix1824 (.Y (nx1825), .A (nx553)) ;
    buf02 ix1826 (.Y (nx1827), .A (nx573)) ;
    buf02 ix1828 (.Y (nx1829), .A (nx593)) ;
    buf02 ix1830 (.Y (nx1831), .A (nx613)) ;
    buf02 ix1832 (.Y (nx1833), .A (nx633)) ;
    buf02 ix1834 (.Y (nx1835), .A (nx733)) ;
    buf02 ix1836 (.Y (nx1837), .A (nx743)) ;
    buf02 ix1838 (.Y (nx1839), .A (nx753)) ;
    buf02 ix1840 (.Y (nx1841), .A (nx763)) ;
    buf02 ix1842 (.Y (nx1843), .A (nx773)) ;
    buf02 ix1844 (.Y (nx1845), .A (nx783)) ;
    buf02 ix1846 (.Y (nx1847), .A (nx793)) ;
    buf02 ix1848 (.Y (nx1849), .A (nx803)) ;
    buf02 ix1850 (.Y (nx1851), .A (nx813)) ;
    buf02 ix1852 (.Y (nx1853), .A (nx823)) ;
    buf02 ix1854 (.Y (nx1855), .A (nx833)) ;
    buf02 ix1856 (.Y (nx1857), .A (nx843)) ;
    buf02 ix1858 (.Y (nx1859), .A (nx853)) ;
    buf02 ix1860 (.Y (nx1861), .A (nx863)) ;
    buf02 ix1862 (.Y (nx1863), .A (nx873)) ;
    buf02 ix1864 (.Y (nx1865), .A (nx883)) ;
    buf02 ix1866 (.Y (nx1867), .A (nx903)) ;
    buf02 ix1868 (.Y (nx1869), .A (nx913)) ;
    buf02 ix1870 (.Y (nx1871), .A (nx923)) ;
    buf02 ix1872 (.Y (nx1873), .A (nx933)) ;
    buf02 ix1874 (.Y (nx1875), .A (nx943)) ;
    buf02 ix1876 (.Y (nx1877), .A (nx953)) ;
    buf02 ix1878 (.Y (nx1879), .A (nx963)) ;
    buf02 ix1880 (.Y (nx1881), .A (nx973)) ;
    buf02 ix1882 (.Y (nx1883), .A (nx983)) ;
    buf02 ix1884 (.Y (nx1885), .A (nx993)) ;
    buf02 ix1886 (.Y (nx1887), .A (nx1017)) ;
    inv02 ix1888 (.Y (nx1889), .A (nx32)) ;
    inv02 ix1890 (.Y (nx1891), .A (nx24)) ;
    buf02 ix1892 (.Y (nx1893), .A (nx1033)) ;
    buf02 ix1894 (.Y (nx1895), .A (nx1041)) ;
    buf02 ix1896 (.Y (nx1897), .A (nx1057)) ;
    buf02 ix1898 (.Y (nx1899), .A (nx1075)) ;
    buf02 ix1900 (.Y (nx1901), .A (nx1079)) ;
    buf02 ix1902 (.Y (nx1903), .A (nx1079)) ;
    inv02 ix1904 (.Y (nx1905), .A (nx216)) ;
    inv02 ix1906 (.Y (nx1907), .A (nx192)) ;
    buf02 ix1908 (.Y (nx1909), .A (nx1092)) ;
    inv02 ix1910 (.Y (nx1911), .A (nx2093)) ;
    buf04 ix1912 (.Y (nx1913), .A (nx2067)) ;
    buf04 ix1914 (.Y (nx1915), .A (nx2067)) ;
    buf02 ix1916 (.Y (nx1917), .A (nx1125)) ;
    buf02 ix1918 (.Y (nx1919), .A (nx1135)) ;
    buf02 ix1920 (.Y (nx1921), .A (nx1145)) ;
    buf02 ix1922 (.Y (nx1923), .A (nx1149)) ;
    buf02 ix1924 (.Y (nx1925), .A (nx1151)) ;
    buf02 ix1926 (.Y (nx1927), .A (nx1153)) ;
    buf02 ix1928 (.Y (nx1929), .A (nx1167)) ;
    buf02 ix1930 (.Y (nx1931), .A (nx1171)) ;
    buf02 ix1932 (.Y (nx1933), .A (nx1173)) ;
    buf02 ix1934 (.Y (nx1935), .A (nx1189)) ;
    buf02 ix1936 (.Y (nx1937), .A (nx1192)) ;
    buf02 ix1938 (.Y (nx1939), .A (nx1194)) ;
    buf02 ix1940 (.Y (nx1941), .A (nx1196)) ;
    buf02 ix1942 (.Y (nx1943), .A (nx1209)) ;
    buf02 ix1944 (.Y (nx1945), .A (nx1212)) ;
    buf02 ix1946 (.Y (nx1947), .A (nx1214)) ;
    buf02 ix1948 (.Y (nx1949), .A (nx1216)) ;
    buf02 ix1950 (.Y (nx1951), .A (nx1229)) ;
    buf02 ix1952 (.Y (nx1953), .A (nx1232)) ;
    buf02 ix1954 (.Y (nx1955), .A (nx1234)) ;
    buf02 ix1956 (.Y (nx1957), .A (nx1236)) ;
    buf02 ix1958 (.Y (nx1959), .A (nx1250)) ;
    buf02 ix1960 (.Y (nx1961), .A (nx1253)) ;
    buf02 ix1962 (.Y (nx1963), .A (nx1255)) ;
    buf02 ix1964 (.Y (nx1965), .A (nx1257)) ;
    buf02 ix1966 (.Y (nx1967), .A (nx1270)) ;
    buf02 ix1968 (.Y (nx1969), .A (nx1273)) ;
    buf02 ix1970 (.Y (nx1971), .A (nx1275)) ;
    buf02 ix1972 (.Y (nx1973), .A (nx2069)) ;
    buf02 ix1974 (.Y (nx1975), .A (nx2069)) ;
    buf02 ix1976 (.Y (nx1977), .A (nx1293)) ;
    buf02 ix1978 (.Y (nx1979), .A (nx1299)) ;
    buf02 ix1980 (.Y (nx1981), .A (nx1307)) ;
    buf02 ix1982 (.Y (nx1983), .A (nx1309)) ;
    buf02 ix1984 (.Y (nx1985), .A (nx1318)) ;
    buf02 ix1986 (.Y (nx1987), .A (nx1321)) ;
    buf02 ix1988 (.Y (nx1989), .A (nx1329)) ;
    buf02 ix1990 (.Y (nx1991), .A (nx1331)) ;
    buf02 ix1992 (.Y (nx1993), .A (nx1339)) ;
    buf02 ix1994 (.Y (nx1995), .A (nx1343)) ;
    buf02 ix1996 (.Y (nx1997), .A (nx1353)) ;
    buf02 ix1998 (.Y (nx1999), .A (nx1355)) ;
    buf02 ix2000 (.Y (nx2001), .A (nx1365)) ;
    buf02 ix2002 (.Y (nx2003), .A (nx1368)) ;
    buf02 ix2004 (.Y (nx2005), .A (nx1381)) ;
    buf02 ix2006 (.Y (nx2007), .A (nx1393)) ;
    buf02 ix2008 (.Y (nx2009), .A (nx1397)) ;
    buf02 ix2010 (.Y (nx2011), .A (nx1407)) ;
    buf02 ix2012 (.Y (nx2013), .A (nx1419)) ;
    buf02 ix2014 (.Y (nx2015), .A (nx1423)) ;
    buf02 ix2016 (.Y (nx2017), .A (nx1432)) ;
    buf02 ix2018 (.Y (nx2019), .A (nx1441)) ;
    buf02 ix2020 (.Y (nx2021), .A (nx1445)) ;
    buf02 ix2022 (.Y (nx2023), .A (nx1453)) ;
    buf02 ix2024 (.Y (nx2025), .A (nx1463)) ;
    buf02 ix2026 (.Y (nx2027), .A (nx1466)) ;
    buf02 ix2028 (.Y (nx2029), .A (nx1475)) ;
    buf02 ix2030 (.Y (nx2031), .A (nx1483)) ;
    buf02 ix2032 (.Y (nx2033), .A (nx1491)) ;
    buf02 ix2034 (.Y (nx2035), .A (nx1507)) ;
    buf02 ix2036 (.Y (nx2037), .A (nx1519)) ;
    buf02 ix2038 (.Y (nx2039), .A (nx1521)) ;
    buf02 ix2040 (.Y (nx2041), .A (nx1536)) ;
    inv02 ix2044 (.Y (nx2045), .A (nx2043)) ;
    inv02 ix2046 (.Y (nx2047), .A (nx2125)) ;
    inv02 ix2048 (.Y (nx2049), .A (nx2125)) ;
    inv02 ix2050 (.Y (nx2051), .A (nx2125)) ;
    buf02 ix2052 (.Y (nx2053), .A (nx1657)) ;
    inv02 ix2054 (.Y (nx2055), .A (nx72)) ;
    inv02 ix2056 (.Y (nx2057), .A (nx14)) ;
    buf04 ix2058 (.Y (nx2059), .A (nx2071)) ;
    buf04 ix2060 (.Y (nx2061), .A (nx2071)) ;
    buf02 ix2066 (.Y (nx2067), .A (nx1119)) ;
    buf02 ix2068 (.Y (nx2069), .A (nx1286)) ;
    buf02 ix2070 (.Y (nx2071), .A (nx1674)) ;
    or03 ix1022 (.Y (nx24), .A0 (STATE[2]), .A1 (STATE[1]), .A2 (nx1023)) ;
    and02 ix175 (.Y (nx174), .A0 (INTR_LCALL), .A1 (nx2111)) ;
    nor03 ix5 (.Y (nx1067), .A0 (STATE[2]), .A1 (nx2077), .A2 (nx2099)) ;
    inv02 ix2076 (.Y (nx2077), .A (STATE[1])) ;
    nand04 ix169 (.Y (nx1085), .A0 (PC_CON[9]), .A1 (nx1073), .A2 (nx1044), .A3 (
           nx2111)) ;
    or04 ix209 (.Y (nx1083), .A0 (nx1763), .A1 (nx1064), .A2 (nx1767), .A3 (
         nx1769)) ;
    nand03 ix187 (.Y (nx1379), .A0 (nx1044), .A1 (nx2111), .A2 (PC_CON[11])) ;
    and03 ix1082 (.Y (nx216), .A0 (nx1061), .A1 (PC_CON[16]), .A2 (nx1889)) ;
    nand02 ix1090 (.Y (nx192), .A0 (nx1061), .A1 (nx1379)) ;
    ao21 ix119 (.Y (nx118), .A0 (nx10), .A1 (nx2079), .B0 (nx2095)) ;
    inv02 ix2078 (.Y (nx2079), .A (nx1919)) ;
    and02 ix1547 (.Y (nx1546), .A0 (nx2107), .A1 (PROGRAM_COUNT_8_)) ;
    and02 ix1555 (.Y (nx1554), .A0 (nx2107), .A1 (PROGRAM_COUNT_9_)) ;
    and02 ix1563 (.Y (nx1562), .A0 (nx2107), .A1 (PROGRAM_COUNT_10_)) ;
    and02 ix1571 (.Y (nx1570), .A0 (nx2107), .A1 (PROGRAM_COUNT_11_)) ;
    and02 ix1579 (.Y (nx1578), .A0 (nx2107), .A1 (PROGRAM_COUNT_12_)) ;
    and02 ix1587 (.Y (nx1586), .A0 (nx2107), .A1 (PROGRAM_COUNT_13_)) ;
    and02 ix1595 (.Y (nx1594), .A0 (nx2109), .A1 (PROGRAM_COUNT_14_)) ;
    and02 ix1603 (.Y (nx1602), .A0 (nx2109), .A1 (PROGRAM_COUNT_15_)) ;
    ao21 ix474 (.Y (nx473), .A0 (NXRAMR), .A1 (nx2119), .B0 (nx2081)) ;
    inv02 ix2080 (.Y (nx2081), .A (nx2037)) ;
    aoi21 ix719 (.Y (nx1523), .A0 (nx1047), .A1 (nx62), .B0 (nx2095)) ;
    mux21 ix464 (.Y (nx463), .A0 (nx2039), .A1 (nx1532), .S0 (nx2119)) ;
    ao21 ix1554 (.Y (nx2043), .A0 (nx1889), .A1 (nx786), .B0 (nx2095)) ;
    oai332 ix1661 (.Y (nx72), .A0 (nx2083), .A1 (EXCEPTION), .A2 (nx2085), .B0 (
           nx2087), .B1 (INTR_LCALL), .B2 (nx2091), .C0 (nx1133), .C1 (nx2121)
           ) ;
    inv02 ix2082 (.Y (nx2083), .A (nx62)) ;
    inv02 ix2084 (.Y (nx2085), .A (LAST_CYC)) ;
    inv02 ix2086 (.Y (nx2087), .A (nx1757)) ;
    inv04 ix2088 (.Y (nx2089), .A (nx1129)) ;
    inv04 ix2090 (.Y (nx2091), .A (nx1129)) ;
    inv02 ix2092 (.Y (nx2093), .A (nx1117)) ;
    inv02 ix2094 (.Y (nx2095), .A (nx1117)) ;
    inv02 ix2096 (.Y (nx2097), .A (nx1023)) ;
    inv02 ix2098 (.Y (nx2099), .A (nx1023)) ;
    inv02 ix2100 (.Y (nx2101), .A (nx2055)) ;
    inv02 ix2102 (.Y (nx2103), .A (nx1907)) ;
    inv02 ix2104 (.Y (nx2105), .A (nx1905)) ;
    inv02 ix2106 (.Y (nx2107), .A (nx1791)) ;
    inv02 ix2108 (.Y (nx2109), .A (nx1791)) ;
    inv02 ix2110 (.Y (nx2111), .A (nx1753)) ;
    inv02 ix2112 (.Y (nx2113), .A (nx1771)) ;
    inv02 ix2114 (.Y (nx2115), .A (nx1763)) ;
    inv02 ix2116 (.Y (nx2117), .A (INTERNAL_RESET)) ;
    inv02 ix2118 (.Y (nx2119), .A (nx1785)) ;
    buf02 ix2120 (.Y (nx2121), .A (nx1684)) ;
    inv02 ix2122 (.Y (nx2123), .A (nx1025)) ;
    inv02 ix2124 (.Y (nx2125), .A (nx2045)) ;
endmodule


module block11 ( PC_SUM, OPERAND_16, OPERAND_8, INCREMENT, SIGN_EXTEND ) ;

    output [15:0]PC_SUM ;
    input [15:0]OPERAND_16 ;
    input [7:0]OPERAND_8 ;
    input INCREMENT ;
    input SIGN_EXTEND ;

    wire CARRY_12, CARRY_8, CARRY_4, PC_PROP_15_, PC_PROP_14_, PC_PROP_13_, 
         PC_PROP_12_, PC_PROP_11_, PC_PROP_10_, PC_PROP_9_, PC_PROP_8_, 
         PC_PROP_7_, PC_PROP_6_, PC_PROP_5_, PC_PROP_4_, PC_PROP_3_, PC_PROP_2_, 
         PC_PROP_1_, PC_PROP_0_, PC_GEN_14_, PC_GEN_13_, PC_GEN_12_, PC_GEN_10_, 
         PC_GEN_9_, PC_GEN_8_, PC_GEN_6_, PC_GEN_5_, PC_GEN_4_, PC_GEN_2_, 
         PC_GEN_1_, PC_GEN_0_, PWR, nx0, nx82, nx86, nx90, nx100, nx104, nx108, 
         nx118, nx122, nx126, nx425, nx427, nx430, nx432, nx435, nx437, nx441, 
         nx443, nx446, nx448, nx451, nx453, nx457, nx459, nx462, nx465, nx469, 
         nx472, nx475, nx495, nx497, nx499, nx501, nx503, nx505, nx507, nx509, 
         nx511, nx513, nx515, nx517, nx519, nx521, nx523;



    block02u u1 (.S ({PC_SUM[3],PC_SUM[2],PC_SUM[1],PC_SUM[0]}), .P ({
                       PC_PROP_3_,nx517,nx519,nx521}), .G ({PC_GEN_2_,PC_GEN_1_,
                       PC_GEN_0_}), .C_IN (INCREMENT), .C_EN (PWR)) ;
    block02u u2 (.S ({PC_SUM[7],PC_SUM[6],PC_SUM[5],PC_SUM[4]}), .P ({
                       PC_PROP_7_,nx511,nx513,nx515}), .G ({PC_GEN_6_,PC_GEN_5_,
                       PC_GEN_4_}), .C_IN (nx497), .C_EN (PWR)) ;
    block02u u3 (.S ({PC_SUM[11],PC_SUM[10],PC_SUM[9],PC_SUM[8]}), .P (
                       {PC_PROP_11_,nx505,nx507,nx509}), .G ({PC_GEN_10_,
                       PC_GEN_9_,PC_GEN_8_}), .C_IN (nx495), .C_EN (PWR)) ;
    block02u u4 (.S ({PC_SUM[15],PC_SUM[14],PC_SUM[13],PC_SUM[12]}), .P (
                       {PC_PROP_15_,nx499,nx501,nx503}), .G ({PC_GEN_14_,
                       PC_GEN_13_,PC_GEN_12_}), .C_IN (CARRY_12), .C_EN (PWR)) ;
    fake_vcc ix378 (.Y (PWR)) ;
    and02 ix73 (.Y (PC_GEN_0_), .A0 (OPERAND_8[0]), .A1 (OPERAND_16[0])) ;
    and02 ix65 (.Y (PC_GEN_1_), .A0 (OPERAND_8[1]), .A1 (OPERAND_16[1])) ;
    and02 ix57 (.Y (PC_GEN_2_), .A0 (OPERAND_8[2]), .A1 (OPERAND_16[2])) ;
    and02 ix47 (.Y (PC_GEN_4_), .A0 (OPERAND_8[4]), .A1 (OPERAND_16[4])) ;
    and02 ix39 (.Y (PC_GEN_5_), .A0 (OPERAND_8[5]), .A1 (OPERAND_16[5])) ;
    and02 ix31 (.Y (PC_GEN_6_), .A0 (OPERAND_8[6]), .A1 (OPERAND_16[6])) ;
    and02 ix21 (.Y (PC_GEN_8_), .A0 (OPERAND_16[8]), .A1 (nx0)) ;
    and02 ix13 (.Y (PC_GEN_9_), .A0 (OPERAND_16[9]), .A1 (nx0)) ;
    and02 ix5 (.Y (PC_GEN_10_), .A0 (OPERAND_16[10]), .A1 (nx0)) ;
    and02 ix137 (.Y (PC_GEN_12_), .A0 (OPERAND_16[12]), .A1 (nx0)) ;
    and02 ix145 (.Y (PC_GEN_13_), .A0 (OPERAND_16[13]), .A1 (nx0)) ;
    and02 ix153 (.Y (PC_GEN_14_), .A0 (OPERAND_16[14]), .A1 (nx0)) ;
    aoi21 ix79 (.Y (PC_PROP_0_), .A0 (nx425), .A1 (nx427), .B0 (PC_GEN_0_)) ;
    inv02 ix426 (.Y (nx425), .A (OPERAND_16[0])) ;
    inv02 ix428 (.Y (nx427), .A (OPERAND_8[0])) ;
    aoi21 ix71 (.Y (PC_PROP_1_), .A0 (nx430), .A1 (nx432), .B0 (PC_GEN_1_)) ;
    inv02 ix431 (.Y (nx430), .A (OPERAND_16[1])) ;
    inv02 ix433 (.Y (nx432), .A (OPERAND_8[1])) ;
    aoi21 ix63 (.Y (PC_PROP_2_), .A0 (nx435), .A1 (nx437), .B0 (PC_GEN_2_)) ;
    inv02 ix436 (.Y (nx435), .A (OPERAND_16[2])) ;
    inv02 ix438 (.Y (nx437), .A (OPERAND_8[2])) ;
    xor2 ix55 (.Y (PC_PROP_3_), .A0 (OPERAND_16[3]), .A1 (OPERAND_8[3])) ;
    aoi21 ix53 (.Y (PC_PROP_4_), .A0 (nx441), .A1 (nx443), .B0 (PC_GEN_4_)) ;
    inv02 ix442 (.Y (nx441), .A (OPERAND_16[4])) ;
    inv02 ix444 (.Y (nx443), .A (OPERAND_8[4])) ;
    aoi21 ix45 (.Y (PC_PROP_5_), .A0 (nx446), .A1 (nx448), .B0 (PC_GEN_5_)) ;
    inv02 ix447 (.Y (nx446), .A (OPERAND_16[5])) ;
    inv02 ix449 (.Y (nx448), .A (OPERAND_8[5])) ;
    aoi21 ix37 (.Y (PC_PROP_6_), .A0 (nx451), .A1 (nx453), .B0 (PC_GEN_6_)) ;
    inv02 ix452 (.Y (nx451), .A (OPERAND_16[6])) ;
    inv02 ix454 (.Y (nx453), .A (OPERAND_8[6])) ;
    xor2 ix29 (.Y (PC_PROP_7_), .A0 (OPERAND_16[7]), .A1 (OPERAND_8[7])) ;
    aoi21 ix27 (.Y (PC_PROP_8_), .A0 (nx523), .A1 (nx459), .B0 (PC_GEN_8_)) ;
    nand02 ix458 (.Y (nx457), .A0 (SIGN_EXTEND), .A1 (OPERAND_8[7])) ;
    inv02 ix460 (.Y (nx459), .A (OPERAND_16[8])) ;
    aoi21 ix19 (.Y (PC_PROP_9_), .A0 (nx523), .A1 (nx462), .B0 (PC_GEN_9_)) ;
    inv02 ix463 (.Y (nx462), .A (OPERAND_16[9])) ;
    aoi21 ix11 (.Y (PC_PROP_10_), .A0 (nx523), .A1 (nx465), .B0 (PC_GEN_10_)) ;
    inv02 ix466 (.Y (nx465), .A (OPERAND_16[10])) ;
    aoi21 ix143 (.Y (PC_PROP_12_), .A0 (nx523), .A1 (nx469), .B0 (PC_GEN_12_)) ;
    inv02 ix470 (.Y (nx469), .A (OPERAND_16[12])) ;
    aoi21 ix151 (.Y (PC_PROP_13_), .A0 (nx523), .A1 (nx472), .B0 (PC_GEN_13_)) ;
    inv02 ix473 (.Y (nx472), .A (OPERAND_16[13])) ;
    aoi21 ix159 (.Y (PC_PROP_14_), .A0 (nx523), .A1 (nx475), .B0 (PC_GEN_14_)) ;
    inv02 ix476 (.Y (nx475), .A (OPERAND_16[14])) ;
    ao22 ix97 (.Y (CARRY_4), .A0 (OPERAND_8[3]), .A1 (OPERAND_16[3]), .B0 (
         PC_PROP_3_), .B1 (nx90)) ;
    ao21 ix91 (.Y (nx90), .A0 (nx517), .A1 (nx86), .B0 (PC_GEN_2_)) ;
    ao21 ix87 (.Y (nx86), .A0 (nx519), .A1 (nx82), .B0 (PC_GEN_1_)) ;
    ao21 ix83 (.Y (nx82), .A0 (INCREMENT), .A1 (nx521), .B0 (PC_GEN_0_)) ;
    ao22 ix115 (.Y (CARRY_8), .A0 (OPERAND_8[7]), .A1 (OPERAND_16[7]), .B0 (
         PC_PROP_7_), .B1 (nx108)) ;
    ao21 ix109 (.Y (nx108), .A0 (nx511), .A1 (nx104), .B0 (PC_GEN_6_)) ;
    ao21 ix105 (.Y (nx104), .A0 (nx513), .A1 (nx100), .B0 (PC_GEN_5_)) ;
    ao21 ix101 (.Y (nx100), .A0 (nx515), .A1 (nx497), .B0 (PC_GEN_4_)) ;
    ao32 ix135 (.Y (CARRY_12), .A0 (SIGN_EXTEND), .A1 (OPERAND_8[7]), .A2 (
         OPERAND_16[11]), .B0 (PC_PROP_11_), .B1 (nx126)) ;
    ao21 ix127 (.Y (nx126), .A0 (nx505), .A1 (nx122), .B0 (PC_GEN_10_)) ;
    ao21 ix123 (.Y (nx122), .A0 (nx507), .A1 (nx118), .B0 (PC_GEN_9_)) ;
    ao21 ix119 (.Y (nx118), .A0 (nx509), .A1 (nx495), .B0 (PC_GEN_8_)) ;
    inv04 ix1 (.Y (nx0), .A (nx457)) ;
    buf02 ix494 (.Y (nx495), .A (CARRY_8)) ;
    buf02 ix496 (.Y (nx497), .A (CARRY_4)) ;
    buf02 ix498 (.Y (nx499), .A (PC_PROP_14_)) ;
    buf02 ix500 (.Y (nx501), .A (PC_PROP_13_)) ;
    buf02 ix502 (.Y (nx503), .A (PC_PROP_12_)) ;
    buf02 ix504 (.Y (nx505), .A (PC_PROP_10_)) ;
    buf02 ix506 (.Y (nx507), .A (PC_PROP_9_)) ;
    buf02 ix508 (.Y (nx509), .A (PC_PROP_8_)) ;
    buf02 ix510 (.Y (nx511), .A (PC_PROP_6_)) ;
    buf02 ix512 (.Y (nx513), .A (PC_PROP_5_)) ;
    buf02 ix514 (.Y (nx515), .A (PC_PROP_4_)) ;
    buf02 ix516 (.Y (nx517), .A (PC_PROP_2_)) ;
    buf02 ix518 (.Y (nx519), .A (PC_PROP_1_)) ;
    buf02 ix520 (.Y (nx521), .A (PC_PROP_0_)) ;
    inv04 ix522 (.Y (nx523), .A (nx0)) ;
    xor2 ix3 (.Y (PC_PROP_11_), .A0 (OPERAND_16[11]), .A1 (nx0)) ;
    xor2 ix161 (.Y (PC_PROP_15_), .A0 (OPERAND_16[15]), .A1 (nx0)) ;
endmodule


module block02u ( S, P, G, C_IN, C_EN ) ;

    output [3:0]S ;
    input [3:0]P ;
    input [2:0]G ;
    input C_IN ;
    input C_EN ;

    wire nx2, nx6, nx83, nx90;



    xor2 ix19 (.Y (S[0]), .A0 (C_IN), .A1 (P[0])) ;
    xor2 ix17 (.Y (S[1]), .A0 (P[1]), .A1 (nx2)) ;
    ao21 ix3 (.Y (nx2), .A0 (C_IN), .A1 (P[0]), .B0 (G[0])) ;
    xor2 ix15 (.Y (S[2]), .A0 (P[2]), .A1 (nx6)) ;
    ao21 ix7 (.Y (nx6), .A0 (P[1]), .A1 (nx2), .B0 (G[1])) ;
    xnor2 ix13 (.Y (S[3]), .A0 (P[3]), .A1 (nx90)) ;
    aoi21 ix84 (.Y (nx83), .A0 (P[2]), .A1 (nx6), .B0 (G[2])) ;
    buf02 ix89 (.Y (nx90), .A (nx83)) ;
endmodule


module block08 ( ACC, B, PSW, WRITE_PSW, REG_RESULT, ACC_RESULT, B_RESULT, 
                  CARRY_RESULT, AUX_CARRY_RESULT, OVERFLOW_RESULT, SFR_WRITE_EN, 
                  SFR_CON, STATE, LAST_CYC, INTERNAL_WAIT, CLK2, INT_RESET ) ;

    output [7:0]ACC ;
    output [7:0]B ;
    output [7:0]PSW ;
    output WRITE_PSW ;
    input [7:0]REG_RESULT ;
    input [7:0]ACC_RESULT ;
    input [7:0]B_RESULT ;
    input CARRY_RESULT ;
    input AUX_CARRY_RESULT ;
    input OVERFLOW_RESULT ;
    input [7:5]SFR_WRITE_EN ;
    input [6:0]SFR_CON ;
    input [2:0]STATE ;
    input LAST_CYC ;
    input INTERNAL_WAIT ;
    input CLK2 ;
    input INT_RESET ;

    wire nx12, nx22, nx34, nx44, nx166, nx218, nx240, nx264, nx59, nx61, nx69, 
         nx71, nx79, nx81, nx89, nx91, nx99, nx101, nx109, nx111, nx119, nx121, 
         nx129, nx131, nx139, nx141, nx149, nx151, nx161, nx169, nx171, nx179, 
         nx181, nx189, nx191, nx201, nx211, nx219, nx221, nx229, nx231, nx239, 
         nx241, nx249, nx251, nx259, nx261, nx269, nx271, nx279, nx281, nx289, 
         nx291, nx304, nx309, nx311, nx313, nx321, nx326, nx331, nx341, nx343, 
         nx350, nx360, nx362, nx372, nx385, nx392, nx394, nx396, nx413, nx415, 
         nx417, nx422, nx424, nx426, nx431, nx436, nx472, nx474, nx476, nx480, 
         nx482, nx484, nx486, nx488, nx490, nx492, nx502, nx504, nx506, nx508, 
         nx510, nx512, nx514, nx516, nx518, nx520, nx522, nx524, nx526, nx528, 
         nx530, nx532, nx534, nx536, nx538, nx540, nx542, nx544, nx546, nx548, 
         nx550, nx552, nx554, nx556, nx558, nx560, nx562, nx564, nx566, nx572;
    wire [20:0] \$dummy ;




    fake_gnd ix7 (.Y (WRITE_PSW)) ;
    dff ix144 (.Q (PSW[0]), .QB (\$dummy [0]), .D (nx141), .CLK (CLK2)) ;
    ao21 ix142 (.Y (nx141), .A0 (PSW[0]), .A1 (nx304), .B0 (nx480)) ;
    nor02 ix305 (.Y (nx304), .A0 (nx472), .A1 (nx530)) ;
    nor04 ix13 (.Y (nx12), .A0 (STATE[1]), .A1 (STATE[2]), .A2 (INTERNAL_WAIT), 
          .A3 (STATE[0])) ;
    nor03 ix140 (.Y (nx139), .A0 (nx530), .A1 (nx309), .A2 (nx304)) ;
    xnor2 ix310 (.Y (nx309), .A0 (nx311), .A1 (nx360)) ;
    xnor2 ix312 (.Y (nx311), .A0 (nx313), .A1 (nx350)) ;
    xnor2 ix314 (.Y (nx313), .A0 (ACC[7]), .A1 (ACC[6])) ;
    dff ix64 (.Q (ACC[7]), .QB (\$dummy [1]), .D (nx61), .CLK (CLK2)) ;
    ao21 ix62 (.Y (nx61), .A0 (ACC[7]), .A1 (nx488), .B0 (nx59)) ;
    nor03 ix23 (.Y (nx22), .A0 (INTERNAL_WAIT), .A1 (nx321), .A2 (STATE[2])) ;
    inv02 ix322 (.Y (nx321), .A (STATE[1])) ;
    inv02 ix327 (.Y (nx326), .A (INTERNAL_WAIT)) ;
    and03 ix60 (.Y (nx59), .A0 (ACC_RESULT[7]), .A1 (nx490), .A2 (nx534)) ;
    inv02 ix332 (.Y (nx331), .A (INT_RESET)) ;
    nand03 ix342 (.Y (nx341), .A0 (LAST_CYC), .A1 (nx326), .A2 (STATE[0])) ;
    nor03 ix344 (.Y (nx343), .A0 (SFR_CON[0]), .A1 (SFR_CON[6]), .A2 (
          SFR_WRITE_EN[6])) ;
    dff ix74 (.Q (ACC[6]), .QB (\$dummy [2]), .D (nx71), .CLK (CLK2)) ;
    ao21 ix72 (.Y (nx71), .A0 (ACC[6]), .A1 (nx488), .B0 (nx69)) ;
    and03 ix70 (.Y (nx69), .A0 (ACC_RESULT[6]), .A1 (nx490), .A2 (nx534)) ;
    xnor2 ix351 (.Y (nx350), .A0 (ACC[5]), .A1 (ACC[4])) ;
    dff ix84 (.Q (ACC[5]), .QB (\$dummy [3]), .D (nx81), .CLK (CLK2)) ;
    ao21 ix82 (.Y (nx81), .A0 (ACC[5]), .A1 (nx488), .B0 (nx79)) ;
    and03 ix80 (.Y (nx79), .A0 (ACC_RESULT[5]), .A1 (nx490), .A2 (nx534)) ;
    dff ix94 (.Q (ACC[4]), .QB (\$dummy [4]), .D (nx91), .CLK (CLK2)) ;
    ao21 ix92 (.Y (nx91), .A0 (ACC[4]), .A1 (nx488), .B0 (nx89)) ;
    and03 ix90 (.Y (nx89), .A0 (ACC_RESULT[4]), .A1 (nx490), .A2 (nx534)) ;
    xnor2 ix361 (.Y (nx360), .A0 (nx362), .A1 (nx372)) ;
    xnor2 ix363 (.Y (nx362), .A0 (ACC[3]), .A1 (ACC[2])) ;
    dff ix104 (.Q (ACC[3]), .QB (\$dummy [5]), .D (nx101), .CLK (CLK2)) ;
    ao21 ix102 (.Y (nx101), .A0 (ACC[3]), .A1 (nx488), .B0 (nx99)) ;
    and03 ix100 (.Y (nx99), .A0 (ACC_RESULT[3]), .A1 (nx490), .A2 (nx534)) ;
    dff ix114 (.Q (ACC[2]), .QB (\$dummy [6]), .D (nx111), .CLK (CLK2)) ;
    ao21 ix112 (.Y (nx111), .A0 (ACC[2]), .A1 (nx488), .B0 (nx109)) ;
    and03 ix110 (.Y (nx109), .A0 (ACC_RESULT[2]), .A1 (nx490), .A2 (nx534)) ;
    xnor2 ix373 (.Y (nx372), .A0 (ACC[1]), .A1 (ACC[0])) ;
    dff ix124 (.Q (ACC[1]), .QB (\$dummy [7]), .D (nx121), .CLK (CLK2)) ;
    ao21 ix122 (.Y (nx121), .A0 (ACC[1]), .A1 (nx488), .B0 (nx119)) ;
    and03 ix120 (.Y (nx119), .A0 (ACC_RESULT[1]), .A1 (nx490), .A2 (nx534)) ;
    dff ix134 (.Q (ACC[0]), .QB (\$dummy [8]), .D (nx131), .CLK (CLK2)) ;
    ao21 ix132 (.Y (nx131), .A0 (ACC[0]), .A1 (nx488), .B0 (nx129)) ;
    and03 ix130 (.Y (nx129), .A0 (ACC_RESULT[0]), .A1 (nx490), .A2 (nx534)) ;
    dff ix154 (.Q (PSW[1]), .QB (\$dummy [9]), .D (nx151), .CLK (CLK2)) ;
    ao21 ix152 (.Y (nx151), .A0 (PSW[1]), .A1 (nx564), .B0 (nx536)) ;
    mux21 ix162 (.Y (nx161), .A0 (nx392), .A1 (nx394), .S0 (nx166)) ;
    dff ix164 (.Q (PSW[2]), .QB (nx392), .D (nx482), .CLK (CLK2)) ;
    or02 ix395 (.Y (nx394), .A0 (nx530), .A1 (nx396)) ;
    mux21 ix397 (.Y (nx396), .A0 (REG_RESULT[2]), .A1 (OVERFLOW_RESULT), .S0 (
          SFR_CON[5])) ;
    ao21 ix167 (.Y (nx166), .A0 (SFR_CON[5]), .A1 (nx34), .B0 (nx476)) ;
    dff ix174 (.Q (PSW[3]), .QB (\$dummy [10]), .D (nx171), .CLK (CLK2)) ;
    ao21 ix172 (.Y (nx171), .A0 (PSW[3]), .A1 (nx564), .B0 (nx538)) ;
    dff ix184 (.Q (PSW[4]), .QB (\$dummy [11]), .D (nx181), .CLK (CLK2)) ;
    ao21 ix182 (.Y (nx181), .A0 (PSW[4]), .A1 (nx564), .B0 (nx540)) ;
    dff ix194 (.Q (PSW[5]), .QB (\$dummy [12]), .D (nx191), .CLK (CLK2)) ;
    ao21 ix192 (.Y (nx191), .A0 (PSW[5]), .A1 (nx564), .B0 (nx542)) ;
    mux21 ix202 (.Y (nx201), .A0 (nx413), .A1 (nx415), .S0 (nx218)) ;
    dff ix204 (.Q (PSW[6]), .QB (nx413), .D (nx484), .CLK (CLK2)) ;
    or02 ix416 (.Y (nx415), .A0 (nx530), .A1 (nx417)) ;
    mux21 ix418 (.Y (nx417), .A0 (REG_RESULT[6]), .A1 (AUX_CARRY_RESULT), .S0 (
          SFR_CON[4])) ;
    ao21 ix219 (.Y (nx218), .A0 (SFR_CON[4]), .A1 (nx34), .B0 (nx476)) ;
    mux21 ix212 (.Y (nx211), .A0 (nx422), .A1 (nx424), .S0 (nx240)) ;
    dff ix214 (.Q (PSW[7]), .QB (nx422), .D (nx486), .CLK (CLK2)) ;
    or02 ix425 (.Y (nx424), .A0 (nx530), .A1 (nx426)) ;
    mux21 ix427 (.Y (nx426), .A0 (REG_RESULT[7]), .A1 (CARRY_RESULT), .S0 (
          SFR_CON[3])) ;
    ao21 ix241 (.Y (nx240), .A0 (SFR_CON[3]), .A1 (nx34), .B0 (nx476)) ;
    dff ix224 (.Q (B[0]), .QB (\$dummy [13]), .D (nx221), .CLK (CLK2)) ;
    ao21 ix222 (.Y (nx221), .A0 (B[0]), .A1 (nx566), .B0 (nx544)) ;
    oai21 ix265 (.Y (nx264), .A0 (nx560), .A1 (nx436), .B0 (nx492)) ;
    nor02 ix437 (.Y (nx436), .A0 (SFR_WRITE_EN[7]), .A1 (SFR_CON[2])) ;
    dff ix234 (.Q (B[1]), .QB (\$dummy [14]), .D (nx231), .CLK (CLK2)) ;
    ao21 ix232 (.Y (nx231), .A0 (B[1]), .A1 (nx566), .B0 (nx546)) ;
    dff ix244 (.Q (B[2]), .QB (\$dummy [15]), .D (nx241), .CLK (CLK2)) ;
    ao21 ix242 (.Y (nx241), .A0 (B[2]), .A1 (nx566), .B0 (nx548)) ;
    dff ix254 (.Q (B[3]), .QB (\$dummy [16]), .D (nx251), .CLK (CLK2)) ;
    ao21 ix252 (.Y (nx251), .A0 (B[3]), .A1 (nx566), .B0 (nx550)) ;
    dff ix264 (.Q (B[4]), .QB (\$dummy [17]), .D (nx261), .CLK (CLK2)) ;
    ao21 ix262 (.Y (nx261), .A0 (B[4]), .A1 (nx566), .B0 (nx552)) ;
    dff ix274 (.Q (B[5]), .QB (\$dummy [18]), .D (nx271), .CLK (CLK2)) ;
    ao21 ix272 (.Y (nx271), .A0 (B[5]), .A1 (nx566), .B0 (nx554)) ;
    dff ix284 (.Q (B[6]), .QB (\$dummy [19]), .D (nx281), .CLK (CLK2)) ;
    ao21 ix282 (.Y (nx281), .A0 (B[6]), .A1 (nx566), .B0 (nx556)) ;
    dff ix294 (.Q (B[7]), .QB (\$dummy [20]), .D (nx291), .CLK (CLK2)) ;
    ao21 ix292 (.Y (nx291), .A0 (B[7]), .A1 (nx566), .B0 (nx558)) ;
    inv02 ix432 (.Y (nx431), .A (nx264)) ;
    inv02 ix35 (.Y (nx34), .A (nx341)) ;
    buf02 ix471 (.Y (nx472), .A (nx12)) ;
    buf02 ix473 (.Y (nx474), .A (nx22)) ;
    inv02 ix475 (.Y (nx476), .A (nx385)) ;
    buf02 ix479 (.Y (nx480), .A (nx139)) ;
    buf02 ix481 (.Y (nx482), .A (nx161)) ;
    buf02 ix483 (.Y (nx484), .A (nx201)) ;
    buf02 ix485 (.Y (nx486), .A (nx211)) ;
    inv02 ix487 (.Y (nx488), .A (nx44)) ;
    inv02 ix489 (.Y (nx490), .A (nx530)) ;
    inv02 ix491 (.Y (nx492), .A (nx530)) ;
    oai321 ix318 (.Y (nx44), .A0 (nx502), .A1 (nx504), .A2 (STATE[0]), .B0 (
           nx560), .B1 (nx562), .C0 (nx331)) ;
    inv02 ix501 (.Y (nx502), .A (nx474)) ;
    inv02 ix503 (.Y (nx504), .A (SFR_CON[1])) ;
    nor03 ix150 (.Y (nx149), .A0 (nx506), .A1 (nx530), .A2 (nx564)) ;
    inv02 ix505 (.Y (nx506), .A (REG_RESULT[1])) ;
    aoi21 ix153 (.Y (nx385), .A0 (SFR_WRITE_EN[5]), .A1 (nx34), .B0 (nx530)) ;
    nor03 ix170 (.Y (nx169), .A0 (nx508), .A1 (nx530), .A2 (nx564)) ;
    inv02 ix507 (.Y (nx508), .A (REG_RESULT[3])) ;
    nor03 ix180 (.Y (nx179), .A0 (nx510), .A1 (nx532), .A2 (nx564)) ;
    inv02 ix509 (.Y (nx510), .A (REG_RESULT[4])) ;
    nor03 ix190 (.Y (nx189), .A0 (nx512), .A1 (nx532), .A2 (nx564)) ;
    inv02 ix511 (.Y (nx512), .A (REG_RESULT[5])) ;
    nor03 ix220 (.Y (nx219), .A0 (nx514), .A1 (nx532), .A2 (nx566)) ;
    inv02 ix513 (.Y (nx514), .A (B_RESULT[0])) ;
    nor03 ix230 (.Y (nx229), .A0 (nx516), .A1 (nx532), .A2 (nx566)) ;
    inv02 ix515 (.Y (nx516), .A (B_RESULT[1])) ;
    nor03 ix240 (.Y (nx239), .A0 (nx518), .A1 (nx532), .A2 (nx431)) ;
    inv02 ix517 (.Y (nx518), .A (B_RESULT[2])) ;
    nor03 ix250 (.Y (nx249), .A0 (nx520), .A1 (nx532), .A2 (nx431)) ;
    inv02 ix519 (.Y (nx520), .A (B_RESULT[3])) ;
    nor03 ix260 (.Y (nx259), .A0 (nx522), .A1 (nx532), .A2 (nx431)) ;
    inv02 ix521 (.Y (nx522), .A (B_RESULT[4])) ;
    nor03 ix270 (.Y (nx269), .A0 (nx524), .A1 (nx532), .A2 (nx431)) ;
    inv02 ix523 (.Y (nx524), .A (B_RESULT[5])) ;
    nor03 ix280 (.Y (nx279), .A0 (nx526), .A1 (nx532), .A2 (nx431)) ;
    inv02 ix525 (.Y (nx526), .A (B_RESULT[6])) ;
    nor03 ix290 (.Y (nx289), .A0 (nx528), .A1 (nx532), .A2 (nx431)) ;
    inv02 ix527 (.Y (nx528), .A (B_RESULT[7])) ;
    inv02 ix529 (.Y (nx530), .A (nx331)) ;
    inv02 ix531 (.Y (nx532), .A (nx331)) ;
    inv04 ix533 (.Y (nx534), .A (nx488)) ;
    buf02 ix535 (.Y (nx536), .A (nx149)) ;
    buf02 ix537 (.Y (nx538), .A (nx169)) ;
    buf02 ix539 (.Y (nx540), .A (nx179)) ;
    buf02 ix541 (.Y (nx542), .A (nx189)) ;
    buf02 ix543 (.Y (nx544), .A (nx219)) ;
    buf02 ix545 (.Y (nx546), .A (nx229)) ;
    buf02 ix547 (.Y (nx548), .A (nx239)) ;
    buf02 ix549 (.Y (nx550), .A (nx249)) ;
    buf02 ix551 (.Y (nx552), .A (nx259)) ;
    buf02 ix553 (.Y (nx554), .A (nx269)) ;
    buf02 ix555 (.Y (nx556), .A (nx279)) ;
    buf02 ix557 (.Y (nx558), .A (nx289)) ;
    inv02 ix559 (.Y (nx560), .A (nx34)) ;
    buf02 ix561 (.Y (nx562), .A (nx343)) ;
    inv02 ix563 (.Y (nx564), .A (nx476)) ;
    inv02 ix565 (.Y (nx566), .A (nx572)) ;
    inv02 ix571 (.Y (nx572), .A (nx431)) ;
endmodule


module block07 ( SFR_DATA, SFR_WRITE_EN, SOURCE_ADDR, DESTIN_ADDR, SFR_WRITE, 
                  PORT_0, PORT_1, PORT_2, PORT_3, STACK_POINTER, DATA_POINTER, 
                  INTR_EN0, INTR_EN1, INTR_PRI0, INTR_PRI1, PSW, ACC, B, PCON, 
                  TIMER_SFR_DATA, SERIAL_SFR_DATA, ESFR_DATA ) ;

    output [7:0]SFR_DATA ;
    output [14:0]SFR_WRITE_EN ;
    input [6:0]SOURCE_ADDR ;
    input [6:0]DESTIN_ADDR ;
    input SFR_WRITE ;
    input [7:0]PORT_0 ;
    input [7:0]PORT_1 ;
    input [7:0]PORT_2 ;
    input [7:0]PORT_3 ;
    input [7:0]STACK_POINTER ;
    input [15:0]DATA_POINTER ;
    input [7:0]INTR_EN0 ;
    input [7:0]INTR_EN1 ;
    input [7:0]INTR_PRI0 ;
    input [7:0]INTR_PRI1 ;
    input [7:0]PSW ;
    input [7:0]ACC ;
    input [7:0]B ;
    input [7:0]PCON ;
    input [7:0]TIMER_SFR_DATA ;
    input [7:0]SERIAL_SFR_DATA ;
    input [7:0]ESFR_DATA ;

    wire nx2, nx6, nx14, nx20, nx28, nx34, nx40, nx46, nx56, nx68, nx74, nx80, 
         nx86, nx98, nx102, nx112, nx124, nx142, nx148, nx154, nx168, nx182, 
         nx200, nx204, nx212, nx220, nx226, nx240, nx246, nx258, nx282, nx288, 
         nx300, nx304, nx312, nx326, nx400, nx474, nx548, nx600, nx670, nx740, 
         nx832, nx846, nx856, nx874, nx884, nx483, nx487, nx489, nx493, nx495, 
         nx497, nx509, nx513, nx521, nx529, nx533, nx537, nx545, nx549, nx555, 
         nx565, nx569, nx571, nx575, nx577, nx581, nx583, nx585, nx589, nx593, 
         nx597, nx599, nx603, nx605, nx614, nx617, nx619, nx621, nx625, nx629, 
         nx633, nx643, nx645, nx651, nx661, nx667, nx681, nx685, nx687, nx689, 
         nx691, nx693, nx695, nx697, nx701, nx705, nx707, nx709, nx711, nx713, 
         nx715, nx717, nx721, nx725, nx727, nx729, nx731, nx733, nx735, nx737, 
         nx741, nx743, nx745, nx749, nx751, nx753, nx755, nx757, nx761, nx763, 
         nx765, nx769, nx771, nx773, nx775, nx777, nx781, nx783, nx785, nx789, 
         nx791, nx793, nx795, nx797, nx801, nx805, nx807, nx809, nx811, nx813, 
         nx815, nx817, nx824, nx826, nx828, nx830, nx833, nx835, nx837, nx839, 
         nx841, nx843, nx845, nx847, nx849, nx851, nx853, nx855, nx857, nx859, 
         nx861, nx863, nx865, nx867, nx869, nx871, nx873, nx875, nx877, nx879, 
         nx881, nx883, nx885, nx887, nx889, nx891, nx893, nx895, nx897, nx899, 
         nx901, nx903, nx905, nx907, nx909, nx911, nx913, nx915, nx917, nx919, 
         nx921, nx923, nx925, nx927, nx929, nx931, nx933, nx935, nx937, nx939, 
         nx941, nx943, nx945, nx947, nx949, nx951, nx953, nx955, nx957, nx959, 
         nx961, nx963, nx965, nx967, nx969, nx971, nx973, nx975, nx977, nx979, 
         nx981, nx983, nx985, nx987, nx989, nx991, nx993, nx995, nx1001, nx1003, 
         nx1005, nx1007, nx1009, nx1011;



    and02 ix861 (.Y (SFR_WRITE_EN[0]), .A0 (nx871), .A1 (nx867)) ;
    nor03 ix484 (.Y (nx483), .A0 (DESTIN_ADDR[5]), .A1 (DESTIN_ADDR[6]), .A2 (
          DESTIN_ADDR[4])) ;
    nor04 ix857 (.Y (nx856), .A0 (nx487), .A1 (DESTIN_ADDR[1]), .A2 (
          DESTIN_ADDR[2]), .A3 (DESTIN_ADDR[3])) ;
    nand02 ix488 (.Y (nx487), .A0 (nx489), .A1 (SFR_WRITE)) ;
    inv02 ix490 (.Y (nx489), .A (DESTIN_ADDR[0])) ;
    nor03 ix871 (.Y (SFR_WRITE_EN[1]), .A0 (nx493), .A1 (DESTIN_ADDR[5]), .A2 (
          nx497)) ;
    nand02 ix494 (.Y (nx493), .A0 (nx495), .A1 (nx867)) ;
    inv02 ix496 (.Y (nx495), .A (DESTIN_ADDR[6])) ;
    inv02 ix498 (.Y (nx497), .A (DESTIN_ADDR[4])) ;
    nor02 ix879 (.Y (SFR_WRITE_EN[2]), .A0 (nx874), .A1 (nx493)) ;
    nand02 ix875 (.Y (nx874), .A0 (nx497), .A1 (DESTIN_ADDR[5])) ;
    nor02 ix889 (.Y (SFR_WRITE_EN[3]), .A0 (nx884), .A1 (nx493)) ;
    nand02 ix885 (.Y (nx884), .A0 (DESTIN_ADDR[4]), .A1 (DESTIN_ADDR[5])) ;
    nor04 ix903 (.Y (SFR_WRITE_EN[4]), .A0 (nx509), .A1 (DESTIN_ADDR[1]), .A2 (
          DESTIN_ADDR[2]), .A3 (DESTIN_ADDR[3])) ;
    nand03 ix510 (.Y (nx509), .A0 (nx871), .A1 (DESTIN_ADDR[0]), .A2 (SFR_WRITE)
           ) ;
    nor03 ix911 (.Y (SFR_WRITE_EN[5]), .A0 (nx513), .A1 (DESTIN_ADDR[5]), .A2 (
          nx497)) ;
    nand02 ix514 (.Y (nx513), .A0 (DESTIN_ADDR[6]), .A1 (nx867)) ;
    nor02 ix915 (.Y (SFR_WRITE_EN[6]), .A0 (nx874), .A1 (nx513)) ;
    nor02 ix919 (.Y (SFR_WRITE_EN[7]), .A0 (nx884), .A1 (nx513)) ;
    and04 ix929 (.Y (SFR_WRITE_EN[8]), .A0 (DESTIN_ADDR[1]), .A1 (nx521), .A2 (
          nx871), .A3 (nx846)) ;
    nor02 ix522 (.Y (nx521), .A0 (DESTIN_ADDR[2]), .A1 (DESTIN_ADDR[3])) ;
    nor04 ix935 (.Y (SFR_WRITE_EN[9]), .A0 (nx509), .A1 (nx529), .A2 (
          DESTIN_ADDR[2]), .A3 (DESTIN_ADDR[3])) ;
    inv02 ix530 (.Y (nx529), .A (DESTIN_ADDR[1])) ;
    nor04 ix943 (.Y (SFR_WRITE_EN[10]), .A0 (DESTIN_ADDR[3]), .A1 (nx533), .A2 (
          nx529), .A3 (nx509)) ;
    inv02 ix534 (.Y (nx533), .A (DESTIN_ADDR[2])) ;
    nor03 ix961 (.Y (SFR_WRITE_EN[11]), .A0 (nx1011), .A1 (DESTIN_ADDR[6]), .A2 (
          nx874)) ;
    nor03 ix969 (.Y (SFR_WRITE_EN[12]), .A0 (nx1011), .A1 (DESTIN_ADDR[6]), .A2 (
          nx884)) ;
    nor03 ix975 (.Y (SFR_WRITE_EN[13]), .A0 (nx1011), .A1 (nx495), .A2 (nx874)
          ) ;
    and04 ix981 (.Y (SFR_WRITE_EN[14]), .A0 (nx869), .A1 (DESTIN_ADDR[6]), .A2 (
          DESTIN_ADDR[4]), .A3 (DESTIN_ADDR[5])) ;
    inv02 ix546 (.Y (nx545), .A (DESTIN_ADDR[3])) ;
    nand04 ix333 (.Y (SFR_DATA[0]), .A0 (nx873), .A1 (nx887), .A2 (nx889), .A3 (
           nx643)) ;
    aoi221 ix550 (.Y (nx549), .A0 (STACK_POINTER[0]), .A1 (nx865), .B0 (
           ESFR_DATA[0]), .B1 (nx863), .C0 (nx326)) ;
    nor04 ix313 (.Y (nx312), .A0 (nx1009), .A1 (SOURCE_ADDR[2]), .A2 (
          SOURCE_ADDR[1]), .A3 (nx828)) ;
    nand02 ix57 (.Y (nx56), .A0 (nx875), .A1 (SOURCE_ADDR[0])) ;
    nor03 ix556 (.Y (nx555), .A0 (nx1003), .A1 (nx1001), .A2 (nx1007)) ;
    and03 ix305 (.Y (nx304), .A0 (nx857), .A1 (nx859), .A2 (nx861)) ;
    nor04 ix283 (.Y (nx282), .A0 (nx824), .A1 (nx877), .A2 (nx571), .A3 (nx881)
          ) ;
    nand02 ix21 (.Y (nx20), .A0 (nx14), .A1 (nx6)) ;
    nand03 ix15 (.Y (nx14), .A0 (nx1007), .A1 (nx1009), .A2 (nx565)) ;
    nor02 ix566 (.Y (nx565), .A0 (nx1003), .A1 (nx1001)) ;
    nand02 ix7 (.Y (nx6), .A0 (nx875), .A1 (nx1009)) ;
    nor04 ix570 (.Y (nx569), .A0 (SOURCE_ADDR[2]), .A1 (nx1009), .A2 (
          SOURCE_ADDR[1]), .A3 (nx828)) ;
    nand02 ix572 (.Y (nx571), .A0 (nx240), .A1 (nx220)) ;
    nand04 ix241 (.Y (nx240), .A0 (nx875), .A1 (nx575), .A2 (SOURCE_ADDR[1]), .A3 (
           nx577)) ;
    nor02 ix576 (.Y (nx575), .A0 (SOURCE_ADDR[2]), .A1 (nx1009)) ;
    inv02 ix578 (.Y (nx577), .A (SOURCE_ADDR[0])) ;
    nand03 ix221 (.Y (nx220), .A0 (nx879), .A1 (nx1007), .A2 (nx565)) ;
    nor04 ix582 (.Y (nx581), .A0 (SOURCE_ADDR[1]), .A1 (SOURCE_ADDR[0]), .A2 (
          SOURCE_ADDR[2]), .A3 (nx1009)) ;
    oai32 ix584 (.Y (nx583), .A0 (nx1009), .A1 (nx585), .A2 (nx828), .B0 (nx204)
          , .B1 (nx74)) ;
    inv02 ix586 (.Y (nx585), .A (SOURCE_ADDR[1])) ;
    inv02 ix590 (.Y (nx589), .A (SOURCE_ADDR[6])) ;
    nand02 ix75 (.Y (nx74), .A0 (nx593), .A1 (nx1003)) ;
    inv02 ix594 (.Y (nx593), .A (SOURCE_ADDR[4])) ;
    aoi321 ix289 (.Y (nx288), .A0 (nx1001), .A1 (nx597), .A2 (nx879), .B0 (nx599
           ), .B1 (nx883), .C0 (nx885)) ;
    nor02 ix598 (.Y (nx597), .A0 (nx593), .A1 (nx1003)) ;
    inv02 ix604 (.Y (nx603), .A (SOURCE_ADDR[3])) ;
    nor03 ix606 (.Y (nx605), .A0 (nx98), .A1 (nx1001), .A2 (nx34)) ;
    nand02 ix35 (.Y (nx34), .A0 (nx1007), .A1 (nx1003)) ;
    aoi322 ix301 (.Y (nx300), .A0 (nx593), .A1 (nx1003), .A2 (nx883), .B0 (
           nx1003), .B1 (nx614), .C0 (nx879), .C1 (nx875)) ;
    ao22 ix327 (.Y (nx326), .A0 (SERIAL_SFR_DATA[0]), .A1 (nx617), .B0 (
         TIMER_SFR_DATA[0]), .B1 (nx619)) ;
    aoi22 ix622 (.Y (nx621), .A0 (INTR_EN0[0]), .A1 (nx855), .B0 (
          DATA_POINTER[0]), .B1 (nx853)) ;
    nor04 ix259 (.Y (nx258), .A0 (nx625), .A1 (nx1001), .A2 (nx1007), .A3 (nx28)
          ) ;
    inv02 ix626 (.Y (nx625), .A (SOURCE_ADDR[5])) ;
    inv02 ix630 (.Y (nx629), .A (SOURCE_ADDR[2])) ;
    nor02 ix247 (.Y (nx246), .A0 (nx824), .A1 (nx240)) ;
    aoi222 ix634 (.Y (nx633), .A0 (PORT_2[0]), .A1 (nx849), .B0 (PORT_1[0]), .B1 (
           nx851), .C0 (PORT_0[0]), .C1 (nx847)) ;
    nor04 ix213 (.Y (nx212), .A0 (nx625), .A1 (nx1001), .A2 (nx98), .A3 (nx1007)
          ) ;
    nor02 ix227 (.Y (nx226), .A0 (nx824), .A1 (nx220)) ;
    nor03 ix201 (.Y (nx200), .A0 (nx98), .A1 (nx1009), .A2 (nx2)) ;
    and04 ix644 (.Y (nx643), .A0 (nx891), .A1 (nx893), .A2 (nx895), .A3 (nx897)
          ) ;
    aoi22 ix646 (.Y (nx645), .A0 (DATA_POINTER[8]), .A1 (nx845), .B0 (PORT_3[0])
          , .B1 (nx843)) ;
    nor04 ix183 (.Y (nx182), .A0 (nx1009), .A1 (SOURCE_ADDR[2]), .A2 (nx585), .A3 (
          nx828)) ;
    and04 ix169 (.Y (nx168), .A0 (nx1003), .A1 (nx589), .A2 (nx879), .A3 (nx1007
          )) ;
    aoi22 ix652 (.Y (nx651), .A0 (INTR_PRI0[0]), .A1 (nx841), .B0 (PSW[0]), .B1 (
          nx839)) ;
    nor02 ix155 (.Y (nx154), .A0 (nx824), .A1 (nx148)) ;
    nand04 ix149 (.Y (nx148), .A0 (nx1007), .A1 (nx1003), .A2 (nx589), .A3 (
           nx883)) ;
    nor04 ix143 (.Y (nx142), .A0 (nx824), .A1 (nx593), .A2 (nx1003), .A3 (nx102)
          ) ;
    nand02 ix103 (.Y (nx102), .A0 (nx879), .A1 (nx1001)) ;
    aoi22 ix662 (.Y (nx661), .A0 (ACC[0]), .A1 (nx837), .B0 (B[0]), .B1 (nx835)
          ) ;
    nor03 ix125 (.Y (nx124), .A0 (nx102), .A1 (nx625), .A2 (nx1007)) ;
    nor03 ix113 (.Y (nx112), .A0 (nx102), .A1 (nx824), .A2 (nx34)) ;
    aoi222 ix668 (.Y (nx667), .A0 (PCON[0]), .A1 (nx830), .B0 (INTR_EN1[0]), .B1 (
           nx833), .C0 (INTR_PRI1[0]), .C1 (nx826)) ;
    nor04 ix69 (.Y (nx68), .A0 (nx1009), .A1 (nx828), .A2 (nx585), .A3 (nx629)
          ) ;
    nor02 ix87 (.Y (nx86), .A0 (nx824), .A1 (nx80)) ;
    nand04 ix81 (.Y (nx80), .A0 (nx593), .A1 (nx1005), .A2 (nx1001), .A3 (nx883)
           ) ;
    nor02 ix47 (.Y (nx46), .A0 (nx824), .A1 (nx40)) ;
    nand04 ix41 (.Y (nx40), .A0 (nx1007), .A1 (nx1005), .A2 (nx1001), .A3 (nx883
           )) ;
    nand04 ix407 (.Y (SFR_DATA[1]), .A0 (nx899), .A1 (nx901), .A2 (nx903), .A3 (
           nx689)) ;
    aoi221 ix682 (.Y (nx681), .A0 (STACK_POINTER[1]), .A1 (nx865), .B0 (
           ESFR_DATA[1]), .B1 (nx863), .C0 (nx400)) ;
    ao22 ix401 (.Y (nx400), .A0 (SERIAL_SFR_DATA[1]), .A1 (nx617), .B0 (
         TIMER_SFR_DATA[1]), .B1 (nx619)) ;
    aoi22 ix686 (.Y (nx685), .A0 (INTR_EN0[1]), .A1 (nx855), .B0 (
          DATA_POINTER[1]), .B1 (nx853)) ;
    aoi222 ix688 (.Y (nx687), .A0 (PORT_2[1]), .A1 (nx849), .B0 (PORT_1[1]), .B1 (
           nx851), .C0 (PORT_0[1]), .C1 (nx847)) ;
    and04 ix690 (.Y (nx689), .A0 (nx905), .A1 (nx907), .A2 (nx909), .A3 (nx911)
          ) ;
    aoi22 ix692 (.Y (nx691), .A0 (DATA_POINTER[9]), .A1 (nx845), .B0 (PORT_3[1])
          , .B1 (nx843)) ;
    aoi22 ix694 (.Y (nx693), .A0 (INTR_PRI0[1]), .A1 (nx841), .B0 (PSW[1]), .B1 (
          nx839)) ;
    aoi22 ix696 (.Y (nx695), .A0 (ACC[1]), .A1 (nx837), .B0 (B[1]), .B1 (nx835)
          ) ;
    aoi222 ix698 (.Y (nx697), .A0 (PCON[1]), .A1 (nx830), .B0 (INTR_EN1[1]), .B1 (
           nx833), .C0 (INTR_PRI1[1]), .C1 (nx826)) ;
    nand04 ix481 (.Y (SFR_DATA[2]), .A0 (nx913), .A1 (nx915), .A2 (nx917), .A3 (
           nx709)) ;
    aoi221 ix702 (.Y (nx701), .A0 (STACK_POINTER[2]), .A1 (nx865), .B0 (
           ESFR_DATA[2]), .B1 (nx863), .C0 (nx474)) ;
    ao22 ix475 (.Y (nx474), .A0 (SERIAL_SFR_DATA[2]), .A1 (nx617), .B0 (
         TIMER_SFR_DATA[2]), .B1 (nx619)) ;
    aoi22 ix706 (.Y (nx705), .A0 (INTR_EN0[2]), .A1 (nx855), .B0 (
          DATA_POINTER[2]), .B1 (nx853)) ;
    aoi222 ix708 (.Y (nx707), .A0 (PORT_2[2]), .A1 (nx849), .B0 (PORT_1[2]), .B1 (
           nx851), .C0 (PORT_0[2]), .C1 (nx847)) ;
    and04 ix710 (.Y (nx709), .A0 (nx919), .A1 (nx921), .A2 (nx923), .A3 (nx925)
          ) ;
    aoi22 ix712 (.Y (nx711), .A0 (DATA_POINTER[10]), .A1 (nx845), .B0 (PORT_3[2]
          ), .B1 (nx843)) ;
    aoi22 ix714 (.Y (nx713), .A0 (INTR_PRI0[2]), .A1 (nx841), .B0 (PSW[2]), .B1 (
          nx839)) ;
    aoi22 ix716 (.Y (nx715), .A0 (ACC[2]), .A1 (nx837), .B0 (B[2]), .B1 (nx835)
          ) ;
    aoi222 ix718 (.Y (nx717), .A0 (PCON[2]), .A1 (nx830), .B0 (INTR_EN1[2]), .B1 (
           nx833), .C0 (INTR_PRI1[2]), .C1 (nx826)) ;
    nand04 ix555 (.Y (SFR_DATA[3]), .A0 (nx927), .A1 (nx929), .A2 (nx931), .A3 (
           nx729)) ;
    aoi221 ix722 (.Y (nx721), .A0 (STACK_POINTER[3]), .A1 (nx865), .B0 (
           ESFR_DATA[3]), .B1 (nx863), .C0 (nx548)) ;
    ao22 ix549 (.Y (nx548), .A0 (SERIAL_SFR_DATA[3]), .A1 (nx617), .B0 (
         TIMER_SFR_DATA[3]), .B1 (nx619)) ;
    aoi22 ix726 (.Y (nx725), .A0 (INTR_EN0[3]), .A1 (nx855), .B0 (
          DATA_POINTER[3]), .B1 (nx853)) ;
    aoi222 ix728 (.Y (nx727), .A0 (PORT_2[3]), .A1 (nx849), .B0 (PORT_1[3]), .B1 (
           nx851), .C0 (PORT_0[3]), .C1 (nx847)) ;
    and04 ix730 (.Y (nx729), .A0 (nx933), .A1 (nx935), .A2 (nx937), .A3 (nx939)
          ) ;
    aoi22 ix732 (.Y (nx731), .A0 (DATA_POINTER[11]), .A1 (nx845), .B0 (PORT_3[3]
          ), .B1 (nx843)) ;
    aoi22 ix734 (.Y (nx733), .A0 (INTR_PRI0[3]), .A1 (nx841), .B0 (PSW[3]), .B1 (
          nx839)) ;
    aoi22 ix736 (.Y (nx735), .A0 (ACC[3]), .A1 (nx837), .B0 (B[3]), .B1 (nx835)
          ) ;
    aoi222 ix738 (.Y (nx737), .A0 (PCON[3]), .A1 (nx830), .B0 (INTR_EN1[3]), .B1 (
           nx833), .C0 (INTR_PRI1[3]), .C1 (nx826)) ;
    nand04 ix625 (.Y (SFR_DATA[4]), .A0 (nx941), .A1 (nx943), .A2 (nx945), .A3 (
           nx749)) ;
    aoi22 ix742 (.Y (nx741), .A0 (SERIAL_SFR_DATA[4]), .A1 (nx617), .B0 (
          TIMER_SFR_DATA[4]), .B1 (nx619)) ;
    aoi22 ix744 (.Y (nx743), .A0 (STACK_POINTER[4]), .A1 (nx865), .B0 (
          ESFR_DATA[4]), .B1 (nx863)) ;
    aoi221 ix746 (.Y (nx745), .A0 (PORT_0[4]), .A1 (nx847), .B0 (PORT_1[4]), .B1 (
           nx851), .C0 (nx600)) ;
    ao22 ix601 (.Y (nx600), .A0 (INTR_EN0[4]), .A1 (nx855), .B0 (DATA_POINTER[4]
         ), .B1 (nx853)) ;
    and04 ix750 (.Y (nx749), .A0 (nx947), .A1 (nx949), .A2 (nx951), .A3 (nx953)
          ) ;
    aoi22 ix752 (.Y (nx751), .A0 (DATA_POINTER[12]), .A1 (nx845), .B0 (PORT_2[4]
          ), .B1 (nx849)) ;
    aoi22 ix754 (.Y (nx753), .A0 (PORT_3[4]), .A1 (nx843), .B0 (INTR_PRI0[4]), .B1 (
          nx841)) ;
    aoi22 ix756 (.Y (nx755), .A0 (ACC[4]), .A1 (nx837), .B0 (PSW[4]), .B1 (nx839
          )) ;
    aoi222 ix758 (.Y (nx757), .A0 (INTR_PRI1[4]), .A1 (nx826), .B0 (INTR_EN1[4])
           , .B1 (nx833), .C0 (B[4]), .C1 (nx835)) ;
    nand04 ix695 (.Y (SFR_DATA[5]), .A0 (nx955), .A1 (nx957), .A2 (nx959), .A3 (
           nx769)) ;
    aoi22 ix762 (.Y (nx761), .A0 (SERIAL_SFR_DATA[5]), .A1 (nx617), .B0 (
          TIMER_SFR_DATA[5]), .B1 (nx619)) ;
    aoi22 ix764 (.Y (nx763), .A0 (STACK_POINTER[5]), .A1 (nx865), .B0 (
          ESFR_DATA[5]), .B1 (nx863)) ;
    aoi221 ix766 (.Y (nx765), .A0 (PORT_0[5]), .A1 (nx847), .B0 (PORT_1[5]), .B1 (
           nx851), .C0 (nx670)) ;
    ao22 ix671 (.Y (nx670), .A0 (INTR_EN0[5]), .A1 (nx855), .B0 (DATA_POINTER[5]
         ), .B1 (nx853)) ;
    and04 ix770 (.Y (nx769), .A0 (nx961), .A1 (nx963), .A2 (nx965), .A3 (nx967)
          ) ;
    aoi22 ix772 (.Y (nx771), .A0 (DATA_POINTER[13]), .A1 (nx845), .B0 (PORT_2[5]
          ), .B1 (nx849)) ;
    aoi22 ix774 (.Y (nx773), .A0 (PORT_3[5]), .A1 (nx843), .B0 (INTR_PRI0[5]), .B1 (
          nx841)) ;
    aoi22 ix776 (.Y (nx775), .A0 (ACC[5]), .A1 (nx837), .B0 (PSW[5]), .B1 (nx839
          )) ;
    aoi222 ix778 (.Y (nx777), .A0 (INTR_PRI1[5]), .A1 (nx826), .B0 (INTR_EN1[5])
           , .B1 (nx833), .C0 (B[5]), .C1 (nx835)) ;
    nand04 ix765 (.Y (SFR_DATA[6]), .A0 (nx969), .A1 (nx971), .A2 (nx973), .A3 (
           nx789)) ;
    aoi22 ix782 (.Y (nx781), .A0 (SERIAL_SFR_DATA[6]), .A1 (nx617), .B0 (
          TIMER_SFR_DATA[6]), .B1 (nx619)) ;
    aoi22 ix784 (.Y (nx783), .A0 (STACK_POINTER[6]), .A1 (nx865), .B0 (
          ESFR_DATA[6]), .B1 (nx863)) ;
    aoi221 ix786 (.Y (nx785), .A0 (PORT_0[6]), .A1 (nx847), .B0 (PORT_1[6]), .B1 (
           nx851), .C0 (nx740)) ;
    ao22 ix741 (.Y (nx740), .A0 (INTR_EN0[6]), .A1 (nx855), .B0 (DATA_POINTER[6]
         ), .B1 (nx853)) ;
    and04 ix790 (.Y (nx789), .A0 (nx975), .A1 (nx977), .A2 (nx979), .A3 (nx981)
          ) ;
    aoi22 ix792 (.Y (nx791), .A0 (DATA_POINTER[14]), .A1 (nx845), .B0 (PORT_2[6]
          ), .B1 (nx849)) ;
    aoi22 ix794 (.Y (nx793), .A0 (PORT_3[6]), .A1 (nx843), .B0 (INTR_PRI0[6]), .B1 (
          nx841)) ;
    aoi22 ix796 (.Y (nx795), .A0 (ACC[6]), .A1 (nx837), .B0 (PSW[6]), .B1 (nx839
          )) ;
    aoi222 ix798 (.Y (nx797), .A0 (INTR_PRI1[6]), .A1 (nx826), .B0 (INTR_EN1[6])
           , .B1 (nx833), .C0 (B[6]), .C1 (nx835)) ;
    nand04 ix839 (.Y (SFR_DATA[7]), .A0 (nx983), .A1 (nx985), .A2 (nx987), .A3 (
           nx809)) ;
    aoi221 ix802 (.Y (nx801), .A0 (STACK_POINTER[7]), .A1 (nx865), .B0 (
           ESFR_DATA[7]), .B1 (nx863), .C0 (nx832)) ;
    ao22 ix833 (.Y (nx832), .A0 (SERIAL_SFR_DATA[7]), .A1 (nx617), .B0 (
         TIMER_SFR_DATA[7]), .B1 (nx619)) ;
    aoi22 ix806 (.Y (nx805), .A0 (INTR_EN0[7]), .A1 (nx855), .B0 (
          DATA_POINTER[7]), .B1 (nx853)) ;
    aoi222 ix808 (.Y (nx807), .A0 (PORT_2[7]), .A1 (nx849), .B0 (PORT_1[7]), .B1 (
           nx851), .C0 (PORT_0[7]), .C1 (nx847)) ;
    and04 ix810 (.Y (nx809), .A0 (nx989), .A1 (nx991), .A2 (nx993), .A3 (nx995)
          ) ;
    aoi22 ix812 (.Y (nx811), .A0 (DATA_POINTER[15]), .A1 (nx845), .B0 (PORT_3[7]
          ), .B1 (nx843)) ;
    aoi22 ix814 (.Y (nx813), .A0 (INTR_PRI0[7]), .A1 (nx841), .B0 (PSW[7]), .B1 (
          nx839)) ;
    aoi22 ix816 (.Y (nx815), .A0 (ACC[7]), .A1 (nx837), .B0 (B[7]), .B1 (nx835)
          ) ;
    aoi222 ix818 (.Y (nx817), .A0 (PCON[7]), .A1 (nx830), .B0 (INTR_EN1[7]), .B1 (
           nx833), .C0 (INTR_PRI1[7]), .C1 (nx826)) ;
    inv02 ix847 (.Y (nx846), .A (nx487)) ;
    inv02 ix615 (.Y (nx614), .A (nx102)) ;
    inv02 ix99 (.Y (nx98), .A (nx581)) ;
    inv02 ix600 (.Y (nx599), .A (nx34)) ;
    inv02 ix618 (.Y (nx617), .A (nx14)) ;
    inv02 ix620 (.Y (nx619), .A (nx6)) ;
    inv02 ix3 (.Y (nx2), .A (nx555)) ;
    buf02 ix823 (.Y (nx824), .A (nx20)) ;
    buf02 ix825 (.Y (nx826), .A (nx46)) ;
    buf02 ix827 (.Y (nx828), .A (nx56)) ;
    buf02 ix829 (.Y (nx830), .A (nx68)) ;
    buf02 ix831 (.Y (nx833), .A (nx86)) ;
    buf02 ix834 (.Y (nx835), .A (nx112)) ;
    buf02 ix836 (.Y (nx837), .A (nx124)) ;
    buf02 ix838 (.Y (nx839), .A (nx142)) ;
    buf02 ix840 (.Y (nx841), .A (nx154)) ;
    buf02 ix842 (.Y (nx843), .A (nx168)) ;
    buf02 ix844 (.Y (nx845), .A (nx182)) ;
    buf02 ix846 (.Y (nx847), .A (nx200)) ;
    buf02 ix848 (.Y (nx849), .A (nx212)) ;
    buf02 ix850 (.Y (nx851), .A (nx226)) ;
    buf02 ix852 (.Y (nx853), .A (nx246)) ;
    buf02 ix854 (.Y (nx855), .A (nx258)) ;
    buf02 ix856 (.Y (nx857), .A (nx282)) ;
    buf02 ix858 (.Y (nx859), .A (nx288)) ;
    buf02 ix860 (.Y (nx861), .A (nx300)) ;
    buf02 ix862 (.Y (nx863), .A (nx304)) ;
    buf02 ix864 (.Y (nx865), .A (nx312)) ;
    buf02 ix866 (.Y (nx867), .A (nx856)) ;
    inv02 ix868 (.Y (nx869), .A (nx537)) ;
    buf02 ix870 (.Y (nx871), .A (nx483)) ;
    buf02 ix872 (.Y (nx873), .A (nx549)) ;
    inv02 ix874 (.Y (nx875), .A (nx2)) ;
    buf02 ix876 (.Y (nx877), .A (nx569)) ;
    inv02 ix878 (.Y (nx879), .A (nx98)) ;
    buf02 ix880 (.Y (nx881), .A (nx583)) ;
    inv02 ix882 (.Y (nx883), .A (nx28)) ;
    buf02 ix884 (.Y (nx885), .A (nx605)) ;
    buf02 ix886 (.Y (nx887), .A (nx621)) ;
    buf02 ix888 (.Y (nx889), .A (nx633)) ;
    buf02 ix890 (.Y (nx891), .A (nx645)) ;
    buf02 ix892 (.Y (nx893), .A (nx651)) ;
    buf02 ix894 (.Y (nx895), .A (nx661)) ;
    buf02 ix896 (.Y (nx897), .A (nx667)) ;
    buf02 ix898 (.Y (nx899), .A (nx681)) ;
    buf02 ix900 (.Y (nx901), .A (nx685)) ;
    buf02 ix902 (.Y (nx903), .A (nx687)) ;
    buf02 ix904 (.Y (nx905), .A (nx691)) ;
    buf02 ix906 (.Y (nx907), .A (nx693)) ;
    buf02 ix908 (.Y (nx909), .A (nx695)) ;
    buf02 ix910 (.Y (nx911), .A (nx697)) ;
    buf02 ix912 (.Y (nx913), .A (nx701)) ;
    buf02 ix914 (.Y (nx915), .A (nx705)) ;
    buf02 ix916 (.Y (nx917), .A (nx707)) ;
    buf02 ix918 (.Y (nx919), .A (nx711)) ;
    buf02 ix920 (.Y (nx921), .A (nx713)) ;
    buf02 ix922 (.Y (nx923), .A (nx715)) ;
    buf02 ix924 (.Y (nx925), .A (nx717)) ;
    buf02 ix926 (.Y (nx927), .A (nx721)) ;
    buf02 ix928 (.Y (nx929), .A (nx725)) ;
    buf02 ix930 (.Y (nx931), .A (nx727)) ;
    buf02 ix932 (.Y (nx933), .A (nx731)) ;
    buf02 ix934 (.Y (nx935), .A (nx733)) ;
    buf02 ix936 (.Y (nx937), .A (nx735)) ;
    buf02 ix938 (.Y (nx939), .A (nx737)) ;
    buf02 ix940 (.Y (nx941), .A (nx741)) ;
    buf02 ix942 (.Y (nx943), .A (nx743)) ;
    buf02 ix944 (.Y (nx945), .A (nx745)) ;
    buf02 ix946 (.Y (nx947), .A (nx751)) ;
    buf02 ix948 (.Y (nx949), .A (nx753)) ;
    buf02 ix950 (.Y (nx951), .A (nx755)) ;
    buf02 ix952 (.Y (nx953), .A (nx757)) ;
    buf02 ix954 (.Y (nx955), .A (nx761)) ;
    buf02 ix956 (.Y (nx957), .A (nx763)) ;
    buf02 ix958 (.Y (nx959), .A (nx765)) ;
    buf02 ix960 (.Y (nx961), .A (nx771)) ;
    buf02 ix962 (.Y (nx963), .A (nx773)) ;
    buf02 ix964 (.Y (nx965), .A (nx775)) ;
    buf02 ix966 (.Y (nx967), .A (nx777)) ;
    buf02 ix968 (.Y (nx969), .A (nx781)) ;
    buf02 ix970 (.Y (nx971), .A (nx783)) ;
    buf02 ix972 (.Y (nx973), .A (nx785)) ;
    buf02 ix974 (.Y (nx975), .A (nx791)) ;
    buf02 ix976 (.Y (nx977), .A (nx793)) ;
    buf02 ix978 (.Y (nx979), .A (nx795)) ;
    buf02 ix980 (.Y (nx981), .A (nx797)) ;
    buf02 ix982 (.Y (nx983), .A (nx801)) ;
    buf02 ix984 (.Y (nx985), .A (nx805)) ;
    buf02 ix986 (.Y (nx987), .A (nx807)) ;
    buf02 ix988 (.Y (nx989), .A (nx811)) ;
    buf02 ix990 (.Y (nx991), .A (nx813)) ;
    buf02 ix992 (.Y (nx993), .A (nx815)) ;
    buf02 ix994 (.Y (nx995), .A (nx817)) ;
    or04 ix953 (.Y (nx537), .A0 (nx545), .A1 (DESTIN_ADDR[2]), .A2 (
         DESTIN_ADDR[1]), .A3 (nx487)) ;
    or02 ix205 (.Y (nx204), .A0 (nx98), .A1 (nx1001)) ;
    or04 ix602 (.Y (nx28), .A0 (SOURCE_ADDR[1]), .A1 (SOURCE_ADDR[2]), .A2 (
         nx603), .A3 (SOURCE_ADDR[0])) ;
    inv02 ix1000 (.Y (nx1001), .A (nx589)) ;
    inv04 ix1002 (.Y (nx1003), .A (nx625)) ;
    inv04 ix1004 (.Y (nx1005), .A (nx625)) ;
    inv04 ix1006 (.Y (nx1007), .A (nx593)) ;
    inv02 ix1008 (.Y (nx1009), .A (nx603)) ;
    inv02 ix1010 (.Y (nx1011), .A (nx869)) ;
endmodule


module block06 ( SOURCE_A, DESTIN_A, SFRSA, INDIRECT_DATA, STACK_POINTER, 
                  NDESTIN_WE, NSOURCE_RE, SFR_WRITE, SOURCE_IS_SFR, BIT_ADDRESS, 
                  PROGDI, OPCODE, PSW, SOURCE_DI, MEM_CON, CONDITION_MET, 
                  REG_RESULT, WRITE_PSW, SFR_WRITE_EN, STATE, LAST_CYC, 
                  INTERNAL_WAIT, INTERNAL_RESET, CLK2 ) ;

    output [7:0]SOURCE_A ;
    output [7:0]DESTIN_A ;
    output [6:0]SFRSA ;
    output [7:0]INDIRECT_DATA ;
    output [7:0]STACK_POINTER ;
    output NDESTIN_WE ;
    output NSOURCE_RE ;
    output SFR_WRITE ;
    output SOURCE_IS_SFR ;
    output [2:0]BIT_ADDRESS ;
    input [7:0]PROGDI ;
    input [2:0]OPCODE ;
    input [4:3]PSW ;
    input [7:0]SOURCE_DI ;
    input [14:0]MEM_CON ;
    input CONDITION_MET ;
    input [7:0]REG_RESULT ;
    input WRITE_PSW ;
    input [4:4]SFR_WRITE_EN ;
    input [2:0]STATE ;
    input LAST_CYC ;
    input INTERNAL_WAIT ;
    input INTERNAL_RESET ;
    input CLK2 ;

    wire nx2, nx10, nx14, nx20, nx24, nx26, nx34, INDIRECT_ADDR_5_, nx40, nx68, 
         nx82, nx86, nx100, nx102, nx110, nx140, nx154, nx160, nx162, nx170, 
         nx202, nx218, nx217, nx236, nx238, nx258, nx260, nx264, nx272, nx278, 
         nx282, nx284, nx306, nx310, DIRECT_SRC_ADDR_7_, nx340, nx360, nx376, 
         nx380, nx388, nx402, nx426, nx458, nx470, nx494, nx530, nx554, nx582, 
         nx654, nx680, nx694, L_NDESTIN_WE, nx734, nx756, nx770, nx808, nx864, 
         nx892, nx912, nx920, nx938, SELECT_INDIRECT, L_SFR_WRITE, L_NSOURCE_RE, 
         nx1028, nx1034, nx1054, nx1062, nx1070, nx1078, nx1086, nx1088, nx1092, 
         nx1138, nx225, nx227, nx235, nx237, nx245, nx247, nx255, nx257, nx265, 
         nx267, nx275, nx277, nx285, nx287, nx295, nx297, nx305, nx307, nx315, 
         nx317, nx325, nx327, nx335, nx337, nx345, nx347, nx355, nx357, nx365, 
         nx367, nx375, nx377, nx385, nx387, nx395, nx397, nx405, nx407, nx417, 
         nx425, nx427, nx435, nx437, nx445, nx447, nx455, nx457, nx465, nx467, 
         nx475, nx477, nx487, nx495, nx497, nx507, nx515, nx517, nx525, nx527, 
         nx535, nx537, nx545, nx547, nx565, nx571, nx573, nx577, nx583, nx591, 
         nx598, nx611, nx615, nx617, nx621, nx623, nx629, nx633, nx635, nx645, 
         nx651, nx655, nx657, nx661, nx663, nx667, nx673, nx678, nx683, nx691, 
         nx701, nx707, nx710, nx712, nx717, nx730, nx733, nx735, nx739, nx750, 
         nx753, nx755, nx759, nx769, nx779, nx783, nx789, nx791, nx799, nx805, 
         nx813, nx819, nx829, nx831, nx836, nx839, nx843, nx861, nx867, nx869, 
         nx881, nx883, nx887, nx889, nx893, nx905, nx913, nx915, nx921, nx927, 
         nx929, nx937, nx949, nx951, nx961, nx969, nx978, nx980, nx989, nx991, 
         nx1001, nx1003, nx1007, nx1009, nx1012, nx1017, nx1023, nx1025, nx1035, 
         nx1037, nx1045, nx1057, nx1059, nx1064, nx1069, nx1077, nx1079, nx1085, 
         nx1087, nx1095, nx1097, nx1101, nx1103, nx1105, nx1113, nx1115, nx1123, 
         nx1148, nx1150, nx1152, nx1154, nx1156, nx1158, nx1160, nx1162, nx1164, 
         nx1166, nx1168, nx1170, nx1172, nx1174, nx1176, nx1178, nx1180, nx1182, 
         nx1184, nx1186, nx1188, nx1190, nx1192, nx1194, nx1196, nx1198, nx1200, 
         nx1202, nx1204, nx1206, nx1208, nx1210, nx1212, nx1214, nx1216, nx1218, 
         nx1220, nx1222, nx1224, nx1226, nx1228, nx1230, nx1232, nx1234, nx1236, 
         nx1238, nx1240, nx1242, nx1244, nx1246, nx1248, nx1252, nx1254, nx1258, 
         nx1260, nx1264, nx1266, nx1268, nx1270, nx1272, nx1274, nx1276, nx1278, 
         nx1280, nx1282, nx1284, nx1286, nx1288, nx1290, nx1292, nx1294, nx1296, 
         nx1298, nx1300, nx1302, nx1304, nx1306, nx1308, nx1310, nx1312, nx1314, 
         nx1316, nx1318, nx1320, nx1322, nx1324, nx1326, nx1328, nx1330, nx1332, 
         nx1334, nx1336, nx1338, nx1340, nx1342, nx1350, nx1352, nx1354, nx1356, 
         nx1358, nx1360, nx1362, nx1364, nx1366, nx1368, nx1370, nx1372, nx1374, 
         nx1376, nx1378, nx1380, nx1382, nx1384, nx1386, nx1388, nx1390;
    wire [27:0] \$dummy ;




    dff ix520 (.Q (BIT_ADDRESS[0]), .QB (\$dummy [0]), .D (nx517), .CLK (CLK2)
        ) ;
    ao21 ix518 (.Y (nx517), .A0 (BIT_ADDRESS[0]), .A1 (nx1358), .B0 (nx515)) ;
    nor02 ix516 (.Y (nx515), .A0 (nx1210), .A1 (nx1358)) ;
    aoi22 ix566 (.Y (nx565), .A0 (BIT_ADDRESS[0]), .A1 (nx1088), .B0 (PROGDI[0])
          , .B1 (nx1186)) ;
    ao21 ix1089 (.Y (nx1088), .A0 (LAST_CYC), .A1 (nx1372), .B0 (nx1184)) ;
    oai21 ix1087 (.Y (nx1086), .A0 (nx571), .A1 (MEM_CON[9]), .B0 (nx573)) ;
    inv02 ix572 (.Y (nx571), .A (STATE[0])) ;
    nor02 ix574 (.Y (nx573), .A0 (STATE[2]), .A1 (STATE[1])) ;
    nor02 ix1093 (.Y (nx1092), .A0 (nx577), .A1 (nx1088)) ;
    inv02 ix578 (.Y (nx577), .A (MEM_CON[4])) ;
    dff ix530 (.Q (BIT_ADDRESS[1]), .QB (\$dummy [1]), .D (nx527), .CLK (CLK2)
        ) ;
    ao21 ix528 (.Y (nx527), .A0 (BIT_ADDRESS[1]), .A1 (nx1358), .B0 (nx525)) ;
    nor02 ix526 (.Y (nx525), .A0 (nx1212), .A1 (nx1358)) ;
    aoi22 ix584 (.Y (nx583), .A0 (BIT_ADDRESS[1]), .A1 (nx1088), .B0 (PROGDI[1])
          , .B1 (nx1186)) ;
    dff ix540 (.Q (BIT_ADDRESS[2]), .QB (\$dummy [2]), .D (nx537), .CLK (CLK2)
        ) ;
    ao21 ix538 (.Y (nx537), .A0 (BIT_ADDRESS[2]), .A1 (nx1358), .B0 (nx535)) ;
    nor02 ix536 (.Y (nx535), .A0 (nx1214), .A1 (nx1358)) ;
    aoi22 ix592 (.Y (nx591), .A0 (BIT_ADDRESS[2]), .A1 (nx1088), .B0 (PROGDI[2])
          , .B1 (nx1186)) ;
    dff ix550 (.Q (SOURCE_IS_SFR), .QB (\$dummy [3]), .D (nx547), .CLK (CLK2)) ;
    ao21 ix548 (.Y (nx547), .A0 (SOURCE_IS_SFR), .A1 (nx1358), .B0 (nx545)) ;
    nor02 ix546 (.Y (nx545), .A0 (nx1216), .A1 (nx1358)) ;
    aoi32 ix599 (.Y (nx598), .A0 (nx1188), .A1 (PROGDI[7]), .A2 (nx1150), .B0 (
          SOURCE_IS_SFR), .B1 (nx14)) ;
    nor03 ix1139 (.Y (nx1138), .A0 (nx1374), .A1 (MEM_CON[3]), .A2 (MEM_CON[2])
          ) ;
    nor02 ix1019 (.Y (SFR_WRITE), .A0 (nx1358), .A1 (nx611)) ;
    ao21 ix498 (.Y (nx497), .A0 (L_SFR_WRITE), .A1 (nx1218), .B0 (nx1206)) ;
    dff ix500 (.Q (L_SFR_WRITE), .QB (nx611), .D (nx497), .CLK (CLK2)) ;
    nor02 ix616 (.Y (nx615), .A0 (nx617), .A1 (nx1368)) ;
    inv04 ix618 (.Y (nx617), .A (INTERNAL_WAIT)) ;
    nor04 ix496 (.Y (nx495), .A0 (nx1368), .A1 (nx621), .A2 (nx1085), .A3 (
          nx1366)) ;
    dff ix340 (.Q (DESTIN_A[7]), .QB (\$dummy [4]), .D (nx337), .CLK (CLK2)) ;
    ao21 ix338 (.Y (nx337), .A0 (DESTIN_A[7]), .A1 (nx1358), .B0 (nx335)) ;
    aoi21 ix336 (.Y (nx335), .A0 (nx1220), .A1 (nx1272), .B0 (nx1366)) ;
    aoi22 ix630 (.Y (nx629), .A0 (DESTIN_A[7]), .A1 (nx1222), .B0 (nx388), .B1 (
          nx1162)) ;
    nor03 ix634 (.Y (nx633), .A0 (STATE[2]), .A1 (STATE[1]), .A2 (nx571)) ;
    nor03 ix636 (.Y (nx635), .A0 (STATE[2]), .A1 (STATE[1]), .A2 (nx1372)) ;
    oai21 ix377 (.Y (nx376), .A0 (nx1230), .A1 (nx1264), .B0 (nx769)) ;
    aoi22 ix646 (.Y (nx645), .A0 (nx1374), .A1 (STACK_POINTER[5]), .B0 (nx1158)
          , .B1 (nx236)) ;
    dff ix280 (.Q (STACK_POINTER[5]), .QB (\$dummy [5]), .D (nx277), .CLK (CLK2)
        ) ;
    ao21 ix278 (.Y (nx277), .A0 (STACK_POINTER[5]), .A1 (nx1232), .B0 (nx1194)
         ) ;
    aoi21 ix652 (.Y (nx651), .A0 (nx617), .A1 (nx1154), .B0 (nx1368)) ;
    oai221 ix69 (.Y (nx68), .A0 (nx655), .A1 (nx1236), .B0 (nx40), .B1 (nx661), 
           .C0 (nx1238)) ;
    inv02 ix656 (.Y (nx655), .A (SFR_WRITE_EN[4])) ;
    nand02 ix658 (.Y (nx657), .A0 (LAST_CYC), .A1 (nx1372)) ;
    nor02 ix662 (.Y (nx661), .A0 (nx1374), .A1 (MEM_CON[6])) ;
    oai21 ix664 (.Y (nx663), .A0 (MEM_CON[9]), .A1 (MEM_CON[12]), .B0 (nx1226)
          ) ;
    nor03 ix276 (.Y (nx275), .A0 (nx1368), .A1 (nx1240), .A2 (nx1234)) ;
    mux21 ix668 (.Y (nx667), .A0 (nx238), .A1 (REG_RESULT[5]), .S0 (nx1380)) ;
    oai21 ix219 (.Y (nx218), .A0 (nx1242), .A1 (nx1258), .B0 (nx750)) ;
    aoi22 ix674 (.Y (nx673), .A0 (nx1374), .A1 (STACK_POINTER[3]), .B0 (nx1156)
          , .B1 (nx160)) ;
    dff ix260 (.Q (STACK_POINTER[3]), .QB (\$dummy [6]), .D (nx257), .CLK (CLK2)
        ) ;
    ao21 ix258 (.Y (nx257), .A0 (STACK_POINTER[3]), .A1 (nx1232), .B0 (nx1190)
         ) ;
    nor03 ix256 (.Y (nx255), .A0 (nx1368), .A1 (nx1244), .A2 (nx1232)) ;
    mux21 ix679 (.Y (nx678), .A0 (nx162), .A1 (REG_RESULT[3]), .S0 (nx1380)) ;
    oai21 ix156 (.Y (nx154), .A0 (nx1246), .A1 (nx1252), .B0 (nx730)) ;
    aoi22 ix684 (.Y (nx683), .A0 (nx1374), .A1 (STACK_POINTER[1]), .B0 (
          STACK_POINTER[0]), .B1 (nx100)) ;
    dff ix240 (.Q (STACK_POINTER[1]), .QB (\$dummy [7]), .D (nx237), .CLK (CLK2)
        ) ;
    ao21 ix238 (.Y (nx237), .A0 (STACK_POINTER[1]), .A1 (nx1232), .B0 (nx235)) ;
    aoi21 ix236 (.Y (nx235), .A0 (nx1248), .A1 (nx707), .B0 (nx1232)) ;
    mux21 ix692 (.Y (nx691), .A0 (nx102), .A1 (REG_RESULT[1]), .S0 (nx1380)) ;
    dff ix230 (.Q (STACK_POINTER[0]), .QB (\$dummy [8]), .D (nx227), .CLK (CLK2)
        ) ;
    ao21 ix228 (.Y (nx227), .A0 (STACK_POINTER[0]), .A1 (nx1232), .B0 (nx225)) ;
    aoi21 ix226 (.Y (nx225), .A0 (nx701), .A1 (nx707), .B0 (nx1232)) ;
    nor02 ix83 (.Y (nx82), .A0 (nx1380), .A1 (STACK_POINTER[0])) ;
    inv02 ix708 (.Y (nx707), .A (INTERNAL_RESET)) ;
    oai21 ix711 (.Y (nx710), .A0 (STACK_POINTER[1]), .A1 (nx1374), .B0 (nx712)
          ) ;
    nand02 ix713 (.Y (nx712), .A0 (nx1374), .A1 (STACK_POINTER[1])) ;
    oai21 ix718 (.Y (nx717), .A0 (STACK_POINTER[2]), .A1 (nx1374), .B0 (nx730)
          ) ;
    dff ix250 (.Q (STACK_POINTER[2]), .QB (\$dummy [9]), .D (nx247), .CLK (CLK2)
        ) ;
    ao21 ix248 (.Y (nx247), .A0 (STACK_POINTER[2]), .A1 (nx1232), .B0 (nx245)) ;
    aoi21 ix246 (.Y (nx245), .A0 (nx1254), .A1 (nx707), .B0 (nx1232)) ;
    nand02 ix732 (.Y (nx730), .A0 (nx1374), .A1 (STACK_POINTER[2])) ;
    oai21 ix734 (.Y (nx733), .A0 (STACK_POINTER[3]), .A1 (nx1374), .B0 (nx735)
          ) ;
    nand02 ix736 (.Y (nx735), .A0 (nx1376), .A1 (STACK_POINTER[3])) ;
    oai21 ix740 (.Y (nx739), .A0 (STACK_POINTER[4]), .A1 (nx1376), .B0 (nx750)
          ) ;
    dff ix270 (.Q (STACK_POINTER[4]), .QB (\$dummy [10]), .D (nx267), .CLK (CLK2
        )) ;
    ao21 ix268 (.Y (nx267), .A0 (STACK_POINTER[4]), .A1 (nx1232), .B0 (nx1192)
         ) ;
    nor03 ix266 (.Y (nx265), .A0 (nx1368), .A1 (nx1260), .A2 (nx1234)) ;
    nand02 ix752 (.Y (nx750), .A0 (nx1376), .A1 (STACK_POINTER[4])) ;
    oai21 ix754 (.Y (nx753), .A0 (STACK_POINTER[5]), .A1 (nx1376), .B0 (nx755)
          ) ;
    nand02 ix756 (.Y (nx755), .A0 (nx1376), .A1 (STACK_POINTER[5])) ;
    oai21 ix760 (.Y (nx759), .A0 (STACK_POINTER[6]), .A1 (nx1376), .B0 (nx769)
          ) ;
    dff ix310 (.Q (STACK_POINTER[6]), .QB (\$dummy [11]), .D (nx307), .CLK (CLK2
        )) ;
    ao21 ix308 (.Y (nx307), .A0 (STACK_POINTER[6]), .A1 (nx1234), .B0 (nx1196)
         ) ;
    nor03 ix306 (.Y (nx305), .A0 (nx1368), .A1 (nx1266), .A2 (nx1234)) ;
    nand02 ix770 (.Y (nx769), .A0 (nx1376), .A1 (STACK_POINTER[6])) ;
    dff ix320 (.Q (STACK_POINTER[7]), .QB (\$dummy [12]), .D (nx317), .CLK (CLK2
        )) ;
    ao21 ix318 (.Y (nx317), .A0 (STACK_POINTER[7]), .A1 (nx1234), .B0 (nx1198)
         ) ;
    nor03 ix316 (.Y (nx315), .A0 (nx1368), .A1 (nx1268), .A2 (nx1234)) ;
    mux21 ix780 (.Y (nx779), .A0 (nx380), .A1 (REG_RESULT[7]), .S0 (nx1380)) ;
    xnor2 ix381 (.Y (nx380), .A0 (nx1168), .A1 (nx783)) ;
    xnor2 ix784 (.Y (nx783), .A0 (nx1376), .A1 (STACK_POINTER[7])) ;
    and02 ix261 (.Y (nx260), .A0 (MEM_CON[6]), .A1 (nx1160)) ;
    nand02 ix259 (.Y (nx258), .A0 (nx1270), .A1 (nx40)) ;
    oai21 ix790 (.Y (nx789), .A0 (MEM_CON[13]), .A1 (MEM_CON[12]), .B0 (nx1226)
          ) ;
    aoi222 ix792 (.Y (nx791), .A0 (nx1160), .A1 (nx340), .B0 (PROGDI[7]), .B1 (
           nx264), .C0 (INDIRECT_DATA[7]), .C1 (nx1166)) ;
    ao21 ix429 (.Y (INDIRECT_DATA[7]), .A0 (SOURCE_DI[7]), .A1 (nx799), .B0 (
         nx426)) ;
    ao21 ix468 (.Y (nx467), .A0 (INDIRECT_ADDR_5_), .A1 (nx1218), .B0 (nx1202)
         ) ;
    dff ix470 (.Q (INDIRECT_ADDR_5_), .QB (nx799), .D (nx467), .CLK (CLK2)) ;
    nor04 ix466 (.Y (nx465), .A0 (nx805), .A1 (nx1370), .A2 (nx1236), .A3 (
          nx1364)) ;
    dff ix300 (.Q (DESTIN_A[5]), .QB (\$dummy [13]), .D (nx297), .CLK (CLK2)) ;
    ao21 ix298 (.Y (nx297), .A0 (DESTIN_A[5]), .A1 (nx1360), .B0 (nx295)) ;
    aoi21 ix296 (.Y (nx295), .A0 (nx813), .A1 (nx1274), .B0 (nx1360)) ;
    aoi222 ix820 (.Y (nx819), .A0 (INDIRECT_DATA[5]), .A1 (nx1166), .B0 (
           PROGDI[5]), .B1 (nx264), .C0 (nx217), .C1 (nx1162)) ;
    ao21 ix309 (.Y (INDIRECT_DATA[5]), .A0 (SOURCE_DI[5]), .A1 (nx799), .B0 (
         nx306)) ;
    and02 ix307 (.Y (nx306), .A0 (SFRSA[5]), .A1 (INDIRECT_ADDR_5_)) ;
    dff ix290 (.Q (SFRSA[5]), .QB (\$dummy [14]), .D (nx287), .CLK (CLK2)) ;
    ao21 ix288 (.Y (nx287), .A0 (SFRSA[5]), .A1 (nx1360), .B0 (nx285)) ;
    aoi21 ix286 (.Y (nx285), .A0 (nx1276), .A1 (nx1278), .B0 (nx1360)) ;
    aoi22 ix830 (.Y (nx829), .A0 (REG_RESULT[5]), .A1 (nx2), .B0 (SFRSA[5]), .B1 (
          nx14)) ;
    aoi221 ix832 (.Y (nx831), .A0 (INDIRECT_DATA[5]), .A1 (nx1164), .B0 (
           PROGDI[5]), .B1 (nx272), .C0 (nx282)) ;
    and02 ix285 (.Y (nx284), .A0 (MEM_CON[3]), .A1 (nx1150)) ;
    aoi21 ix283 (.Y (nx282), .A0 (nx1280), .A1 (nx755), .B0 (nx1282)) ;
    oai21 ix837 (.Y (nx836), .A0 (PROGDI[5]), .A1 (nx839), .B0 (MEM_CON[4])) ;
    inv02 ix840 (.Y (nx839), .A (PROGDI[7])) ;
    nand02 ix844 (.Y (nx843), .A0 (nx1236), .A1 (nx1148)) ;
    oai21 ix11 (.Y (nx10), .A0 (MEM_CON[9]), .A1 (nx571), .B0 (nx573)) ;
    and02 ix311 (.Y (nx310), .A0 (MEM_CON[8]), .A1 (nx1160)) ;
    dff ix360 (.Q (DESTIN_A[6]), .QB (\$dummy [15]), .D (nx357), .CLK (CLK2)) ;
    ao21 ix358 (.Y (nx357), .A0 (DESTIN_A[6]), .A1 (nx1360), .B0 (nx355)) ;
    aoi21 ix356 (.Y (nx355), .A0 (nx1284), .A1 (nx1286), .B0 (nx1360)) ;
    aoi22 ix862 (.Y (nx861), .A0 (DESTIN_A[6]), .A1 (nx1222), .B0 (nx1388), .B1 (
          nx1162)) ;
    xnor2 ix868 (.Y (nx867), .A0 (nx1230), .A1 (nx1264)) ;
    aoi22 ix870 (.Y (nx869), .A0 (INDIRECT_DATA[6]), .A1 (nx1166), .B0 (
          PROGDI[6]), .B1 (nx1170)) ;
    ao21 ix497 (.Y (INDIRECT_DATA[6]), .A0 (SOURCE_DI[6]), .A1 (nx799), .B0 (
         nx494)) ;
    and02 ix495 (.Y (nx494), .A0 (SFRSA[6]), .A1 (INDIRECT_ADDR_5_)) ;
    dff ix350 (.Q (SFRSA[6]), .QB (\$dummy [16]), .D (nx347), .CLK (CLK2)) ;
    ao21 ix348 (.Y (nx347), .A0 (SFRSA[6]), .A1 (nx1360), .B0 (nx345)) ;
    aoi21 ix346 (.Y (nx345), .A0 (nx1288), .A1 (nx1290), .B0 (nx1360)) ;
    aoi22 ix882 (.Y (nx881), .A0 (REG_RESULT[6]), .A1 (nx2), .B0 (SFRSA[6]), .B1 (
          nx14)) ;
    aoi322 ix884 (.Y (nx883), .A0 (nx1150), .A1 (nx1376), .A2 (STACK_POINTER[6])
           , .B0 (INDIRECT_DATA[6]), .B1 (nx1164), .C0 (PROGDI[6]), .C1 (nx1172)
           ) ;
    oai21 ix471 (.Y (nx470), .A0 (nx1282), .A1 (nx887), .B0 (nx889)) ;
    nand02 ix888 (.Y (nx887), .A0 (MEM_CON[4]), .A1 (PROGDI[7])) ;
    nand02 ix890 (.Y (nx889), .A0 (MEM_CON[0]), .A1 (nx1150)) ;
    oai21 ix459 (.Y (nx458), .A0 (nx1222), .A1 (nx887), .B0 (nx893)) ;
    nand02 ix894 (.Y (nx893), .A0 (MEM_CON[5]), .A1 (nx1160)) ;
    dff ix380 (.Q (DESTIN_A[2]), .QB (\$dummy [17]), .D (nx377), .CLK (CLK2)) ;
    ao21 ix378 (.Y (nx377), .A0 (DESTIN_A[2]), .A1 (nx1360), .B0 (nx375)) ;
    aoi21 ix376 (.Y (nx375), .A0 (nx1292), .A1 (nx1298), .B0 (nx1362)) ;
    aoi222 ix906 (.Y (nx905), .A0 (INDIRECT_DATA[2]), .A1 (nx1166), .B0 (
           DESTIN_A[2]), .B1 (nx1222), .C0 (nx1384), .C1 (nx1162)) ;
    ao21 ix585 (.Y (INDIRECT_DATA[2]), .A0 (SOURCE_DI[2]), .A1 (nx799), .B0 (
         nx582)) ;
    and02 ix583 (.Y (nx582), .A0 (SFRSA[2]), .A1 (INDIRECT_ADDR_5_)) ;
    dff ix370 (.Q (SFRSA[2]), .QB (\$dummy [18]), .D (nx367), .CLK (CLK2)) ;
    ao21 ix368 (.Y (nx367), .A0 (SFRSA[2]), .A1 (nx1360), .B0 (nx365)) ;
    aoi21 ix366 (.Y (nx365), .A0 (nx1294), .A1 (nx1296), .B0 (nx1362)) ;
    aoi332 ix914 (.Y (nx913), .A0 (REG_RESULT[2]), .A1 (LAST_CYC), .A2 (nx1372)
           , .B0 (nx1150), .B1 (nx1376), .B2 (STACK_POINTER[2]), .C0 (SFRSA[2])
           , .C1 (nx14)) ;
    aoi221 ix916 (.Y (nx915), .A0 (PROGDI[2]), .A1 (nx272), .B0 (
           INDIRECT_DATA[2]), .B1 (nx1164), .C0 (nx554)) ;
    ao32 ix555 (.Y (nx554), .A0 (OPCODE[2]), .A1 (MEM_CON[2]), .A2 (nx1150), .B0 (
         PROGDI[5]), .B1 (nx1152)) ;
    nor02 ix27 (.Y (nx26), .A0 (nx1282), .A1 (nx921)) ;
    nand02 ix922 (.Y (nx921), .A0 (MEM_CON[4]), .A1 (nx839)) ;
    xnor2 ix928 (.Y (nx927), .A0 (nx1246), .A1 (nx1252)) ;
    aoi322 ix930 (.Y (nx929), .A0 (OPCODE[2]), .A1 (MEM_CON[7]), .A2 (nx1160), .B0 (
           PROGDI[5]), .B1 (nx1174), .C0 (PROGDI[2]), .C1 (nx264)) ;
    nor02 ix531 (.Y (nx530), .A0 (nx1222), .A1 (nx921)) ;
    dff ix390 (.Q (DESTIN_A[1]), .QB (\$dummy [19]), .D (nx387), .CLK (CLK2)) ;
    ao21 ix388 (.Y (nx387), .A0 (DESTIN_A[1]), .A1 (nx1362), .B0 (nx385)) ;
    aoi21 ix386 (.Y (nx385), .A0 (nx1300), .A1 (nx1306), .B0 (nx1362)) ;
    aoi222 ix938 (.Y (nx937), .A0 (INDIRECT_DATA[1]), .A1 (nx1166), .B0 (
           DESTIN_A[1]), .B1 (nx1222), .C0 (nx110), .C1 (nx1162)) ;
    ao21 ix941 (.Y (INDIRECT_DATA[1]), .A0 (SOURCE_DI[1]), .A1 (nx799), .B0 (
         nx938)) ;
    and02 ix939 (.Y (nx938), .A0 (SFRSA[1]), .A1 (INDIRECT_ADDR_5_)) ;
    dff ix480 (.Q (SFRSA[1]), .QB (\$dummy [20]), .D (nx477), .CLK (CLK2)) ;
    ao21 ix478 (.Y (nx477), .A0 (SFRSA[1]), .A1 (nx1362), .B0 (nx475)) ;
    aoi21 ix476 (.Y (nx475), .A0 (nx1302), .A1 (nx1304), .B0 (nx1362)) ;
    aoi332 ix950 (.Y (nx949), .A0 (REG_RESULT[1]), .A1 (LAST_CYC), .A2 (nx1372)
           , .B0 (nx1150), .B1 (nx1378), .B2 (STACK_POINTER[1]), .C0 (SFRSA[1])
           , .C1 (nx14)) ;
    aoi221 ix952 (.Y (nx951), .A0 (PROGDI[1]), .A1 (nx272), .B0 (
           INDIRECT_DATA[1]), .B1 (nx1164), .C0 (nx34)) ;
    ao32 ix35 (.Y (nx34), .A0 (OPCODE[1]), .A1 (MEM_CON[2]), .A2 (nx1150), .B0 (
         PROGDI[4]), .B1 (nx1152)) ;
    aoi322 ix962 (.Y (nx961), .A0 (OPCODE[1]), .A1 (MEM_CON[7]), .A2 (nx1160), .B0 (
           PROGDI[4]), .B1 (nx1174), .C0 (PROGDI[1]), .C1 (nx264)) ;
    dff ix410 (.Q (DESTIN_A[3]), .QB (\$dummy [21]), .D (nx407), .CLK (CLK2)) ;
    ao21 ix408 (.Y (nx407), .A0 (DESTIN_A[3]), .A1 (nx1362), .B0 (nx405)) ;
    aoi21 ix406 (.Y (nx405), .A0 (nx1308), .A1 (nx1312), .B0 (nx1362)) ;
    aoi221 ix970 (.Y (nx969), .A0 (DESTIN_A[3]), .A1 (nx1222), .B0 (nx170), .B1 (
           nx1162), .C0 (nx694)) ;
    nor02 ix695 (.Y (nx694), .A0 (nx1310), .A1 (nx1222)) ;
    aoi32 ix979 (.Y (nx978), .A0 (PROGDI[3]), .A1 (MEM_CON[4]), .A2 (PROGDI[7])
          , .B0 (PROGDI[6]), .B1 (nx24)) ;
    aoi322 ix981 (.Y (nx980), .A0 (PSW[3]), .A1 (MEM_CON[7]), .A2 (nx1160), .B0 (
           PROGDI[3]), .B1 (nx264), .C0 (INDIRECT_DATA[3]), .C1 (nx1166)) ;
    ao21 ix683 (.Y (INDIRECT_DATA[3]), .A0 (SOURCE_DI[3]), .A1 (nx799), .B0 (
         nx680)) ;
    and02 ix681 (.Y (nx680), .A0 (SFRSA[3]), .A1 (INDIRECT_ADDR_5_)) ;
    dff ix400 (.Q (SFRSA[3]), .QB (\$dummy [22]), .D (nx397), .CLK (CLK2)) ;
    ao21 ix398 (.Y (nx397), .A0 (SFRSA[3]), .A1 (nx1362), .B0 (nx395)) ;
    aoi21 ix396 (.Y (nx395), .A0 (nx1314), .A1 (nx1316), .B0 (nx1362)) ;
    aoi332 ix990 (.Y (nx989), .A0 (REG_RESULT[3]), .A1 (LAST_CYC), .A2 (nx1372)
           , .B0 (PROGDI[3]), .B1 (MEM_CON[0]), .B2 (nx1150), .C0 (SFRSA[3]), .C1 (
           nx14)) ;
    aoi321 ix992 (.Y (nx991), .A0 (PSW[3]), .A1 (MEM_CON[2]), .A2 (nx1382), .B0 (
           INDIRECT_DATA[3]), .B1 (nx1164), .C0 (nx654)) ;
    aoi21 ix655 (.Y (nx654), .A0 (nx735), .A1 (nx1310), .B0 (nx1282)) ;
    oai32 ix418 (.Y (nx417), .A0 (nx1001), .A1 (nx617), .A2 (nx1368), .B0 (
          nx1318), .B1 (nx1218)) ;
    dff ix420 (.Q (L_NDESTIN_WE), .QB (nx1001), .D (nx1200), .CLK (CLK2)) ;
    nor03 ix1004 (.Y (nx1003), .A0 (nx1178), .A1 (nx1176), .A2 (nx1368)) ;
    aoi422 ix757 (.Y (nx756), .A0 (nx1007), .A1 (nx571), .A2 (MEM_CON[10]), .A3 (
           LAST_CYC), .B0 (nx1228), .B1 (MEM_CON[11]), .C0 (nx1226), .C1 (
           MEM_CON[12])) ;
    nand02 ix1008 (.Y (nx1007), .A0 (nx1009), .A1 (MEM_CON[14])) ;
    inv02 ix1010 (.Y (nx1009), .A (CONDITION_MET)) ;
    nor04 ix735 (.Y (nx734), .A0 (MEM_CON[8]), .A1 (MEM_CON[7]), .A2 (MEM_CON[6]
          ), .A3 (nx623)) ;
    xnor2 ix1013 (.Y (nx1012), .A0 (DESTIN_A[4]), .A1 (PSW[4])) ;
    dff ix440 (.Q (DESTIN_A[4]), .QB (\$dummy [23]), .D (nx437), .CLK (CLK2)) ;
    ao21 ix438 (.Y (nx437), .A0 (DESTIN_A[4]), .A1 (nx1364), .B0 (nx435)) ;
    aoi21 ix436 (.Y (nx435), .A0 (nx1320), .A1 (nx1322), .B0 (nx1364)) ;
    aoi22 ix1018 (.Y (nx1017), .A0 (DESTIN_A[4]), .A1 (nx1222), .B0 (nx1386), .B1 (
          nx1162)) ;
    xnor2 ix1024 (.Y (nx1023), .A0 (nx1242), .A1 (nx1258)) ;
    aoi322 ix1026 (.Y (nx1025), .A0 (PSW[4]), .A1 (MEM_CON[7]), .A2 (nx1160), .B0 (
           INDIRECT_DATA[4]), .B1 (nx1166), .C0 (PROGDI[4]), .C1 (nx1170)) ;
    ao21 ix811 (.Y (INDIRECT_DATA[4]), .A0 (SOURCE_DI[4]), .A1 (nx799), .B0 (
         nx808)) ;
    and02 ix809 (.Y (nx808), .A0 (SFRSA[4]), .A1 (INDIRECT_ADDR_5_)) ;
    dff ix430 (.Q (SFRSA[4]), .QB (\$dummy [24]), .D (nx427), .CLK (CLK2)) ;
    ao21 ix428 (.Y (nx427), .A0 (SFRSA[4]), .A1 (nx1364), .B0 (nx425)) ;
    aoi21 ix426 (.Y (nx425), .A0 (nx1324), .A1 (nx1326), .B0 (nx1364)) ;
    aoi332 ix1036 (.Y (nx1035), .A0 (REG_RESULT[4]), .A1 (LAST_CYC), .A2 (nx1372
           ), .B0 (nx1382), .B1 (nx1378), .B2 (STACK_POINTER[4]), .C0 (SFRSA[4])
           , .C1 (nx14)) ;
    aoi322 ix1038 (.Y (nx1037), .A0 (PSW[4]), .A1 (MEM_CON[2]), .A2 (nx1382), .B0 (
           INDIRECT_DATA[4]), .B1 (nx1164), .C0 (PROGDI[4]), .C1 (nx1172)) ;
    xnor2 ix913 (.Y (nx912), .A0 (DESTIN_A[0]), .A1 (PROGDI[0])) ;
    dff ix460 (.Q (DESTIN_A[0]), .QB (\$dummy [25]), .D (nx457), .CLK (CLK2)) ;
    ao21 ix458 (.Y (nx457), .A0 (DESTIN_A[0]), .A1 (nx1364), .B0 (nx455)) ;
    aoi21 ix456 (.Y (nx455), .A0 (nx1328), .A1 (nx1334), .B0 (nx1364)) ;
    aoi222 ix1046 (.Y (nx1045), .A0 (DESTIN_A[0]), .A1 (nx1222), .B0 (nx86), .B1 (
           nx1162), .C0 (INDIRECT_DATA[0]), .C1 (nx1166)) ;
    ao21 ix87 (.Y (nx86), .A0 (REG_RESULT[0]), .A1 (nx1380), .B0 (nx82)) ;
    ao21 ix895 (.Y (INDIRECT_DATA[0]), .A0 (SOURCE_DI[0]), .A1 (nx799), .B0 (
         nx892)) ;
    and02 ix893 (.Y (nx892), .A0 (SFRSA[0]), .A1 (INDIRECT_ADDR_5_)) ;
    dff ix450 (.Q (SFRSA[0]), .QB (\$dummy [26]), .D (nx447), .CLK (CLK2)) ;
    ao21 ix448 (.Y (nx447), .A0 (SFRSA[0]), .A1 (nx1364), .B0 (nx445)) ;
    aoi21 ix446 (.Y (nx445), .A0 (nx1330), .A1 (nx1332), .B0 (nx1364)) ;
    aoi332 ix1058 (.Y (nx1057), .A0 (REG_RESULT[0]), .A1 (LAST_CYC), .A2 (nx1372
           ), .B0 (PROGDI[0]), .B1 (MEM_CON[0]), .B2 (nx1382), .C0 (SFRSA[0]), .C1 (
           nx14)) ;
    aoi321 ix1060 (.Y (nx1059), .A0 (OPCODE[0]), .A1 (MEM_CON[2]), .A2 (nx1382)
           , .B0 (INDIRECT_DATA[0]), .B1 (nx1164), .C0 (nx864)) ;
    ao32 ix865 (.Y (nx864), .A0 (nx1382), .A1 (nx1378), .A2 (STACK_POINTER[0]), 
         .B0 (PROGDI[3]), .B1 (nx1152)) ;
    aoi322 ix1066 (.Y (nx1064), .A0 (OPCODE[0]), .A1 (MEM_CON[7]), .A2 (nx1160)
           , .B0 (PROGDI[3]), .B1 (nx1174), .C0 (PROGDI[0]), .C1 (nx264)) ;
    ao21 ix328 (.Y (nx327), .A0 (DIRECT_SRC_ADDR_7_), .A1 (nx1364), .B0 (nx325)
         ) ;
    dff ix330 (.Q (DIRECT_SRC_ADDR_7_), .QB (nx1069), .D (nx327), .CLK (CLK2)) ;
    aoi21 ix326 (.Y (nx325), .A0 (nx1336), .A1 (nx1338), .B0 (nx1366)) ;
    aoi22 ix1078 (.Y (nx1077), .A0 (REG_RESULT[7]), .A1 (nx2), .B0 (
          DIRECT_SRC_ADDR_7_), .B1 (nx14)) ;
    aoi222 ix1080 (.Y (nx1079), .A0 (nx1382), .A1 (nx402), .B0 (INDIRECT_DATA[7]
           ), .B1 (nx1164), .C0 (PROGDI[7]), .C1 (nx272)) ;
    ao21 ix403 (.Y (nx402), .A0 (nx1378), .A1 (STACK_POINTER[7]), .B0 (nx340)) ;
    ao21 ix1086 (.Y (nx1085), .A0 (MEM_CON[14]), .A1 (nx1009), .B0 (nx1087)) ;
    nand03 ix1088 (.Y (nx1087), .A0 (nx571), .A1 (MEM_CON[10]), .A2 (LAST_CYC)
           ) ;
    or02 ix1047 (.Y (NSOURCE_RE), .A0 (L_NSOURCE_RE), .A1 (nx1366)) ;
    oai32 ix508 (.Y (nx507), .A0 (nx1095), .A1 (nx617), .A2 (nx1370), .B0 (
          nx1340), .B1 (nx1218)) ;
    dff ix510 (.Q (L_NSOURCE_RE), .QB (nx1095), .D (nx1208), .CLK (CLK2)) ;
    nor03 ix1098 (.Y (nx1097), .A0 (nx1180), .A1 (nx1370), .A2 (nx1034)) ;
    nor04 ix921 (.Y (nx920), .A0 (nx1101), .A1 (DESTIN_A[2]), .A2 (DESTIN_A[1])
          , .A3 (nx1103)) ;
    or03 ix1102 (.Y (nx1101), .A0 (DESTIN_A[5]), .A1 (DESTIN_A[7]), .A2 (
         DESTIN_A[6])) ;
    nand04 ix1104 (.Y (nx1103), .A0 (nx1105), .A1 (nx770), .A2 (nx1012), .A3 (
           nx912)) ;
    xnor2 ix1106 (.Y (nx1105), .A0 (DESTIN_A[3]), .A1 (PSW[3])) ;
    ao21 ix1035 (.Y (nx1034), .A0 (MEM_CON[11]), .A1 (nx1226), .B0 (nx1182)) ;
    nor04 ix1029 (.Y (nx1028), .A0 (nx1113), .A1 (STATE[2]), .A2 (nx1115), .A3 (
          nx1372)) ;
    inv02 ix1114 (.Y (nx1113), .A (STATE[1])) ;
    inv02 ix1116 (.Y (nx1115), .A (MEM_CON[12])) ;
    ao21 ix1057 (.Y (SOURCE_A[0]), .A0 (SFRSA[0]), .A1 (nx1342), .B0 (nx1054)) ;
    dff ix490 (.Q (SELECT_INDIRECT), .QB (\$dummy [27]), .D (nx1204), .CLK (CLK2
        )) ;
    mux21 ix488 (.Y (nx487), .A0 (nx1390), .A1 (nx1342), .S0 (nx1366)) ;
    and02 ix1055 (.Y (nx1054), .A0 (OPCODE[0]), .A1 (SELECT_INDIRECT)) ;
    and02 ix985 (.Y (SOURCE_A[1]), .A0 (SFRSA[1]), .A1 (nx1342)) ;
    and02 ix989 (.Y (SOURCE_A[2]), .A0 (SFRSA[2]), .A1 (nx1342)) ;
    ao21 ix1065 (.Y (SOURCE_A[3]), .A0 (SFRSA[3]), .A1 (nx1342), .B0 (nx1062)) ;
    ao21 ix1073 (.Y (SOURCE_A[4]), .A0 (SFRSA[4]), .A1 (nx1342), .B0 (nx1070)) ;
    ao21 ix1081 (.Y (SOURCE_A[5]), .A0 (SFRSA[5]), .A1 (nx1342), .B0 (nx1078)) ;
    nor02 ix997 (.Y (SOURCE_A[7]), .A0 (nx1069), .A1 (SELECT_INDIRECT)) ;
    inv02 ix806 (.Y (nx805), .A (nx920)) ;
    inv02 ix622 (.Y (nx621), .A (nx734)) ;
    inv02 ix389 (.Y (nx388), .A (nx779)) ;
    inv02 ix341 (.Y (nx340), .A (nx887)) ;
    inv02 ix279 (.Y (nx278), .A (nx836)) ;
    inv02 ix273 (.Y (nx272), .A (nx889)) ;
    inv02 ix265 (.Y (nx264), .A (nx893)) ;
    inv02 ix237 (.Y (nx236), .A (nx753)) ;
    inv02 ix247 (.Y (nx217), .A (nx667)) ;
    inv02 ix171 (.Y (nx170), .A (nx678)) ;
    inv02 ix161 (.Y (nx160), .A (nx733)) ;
    inv02 ix111 (.Y (nx110), .A (nx691)) ;
    inv02 ix101 (.Y (nx100), .A (nx710)) ;
    inv02 ix702 (.Y (nx701), .A (nx86)) ;
    inv02 ix41 (.Y (nx40), .A (nx635)) ;
    inv02 ix25 (.Y (nx24), .A (nx921)) ;
    inv02 ix15 (.Y (nx14), .A (nx843)) ;
    inv02 ix3 (.Y (nx2), .A (nx657)) ;
    buf02 ix1147 (.Y (nx1148), .A (nx10)) ;
    inv02 ix1149 (.Y (nx1150), .A (nx1282)) ;
    buf02 ix1151 (.Y (nx1152), .A (nx26)) ;
    buf02 ix1153 (.Y (nx1154), .A (nx68)) ;
    buf02 ix1155 (.Y (nx1156), .A (nx154)) ;
    buf02 ix1157 (.Y (nx1158), .A (nx218)) ;
    inv04 ix1159 (.Y (nx1160), .A (nx1224)) ;
    buf02 ix1161 (.Y (nx1162), .A (nx260)) ;
    buf02 ix1163 (.Y (nx1164), .A (nx284)) ;
    buf02 ix1165 (.Y (nx1166), .A (nx310)) ;
    buf02 ix1167 (.Y (nx1168), .A (nx376)) ;
    buf02 ix1169 (.Y (nx1170), .A (nx458)) ;
    buf02 ix1171 (.Y (nx1172), .A (nx470)) ;
    buf02 ix1173 (.Y (nx1174), .A (nx530)) ;
    inv02 ix1175 (.Y (nx1176), .A (nx621)) ;
    buf02 ix1177 (.Y (nx1178), .A (nx756)) ;
    inv02 ix1179 (.Y (nx1180), .A (nx805)) ;
    buf02 ix1181 (.Y (nx1182), .A (nx1028)) ;
    buf02 ix1183 (.Y (nx1184), .A (nx1086)) ;
    buf02 ix1185 (.Y (nx1186), .A (nx1092)) ;
    buf02 ix1187 (.Y (nx1188), .A (nx1138)) ;
    buf02 ix1189 (.Y (nx1190), .A (nx255)) ;
    buf02 ix1191 (.Y (nx1192), .A (nx265)) ;
    buf02 ix1193 (.Y (nx1194), .A (nx275)) ;
    buf02 ix1195 (.Y (nx1196), .A (nx305)) ;
    buf02 ix1197 (.Y (nx1198), .A (nx315)) ;
    buf02 ix1199 (.Y (nx1200), .A (nx417)) ;
    buf02 ix1201 (.Y (nx1202), .A (nx465)) ;
    buf02 ix1203 (.Y (nx1204), .A (nx487)) ;
    buf02 ix1205 (.Y (nx1206), .A (nx495)) ;
    buf02 ix1207 (.Y (nx1208), .A (nx507)) ;
    buf02 ix1209 (.Y (nx1210), .A (nx565)) ;
    buf02 ix1211 (.Y (nx1212), .A (nx583)) ;
    buf02 ix1213 (.Y (nx1214), .A (nx591)) ;
    buf02 ix1215 (.Y (nx1216), .A (nx598)) ;
    buf02 ix1217 (.Y (nx1218), .A (nx615)) ;
    buf02 ix1219 (.Y (nx1220), .A (nx629)) ;
    inv02 ix1221 (.Y (nx1222), .A (nx258)) ;
    inv02 ix1223 (.Y (nx1224), .A (nx258)) ;
    buf02 ix1225 (.Y (nx1226), .A (nx633)) ;
    inv02 ix1227 (.Y (nx1228), .A (nx40)) ;
    buf02 ix1229 (.Y (nx1230), .A (nx645)) ;
    buf02 ix1231 (.Y (nx1232), .A (nx651)) ;
    buf02 ix1233 (.Y (nx1234), .A (nx651)) ;
    inv02 ix1235 (.Y (nx1236), .A (nx2)) ;
    buf02 ix1237 (.Y (nx1238), .A (nx663)) ;
    inv02 ix1239 (.Y (nx1240), .A (nx217)) ;
    buf02 ix1241 (.Y (nx1242), .A (nx673)) ;
    inv02 ix1243 (.Y (nx1244), .A (nx170)) ;
    buf02 ix1245 (.Y (nx1246), .A (nx683)) ;
    inv02 ix1247 (.Y (nx1248), .A (nx110)) ;
    buf02 ix1251 (.Y (nx1252), .A (nx717)) ;
    inv02 ix1253 (.Y (nx1254), .A (nx140)) ;
    buf02 ix1257 (.Y (nx1258), .A (nx739)) ;
    inv02 ix1259 (.Y (nx1260), .A (nx202)) ;
    buf02 ix1263 (.Y (nx1264), .A (nx759)) ;
    inv02 ix1265 (.Y (nx1266), .A (nx360)) ;
    inv02 ix1267 (.Y (nx1268), .A (nx388)) ;
    buf02 ix1269 (.Y (nx1270), .A (nx789)) ;
    buf02 ix1271 (.Y (nx1272), .A (nx791)) ;
    buf02 ix1273 (.Y (nx1274), .A (nx819)) ;
    buf02 ix1275 (.Y (nx1276), .A (nx829)) ;
    buf02 ix1277 (.Y (nx1278), .A (nx831)) ;
    inv02 ix1279 (.Y (nx1280), .A (nx278)) ;
    inv02 ix1281 (.Y (nx1282), .A (nx20)) ;
    buf02 ix1283 (.Y (nx1284), .A (nx861)) ;
    buf02 ix1285 (.Y (nx1286), .A (nx869)) ;
    buf02 ix1287 (.Y (nx1288), .A (nx881)) ;
    buf02 ix1289 (.Y (nx1290), .A (nx883)) ;
    buf02 ix1291 (.Y (nx1292), .A (nx905)) ;
    buf02 ix1293 (.Y (nx1294), .A (nx913)) ;
    buf02 ix1295 (.Y (nx1296), .A (nx915)) ;
    buf02 ix1297 (.Y (nx1298), .A (nx929)) ;
    buf02 ix1299 (.Y (nx1300), .A (nx937)) ;
    buf02 ix1301 (.Y (nx1302), .A (nx949)) ;
    buf02 ix1303 (.Y (nx1304), .A (nx951)) ;
    buf02 ix1305 (.Y (nx1306), .A (nx961)) ;
    buf02 ix1307 (.Y (nx1308), .A (nx969)) ;
    buf02 ix1309 (.Y (nx1310), .A (nx978)) ;
    buf02 ix1311 (.Y (nx1312), .A (nx980)) ;
    buf02 ix1313 (.Y (nx1314), .A (nx989)) ;
    buf02 ix1315 (.Y (nx1316), .A (nx991)) ;
    buf02 ix1317 (.Y (nx1318), .A (nx1003)) ;
    buf02 ix1319 (.Y (nx1320), .A (nx1017)) ;
    buf02 ix1321 (.Y (nx1322), .A (nx1025)) ;
    buf02 ix1323 (.Y (nx1324), .A (nx1035)) ;
    buf02 ix1325 (.Y (nx1326), .A (nx1037)) ;
    buf02 ix1327 (.Y (nx1328), .A (nx1045)) ;
    buf02 ix1329 (.Y (nx1330), .A (nx1057)) ;
    buf02 ix1331 (.Y (nx1332), .A (nx1059)) ;
    buf02 ix1333 (.Y (nx1334), .A (nx1064)) ;
    buf02 ix1335 (.Y (nx1336), .A (nx1077)) ;
    buf02 ix1337 (.Y (nx1338), .A (nx1079)) ;
    buf02 ix1339 (.Y (nx1340), .A (nx1097)) ;
    inv02 ix1341 (.Y (nx1342), .A (SELECT_INDIRECT)) ;
    mux21 ix624 (.Y (nx623), .A0 (PROGDI[7]), .A1 (DESTIN_A[7]), .S0 (nx40)) ;
    xor2 ix239 (.Y (nx238), .A0 (nx1158), .A1 (nx236)) ;
    xor2 ix163 (.Y (nx162), .A0 (nx1156), .A1 (nx160)) ;
    xor2 ix103 (.Y (nx102), .A0 (STACK_POINTER[0]), .A1 (nx100)) ;
    mux21 ix726 (.Y (nx140), .A0 (nx927), .A1 (nx1350), .S0 (nx1380)) ;
    inv02 ix1349 (.Y (nx1350), .A (REG_RESULT[2])) ;
    mux21 ix746 (.Y (nx202), .A0 (nx1023), .A1 (nx1352), .S0 (nx1380)) ;
    inv02 ix1351 (.Y (nx1352), .A (REG_RESULT[4])) ;
    mux21 ix766 (.Y (nx360), .A0 (nx867), .A1 (nx1354), .S0 (nx1380)) ;
    inv02 ix1353 (.Y (nx1354), .A (REG_RESULT[6])) ;
    mux21 ix814 (.Y (nx813), .A0 (nx278), .A1 (DESTIN_A[5]), .S0 (nx1224)) ;
    and02 ix842 (.Y (nx20), .A0 (nx1236), .A1 (nx843)) ;
    and02 ix427 (.Y (nx426), .A0 (DIRECT_SRC_ADDR_7_), .A1 (INDIRECT_ADDR_5_)) ;
    and02 ix771 (.Y (nx770), .A0 (nx1001), .A1 (nx2)) ;
    or02 ix1049 (.Y (NDESTIN_WE), .A0 (L_NDESTIN_WE), .A1 (nx1366)) ;
    oai21 ix1124 (.Y (nx1123), .A0 (nx843), .A1 (SELECT_INDIRECT), .B0 (nx1282)
          ) ;
    and02 ix1063 (.Y (nx1062), .A0 (PSW[3]), .A1 (SELECT_INDIRECT)) ;
    and02 ix1071 (.Y (nx1070), .A0 (PSW[4]), .A1 (SELECT_INDIRECT)) ;
    and02 ix1079 (.Y (nx1078), .A0 (SELECT_INDIRECT), .A1 (INDIRECT_ADDR_5_)) ;
    nor02 ix993 (.Y (SOURCE_A[6]), .A0 (nx1356), .A1 (SELECT_INDIRECT)) ;
    inv02 ix1355 (.Y (nx1356), .A (SFRSA[6])) ;
    inv02 ix1357 (.Y (nx1358), .A (nx617)) ;
    inv02 ix1359 (.Y (nx1360), .A (nx617)) ;
    inv02 ix1361 (.Y (nx1362), .A (nx617)) ;
    inv02 ix1363 (.Y (nx1364), .A (nx617)) ;
    inv02 ix1365 (.Y (nx1366), .A (nx617)) ;
    inv04 ix1367 (.Y (nx1368), .A (nx707)) ;
    inv04 ix1369 (.Y (nx1370), .A (nx707)) ;
    inv04 ix1371 (.Y (nx1372), .A (nx571)) ;
    buf02 ix1373 (.Y (nx1374), .A (MEM_CON[1])) ;
    buf02 ix1375 (.Y (nx1376), .A (MEM_CON[1])) ;
    buf02 ix1377 (.Y (nx1378), .A (MEM_CON[1])) ;
    inv04 ix1379 (.Y (nx1380), .A (nx655)) ;
    inv02 ix1381 (.Y (nx1382), .A (nx1282)) ;
    inv02 ix1383 (.Y (nx1384), .A (nx1254)) ;
    inv02 ix1385 (.Y (nx1386), .A (nx1260)) ;
    inv02 ix1387 (.Y (nx1388), .A (nx1266)) ;
    buf02 ix1389 (.Y (nx1390), .A (nx1123)) ;
endmodule


module block04 ( OPERAND_A, OPERAND_B, ACC, PSW, SOURCE_DI, SFR_DATA, IMMEDIATE, 
                  SWITCH_CON, SOURCE_IS_SFR ) ;

    output [7:0]OPERAND_A ;
    output [7:0]OPERAND_B ;
    input [7:0]ACC ;
    input [7:6]PSW ;
    input [7:0]SOURCE_DI ;
    input [7:0]SFR_DATA ;
    input [7:0]IMMEDIATE ;
    input [5:0]SWITCH_CON ;
    input SOURCE_IS_SFR ;

    wire nx22, nx36, nx52, nx64, nx66, nx70, nx82, nx98, nx116, nx130, nx144, 
         nx150, nx392, nx394, nx398, nx402, nx405, nx407, nx409, nx412, nx418, 
         nx420, nx424, nx427, nx432, nx436, nx443, nx449, nx452, nx459, nx470, 
         nx475, nx487, nx489, nx491, nx493, nx495, nx499, nx501, nx503, nx517, 
         nx519, nx521, nx523, nx525;



    ao21 ix121 (.Y (OPERAND_B[3]), .A0 (IMMEDIATE[3]), .A1 (SWITCH_CON[3]), .B0 (
         nx116)) ;
    nor02 ix117 (.Y (nx116), .A0 (nx392), .A1 (nx487)) ;
    inv02 ix393 (.Y (nx392), .A (SWITCH_CON[2])) ;
    mux21 ix395 (.Y (nx394), .A0 (SOURCE_DI[3]), .A1 (SFR_DATA[3]), .S0 (
          SOURCE_IS_SFR)) ;
    ao21 ix135 (.Y (OPERAND_B[4]), .A0 (IMMEDIATE[4]), .A1 (SWITCH_CON[3]), .B0 (
         nx130)) ;
    nor02 ix131 (.Y (nx130), .A0 (nx392), .A1 (nx489)) ;
    mux21 ix399 (.Y (nx398), .A0 (SOURCE_DI[4]), .A1 (SFR_DATA[4]), .S0 (
          SOURCE_IS_SFR)) ;
    ao21 ix149 (.Y (OPERAND_B[7]), .A0 (IMMEDIATE[7]), .A1 (SWITCH_CON[3]), .B0 (
         nx144)) ;
    nor02 ix145 (.Y (nx144), .A0 (nx392), .A1 (nx491)) ;
    mux21 ix403 (.Y (nx402), .A0 (SOURCE_DI[7]), .A1 (SFR_DATA[7]), .S0 (
          SOURCE_IS_SFR)) ;
    oai221 ix19 (.Y (OPERAND_B[0]), .A0 (nx392), .A1 (nx493), .B0 (SWITCH_CON[5]
           ), .B1 (nx407), .C0 (nx409)) ;
    mux21 ix406 (.Y (nx405), .A0 (SOURCE_DI[0]), .A1 (SFR_DATA[0]), .S0 (
          SOURCE_IS_SFR)) ;
    inv02 ix408 (.Y (nx407), .A (SWITCH_CON[4])) ;
    nand02 ix410 (.Y (nx409), .A0 (IMMEDIATE[0]), .A1 (SWITCH_CON[3])) ;
    nand02 ix45 (.Y (OPERAND_B[1]), .A0 (nx495), .A1 (nx525)) ;
    aoi22 ix413 (.Y (nx412), .A0 (IMMEDIATE[1]), .A1 (SWITCH_CON[3]), .B0 (
          SWITCH_CON[2]), .B1 (nx36)) ;
    oai21 ix421 (.Y (nx420), .A0 (ACC[2]), .A1 (ACC[1]), .B0 (ACC[3])) ;
    nand02 ix425 (.Y (nx424), .A0 (SWITCH_CON[5]), .A1 (SWITCH_CON[4])) ;
    nand02 ix61 (.Y (OPERAND_B[2]), .A0 (nx499), .A1 (nx525)) ;
    aoi22 ix428 (.Y (nx427), .A0 (IMMEDIATE[2]), .A1 (SWITCH_CON[3]), .B0 (
          SWITCH_CON[2]), .B1 (nx52)) ;
    nand02 ix91 (.Y (OPERAND_B[5]), .A0 (nx501), .A1 (nx436)) ;
    aoi22 ix433 (.Y (nx432), .A0 (IMMEDIATE[5]), .A1 (SWITCH_CON[3]), .B0 (
          SWITCH_CON[2]), .B1 (nx82)) ;
    nand03 ix437 (.Y (nx436), .A0 (nx70), .A1 (SWITCH_CON[5]), .A2 (
           SWITCH_CON[4])) ;
    ao21 ix71 (.Y (nx70), .A0 (ACC[7]), .A1 (nx66), .B0 (PSW[7])) ;
    or02 ix67 (.Y (nx66), .A0 (nx64), .A1 (ACC[5])) ;
    ao21 ix65 (.Y (nx64), .A0 (ACC[4]), .A1 (nx22), .B0 (ACC[6])) ;
    inv02 ix23 (.Y (nx22), .A (nx420)) ;
    nand02 ix107 (.Y (OPERAND_B[6]), .A0 (nx503), .A1 (nx436)) ;
    aoi22 ix444 (.Y (nx443), .A0 (IMMEDIATE[6]), .A1 (SWITCH_CON[3]), .B0 (
          SWITCH_CON[2]), .B1 (nx98)) ;
    ao21 ix155 (.Y (OPERAND_A[0]), .A0 (ACC[0]), .A1 (SWITCH_CON[0]), .B0 (nx150
         )) ;
    nor02 ix151 (.Y (nx150), .A0 (nx449), .A1 (nx493)) ;
    inv02 ix450 (.Y (nx449), .A (SWITCH_CON[1])) ;
    mux21 ix453 (.Y (nx452), .A0 (SOURCE_DI[1]), .A1 (SFR_DATA[1]), .S0 (
          SOURCE_IS_SFR)) ;
    mux21 ix460 (.Y (nx459), .A0 (SOURCE_DI[2]), .A1 (SFR_DATA[2]), .S0 (
          SOURCE_IS_SFR)) ;
    mux21 ix471 (.Y (nx470), .A0 (SOURCE_DI[5]), .A1 (SFR_DATA[5]), .S0 (
          SOURCE_IS_SFR)) ;
    mux21 ix476 (.Y (nx475), .A0 (SOURCE_DI[6]), .A1 (SFR_DATA[6]), .S0 (
          SOURCE_IS_SFR)) ;
    inv02 ix99 (.Y (nx98), .A (nx475)) ;
    inv02 ix83 (.Y (nx82), .A (nx470)) ;
    inv02 ix53 (.Y (nx52), .A (nx459)) ;
    inv02 ix37 (.Y (nx36), .A (nx452)) ;
    buf02 ix486 (.Y (nx487), .A (nx394)) ;
    buf02 ix488 (.Y (nx489), .A (nx398)) ;
    buf02 ix490 (.Y (nx491), .A (nx402)) ;
    buf02 ix492 (.Y (nx493), .A (nx405)) ;
    buf02 ix494 (.Y (nx495), .A (nx412)) ;
    buf02 ix498 (.Y (nx499), .A (nx427)) ;
    buf02 ix500 (.Y (nx501), .A (nx432)) ;
    buf02 ix502 (.Y (nx503), .A (nx443)) ;
    oai21 ix419 (.Y (nx418), .A0 (nx22), .A1 (PSW[6]), .B0 (nx517)) ;
    inv02 ix516 (.Y (nx517), .A (nx424)) ;
    ao22 ix161 (.Y (OPERAND_A[1]), .A0 (SWITCH_CON[1]), .A1 (nx36), .B0 (ACC[1])
         , .B1 (SWITCH_CON[0])) ;
    ao22 ix167 (.Y (OPERAND_A[2]), .A0 (SWITCH_CON[1]), .A1 (nx52), .B0 (ACC[2])
         , .B1 (SWITCH_CON[0])) ;
    ao22 ix173 (.Y (OPERAND_A[3]), .A0 (ACC[3]), .A1 (SWITCH_CON[0]), .B0 (
         SWITCH_CON[1]), .B1 (nx519)) ;
    inv02 ix518 (.Y (nx519), .A (nx487)) ;
    ao22 ix179 (.Y (OPERAND_A[4]), .A0 (ACC[4]), .A1 (SWITCH_CON[0]), .B0 (
         SWITCH_CON[1]), .B1 (nx521)) ;
    inv02 ix520 (.Y (nx521), .A (nx489)) ;
    ao22 ix185 (.Y (OPERAND_A[5]), .A0 (SWITCH_CON[1]), .A1 (nx82), .B0 (ACC[5])
         , .B1 (SWITCH_CON[0])) ;
    ao22 ix191 (.Y (OPERAND_A[6]), .A0 (SWITCH_CON[1]), .A1 (nx98), .B0 (ACC[6])
         , .B1 (SWITCH_CON[0])) ;
    ao22 ix197 (.Y (OPERAND_A[7]), .A0 (ACC[7]), .A1 (SWITCH_CON[0]), .B0 (
         SWITCH_CON[1]), .B1 (nx523)) ;
    inv02 ix522 (.Y (nx523), .A (nx491)) ;
    buf02 ix524 (.Y (nx525), .A (nx418)) ;
endmodule


module block05 ( RESULT_A, RESULT_B, RESULT_OV, ACC, B, STATE, CLK2, MULNDIV, 
                  INTERNAL_WAIT ) ;

    output [7:0]RESULT_A ;
    output [7:0]RESULT_B ;
    output RESULT_OV ;
    input [7:0]ACC ;
    input [7:0]B ;
    input [2:0]STATE ;
    input CLK2 ;
    input MULNDIV ;
    input INTERNAL_WAIT ;

    wire nx8, nx14, nx30, nx40, nx44, nx52, nx62, nx92, nx94, nx98, nx100, 
         SUB_PRODUCT_14_, nx110, nx136, nx140, nx148, nx168, nx172, 
         SUB_PRODUCT_15_, nx190, nx218, nx725, nx226, nx244, nx248, nx250, 
         SUB_PRODUCT_13_, nx290, nx298, SUB_PRODUCT_12_, nx300, SUB_PRODUCT_11_, 
         nx310, SUB_PRODUCT_10_, nx312, SUB_PRODUCT_9_, nx318, SUB_PRODUCT_8_, 
         nx730, nx731, nx332, nx334, SUB_PRODUCT_7_, nx348, nx354, 
         SUB_PRODUCT_6_, nx366, nx372, SUB_PRODUCT_5_, nx380, SUB_PRODUCT_4_, 
         nx388, SUB_PRODUCT_3_, nx396, SUB_PRODUCT_2_, SUB_PRODUCT_1_, 
         SUB_PRODUCT_0_, nx418, nx444, nx468, nx751, nx470, nx494, nx753, nx496, 
         nx520, nx755, nx522, nx546, nx757, nx548, nx572, nx759, nx574, nx598, 
         nx761, nx600, nx624, nx640, nx646, nx648, nx650, nx765, nx680, nx688, 
         nx696, nx702, nx704, nx706, nx742, nx750, nx760, nx762, nx764, nx794, 
         nx814, nx850, nx858, nx860, nx864, nx894, nx916, nx944, nx948, nx964, 
         nx980, nx996, nx1006, nx1048, nx777, nx1088, nx781, nx785, nx791, nx795, 
         nx801, nx805, nx811, nx815, nx821, nx825, nx831, nx835, nx841, nx845, 
         nx851, nx855, nx861, nx865, nx871, nx875, nx881, nx885, nx891, nx895, 
         nx901, nx905, nx911, nx915, nx921, nx925, nx931, nx935, nx957, nx965, 
         nx969, nx971, nx975, nx977, nx979, nx981, nx985, nx987, nx991, nx995, 
         nx997, nx999, nx1001, nx1003, nx1011, nx1015, nx1021, nx1024, nx1027, 
         nx1033, nx1039, nx1043, nx1047, nx1049, nx1057, nx1062, nx1067, nx1071, 
         nx1075, nx1077, nx1081, nx1083, nx1087, nx1096, nx1099, nx1101, nx1106, 
         nx1122, nx1128, nx1130, nx1145, nx1147, nx1153, nx1158, nx1160, nx1167, 
         nx1172, nx1174, nx1180, nx1185, nx1187, nx1191, nx1196, nx1198, nx1201, 
         nx1205, nx1207, nx1209, nx1214, nx1254, nx1257, nx1261, nx1266, nx1268, 
         nx1280, nx1284, nx1288, nx1290, nx1292, nx1297, nx1299, nx1301, nx1306, 
         nx1308, nx1310, nx1317, nx1319, nx1326, nx1328, nx1330, nx1333, nx1337, 
         nx1339, nx1341, nx1346, nx1348, nx1350, nx1360, nx1362, nx1364, nx1366, 
         nx1372, nx1374, nx1379, nx1381, nx1385, nx1388, nx1394, nx1396, nx1398, 
         nx1402, nx1405, nx1408, nx1411, nx1417, nx1419, nx1421, nx1423, nx1425, 
         nx1436, nx1444, nx1446, nx1448, nx1450, nx1452, nx1454, nx1456, nx1458, 
         nx1460, nx1462, nx1464, nx1466, nx1468, nx1470, nx1472, nx1474, nx1476, 
         nx1478, nx1480, nx1482, nx1484, nx1486, nx1488, nx1490, nx1492, nx1496, 
         nx1498, nx1500, nx1502, nx1504, nx1506, nx1508, nx1510, nx1512, nx1514, 
         nx1516, nx1518, nx1522, nx1524, nx1526, nx1528, nx1530, nx1532, nx1534, 
         nx1536, nx1538, nx1540, nx1542, nx1544, nx1546, nx1548, nx1550, nx1552, 
         nx1554, nx1556, nx1558, nx1562, nx1564, nx1566, nx1572, nx1574, nx1576, 
         nx1578, nx1580, nx1582, nx1584, nx1586, nx1588, nx1590, nx1592, nx1594, 
         nx1596, nx1598, nx1600, nx1602, nx1604, nx1606, nx1608, nx1610, nx1612, 
         nx1614, nx1618, nx1620, nx1626, nx1628, nx1634, nx1638, nx1640, nx1646, 
         nx1650, nx1652, nx1654, nx1658, nx1660, nx1662, nx1664, nx1668, nx1670, 
         nx1672, nx1674, nx1676, nx1678, nx1680, nx1682, nx1684, nx1686, nx1688, 
         nx1690, nx1692, nx1694, nx1700, nx1702, nx1704, nx1706, nx1708, nx1710, 
         nx1712, nx1714, nx1720, nx1722, nx1724, nx1726, nx1728, nx1730, nx1732, 
         nx1734, nx1740, nx1742, nx1744, nx1746, nx1748, nx1750, nx1752, nx1754, 
         nx1760, nx1762, nx1764, nx1766, nx1768, nx1770, nx1772, nx1774, nx1780, 
         nx1782, nx1784, nx1786, nx1788, nx1790, nx1792, nx1794, nx1800, nx1802, 
         nx1804, nx1806, nx1808, nx1810, nx1812, nx1814, nx1816, nx1818, nx1820, 
         nx1822, nx1824, nx1826, nx1828, nx1830, nx1832, nx1834, nx1836, nx1838, 
         nx1840, nx1842, nx1844, nx1846, nx1848, nx1850, nx1852, nx1854, nx1856, 
         nx1858, nx1860, nx1862, nx1864, nx1866, nx1868, nx1870, nx1872, nx1874, 
         nx1876, nx1878, nx1880, nx1882, nx1884, nx1886, nx1888, nx1890, nx1892, 
         nx1894, nx1896, nx1898, nx1900, nx1902, nx1908, nx1910, nx1912, nx1914, 
         nx1916, nx1918, nx1920, nx1922, nx1928, nx1930, nx1932, nx1934, nx1936, 
         nx1938, nx1940, nx1942, nx1948, nx1950, nx1952, nx1954, nx1956, nx1958, 
         nx1960, nx1962, nx1968, nx1970, nx1972, nx1974, nx1976, nx1978, nx1980, 
         nx1982, nx1988, nx1990, nx1992, nx1994, nx1996, nx1998, nx2000, nx2002, 
         nx2008, nx2010, nx2012, nx2014, nx2016, nx2018, nx2020, nx2022;
    wire [15:0] \$dummy ;




    ao32 ix1093 (.Y (RESULT_OV), .A0 (nx1460), .A1 (nx14), .A2 (nx1462), .B0 (
         nx1818), .B1 (nx1088)) ;
    nor03 ix9 (.Y (nx8), .A0 (B[3]), .A1 (B[1]), .A2 (B[2])) ;
    nor02 ix15 (.Y (nx14), .A0 (B[4]), .A1 (B[5])) ;
    nor04 ix31 (.Y (nx30), .A0 (B[6]), .A1 (B[7]), .A2 (B[0]), .A3 (nx1818)) ;
    nand04 ix1089 (.Y (nx1088), .A0 (nx1566), .A1 (nx1436), .A2 (nx1381), .A3 (
           nx1394)) ;
    nor04 ix958 (.Y (nx957), .A0 (nx650), .A1 (nx706), .A2 (nx764), .A3 (nx814)
          ) ;
    mux21 ix966 (.Y (nx965), .A0 (nx1476), .A1 (nx1478), .S0 (nx1806)) ;
    mux21 ix149 (.Y (nx148), .A0 (nx1572), .A1 (nx1574), .S0 (nx1810)) ;
    mux21 ix970 (.Y (nx969), .A0 (B[0]), .A1 (B[1]), .S0 (nx1814)) ;
    mux21 ix972 (.Y (nx971), .A0 (B[2]), .A1 (B[3]), .S0 (nx1814)) ;
    mux21 ix169 (.Y (nx168), .A0 (nx1576), .A1 (nx1578), .S0 (nx1810)) ;
    mux21 ix976 (.Y (nx975), .A0 (B[4]), .A1 (B[5]), .S0 (nx1814)) ;
    mux21 ix978 (.Y (nx977), .A0 (B[6]), .A1 (B[7]), .S0 (nx1814)) ;
    nor03 ix982 (.Y (nx981), .A0 (nx1806), .A1 (nx1810), .A2 (nx1814)) ;
    oai21 ix93 (.Y (nx92), .A0 (nx1814), .A1 (nx1584), .B0 (nx995)) ;
    aoi322 ix986 (.Y (nx985), .A0 (ACC[3]), .A1 (nx987), .A2 (nx1806), .B0 (
           ACC[1]), .B1 (nx62), .C0 (ACC[5]), .C1 (nx52)) ;
    inv02 ix988 (.Y (nx987), .A (STATE[1])) ;
    inv02 ix992 (.Y (nx991), .A (STATE[2])) ;
    ao21 ix996 (.Y (nx995), .A0 (nx1586), .A1 (nx1588), .B0 (nx1003)) ;
    aoi32 ix998 (.Y (nx997), .A0 (ACC[0]), .A1 (nx1810), .A2 (nx1806), .B0 (
          ACC[4]), .B1 (nx52)) ;
    aoi32 ix1000 (.Y (nx999), .A0 (ACC[2]), .A1 (nx987), .A2 (nx1806), .B0 (
          ACC[6]), .B1 (nx1590)) ;
    nor02 ix1002 (.Y (nx1001), .A0 (nx1806), .A1 (nx1810)) ;
    inv02 ix1004 (.Y (nx1003), .A (STATE[0])) ;
    dff ix868 (.Q (SUB_PRODUCT_7_), .QB (\$dummy [0]), .D (nx865), .CLK (CLK2)
        ) ;
    ao21 ix866 (.Y (nx865), .A0 (nx1444), .A1 (nx1101), .B0 (nx861)) ;
    oai21 ix607 (.Y (RESULT_A[7]), .A0 (nx1818), .A1 (nx1011), .B0 (nx1592)) ;
    nand02 ix1012 (.Y (nx1011), .A0 (SUB_PRODUCT_7_), .A1 (nx1464)) ;
    aoi22 ix1016 (.Y (nx1015), .A0 (nx1590), .A1 (nx1504), .B0 (nx1824), .B1 (
          nx600)) ;
    nor03 ix349 (.Y (nx348), .A0 (nx1484), .A1 (nx1824), .A2 (nx1816)) ;
    nand04 ix1021 (.Y (nx725), .A0 (nx1594), .A1 (nx1600), .A2 (nx1602), .A3 (
           nx1606)) ;
    mux21 ix1022 (.Y (nx1021), .A0 (nx1482), .A1 (nx40), .S0 (nx1806)) ;
    mux21 ix219 (.Y (nx218), .A0 (nx1596), .A1 (nx1598), .S0 (nx1810)) ;
    mux21 ix1026 (.Y (nx1024), .A0 (B[3]), .A1 (B[4]), .S0 (nx1814)) ;
    mux21 ix1028 (.Y (nx1027), .A0 (B[5]), .A1 (B[6]), .S0 (nx1814)) ;
    mux21 ix1034 (.Y (nx1033), .A0 (nx1474), .A1 (nx1544), .S0 (nx1806)) ;
    mux21 ix137 (.Y (nx136), .A0 (nx1574), .A1 (nx1576), .S0 (nx1810)) ;
    nor02 ix697 (.Y (nx696), .A0 (nx1810), .A1 (nx1578)) ;
    mux21 ix1040 (.Y (nx1039), .A0 (nx1490), .A1 (nx1536), .S0 (nx1806)) ;
    mux21 ix291 (.Y (nx290), .A0 (nx1604), .A1 (nx1596), .S0 (nx1810)) ;
    mux21 ix1044 (.Y (nx1043), .A0 (B[1]), .A1 (B[2]), .S0 (nx1814)) ;
    oai21 ix641 (.Y (nx640), .A0 (nx1810), .A1 (nx1598), .B0 (nx1047)) ;
    nand03 ix1048 (.Y (nx1047), .A0 (nx1812), .A1 (B[7]), .A2 (nx1003)) ;
    aoi222 ix1050 (.Y (nx1049), .A0 (nx991), .A1 (nx1006), .B0 (nx172), .B1 (
           nx1608), .C0 (nx1402), .C1 (nx996)) ;
    or04 ix1007 (.Y (nx1006), .A0 (nx40), .A1 (nx1544), .A2 (nx1536), .A3 (
         nx1478)) ;
    dff ix788 (.Q (SUB_PRODUCT_15_), .QB (\$dummy [1]), .D (nx785), .CLK (CLK2)
        ) ;
    ao21 ix786 (.Y (nx785), .A0 (RESULT_B[7]), .A1 (nx1101), .B0 (nx781)) ;
    mux21 ix261 (.Y (RESULT_B[7]), .A0 (nx1062), .A1 (nx1394), .S0 (nx1822)) ;
    xnor2 ix1064 (.Y (nx1062), .A0 (nx1488), .A1 (nx250)) ;
    mux21 ix245 (.Y (nx244), .A0 (nx1610), .A1 (nx1486), .S0 (nx1690)) ;
    mux21 ix1068 (.Y (nx1067), .A0 (nx1558), .A1 (nx1337), .S0 (nx1682)) ;
    mux21 ix895 (.Y (nx894), .A0 (nx1612), .A1 (nx1492), .S0 (nx1676)) ;
    mux21 ix1072 (.Y (nx1071), .A0 (nx1554), .A1 (nx1288), .S0 (nx1668)) ;
    mux21 ix795 (.Y (nx794), .A0 (nx1614), .A1 (nx1496), .S0 (nx1662)) ;
    mux21 ix1076 (.Y (nx1075), .A0 (nx1077), .A1 (nx1500), .S0 (nx1542)) ;
    nand02 ix1078 (.Y (nx1077), .A0 (nx1498), .A1 (nx1083)) ;
    nor02 ix313 (.Y (nx312), .A0 (nx1572), .A1 (nx1081)) ;
    nand02 ix1082 (.Y (nx1081), .A0 (nx1812), .A1 (nx1806)) ;
    dff ix878 (.Q (SUB_PRODUCT_8_), .QB (\$dummy [2]), .D (nx875), .CLK (CLK2)
        ) ;
    ao21 ix876 (.Y (nx875), .A0 (RESULT_B[0]), .A1 (nx1618), .B0 (nx871)) ;
    ao21 ix655 (.Y (RESULT_B[0]), .A0 (nx1818), .A1 (nx650), .B0 (nx332)) ;
    aoi21 ix333 (.Y (nx332), .A0 (nx1898), .A1 (nx1500), .B0 (nx1818)) ;
    nand02 ix1100 (.Y (nx1099), .A0 (B[0]), .A1 (nx1814)) ;
    inv02 ix1102 (.Y (nx1101), .A (INTERNAL_WAIT)) ;
    and02 ix872 (.Y (nx871), .A0 (SUB_PRODUCT_8_), .A1 (nx1802)) ;
    xnor2 ix727 (.Y (nx765), .A0 (nx1620), .A1 (nx1077)) ;
    dff ix888 (.Q (SUB_PRODUCT_9_), .QB (\$dummy [3]), .D (nx885), .CLK (CLK2)
        ) ;
    ao21 ix886 (.Y (nx885), .A0 (RESULT_B[1]), .A1 (nx1618), .B0 (nx881)) ;
    ao21 ix711 (.Y (RESULT_B[1]), .A0 (nx1818), .A1 (nx706), .B0 (nx680)) ;
    nor02 ix647 (.Y (nx646), .A0 (nx1602), .A1 (nx979)) ;
    ao21 ix95 (.Y (nx94), .A0 (ACC[7]), .A1 (nx1580), .B0 (nx1470)) ;
    nor02 ix355 (.Y (nx354), .A0 (nx1626), .A1 (nx979)) ;
    mux21 ix1123 (.Y (nx1122), .A0 (nx1480), .A1 (nx1482), .S0 (nx1808)) ;
    mux21 ix191 (.Y (nx190), .A0 (nx1099), .A1 (nx1604), .S0 (nx1812)) ;
    dff ix858 (.Q (SUB_PRODUCT_6_), .QB (\$dummy [4]), .D (nx855), .CLK (CLK2)
        ) ;
    ao21 ix856 (.Y (nx855), .A0 (nx1446), .A1 (nx1618), .B0 (nx851)) ;
    oai21 ix581 (.Y (RESULT_A[6]), .A0 (nx1818), .A1 (nx1128), .B0 (nx1628)) ;
    nand02 ix1129 (.Y (nx1128), .A0 (SUB_PRODUCT_6_), .A1 (nx1464)) ;
    aoi22 ix1131 (.Y (nx1130), .A0 (nx1818), .A1 (nx574), .B0 (nx1590), .B1 (
          nx1508)) ;
    dff ix848 (.Q (SUB_PRODUCT_5_), .QB (\$dummy [5]), .D (nx845), .CLK (CLK2)
        ) ;
    ao21 ix846 (.Y (nx845), .A0 (nx1448), .A1 (nx1618), .B0 (nx841)) ;
    oai21 ix555 (.Y (RESULT_A[5]), .A0 (nx1818), .A1 (nx1145), .B0 (nx1634)) ;
    nand02 ix1146 (.Y (nx1145), .A0 (SUB_PRODUCT_5_), .A1 (nx1464)) ;
    aoi32 ix1148 (.Y (nx1147), .A0 (nx1812), .A1 (nx991), .A2 (nx1504), .B0 (
          nx1818), .B1 (nx548)) ;
    nor02 ix381 (.Y (nx380), .A0 (nx1638), .A1 (nx979)) ;
    aoi32 ix1154 (.Y (nx1153), .A0 (B[0]), .A1 (nx1816), .A2 (nx52), .B0 (nx1808
          ), .B1 (nx1490)) ;
    dff ix838 (.Q (SUB_PRODUCT_4_), .QB (\$dummy [6]), .D (nx835), .CLK (CLK2)
        ) ;
    ao21 ix836 (.Y (nx835), .A0 (nx1450), .A1 (nx1618), .B0 (nx831)) ;
    oai21 ix529 (.Y (RESULT_A[4]), .A0 (nx1820), .A1 (nx1158), .B0 (nx1640)) ;
    nand02 ix1159 (.Y (nx1158), .A0 (SUB_PRODUCT_4_), .A1 (nx1464)) ;
    aoi32 ix1161 (.Y (nx1160), .A0 (nx1812), .A1 (nx991), .A2 (nx1508), .B0 (
          nx1820), .B1 (nx522)) ;
    nor03 ix367 (.Y (nx366), .A0 (nx1484), .A1 (nx1820), .A2 (nx1003)) ;
    nand02 ix1168 (.Y (nx1167), .A0 (nx1808), .A1 (nx1476)) ;
    dff ix828 (.Q (SUB_PRODUCT_3_), .QB (\$dummy [7]), .D (nx825), .CLK (CLK2)
        ) ;
    ao21 ix826 (.Y (nx825), .A0 (nx1452), .A1 (nx1618), .B0 (nx821)) ;
    oai21 ix503 (.Y (RESULT_A[3]), .A0 (nx1820), .A1 (nx1172), .B0 (nx1646)) ;
    nand02 ix1173 (.Y (nx1172), .A0 (SUB_PRODUCT_3_), .A1 (nx1464)) ;
    aoi32 ix1175 (.Y (nx1174), .A0 (nx987), .A1 (nx1808), .A2 (nx1504), .B0 (
          nx1820), .B1 (nx496)) ;
    nor02 ix397 (.Y (nx396), .A0 (nx1650), .A1 (nx979)) ;
    nand02 ix1181 (.Y (nx1180), .A0 (nx1808), .A1 (nx1480)) ;
    dff ix818 (.Q (SUB_PRODUCT_2_), .QB (\$dummy [8]), .D (nx815), .CLK (CLK2)
        ) ;
    ao21 ix816 (.Y (nx815), .A0 (nx1454), .A1 (nx1618), .B0 (nx811)) ;
    oai21 ix477 (.Y (RESULT_A[2]), .A0 (nx1820), .A1 (nx1185), .B0 (nx1652)) ;
    nand02 ix1186 (.Y (nx1185), .A0 (SUB_PRODUCT_2_), .A1 (nx1464)) ;
    aoi32 ix1188 (.Y (nx1187), .A0 (nx987), .A1 (nx1808), .A2 (nx1508), .B0 (
          nx1820), .B1 (nx470)) ;
    xor2 ix471 (.Y (nx470), .A0 (nx1522), .A1 (nx1524)) ;
    mux21 ix469 (.Y (nx468), .A0 (nx1900), .A1 (nx1205), .S0 (nx1658)) ;
    dff ix798 (.Q (SUB_PRODUCT_0_), .QB (\$dummy [9]), .D (nx795), .CLK (CLK2)
        ) ;
    ao21 ix796 (.Y (nx795), .A0 (nx1458), .A1 (nx1618), .B0 (nx791)) ;
    oai21 ix431 (.Y (RESULT_A[0]), .A0 (nx1820), .A1 (nx1196), .B0 (nx1654)) ;
    nand02 ix1197 (.Y (nx1196), .A0 (SUB_PRODUCT_0_), .A1 (nx1464)) ;
    aoi33 ix1199 (.Y (nx1198), .A0 (nx1518), .A1 (nx1820), .A2 (nx1900), .B0 (
          nx1812), .B1 (nx1808), .B2 (nx1508)) ;
    nand04 ix1202 (.Y (nx1201), .A0 (B[0]), .A1 (nx1816), .A2 (nx1812), .A3 (
           nx1808)) ;
    and02 ix792 (.Y (nx791), .A0 (SUB_PRODUCT_0_), .A1 (nx1802)) ;
    nand02 ix1206 (.Y (nx1205), .A0 (nx1498), .A1 (nx1890)) ;
    xnor2 ix1208 (.Y (nx1207), .A0 (nx1209), .A1 (nx1205)) ;
    nand02 ix1210 (.Y (nx1209), .A0 (SUB_PRODUCT_1_), .A1 (nx1464)) ;
    dff ix808 (.Q (SUB_PRODUCT_1_), .QB (\$dummy [10]), .D (nx805), .CLK (CLK2)
        ) ;
    ao21 ix806 (.Y (nx805), .A0 (nx1456), .A1 (nx1618), .B0 (nx801)) ;
    oai21 ix451 (.Y (RESULT_A[1]), .A0 (nx1820), .A1 (nx1209), .B0 (nx1660)) ;
    aoi32 ix1215 (.Y (nx1214), .A0 (nx1812), .A1 (nx1808), .A2 (nx1504), .B0 (
          nx1822), .B1 (nx444)) ;
    and02 ix802 (.Y (nx801), .A0 (SUB_PRODUCT_1_), .A1 (nx1802)) ;
    xnor2 ix487 (.Y (nx751), .A0 (nx1185), .A1 (nx1516)) ;
    and02 ix812 (.Y (nx811), .A0 (SUB_PRODUCT_2_), .A1 (nx1802)) ;
    xnor2 ix513 (.Y (nx753), .A0 (nx1172), .A1 (nx1514)) ;
    and02 ix822 (.Y (nx821), .A0 (SUB_PRODUCT_3_), .A1 (nx1802)) ;
    xnor2 ix539 (.Y (nx755), .A0 (nx1158), .A1 (nx1512)) ;
    and02 ix832 (.Y (nx831), .A0 (SUB_PRODUCT_4_), .A1 (nx1802)) ;
    xnor2 ix565 (.Y (nx757), .A0 (nx1145), .A1 (nx1510)) ;
    and02 ix842 (.Y (nx841), .A0 (SUB_PRODUCT_5_), .A1 (nx1802)) ;
    xnor2 ix591 (.Y (nx759), .A0 (nx1128), .A1 (nx1506)) ;
    and02 ix852 (.Y (nx851), .A0 (SUB_PRODUCT_6_), .A1 (nx1802)) ;
    xnor2 ix617 (.Y (nx761), .A0 (nx1011), .A1 (nx1502)) ;
    xnor2 ix649 (.Y (nx648), .A0 (nx1254), .A1 (nx1538)) ;
    nand02 ix1255 (.Y (nx1254), .A0 (SUB_PRODUCT_8_), .A1 (nx1466)) ;
    xnor2 ix705 (.Y (nx704), .A0 (nx1257), .A1 (nx1546)) ;
    nand02 ix1258 (.Y (nx1257), .A0 (SUB_PRODUCT_9_), .A1 (nx1466)) ;
    nor02 ix703 (.Y (nx702), .A0 (nx1600), .A1 (nx979)) ;
    nor02 ix681 (.Y (nx680), .A0 (nx1822), .A1 (nx1261)) ;
    xnor2 ix1262 (.Y (nx1261), .A0 (nx1500), .A1 (nx1542)) ;
    and02 ix882 (.Y (nx881), .A0 (SUB_PRODUCT_9_), .A1 (nx1802)) ;
    nor02 ix311 (.Y (nx310), .A0 (nx1650), .A1 (nx1484)) ;
    xnor2 ix1267 (.Y (nx1266), .A0 (nx1664), .A1 (nx1496)) ;
    dff ix898 (.Q (SUB_PRODUCT_10_), .QB (\$dummy [11]), .D (nx895), .CLK (CLK2)
        ) ;
    ao21 ix896 (.Y (nx895), .A0 (RESULT_B[2]), .A1 (nx1618), .B0 (nx891)) ;
    ao21 ix769 (.Y (RESULT_B[2]), .A0 (nx1822), .A1 (nx764), .B0 (nx742)) ;
    xnor2 ix763 (.Y (nx762), .A0 (nx1280), .A1 (nx1550)) ;
    nand02 ix1281 (.Y (nx1280), .A0 (SUB_PRODUCT_10_), .A1 (nx1466)) ;
    nor02 ix761 (.Y (nx760), .A0 (nx1594), .A1 (nx979)) ;
    nor02 ix743 (.Y (nx742), .A0 (nx1822), .A1 (nx1284)) ;
    xnor2 ix1285 (.Y (nx1284), .A0 (nx1614), .A1 (nx1662)) ;
    and02 ix892 (.Y (nx891), .A0 (SUB_PRODUCT_10_), .A1 (nx1802)) ;
    dff ix908 (.Q (SUB_PRODUCT_11_), .QB (\$dummy [12]), .D (nx905), .CLK (CLK2)
        ) ;
    ao21 ix906 (.Y (nx905), .A0 (RESULT_B[3]), .A1 (nx1101), .B0 (nx901)) ;
    mux21 ix819 (.Y (RESULT_B[3]), .A0 (nx1297), .A1 (nx1299), .S0 (nx1822)) ;
    xor2 ix1298 (.Y (nx1297), .A0 (nx1554), .A1 (nx1668)) ;
    xnor2 ix1300 (.Y (nx1299), .A0 (nx1672), .A1 (nx1674)) ;
    aoi32 ix1302 (.Y (nx1301), .A0 (nx1550), .A1 (SUB_PRODUCT_10_), .A2 (nx1466)
          , .B0 (nx750), .B1 (nx1552)) ;
    xnor2 ix1307 (.Y (nx1306), .A0 (nx1308), .A1 (nx1310)) ;
    nand02 ix1309 (.Y (nx1308), .A0 (SUB_PRODUCT_11_), .A1 (nx1466)) ;
    nand02 ix1311 (.Y (nx1310), .A0 (nx1478), .A1 (nx98)) ;
    and02 ix902 (.Y (nx901), .A0 (SUB_PRODUCT_11_), .A1 (nx1804)) ;
    nor02 ix299 (.Y (nx298), .A0 (nx1638), .A1 (nx1484)) ;
    xnor2 ix1318 (.Y (nx1317), .A0 (nx1678), .A1 (nx1492)) ;
    dff ix918 (.Q (SUB_PRODUCT_12_), .QB (\$dummy [13]), .D (nx915), .CLK (CLK2)
        ) ;
    ao21 ix916 (.Y (nx915), .A0 (RESULT_B[4]), .A1 (nx1101), .B0 (nx911)) ;
    ao21 ix869 (.Y (RESULT_B[4]), .A0 (nx1822), .A1 (nx864), .B0 (nx850)) ;
    xnor2 ix865 (.Y (nx864), .A0 (nx1556), .A1 (nx1680)) ;
    mux21 ix859 (.Y (nx858), .A0 (nx1672), .A1 (nx1310), .S0 (nx1674)) ;
    xnor2 ix1327 (.Y (nx1326), .A0 (nx1328), .A1 (nx1330)) ;
    nand02 ix1329 (.Y (nx1328), .A0 (SUB_PRODUCT_12_), .A1 (nx1468)) ;
    nand02 ix1331 (.Y (nx1330), .A0 (nx1536), .A1 (nx98)) ;
    nor02 ix851 (.Y (nx850), .A0 (nx1822), .A1 (nx1333)) ;
    xnor2 ix1334 (.Y (nx1333), .A0 (nx1612), .A1 (nx1676)) ;
    and02 ix912 (.Y (nx911), .A0 (SUB_PRODUCT_12_), .A1 (nx1804)) ;
    dff ix928 (.Q (SUB_PRODUCT_13_), .QB (\$dummy [14]), .D (nx925), .CLK (CLK2)
        ) ;
    ao21 ix926 (.Y (nx925), .A0 (RESULT_B[5]), .A1 (nx1101), .B0 (nx921)) ;
    mux21 ix921 (.Y (RESULT_B[5]), .A0 (nx1346), .A1 (nx1348), .S0 (nx1822)) ;
    xor2 ix1347 (.Y (nx1346), .A0 (nx1558), .A1 (nx1682)) ;
    xnor2 ix1349 (.Y (nx1348), .A0 (nx1686), .A1 (nx1688)) ;
    mux21 ix1351 (.Y (nx1350), .A0 (nx1556), .A1 (nx860), .S0 (nx1680)) ;
    nand02 ix1361 (.Y (nx1360), .A0 (nx991), .A1 (nx1890)) ;
    xnor2 ix1363 (.Y (nx1362), .A0 (nx1364), .A1 (nx1366)) ;
    nand02 ix1365 (.Y (nx1364), .A0 (SUB_PRODUCT_13_), .A1 (nx1468)) ;
    nand02 ix1367 (.Y (nx1366), .A0 (nx1544), .A1 (nx98)) ;
    and02 ix922 (.Y (nx921), .A0 (SUB_PRODUCT_13_), .A1 (nx1804)) ;
    nor02 ix227 (.Y (nx226), .A0 (nx1626), .A1 (nx1484)) ;
    xnor2 ix1373 (.Y (nx1372), .A0 (nx1692), .A1 (nx1486)) ;
    dff ix938 (.Q (SUB_PRODUCT_14_), .QB (\$dummy [15]), .D (nx935), .CLK (CLK2)
        ) ;
    ao21 ix936 (.Y (nx935), .A0 (RESULT_B[6]), .A1 (nx1101), .B0 (nx931)) ;
    mux21 ix1055 (.Y (RESULT_B[6]), .A0 (nx1379), .A1 (nx1381), .S0 (nx1822)) ;
    xnor2 ix1380 (.Y (nx1379), .A0 (nx1610), .A1 (nx1690)) ;
    xnor2 ix1382 (.Y (nx1381), .A0 (nx1562), .A1 (nx1564)) ;
    mux21 ix1049 (.Y (nx1048), .A0 (nx1686), .A1 (nx1366), .S0 (nx1688)) ;
    xnor2 ix1065 (.Y (nx777), .A0 (nx1385), .A1 (nx1472)) ;
    nand02 ix1386 (.Y (nx1385), .A0 (SUB_PRODUCT_14_), .A1 (nx1468)) ;
    nor02 ix101 (.Y (nx100), .A0 (nx1388), .A1 (nx1360)) ;
    nand03 ix1389 (.Y (nx1388), .A0 (nx987), .A1 (B[7]), .A2 (nx1003)) ;
    and02 ix932 (.Y (nx931), .A0 (SUB_PRODUCT_14_), .A1 (nx1804)) ;
    xor2 ix251 (.Y (nx250), .A0 (nx1608), .A1 (nx248)) ;
    xnor2 ix1395 (.Y (nx1394), .A0 (nx1694), .A1 (nx1398)) ;
    aoi32 ix1397 (.Y (nx1396), .A0 (nx1472), .A1 (SUB_PRODUCT_14_), .A2 (nx1468)
          , .B0 (nx1562), .B1 (nx1564)) ;
    nand02 ix1399 (.Y (nx1398), .A0 (SUB_PRODUCT_15_), .A1 (nx1468)) ;
    and02 ix782 (.Y (nx781), .A0 (SUB_PRODUCT_15_), .A1 (nx1804)) ;
    mux21 ix997 (.Y (nx996), .A0 (nx1626), .A1 (nx1405), .S0 (nx1425)) ;
    mux21 ix1406 (.Y (nx1405), .A0 (nx1892), .A1 (nx980), .S0 (nx1423)) ;
    mux21 ix981 (.Y (nx980), .A0 (nx1638), .A1 (nx1408), .S0 (nx1421)) ;
    mux21 ix1409 (.Y (nx1408), .A0 (nx300), .A1 (nx964), .S0 (nx1419)) ;
    mux21 ix965 (.Y (nx964), .A0 (nx1650), .A1 (nx1411), .S0 (nx1417)) ;
    mux21 ix1412 (.Y (nx1411), .A0 (nx948), .A1 (nx1498), .S0 (nx944)) ;
    xnor2 ix945 (.Y (nx944), .A0 (nx1498), .A1 (nx1620)) ;
    xnor2 ix1418 (.Y (nx1417), .A0 (nx1650), .A1 (nx1664)) ;
    xnor2 ix1422 (.Y (nx1421), .A0 (nx1638), .A1 (nx1678)) ;
    xnor2 ix1426 (.Y (nx1425), .A0 (nx1626), .A1 (nx1692)) ;
    and02 ix862 (.Y (nx861), .A0 (SUB_PRODUCT_7_), .A1 (nx1804)) ;
    nor02 ix1437 (.Y (nx1436), .A0 (nx864), .A1 (nx916)) ;
    inv02 ix917 (.Y (nx916), .A (nx1348)) ;
    inv02 ix861 (.Y (nx860), .A (nx1330)) ;
    inv02 ix815 (.Y (nx814), .A (nx1299)) ;
    inv02 ix669 (.Y (nx731), .A (nx1087)) ;
    inv02 ix319 (.Y (nx318), .A (nx1201)) ;
    inv02 ix301 (.Y (nx300), .A (nx1167)) ;
    inv02 ix1084 (.Y (nx1083), .A (nx725)) ;
    inv02 ix173 (.Y (nx172), .A (nx965)) ;
    inv02 ix111 (.Y (nx110), .A (nx969)) ;
    inv02 ix99 (.Y (nx98), .A (nx1360)) ;
    inv02 ix980 (.Y (nx979), .A (nx94)) ;
    inv02 ix63 (.Y (nx62), .A (nx1081)) ;
    inv04 ix45 (.Y (nx44), .A (nx981)) ;
    inv02 ix41 (.Y (nx40), .A (nx1388)) ;
    buf02 ix1443 (.Y (nx1444), .A (nx1700)) ;
    buf02 ix1445 (.Y (nx1446), .A (nx1702)) ;
    buf02 ix1447 (.Y (nx1448), .A (nx1704)) ;
    buf02 ix1449 (.Y (nx1450), .A (nx1706)) ;
    buf02 ix1451 (.Y (nx1452), .A (nx1708)) ;
    buf02 ix1453 (.Y (nx1454), .A (nx1710)) ;
    buf02 ix1455 (.Y (nx1456), .A (nx1712)) ;
    buf02 ix1457 (.Y (nx1458), .A (nx1714)) ;
    buf02 ix1459 (.Y (nx1460), .A (nx8)) ;
    buf02 ix1461 (.Y (nx1462), .A (nx30)) ;
    inv04 ix1463 (.Y (nx1464), .A (nx1580)) ;
    inv04 ix1465 (.Y (nx1466), .A (nx1582)) ;
    inv04 ix1467 (.Y (nx1468), .A (nx1582)) ;
    buf02 ix1469 (.Y (nx1470), .A (nx92)) ;
    buf02 ix1471 (.Y (nx1472), .A (nx100)) ;
    buf02 ix1473 (.Y (nx1474), .A (nx136)) ;
    buf02 ix1475 (.Y (nx1476), .A (nx148)) ;
    buf02 ix1477 (.Y (nx1478), .A (nx168)) ;
    buf02 ix1479 (.Y (nx1480), .A (nx190)) ;
    buf02 ix1481 (.Y (nx1482), .A (nx218)) ;
    inv02 ix1483 (.Y (nx1484), .A (nx1083)) ;
    buf02 ix1485 (.Y (nx1486), .A (nx226)) ;
    buf02 ix1487 (.Y (nx1488), .A (nx244)) ;
    buf02 ix1489 (.Y (nx1490), .A (nx290)) ;
    buf02 ix1491 (.Y (nx1492), .A (nx298)) ;
    buf02 ix1495 (.Y (nx1496), .A (nx310)) ;
    buf02 ix1497 (.Y (nx1498), .A (nx312)) ;
    buf02 ix1499 (.Y (nx1500), .A (nx730)) ;
    buf02 ix1501 (.Y (nx1502), .A (nx334)) ;
    buf02 ix1503 (.Y (nx1504), .A (nx348)) ;
    buf02 ix1505 (.Y (nx1506), .A (nx354)) ;
    buf02 ix1507 (.Y (nx1508), .A (nx366)) ;
    buf02 ix1509 (.Y (nx1510), .A (nx372)) ;
    buf02 ix1511 (.Y (nx1512), .A (nx380)) ;
    buf02 ix1513 (.Y (nx1514), .A (nx388)) ;
    buf02 ix1515 (.Y (nx1516), .A (nx396)) ;
    buf02 ix1517 (.Y (nx1518), .A (nx418)) ;
    buf02 ix1521 (.Y (nx1522), .A (nx468)) ;
    buf02 ix1523 (.Y (nx1524), .A (nx751)) ;
    buf02 ix1525 (.Y (nx1526), .A (nx753)) ;
    buf02 ix1527 (.Y (nx1528), .A (nx755)) ;
    buf02 ix1529 (.Y (nx1530), .A (nx757)) ;
    buf02 ix1531 (.Y (nx1532), .A (nx759)) ;
    buf02 ix1533 (.Y (nx1534), .A (nx761)) ;
    buf02 ix1535 (.Y (nx1536), .A (nx640)) ;
    buf02 ix1537 (.Y (nx1538), .A (nx646)) ;
    buf02 ix1539 (.Y (nx1540), .A (nx648)) ;
    buf02 ix1541 (.Y (nx1542), .A (nx765)) ;
    buf02 ix1543 (.Y (nx1544), .A (nx696)) ;
    buf02 ix1545 (.Y (nx1546), .A (nx702)) ;
    buf02 ix1547 (.Y (nx1548), .A (nx704)) ;
    buf02 ix1549 (.Y (nx1550), .A (nx760)) ;
    buf02 ix1551 (.Y (nx1552), .A (nx762)) ;
    buf02 ix1553 (.Y (nx1554), .A (nx794)) ;
    buf02 ix1555 (.Y (nx1556), .A (nx858)) ;
    buf02 ix1557 (.Y (nx1558), .A (nx894)) ;
    buf02 ix1561 (.Y (nx1562), .A (nx1048)) ;
    buf02 ix1563 (.Y (nx1564), .A (nx777)) ;
    buf02 ix1565 (.Y (nx1566), .A (nx957)) ;
    inv02 ix1571 (.Y (nx1572), .A (nx110)) ;
    buf02 ix1573 (.Y (nx1574), .A (nx971)) ;
    buf02 ix1575 (.Y (nx1576), .A (nx975)) ;
    buf02 ix1577 (.Y (nx1578), .A (nx977)) ;
    inv04 ix1579 (.Y (nx1580), .A (nx44)) ;
    inv04 ix1581 (.Y (nx1582), .A (nx44)) ;
    buf02 ix1583 (.Y (nx1584), .A (nx985)) ;
    buf02 ix1585 (.Y (nx1586), .A (nx997)) ;
    buf02 ix1587 (.Y (nx1588), .A (nx999)) ;
    buf02 ix1589 (.Y (nx1590), .A (nx1001)) ;
    buf02 ix1591 (.Y (nx1592), .A (nx1015)) ;
    buf02 ix1593 (.Y (nx1594), .A (nx1021)) ;
    buf02 ix1595 (.Y (nx1596), .A (nx1024)) ;
    buf02 ix1597 (.Y (nx1598), .A (nx1027)) ;
    buf02 ix1599 (.Y (nx1600), .A (nx1033)) ;
    buf02 ix1601 (.Y (nx1602), .A (nx1039)) ;
    buf02 ix1603 (.Y (nx1604), .A (nx1043)) ;
    buf02 ix1605 (.Y (nx1606), .A (nx1049)) ;
    buf02 ix1607 (.Y (nx1608), .A (nx1057)) ;
    buf02 ix1609 (.Y (nx1610), .A (nx1067)) ;
    buf02 ix1611 (.Y (nx1612), .A (nx1071)) ;
    buf02 ix1613 (.Y (nx1614), .A (nx1075)) ;
    inv02 ix1617 (.Y (nx1618), .A (nx1804)) ;
    buf02 ix1619 (.Y (nx1620), .A (nx1106)) ;
    buf02 ix1625 (.Y (nx1626), .A (nx1122)) ;
    buf02 ix1627 (.Y (nx1628), .A (nx1130)) ;
    buf02 ix1633 (.Y (nx1634), .A (nx1147)) ;
    buf02 ix1637 (.Y (nx1638), .A (nx1153)) ;
    buf02 ix1639 (.Y (nx1640), .A (nx1160)) ;
    buf02 ix1645 (.Y (nx1646), .A (nx1174)) ;
    buf02 ix1649 (.Y (nx1650), .A (nx1180)) ;
    buf02 ix1651 (.Y (nx1652), .A (nx1187)) ;
    buf02 ix1653 (.Y (nx1654), .A (nx1198)) ;
    buf02 ix1657 (.Y (nx1658), .A (nx1207)) ;
    buf02 ix1659 (.Y (nx1660), .A (nx1214)) ;
    buf02 ix1661 (.Y (nx1662), .A (nx1266)) ;
    buf02 ix1663 (.Y (nx1664), .A (nx1268)) ;
    buf02 ix1667 (.Y (nx1668), .A (nx1290)) ;
    buf02 ix1669 (.Y (nx1670), .A (nx1292)) ;
    buf02 ix1671 (.Y (nx1672), .A (nx1301)) ;
    buf02 ix1673 (.Y (nx1674), .A (nx1306)) ;
    buf02 ix1675 (.Y (nx1676), .A (nx1317)) ;
    buf02 ix1677 (.Y (nx1678), .A (nx1319)) ;
    buf02 ix1679 (.Y (nx1680), .A (nx1326)) ;
    buf02 ix1681 (.Y (nx1682), .A (nx1339)) ;
    buf02 ix1683 (.Y (nx1684), .A (nx1341)) ;
    buf02 ix1685 (.Y (nx1686), .A (nx1350)) ;
    buf02 ix1687 (.Y (nx1688), .A (nx1362)) ;
    buf02 ix1689 (.Y (nx1690), .A (nx1372)) ;
    buf02 ix1691 (.Y (nx1692), .A (nx1374)) ;
    buf02 ix1693 (.Y (nx1694), .A (nx1396)) ;
    buf02 ix1699 (.Y (nx1700), .A (nx1720)) ;
    buf02 ix1701 (.Y (nx1702), .A (nx1722)) ;
    buf02 ix1703 (.Y (nx1704), .A (nx1724)) ;
    buf02 ix1705 (.Y (nx1706), .A (nx1726)) ;
    buf02 ix1707 (.Y (nx1708), .A (nx1728)) ;
    buf02 ix1709 (.Y (nx1710), .A (nx1730)) ;
    buf02 ix1711 (.Y (nx1712), .A (nx1732)) ;
    buf02 ix1713 (.Y (nx1714), .A (nx1734)) ;
    buf02 ix1719 (.Y (nx1720), .A (nx1740)) ;
    buf02 ix1721 (.Y (nx1722), .A (nx1742)) ;
    buf02 ix1723 (.Y (nx1724), .A (nx1744)) ;
    buf02 ix1725 (.Y (nx1726), .A (nx1746)) ;
    buf02 ix1727 (.Y (nx1728), .A (nx1748)) ;
    buf02 ix1729 (.Y (nx1730), .A (nx1750)) ;
    buf02 ix1731 (.Y (nx1732), .A (nx1752)) ;
    buf02 ix1733 (.Y (nx1734), .A (nx1754)) ;
    buf02 ix1739 (.Y (nx1740), .A (nx1760)) ;
    buf02 ix1741 (.Y (nx1742), .A (nx1762)) ;
    buf02 ix1743 (.Y (nx1744), .A (nx1764)) ;
    buf02 ix1745 (.Y (nx1746), .A (nx1766)) ;
    buf02 ix1747 (.Y (nx1748), .A (nx1768)) ;
    buf02 ix1749 (.Y (nx1750), .A (nx1770)) ;
    buf02 ix1751 (.Y (nx1752), .A (nx1772)) ;
    buf02 ix1753 (.Y (nx1754), .A (nx1774)) ;
    buf02 ix1759 (.Y (nx1760), .A (nx1780)) ;
    buf02 ix1761 (.Y (nx1762), .A (nx1782)) ;
    buf02 ix1763 (.Y (nx1764), .A (nx1784)) ;
    buf02 ix1765 (.Y (nx1766), .A (nx1786)) ;
    buf02 ix1767 (.Y (nx1768), .A (nx1788)) ;
    buf02 ix1769 (.Y (nx1770), .A (nx1790)) ;
    buf02 ix1771 (.Y (nx1772), .A (nx1792)) ;
    buf02 ix1773 (.Y (nx1774), .A (nx1794)) ;
    buf02 ix1779 (.Y (nx1780), .A (nx1826)) ;
    buf02 ix1781 (.Y (nx1782), .A (nx1828)) ;
    buf02 ix1783 (.Y (nx1784), .A (nx1830)) ;
    buf02 ix1785 (.Y (nx1786), .A (nx1832)) ;
    buf02 ix1787 (.Y (nx1788), .A (nx1834)) ;
    buf02 ix1789 (.Y (nx1790), .A (nx1836)) ;
    buf02 ix1791 (.Y (nx1792), .A (nx1838)) ;
    buf02 ix1793 (.Y (nx1794), .A (nx1840)) ;
    xor2 ix651 (.Y (nx650), .A0 (nx624), .A1 (nx1540)) ;
    ao32 ix962 (.Y (nx624), .A0 (nx1502), .A1 (SUB_PRODUCT_7_), .A2 (nx1468), .B0 (
         nx598), .B1 (nx1534)) ;
    and02 ix335 (.Y (nx334), .A0 (nx172), .A1 (nx1890)) ;
    mux21 ix1058 (.Y (nx1057), .A0 (ACC[7]), .A1 (SUB_PRODUCT_15_), .S0 (nx44)
          ) ;
    or03 ix675 (.Y (nx730), .A0 (nx731), .A1 (nx1902), .A2 (nx1894)) ;
    mux21 ix1088 (.Y (nx1087), .A0 (ACC[0]), .A1 (SUB_PRODUCT_8_), .S0 (nx44)) ;
    oai21 ix1097 (.Y (nx1096), .A0 (nx1894), .A1 (nx1902), .B0 (nx731)) ;
    mux21 ix1107 (.Y (nx1106), .A0 (ACC[1]), .A1 (SUB_PRODUCT_9_), .S0 (nx44)) ;
    xor2 ix707 (.Y (nx706), .A0 (nx688), .A1 (nx1548)) ;
    ao32 ix1113 (.Y (nx688), .A0 (nx1538), .A1 (SUB_PRODUCT_8_), .A2 (nx1464), .B0 (
         nx624), .B1 (nx1540)) ;
    ao32 ix1120 (.Y (nx598), .A0 (nx1506), .A1 (SUB_PRODUCT_6_), .A2 (nx1466), .B0 (
         nx572), .B1 (nx1532)) ;
    xor2 ix575 (.Y (nx574), .A0 (nx572), .A1 (nx1532)) ;
    ao32 ix1134 (.Y (nx572), .A0 (nx1510), .A1 (SUB_PRODUCT_5_), .A2 (nx1466), .B0 (
         nx546), .B1 (nx1530)) ;
    and02 ix373 (.Y (nx372), .A0 (nx1892), .A1 (nx1890)) ;
    ao22 ix1137 (.Y (nx140), .A0 (nx110), .A1 (nx52), .B0 (nx1808), .B1 (nx1474)
         ) ;
    xor2 ix549 (.Y (nx548), .A0 (nx546), .A1 (nx1530)) ;
    ao32 ix1151 (.Y (nx546), .A0 (nx1512), .A1 (SUB_PRODUCT_4_), .A2 (nx1466), .B0 (
         nx520), .B1 (nx1528)) ;
    xor2 ix523 (.Y (nx522), .A0 (nx520), .A1 (nx1528)) ;
    ao32 ix1165 (.Y (nx520), .A0 (nx1514), .A1 (SUB_PRODUCT_3_), .A2 (nx1466), .B0 (
         nx494), .B1 (nx1526)) ;
    and02 ix389 (.Y (nx388), .A0 (nx300), .A1 (nx1890)) ;
    xor2 ix497 (.Y (nx496), .A0 (nx494), .A1 (nx1526)) ;
    ao32 ix1178 (.Y (nx494), .A0 (nx1516), .A1 (SUB_PRODUCT_2_), .A2 (nx1464), .B0 (
         nx1522), .B1 (nx1524)) ;
    ao21 ix419 (.Y (nx418), .A0 (nx318), .A1 (nx1890), .B0 (nx1800)) ;
    inv02 ix1799 (.Y (nx1800), .A (nx1196)) ;
    xor2 ix445 (.Y (nx444), .A0 (nx1900), .A1 (nx1658)) ;
    nand03 ix443 (.Y (nx1191), .A0 (nx1800), .A1 (nx318), .A2 (nx1890)) ;
    and02 ix1251 (.Y (nx52), .A0 (nx1812), .A1 (nx991)) ;
    mux21 ix1269 (.Y (nx1268), .A0 (ACC[2]), .A1 (SUB_PRODUCT_10_), .S0 (nx44)
          ) ;
    xor2 ix765 (.Y (nx764), .A0 (nx750), .A1 (nx1552)) ;
    ao32 ix1275 (.Y (nx750), .A0 (nx1546), .A1 (SUB_PRODUCT_9_), .A2 (nx1466), .B0 (
         nx688), .B1 (nx1548)) ;
    xor2 ix1291 (.Y (nx1290), .A0 (nx1670), .A1 (nx1288)) ;
    mux21 ix1293 (.Y (nx1292), .A0 (ACC[3]), .A1 (SUB_PRODUCT_11_), .S0 (nx44)
          ) ;
    nand02 ix305 (.Y (nx1288), .A0 (nx300), .A1 (nx1083)) ;
    mux21 ix1320 (.Y (nx1319), .A0 (ACC[4]), .A1 (SUB_PRODUCT_12_), .S0 (nx44)
          ) ;
    xor2 ix1340 (.Y (nx1339), .A0 (nx1684), .A1 (nx1337)) ;
    mux21 ix1342 (.Y (nx1341), .A0 (ACC[5]), .A1 (SUB_PRODUCT_13_), .S0 (nx44)
          ) ;
    nand02 ix1025 (.Y (nx1337), .A0 (nx1892), .A1 (nx1083)) ;
    mux21 ix1375 (.Y (nx1374), .A0 (ACC[6]), .A1 (SUB_PRODUCT_14_), .S0 (nx44)
          ) ;
    and02 ix249 (.Y (nx248), .A0 (nx172), .A1 (nx1083)) ;
    xor2 ix1403 (.Y (nx1402), .A0 (nx172), .A1 (nx1608)) ;
    and02 ix949 (.Y (nx948), .A0 (nx318), .A1 (nx1896)) ;
    xor2 ix1420 (.Y (nx1419), .A0 (nx300), .A1 (nx1670)) ;
    xor2 ix1424 (.Y (nx1423), .A0 (nx1892), .A1 (nx1684)) ;
    xor2 ix601 (.Y (nx600), .A0 (nx598), .A1 (nx1534)) ;
    inv02 ix1801 (.Y (nx1802), .A (nx1101)) ;
    inv02 ix1803 (.Y (nx1804), .A (nx1101)) ;
    inv04 ix1805 (.Y (nx1806), .A (nx991)) ;
    inv04 ix1807 (.Y (nx1808), .A (nx991)) ;
    inv04 ix1809 (.Y (nx1810), .A (nx987)) ;
    inv04 ix1811 (.Y (nx1812), .A (nx987)) ;
    inv04 ix1813 (.Y (nx1814), .A (nx1003)) ;
    inv04 ix1815 (.Y (nx1816), .A (nx1003)) ;
    buf02 ix1817 (.Y (nx1818), .A (MULNDIV)) ;
    buf02 ix1819 (.Y (nx1820), .A (MULNDIV)) ;
    buf02 ix1821 (.Y (nx1822), .A (MULNDIV)) ;
    buf02 ix1823 (.Y (nx1824), .A (MULNDIV)) ;
    buf02 ix1825 (.Y (nx1826), .A (nx1842)) ;
    buf02 ix1827 (.Y (nx1828), .A (nx1844)) ;
    buf02 ix1829 (.Y (nx1830), .A (nx1846)) ;
    buf02 ix1831 (.Y (nx1832), .A (nx1848)) ;
    buf02 ix1833 (.Y (nx1834), .A (nx1850)) ;
    buf02 ix1835 (.Y (nx1836), .A (nx1852)) ;
    buf02 ix1837 (.Y (nx1838), .A (nx1854)) ;
    buf02 ix1839 (.Y (nx1840), .A (nx1856)) ;
    buf02 ix1841 (.Y (nx1842), .A (nx1858)) ;
    buf02 ix1843 (.Y (nx1844), .A (nx1860)) ;
    buf02 ix1845 (.Y (nx1846), .A (nx1862)) ;
    buf02 ix1847 (.Y (nx1848), .A (nx1864)) ;
    buf02 ix1849 (.Y (nx1850), .A (nx1866)) ;
    buf02 ix1851 (.Y (nx1852), .A (nx1868)) ;
    buf02 ix1853 (.Y (nx1854), .A (nx1870)) ;
    buf02 ix1855 (.Y (nx1856), .A (nx1872)) ;
    buf02 ix1857 (.Y (nx1858), .A (nx1874)) ;
    buf02 ix1859 (.Y (nx1860), .A (nx1876)) ;
    buf02 ix1861 (.Y (nx1862), .A (nx1878)) ;
    buf02 ix1863 (.Y (nx1864), .A (nx1880)) ;
    buf02 ix1865 (.Y (nx1866), .A (nx1882)) ;
    buf02 ix1867 (.Y (nx1868), .A (nx1884)) ;
    buf02 ix1869 (.Y (nx1870), .A (nx1886)) ;
    buf02 ix1871 (.Y (nx1872), .A (nx1888)) ;
    buf02 ix1873 (.Y (nx1874), .A (nx1908)) ;
    buf02 ix1875 (.Y (nx1876), .A (nx1910)) ;
    buf02 ix1877 (.Y (nx1878), .A (nx1912)) ;
    buf02 ix1879 (.Y (nx1880), .A (nx1914)) ;
    buf02 ix1881 (.Y (nx1882), .A (nx1916)) ;
    buf02 ix1883 (.Y (nx1884), .A (nx1918)) ;
    buf02 ix1885 (.Y (nx1886), .A (nx1920)) ;
    buf02 ix1887 (.Y (nx1888), .A (nx1922)) ;
    inv02 ix1889 (.Y (nx1890), .A (nx979)) ;
    buf02 ix1891 (.Y (nx1892), .A (nx140)) ;
    inv02 ix1893 (.Y (nx1894), .A (nx1083)) ;
    inv02 ix1895 (.Y (nx1896), .A (nx731)) ;
    buf02 ix1897 (.Y (nx1898), .A (nx1096)) ;
    buf02 ix1899 (.Y (nx1900), .A (nx1191)) ;
    inv02 ix1901 (.Y (nx1902), .A (nx318)) ;
    buf02 ix1907 (.Y (nx1908), .A (nx1928)) ;
    buf02 ix1909 (.Y (nx1910), .A (nx1930)) ;
    buf02 ix1911 (.Y (nx1912), .A (nx1932)) ;
    buf02 ix1913 (.Y (nx1914), .A (nx1934)) ;
    buf02 ix1915 (.Y (nx1916), .A (nx1936)) ;
    buf02 ix1917 (.Y (nx1918), .A (nx1938)) ;
    buf02 ix1919 (.Y (nx1920), .A (nx1940)) ;
    buf02 ix1921 (.Y (nx1922), .A (nx1942)) ;
    buf02 ix1927 (.Y (nx1928), .A (nx1948)) ;
    buf02 ix1929 (.Y (nx1930), .A (nx1950)) ;
    buf02 ix1931 (.Y (nx1932), .A (nx1952)) ;
    buf02 ix1933 (.Y (nx1934), .A (nx1954)) ;
    buf02 ix1935 (.Y (nx1936), .A (nx1956)) ;
    buf02 ix1937 (.Y (nx1938), .A (nx1958)) ;
    buf02 ix1939 (.Y (nx1940), .A (nx1960)) ;
    buf02 ix1941 (.Y (nx1942), .A (nx1962)) ;
    buf02 ix1947 (.Y (nx1948), .A (nx1968)) ;
    buf02 ix1949 (.Y (nx1950), .A (nx1970)) ;
    buf02 ix1951 (.Y (nx1952), .A (nx1972)) ;
    buf02 ix1953 (.Y (nx1954), .A (nx1974)) ;
    buf02 ix1955 (.Y (nx1956), .A (nx1976)) ;
    buf02 ix1957 (.Y (nx1958), .A (nx1978)) ;
    buf02 ix1959 (.Y (nx1960), .A (nx1980)) ;
    buf02 ix1961 (.Y (nx1962), .A (nx1982)) ;
    buf02 ix1967 (.Y (nx1968), .A (nx1988)) ;
    buf02 ix1969 (.Y (nx1970), .A (nx1990)) ;
    buf02 ix1971 (.Y (nx1972), .A (nx1992)) ;
    buf02 ix1973 (.Y (nx1974), .A (nx1994)) ;
    buf02 ix1975 (.Y (nx1976), .A (nx1996)) ;
    buf02 ix1977 (.Y (nx1978), .A (nx1998)) ;
    buf02 ix1979 (.Y (nx1980), .A (nx2000)) ;
    buf02 ix1981 (.Y (nx1982), .A (nx2002)) ;
    buf02 ix1987 (.Y (nx1988), .A (nx2008)) ;
    buf02 ix1989 (.Y (nx1990), .A (nx2010)) ;
    buf02 ix1991 (.Y (nx1992), .A (nx2012)) ;
    buf02 ix1993 (.Y (nx1994), .A (nx2014)) ;
    buf02 ix1995 (.Y (nx1996), .A (nx2016)) ;
    buf02 ix1997 (.Y (nx1998), .A (nx2018)) ;
    buf02 ix1999 (.Y (nx2000), .A (nx2020)) ;
    buf02 ix2001 (.Y (nx2002), .A (nx2022)) ;
    buf02 ix2007 (.Y (nx2008), .A (RESULT_A[7])) ;
    buf02 ix2009 (.Y (nx2010), .A (RESULT_A[6])) ;
    buf02 ix2011 (.Y (nx2012), .A (RESULT_A[5])) ;
    buf02 ix2013 (.Y (nx2014), .A (RESULT_A[4])) ;
    buf02 ix2015 (.Y (nx2016), .A (RESULT_A[3])) ;
    buf02 ix2017 (.Y (nx2018), .A (RESULT_A[2])) ;
    buf02 ix2019 (.Y (nx2020), .A (RESULT_A[1])) ;
    buf02 ix2021 (.Y (nx2022), .A (RESULT_A[0])) ;
endmodule


module block03 ( REG_RESULT, ACC_RESULT, B_RESULT, CARRY_RESULT, 
                  AUX_CARRY_RESULT, OVERFLOW_RESULT, CONDITION_MET, OPERAND_A, 
                  OPERAND_B, SAVE_ADDR, XRAMDI, PROGDI, MULDIV_A, MULDIV_B, 
                  MULDIV_OV, CARRY_FLAG, ALU_CON, OPCODE, BIT_ADDRESS ) ;

    output [7:0]REG_RESULT ;
    output [7:0]ACC_RESULT ;
    output [7:0]B_RESULT ;
    output CARRY_RESULT ;
    output AUX_CARRY_RESULT ;
    output OVERFLOW_RESULT ;
    output CONDITION_MET ;
    input [7:0]OPERAND_A ;
    input [7:0]OPERAND_B ;
    input [7:0]SAVE_ADDR ;
    input [7:0]XRAMDI ;
    input [7:0]PROGDI ;
    input [7:0]MULDIV_A ;
    input [7:0]MULDIV_B ;
    input MULDIV_OV ;
    input CARRY_FLAG ;
    input [18:0]ALU_CON ;
    input [7:4]OPCODE ;
    input [2:0]BIT_ADDRESS ;

    wire CARRY_4, CARRY_IN, CARRY_ENABLE, ALU_SUM_7_, ALU_SUM_6_, ALU_SUM_5_, 
         ALU_SUM_4_, ALU_SUM_3_, ALU_SUM_2_, ALU_SUM_1_, ALU_SUM_0_, ALU_PROP_7_, 
         ALU_PROP_6_, ALU_PROP_5_, ALU_PROP_4_, ALU_PROP_3_, ALU_PROP_2_, 
         ALU_PROP_1_, ALU_PROP_0_, ALU_GEN_7_, ALU_GEN_6_, ALU_GEN_5_, 
         ALU_GEN_4_, ALU_GEN_3_, ALU_GEN_2_, ALU_GEN_1_, ALU_GEN_0_, nx2, nx8, 
         nx22, nx36, nx82, nx106, nx116, nx122, nx126, nx132, nx136, nx152, 
         nx154, nx160, nx166, nx194, nx202, nx222, nx230, nx250, nx258, nx278, 
         nx286, nx306, nx314, nx334, nx342, nx354, nx362, nx370, nx374, nx378, 
         nx386, nx390, nx394, nx398, nx408, nx430, nx440, nx454, nx472, nx480, 
         nx482, nx486, nx496, nx504, nx516, nx522, nx530, nx538, nx742, nx748, 
         nx796, nx808, nx824, nx834, nx838, nx848, nx868, nx876, nx878, nx882, 
         nx885, nx887, nx889, nx892, nx895, nx897, nx899, nx901, nx904, nx908, 
         nx910, nx912, nx914, nx919, nx927, nx929, nx932, nx934, nx936, nx938, 
         nx940, nx942, nx945, nx947, nx951, nx956, nx958, nx962, nx978, nx980, 
         nx987, nx993, nx995, nx1002, nx1008, nx1015, nx1021, nx1025, nx1029, 
         nx1031, nx1033, nx1037, nx1039, nx1046, nx1052, nx1055, nx1058, nx1060, 
         nx1062, nx1069, nx1071, nx1073, nx1075, nx1078, nx1080, nx1082, nx1084, 
         nx1087, nx1089, nx1091, nx1093, nx1096, nx1098, nx1100, nx1102, nx1105, 
         nx1107, nx1109, nx1111, nx1114, nx1116, nx1118, nx1120, nx1129, nx1131, 
         nx1133, nx1135, nx1137, nx1139, nx1141, nx1143, nx1145, nx1147, nx1149, 
         nx1151, nx1153, nx1155, nx1157, nx1159, nx1161, nx1163, nx1165, nx1167, 
         nx1169, nx1171, nx1173, nx1175, nx1177, nx1179, nx1181, nx1183, nx1185, 
         nx1187, nx1189, nx1191, nx1193, nx1195, nx1197, nx1199, nx1201, nx1203, 
         nx1205, nx1207, nx1209, nx1211, nx1213, nx1215, nx1217, nx1219, nx1221, 
         nx1223, nx1225, nx1229, nx1231, nx1233, nx1235, nx1237, nx1239, nx1241, 
         nx1243, nx1245, nx1247, nx1249, nx1255, nx1257, nx1259, nx1261, nx1263, 
         nx1265, nx1267, nx1269, nx1271, nx1273, nx1275, nx1277, nx1279, nx1281, 
         nx1283, nx1285, nx1287, nx1289, nx1291, nx1293, nx1295, nx1297, nx1299, 
         nx1301, nx1303, nx1305, nx1307, nx1309, nx1315, nx1321, nx1327, nx1333, 
         nx1339, nx1345, nx1347, nx1349, nx1351, nx1353, nx1355, nx1357, nx1359, 
         nx1361, nx1363, nx1365, nx1367, nx1369, nx1371, nx1373;



    block01 u1 (.P (ALU_PROP_0_), .CO (ALU_GEN_0_), .ALU_CON ({nx1367,
             ALU_CON[4],ALU_CON[3],ALU_CON[2],ALU_CON[1],ALU_CON[0]}), .A (
             OPERAND_A[0]), .B (OPERAND_B[0])) ;
    block01 u2 (.P (ALU_PROP_1_), .CO (ALU_GEN_1_), .ALU_CON ({nx1367,
             ALU_CON[4],ALU_CON[3],ALU_CON[2],ALU_CON[1],ALU_CON[0]}), .A (
             OPERAND_A[1]), .B (OPERAND_B[1])) ;
    block01 u3 (.P (ALU_PROP_2_), .CO (ALU_GEN_2_), .ALU_CON ({nx1367,
             ALU_CON[4],ALU_CON[3],ALU_CON[2],ALU_CON[1],ALU_CON[0]}), .A (
             OPERAND_A[2]), .B (OPERAND_B[2])) ;
    block01 u4 (.P (ALU_PROP_3_), .CO (ALU_GEN_3_), .ALU_CON ({nx1367,
             ALU_CON[4],ALU_CON[3],ALU_CON[2],ALU_CON[1],ALU_CON[0]}), .A (
             OPERAND_A[3]), .B (OPERAND_B[3])) ;
    block01 u5 (.P (ALU_PROP_4_), .CO (ALU_GEN_4_), .ALU_CON ({nx1367,
             ALU_CON[4],ALU_CON[3],ALU_CON[2],ALU_CON[1],ALU_CON[0]}), .A (
             OPERAND_A[4]), .B (OPERAND_B[4])) ;
    block01 u6 (.P (ALU_PROP_5_), .CO (ALU_GEN_5_), .ALU_CON ({nx1367,
             ALU_CON[4],ALU_CON[3],ALU_CON[2],ALU_CON[1],ALU_CON[0]}), .A (
             OPERAND_A[5]), .B (OPERAND_B[5])) ;
    block01 u7 (.P (ALU_PROP_6_), .CO (ALU_GEN_6_), .ALU_CON ({nx1367,
             ALU_CON[4],ALU_CON[3],ALU_CON[2],ALU_CON[1],ALU_CON[0]}), .A (
             OPERAND_A[6]), .B (OPERAND_B[6])) ;
    block01 u8 (.P (ALU_PROP_7_), .CO (ALU_GEN_7_), .ALU_CON ({nx1367,
             ALU_CON[4],ALU_CON[3],ALU_CON[2],ALU_CON[1],ALU_CON[0]}), .A (
             OPERAND_A[7]), .B (OPERAND_B[7])) ;
    block02 u9 (.S ({ALU_SUM_3_,ALU_SUM_2_,ALU_SUM_1_,ALU_SUM_0_}), .P ({nx1143
             ,nx1145,nx1147,nx1149}), .G ({ALU_GEN_2_,ALU_GEN_1_,ALU_GEN_0_}), .C_IN (
             CARRY_IN), .C_EN (nx1133)) ;
    block02 u10 (.S ({ALU_SUM_7_,ALU_SUM_6_,ALU_SUM_5_,ALU_SUM_4_}), .P ({
             nx1135,nx1137,nx1139,nx1141}), .G ({ALU_GEN_6_,ALU_GEN_5_,
             ALU_GEN_4_}), .C_IN (nx1131), .C_EN (nx1133)) ;
    or02 ix783 (.Y (CARRY_ENABLE), .A0 (nx1367), .A1 (ALU_CON[4])) ;
    ao21 ix367 (.Y (CARRY_IN), .A0 (nx1367), .A1 (nx354), .B0 (nx1183)) ;
    nand02 ix355 (.Y (nx354), .A0 (CARRY_FLAG), .A1 (ALU_CON[10])) ;
    nor03 ix363 (.Y (nx362), .A0 (nx354), .A1 (nx868), .A2 (nx1369)) ;
    inv02 ix869 (.Y (nx868), .A (ALU_CON[4])) ;
    ao21 ix383 (.Y (CARRY_4), .A0 (nx1143), .A1 (nx378), .B0 (ALU_GEN_3_)) ;
    ao21 ix379 (.Y (nx378), .A0 (nx1145), .A1 (nx374), .B0 (ALU_GEN_2_)) ;
    ao21 ix375 (.Y (nx374), .A0 (nx1147), .A1 (nx370), .B0 (ALU_GEN_1_)) ;
    ao21 ix371 (.Y (nx370), .A0 (nx1149), .A1 (CARRY_IN), .B0 (ALU_GEN_0_)) ;
    ao21 ix841 (.Y (CONDITION_MET), .A0 (OPCODE[7]), .A1 (nx796), .B0 (nx838)) ;
    nand02 ix797 (.Y (nx796), .A0 (nx1207), .A1 (nx1209)) ;
    nor04 ix877 (.Y (nx876), .A0 (ALU_SUM_7_), .A1 (ALU_SUM_6_), .A2 (ALU_SUM_5_
          ), .A3 (ALU_SUM_4_)) ;
    nor04 ix879 (.Y (nx878), .A0 (ALU_SUM_3_), .A1 (ALU_SUM_2_), .A2 (ALU_SUM_1_
          ), .A3 (ALU_SUM_0_)) ;
    ao21 ix839 (.Y (nx838), .A0 (OPCODE[6]), .A1 (nx834), .B0 (nx1205)) ;
    ao32 ix835 (.Y (nx834), .A0 (nx796), .A1 (OPCODE[4]), .A2 (OPCODE[5]), .B0 (
         nx882), .B1 (nx824)) ;
    inv02 ix883 (.Y (nx882), .A (OPCODE[7])) ;
    oai22 ix825 (.Y (nx824), .A0 (nx796), .A1 (nx885), .B0 (OPCODE[5]), .B1 (
          nx889)) ;
    nand02 ix886 (.Y (nx885), .A0 (OPCODE[5]), .A1 (nx887)) ;
    inv02 ix888 (.Y (nx887), .A (OPCODE[4])) ;
    xnor2 ix890 (.Y (nx889), .A0 (OPCODE[4]), .A1 (CARRY_FLAG)) ;
    nor03 ix809 (.Y (nx808), .A0 (nx892), .A1 (OPCODE[6]), .A2 (OPCODE[7])) ;
    xor2 ix893 (.Y (nx892), .A0 (nx1161), .A1 (nx430)) ;
    oai21 ix83 (.Y (nx82), .A0 (BIT_ADDRESS[0]), .A1 (nx1211), .B0 (nx908)) ;
    aoi221 ix896 (.Y (nx895), .A0 (OPERAND_B[0]), .A1 (nx1213), .B0 (
           OPERAND_B[2]), .B1 (nx1373), .C0 (nx36)) ;
    nor02 ix898 (.Y (nx897), .A0 (BIT_ADDRESS[1]), .A1 (BIT_ADDRESS[2])) ;
    inv02 ix902 (.Y (nx901), .A (BIT_ADDRESS[1])) ;
    ao32 ix37 (.Y (nx36), .A0 (OPERAND_B[6]), .A1 (BIT_ADDRESS[1]), .A2 (
         BIT_ADDRESS[2]), .B0 (OPERAND_B[4]), .B1 (nx904)) ;
    ao21 ix909 (.Y (nx908), .A0 (nx1215), .A1 (nx1217), .B0 (nx914)) ;
    aoi22 ix911 (.Y (nx910), .A0 (OPERAND_B[1]), .A1 (nx1213), .B0 (OPERAND_B[3]
          ), .B1 (nx1373)) ;
    aoi32 ix913 (.Y (nx912), .A0 (OPERAND_B[7]), .A1 (BIT_ADDRESS[1]), .A2 (
          BIT_ADDRESS[2]), .B0 (OPERAND_B[5]), .B1 (nx904)) ;
    inv02 ix915 (.Y (nx914), .A (BIT_ADDRESS[0])) ;
    nand02 ix431 (.Y (nx430), .A0 (OPCODE[4]), .A1 (OPCODE[5])) ;
    ao21 ix853 (.Y (OVERFLOW_RESULT), .A0 (nx1361), .A1 (MULDIV_OV), .B0 (nx848)
         ) ;
    nor02 ix849 (.Y (nx848), .A0 (nx1361), .A1 (nx919)) ;
    xnor2 ix920 (.Y (nx919), .A0 (nx394), .A1 (nx1185)) ;
    ao21 ix395 (.Y (nx394), .A0 (nx1137), .A1 (nx390), .B0 (ALU_GEN_6_)) ;
    ao21 ix391 (.Y (nx390), .A0 (nx1139), .A1 (nx386), .B0 (ALU_GEN_5_)) ;
    ao21 ix387 (.Y (nx386), .A0 (nx1141), .A1 (nx1131), .B0 (ALU_GEN_4_)) ;
    ao21 ix399 (.Y (nx398), .A0 (nx1135), .A1 (nx394), .B0 (ALU_GEN_7_)) ;
    xor2 ix855 (.Y (AUX_CARRY_RESULT), .A0 (nx1131), .A1 (nx1369)) ;
    oai21 ix447 (.Y (CARRY_RESULT), .A0 (ALU_CON[18]), .A1 (nx927), .B0 (nx1219)
          ) ;
    xnor2 ix928 (.Y (nx927), .A0 (nx1185), .A1 (nx1369)) ;
    aoi22 ix930 (.Y (nx929), .A0 (ALU_CON[17]), .A1 (nx1187), .B0 (nx1163), .B1 (
          nx408)) ;
    oai21 ix441 (.Y (nx440), .A0 (nx932), .A1 (nx1221), .B0 (nx940)) ;
    inv02 ix933 (.Y (nx932), .A (ALU_CON[18])) ;
    aoi32 ix935 (.Y (nx934), .A0 (OPCODE[4]), .A1 (nx936), .A2 (OPERAND_A[0]), .B0 (
          OPERAND_A[7]), .B1 (nx938)) ;
    inv02 ix937 (.Y (nx936), .A (OPCODE[5])) ;
    ao21 ix941 (.Y (nx940), .A0 (OPCODE[4]), .A1 (ALU_CON[18]), .B0 (nx942)) ;
    inv02 ix943 (.Y (nx942), .A (CARRY_FLAG)) ;
    mux21 ix107 (.Y (nx106), .A0 (nx945), .A1 (nx947), .S0 (CARRY_FLAG)) ;
    mux21 ix946 (.Y (nx945), .A0 (ALU_CON[6]), .A1 (ALU_CON[7]), .S0 (nx1161)) ;
    mux21 ix948 (.Y (nx947), .A0 (ALU_CON[9]), .A1 (ALU_CON[8]), .S0 (nx1161)) ;
    nor02 ix409 (.Y (nx408), .A0 (nx932), .A1 (ALU_CON[17])) ;
    ao32 ix143 (.Y (B_RESULT[0]), .A0 (MULDIV_B[0]), .A1 (nx1361), .A2 (nx951), 
         .B0 (REG_RESULT[0]), .B1 (nx1151)) ;
    inv02 ix952 (.Y (nx951), .A (ALU_CON[15])) ;
    ao21 ix139 (.Y (REG_RESULT[0]), .A0 (nx1165), .A1 (nx1167), .B0 (nx136)) ;
    oai21 ix117 (.Y (nx116), .A0 (nx8), .A1 (nx1223), .B0 (nx1225)) ;
    nand02 ix957 (.Y (nx956), .A0 (nx1163), .A1 (nx958)) ;
    nor02 ix123 (.Y (nx122), .A0 (ALU_CON[15]), .A1 (nx1361)) ;
    ao32 ix137 (.Y (nx136), .A0 (SAVE_ADDR[0]), .A1 (ALU_CON[15]), .A2 (nx1361)
         , .B0 (OPERAND_A[0]), .B1 (nx1169)) ;
    nor02 ix133 (.Y (nx132), .A0 (nx951), .A1 (nx1361)) ;
    nand02 ix3 (.Y (nx2), .A0 (nx1361), .A1 (nx951)) ;
    ao32 ix181 (.Y (B_RESULT[1]), .A0 (MULDIV_B[1]), .A1 (nx1361), .A2 (nx951), 
         .B0 (nx1151), .B1 (nx1129)) ;
    nand03 ix155 (.Y (nx154), .A0 (ALU_CON[11]), .A1 (BIT_ADDRESS[0]), .A2 (
           nx1213)) ;
    nand02 ix153 (.Y (nx152), .A0 (ALU_CON[11]), .A1 (BIT_ADDRESS[0])) ;
    aoi22 ix981 (.Y (nx980), .A0 (OPERAND_A[1]), .A1 (nx1169), .B0 (SAVE_ADDR[1]
          ), .B1 (nx126)) ;
    and02 ix127 (.Y (nx126), .A0 (ALU_CON[15]), .A1 (nx1361)) ;
    ao32 ix209 (.Y (B_RESULT[2]), .A0 (MULDIV_B[2]), .A1 (nx1361), .A2 (nx951), 
         .B0 (nx1151), .B1 (REG_RESULT[2])) ;
    ao21 ix205 (.Y (REG_RESULT[2]), .A0 (nx1171), .A1 (nx1167), .B0 (nx202)) ;
    oai21 ix195 (.Y (nx194), .A0 (nx1159), .A1 (nx1223), .B0 (nx1231)) ;
    ao32 ix203 (.Y (nx202), .A0 (SAVE_ADDR[2]), .A1 (ALU_CON[15]), .A2 (nx1363)
         , .B0 (OPERAND_A[2]), .B1 (nx1169)) ;
    ao32 ix237 (.Y (B_RESULT[3]), .A0 (MULDIV_B[3]), .A1 (nx1363), .A2 (nx951), 
         .B0 (nx1151), .B1 (REG_RESULT[3])) ;
    ao21 ix233 (.Y (REG_RESULT[3]), .A0 (nx1173), .A1 (nx1167), .B0 (nx230)) ;
    nand03 ix994 (.Y (nx993), .A0 (nx1163), .A1 (ALU_CON[11]), .A2 (
           BIT_ADDRESS[0])) ;
    oai21 ix996 (.Y (nx995), .A0 (nx1159), .A1 (nx152), .B0 (ALU_SUM_3_)) ;
    ao32 ix231 (.Y (nx230), .A0 (SAVE_ADDR[3]), .A1 (ALU_CON[15]), .A2 (nx1363)
         , .B0 (OPERAND_A[3]), .B1 (nx1169)) ;
    ao32 ix265 (.Y (B_RESULT[4]), .A0 (MULDIV_B[4]), .A1 (nx1363), .A2 (nx951), 
         .B0 (nx1151), .B1 (REG_RESULT[4])) ;
    ao21 ix261 (.Y (REG_RESULT[4]), .A0 (nx1175), .A1 (nx1167), .B0 (nx258)) ;
    oai21 ix251 (.Y (nx250), .A0 (nx1157), .A1 (nx1223), .B0 (nx1237)) ;
    ao32 ix259 (.Y (nx258), .A0 (SAVE_ADDR[4]), .A1 (ALU_CON[15]), .A2 (nx1363)
         , .B0 (OPERAND_B[4]), .B1 (nx1169)) ;
    ao32 ix293 (.Y (B_RESULT[5]), .A0 (MULDIV_B[5]), .A1 (nx1363), .A2 (nx951), 
         .B0 (nx1151), .B1 (REG_RESULT[5])) ;
    ao21 ix289 (.Y (REG_RESULT[5]), .A0 (nx1177), .A1 (nx1167), .B0 (nx286)) ;
    oai21 ix1009 (.Y (nx1008), .A0 (nx1157), .A1 (nx152), .B0 (ALU_SUM_5_)) ;
    ao32 ix287 (.Y (nx286), .A0 (SAVE_ADDR[5]), .A1 (ALU_CON[15]), .A2 (nx1363)
         , .B0 (OPERAND_B[5]), .B1 (nx1169)) ;
    ao32 ix321 (.Y (B_RESULT[6]), .A0 (MULDIV_B[6]), .A1 (nx1363), .A2 (nx951), 
         .B0 (nx1151), .B1 (REG_RESULT[6])) ;
    ao21 ix317 (.Y (REG_RESULT[6]), .A0 (nx1179), .A1 (nx1167), .B0 (nx314)) ;
    oai21 ix307 (.Y (nx306), .A0 (nx1155), .A1 (nx1223), .B0 (nx1241)) ;
    nand02 ix23 (.Y (nx22), .A0 (BIT_ADDRESS[1]), .A1 (BIT_ADDRESS[2])) ;
    oai21 ix1016 (.Y (nx1015), .A0 (nx1155), .A1 (nx1153), .B0 (ALU_SUM_6_)) ;
    ao32 ix315 (.Y (nx314), .A0 (SAVE_ADDR[6]), .A1 (ALU_CON[15]), .A2 (nx1363)
         , .B0 (OPERAND_B[6]), .B1 (nx1169)) ;
    ao32 ix349 (.Y (B_RESULT[7]), .A0 (MULDIV_B[7]), .A1 (nx1365), .A2 (nx951), 
         .B0 (nx1151), .B1 (REG_RESULT[7])) ;
    ao21 ix345 (.Y (REG_RESULT[7]), .A0 (nx1181), .A1 (nx1167), .B0 (nx342)) ;
    oai21 ix335 (.Y (nx334), .A0 (nx1155), .A1 (nx1233), .B0 (nx1243)) ;
    oai21 ix1022 (.Y (nx1021), .A0 (nx1155), .A1 (nx152), .B0 (ALU_SUM_7_)) ;
    ao32 ix343 (.Y (nx342), .A0 (SAVE_ADDR[7]), .A1 (ALU_CON[15]), .A2 (nx1365)
         , .B0 (OPERAND_B[7]), .B1 (nx1169)) ;
    nand03 ix547 (.Y (ACC_RESULT[0]), .A0 (nx1245), .A1 (nx1247), .A2 (nx1249)
           ) ;
    aoi22 ix1026 (.Y (nx1025), .A0 (XRAMDI[0]), .A1 (nx1201), .B0 (OPERAND_A[1])
          , .B1 (nx1203)) ;
    and03 ix531 (.Y (nx530), .A0 (ALU_CON[12]), .A1 (ALU_CON[14]), .A2 (
          ALU_CON[13])) ;
    nor04 ix539 (.Y (nx538), .A0 (nx1029), .A1 (ALU_CON[12]), .A2 (nx1031), .A3 (
          OPCODE[5])) ;
    inv02 ix1030 (.Y (nx1029), .A (ALU_CON[14])) ;
    inv02 ix1032 (.Y (nx1031), .A (ALU_CON[13])) ;
    aoi22 ix1034 (.Y (nx1033), .A0 (MULDIV_A[0]), .A1 (nx1199), .B0 (
          OPERAND_A[4]), .B1 (nx1197)) ;
    nor03 ix523 (.Y (nx522), .A0 (ALU_CON[13]), .A1 (nx1029), .A2 (ALU_CON[12])
          ) ;
    nor03 ix517 (.Y (nx516), .A0 (nx1037), .A1 (ALU_CON[14]), .A2 (nx1031)) ;
    inv02 ix1038 (.Y (nx1037), .A (ALU_CON[12])) ;
    aoi221 ix1040 (.Y (nx1039), .A0 (PROGDI[0]), .A1 (nx1195), .B0 (nx1165), .B1 (
           nx1193), .C0 (nx486)) ;
    nor03 ix505 (.Y (nx504), .A0 (nx1037), .A1 (nx1029), .A2 (ALU_CON[13])) ;
    nor03 ix497 (.Y (nx496), .A0 (ALU_CON[12]), .A1 (ALU_CON[14]), .A2 (
          ALU_CON[13])) ;
    nor02 ix1047 (.Y (nx1046), .A0 (nx1191), .A1 (nx1189)) ;
    nor03 ix481 (.Y (nx480), .A0 (nx1037), .A1 (ALU_CON[14]), .A2 (ALU_CON[13])
          ) ;
    nor03 ix473 (.Y (nx472), .A0 (ALU_CON[12]), .A1 (ALU_CON[14]), .A2 (nx1031)
          ) ;
    mux21 ix1053 (.Y (nx1052), .A0 (OPERAND_A[7]), .A1 (CARRY_FLAG), .S0 (
          OPCODE[4])) ;
    nand04 ix577 (.Y (ACC_RESULT[1]), .A0 (nx1255), .A1 (nx1257), .A2 (nx1259), 
           .A3 (nx1261)) ;
    aoi22 ix1056 (.Y (nx1055), .A0 (OPERAND_A[2]), .A1 (nx1203), .B0 (
          OPERAND_A[0]), .B1 (nx1371)) ;
    aoi22 ix1059 (.Y (nx1058), .A0 (MULDIV_A[1]), .A1 (nx1199), .B0 (XRAMDI[1])
          , .B1 (nx1201)) ;
    aoi22 ix1061 (.Y (nx1060), .A0 (OPERAND_A[5]), .A1 (nx1197), .B0 (PROGDI[1])
          , .B1 (nx1195)) ;
    aoi22 ix1063 (.Y (nx1062), .A0 (OPERAND_B[1]), .A1 (nx482), .B0 (nx166), .B1 (
          nx1193)) ;
    nand04 ix607 (.Y (ACC_RESULT[2]), .A0 (nx1263), .A1 (nx1265), .A2 (nx1267), 
           .A3 (nx1269)) ;
    aoi22 ix1070 (.Y (nx1069), .A0 (OPERAND_A[3]), .A1 (nx1203), .B0 (
          OPERAND_A[1]), .B1 (nx1371)) ;
    aoi22 ix1072 (.Y (nx1071), .A0 (MULDIV_A[2]), .A1 (nx1199), .B0 (XRAMDI[2])
          , .B1 (nx1201)) ;
    aoi22 ix1074 (.Y (nx1073), .A0 (OPERAND_A[6]), .A1 (nx1197), .B0 (PROGDI[2])
          , .B1 (nx1195)) ;
    aoi22 ix1076 (.Y (nx1075), .A0 (OPERAND_B[2]), .A1 (nx482), .B0 (nx1171), .B1 (
          nx1193)) ;
    nand04 ix637 (.Y (ACC_RESULT[3]), .A0 (nx1271), .A1 (nx1273), .A2 (nx1275), 
           .A3 (nx1277)) ;
    aoi22 ix1079 (.Y (nx1078), .A0 (OPERAND_A[4]), .A1 (nx1203), .B0 (
          OPERAND_A[2]), .B1 (nx1371)) ;
    aoi22 ix1081 (.Y (nx1080), .A0 (MULDIV_A[3]), .A1 (nx1199), .B0 (XRAMDI[3])
          , .B1 (nx1201)) ;
    aoi22 ix1083 (.Y (nx1082), .A0 (OPERAND_A[7]), .A1 (nx1197), .B0 (PROGDI[3])
          , .B1 (nx1195)) ;
    aoi22 ix1085 (.Y (nx1084), .A0 (OPERAND_B[3]), .A1 (nx482), .B0 (nx1173), .B1 (
          nx1193)) ;
    nand04 ix671 (.Y (ACC_RESULT[4]), .A0 (nx1279), .A1 (nx1281), .A2 (nx1283), 
           .A3 (nx1285)) ;
    aoi22 ix1088 (.Y (nx1087), .A0 (OPERAND_A[5]), .A1 (nx1203), .B0 (
          OPERAND_A[3]), .B1 (nx1371)) ;
    aoi22 ix1090 (.Y (nx1089), .A0 (MULDIV_A[4]), .A1 (nx1199), .B0 (XRAMDI[4])
          , .B1 (nx1201)) ;
    aoi22 ix1092 (.Y (nx1091), .A0 (OPERAND_A[0]), .A1 (nx1197), .B0 (PROGDI[4])
          , .B1 (nx1195)) ;
    aoi222 ix1094 (.Y (nx1093), .A0 (OPERAND_A[4]), .A1 (nx1189), .B0 (
           OPERAND_B[4]), .B1 (nx1191), .C0 (nx1175), .C1 (nx1193)) ;
    nand04 ix705 (.Y (ACC_RESULT[5]), .A0 (nx1287), .A1 (nx1289), .A2 (nx1291), 
           .A3 (nx1293)) ;
    aoi22 ix1097 (.Y (nx1096), .A0 (OPERAND_A[6]), .A1 (nx1203), .B0 (
          OPERAND_A[4]), .B1 (nx1371)) ;
    aoi22 ix1099 (.Y (nx1098), .A0 (MULDIV_A[5]), .A1 (nx1199), .B0 (XRAMDI[5])
          , .B1 (nx1201)) ;
    aoi22 ix1101 (.Y (nx1100), .A0 (OPERAND_A[1]), .A1 (nx1197), .B0 (PROGDI[5])
          , .B1 (nx1195)) ;
    aoi222 ix1103 (.Y (nx1102), .A0 (OPERAND_A[5]), .A1 (nx1189), .B0 (
           OPERAND_B[5]), .B1 (nx1191), .C0 (nx1177), .C1 (nx1193)) ;
    nand04 ix739 (.Y (ACC_RESULT[6]), .A0 (nx1295), .A1 (nx1297), .A2 (nx1299), 
           .A3 (nx1301)) ;
    aoi22 ix1106 (.Y (nx1105), .A0 (OPERAND_A[7]), .A1 (nx1203), .B0 (
          OPERAND_A[5]), .B1 (nx1371)) ;
    aoi22 ix1108 (.Y (nx1107), .A0 (MULDIV_A[6]), .A1 (nx1199), .B0 (XRAMDI[6])
          , .B1 (nx1201)) ;
    aoi22 ix1110 (.Y (nx1109), .A0 (OPERAND_A[2]), .A1 (nx1197), .B0 (PROGDI[6])
          , .B1 (nx1195)) ;
    aoi222 ix1112 (.Y (nx1111), .A0 (OPERAND_A[6]), .A1 (nx1189), .B0 (
           OPERAND_B[6]), .B1 (nx1191), .C0 (nx1179), .C1 (nx1193)) ;
    nand04 ix781 (.Y (ACC_RESULT[7]), .A0 (nx1303), .A1 (nx1305), .A2 (nx1307), 
           .A3 (nx1309)) ;
    aoi22 ix1115 (.Y (nx1114), .A0 (XRAMDI[7]), .A1 (nx1201), .B0 (OPERAND_A[6])
          , .B1 (nx1371)) ;
    aoi22 ix1117 (.Y (nx1116), .A0 (MULDIV_A[7]), .A1 (nx1199), .B0 (
          OPERAND_A[3]), .B1 (nx1197)) ;
    aoi22 ix1119 (.Y (nx1118), .A0 (PROGDI[7]), .A1 (nx1195), .B0 (nx1181), .B1 (
          nx1193)) ;
    aoi222 ix1121 (.Y (nx1120), .A0 (OPERAND_A[7]), .A1 (nx1189), .B0 (
           OPERAND_B[7]), .B1 (nx1191), .C0 (nx1203), .C1 (nx748)) ;
    ao21 ix750 (.Y (nx748), .A0 (OPERAND_A[0]), .A1 (nx887), .B0 (nx742)) ;
    inv02 ix483 (.Y (nx482), .A (nx1046)) ;
    inv02 ix939 (.Y (nx938), .A (nx430)) ;
    inv02 ix161 (.Y (nx160), .A (nx993)) ;
    inv02 ix979 (.Y (nx978), .A (nx122)) ;
    inv02 ix9 (.Y (nx8), .A (nx897)) ;
    buf02 ix1128 (.Y (nx1129), .A (nx1315)) ;
    buf02 ix1130 (.Y (nx1131), .A (CARRY_4)) ;
    buf02 ix1132 (.Y (nx1133), .A (CARRY_ENABLE)) ;
    buf02 ix1134 (.Y (nx1135), .A (ALU_PROP_7_)) ;
    buf02 ix1136 (.Y (nx1137), .A (ALU_PROP_6_)) ;
    buf02 ix1138 (.Y (nx1139), .A (ALU_PROP_5_)) ;
    buf02 ix1140 (.Y (nx1141), .A (ALU_PROP_4_)) ;
    buf02 ix1142 (.Y (nx1143), .A (ALU_PROP_3_)) ;
    buf02 ix1144 (.Y (nx1145), .A (ALU_PROP_2_)) ;
    buf02 ix1146 (.Y (nx1147), .A (ALU_PROP_1_)) ;
    buf02 ix1148 (.Y (nx1149), .A (ALU_PROP_0_)) ;
    buf02 ix1150 (.Y (nx1151), .A (nx2)) ;
    inv02 ix1152 (.Y (nx1153), .A (nx958)) ;
    buf02 ix1154 (.Y (nx1155), .A (nx22)) ;
    inv02 ix1156 (.Y (nx1157), .A (nx904)) ;
    inv02 ix1158 (.Y (nx1159), .A (nx899)) ;
    buf02 ix1160 (.Y (nx1161), .A (nx82)) ;
    buf02 ix1162 (.Y (nx1163), .A (nx106)) ;
    buf02 ix1164 (.Y (nx1165), .A (nx116)) ;
    inv02 ix1166 (.Y (nx1167), .A (nx978)) ;
    buf02 ix1168 (.Y (nx1169), .A (nx132)) ;
    buf02 ix1170 (.Y (nx1171), .A (nx194)) ;
    buf02 ix1172 (.Y (nx1173), .A (nx222)) ;
    buf02 ix1174 (.Y (nx1175), .A (nx250)) ;
    buf02 ix1176 (.Y (nx1177), .A (nx278)) ;
    buf02 ix1178 (.Y (nx1179), .A (nx306)) ;
    buf02 ix1180 (.Y (nx1181), .A (nx334)) ;
    buf02 ix1182 (.Y (nx1183), .A (nx362)) ;
    buf02 ix1184 (.Y (nx1185), .A (nx398)) ;
    buf02 ix1186 (.Y (nx1187), .A (nx440)) ;
    buf02 ix1188 (.Y (nx1189), .A (nx472)) ;
    buf02 ix1190 (.Y (nx1191), .A (nx480)) ;
    buf02 ix1192 (.Y (nx1193), .A (nx496)) ;
    buf02 ix1194 (.Y (nx1195), .A (nx504)) ;
    buf02 ix1196 (.Y (nx1197), .A (nx516)) ;
    buf02 ix1198 (.Y (nx1199), .A (nx522)) ;
    buf02 ix1200 (.Y (nx1201), .A (nx530)) ;
    buf02 ix1202 (.Y (nx1203), .A (nx538)) ;
    buf02 ix1204 (.Y (nx1205), .A (nx808)) ;
    buf02 ix1206 (.Y (nx1207), .A (nx876)) ;
    buf02 ix1208 (.Y (nx1209), .A (nx878)) ;
    buf02 ix1210 (.Y (nx1211), .A (nx895)) ;
    inv02 ix1212 (.Y (nx1213), .A (nx8)) ;
    buf02 ix1214 (.Y (nx1215), .A (nx910)) ;
    buf02 ix1216 (.Y (nx1217), .A (nx912)) ;
    buf02 ix1218 (.Y (nx1219), .A (nx929)) ;
    buf02 ix1220 (.Y (nx1221), .A (nx934)) ;
    buf02 ix1222 (.Y (nx1223), .A (nx956)) ;
    buf02 ix1224 (.Y (nx1225), .A (nx962)) ;
    buf02 ix1228 (.Y (nx1229), .A (nx980)) ;
    buf02 ix1230 (.Y (nx1231), .A (nx987)) ;
    inv02 ix1232 (.Y (nx1233), .A (nx160)) ;
    buf02 ix1234 (.Y (nx1235), .A (nx995)) ;
    buf02 ix1236 (.Y (nx1237), .A (nx1002)) ;
    buf02 ix1238 (.Y (nx1239), .A (nx1008)) ;
    buf02 ix1240 (.Y (nx1241), .A (nx1015)) ;
    buf02 ix1242 (.Y (nx1243), .A (nx1021)) ;
    buf02 ix1244 (.Y (nx1245), .A (nx1025)) ;
    buf02 ix1246 (.Y (nx1247), .A (nx1033)) ;
    buf02 ix1248 (.Y (nx1249), .A (nx1039)) ;
    buf02 ix1254 (.Y (nx1255), .A (nx1055)) ;
    buf02 ix1256 (.Y (nx1257), .A (nx1058)) ;
    buf02 ix1258 (.Y (nx1259), .A (nx1060)) ;
    buf02 ix1260 (.Y (nx1261), .A (nx1062)) ;
    buf02 ix1262 (.Y (nx1263), .A (nx1069)) ;
    buf02 ix1264 (.Y (nx1265), .A (nx1071)) ;
    buf02 ix1266 (.Y (nx1267), .A (nx1073)) ;
    buf02 ix1268 (.Y (nx1269), .A (nx1075)) ;
    buf02 ix1270 (.Y (nx1271), .A (nx1078)) ;
    buf02 ix1272 (.Y (nx1273), .A (nx1080)) ;
    buf02 ix1274 (.Y (nx1275), .A (nx1082)) ;
    buf02 ix1276 (.Y (nx1277), .A (nx1084)) ;
    buf02 ix1278 (.Y (nx1279), .A (nx1087)) ;
    buf02 ix1280 (.Y (nx1281), .A (nx1089)) ;
    buf02 ix1282 (.Y (nx1283), .A (nx1091)) ;
    buf02 ix1284 (.Y (nx1285), .A (nx1093)) ;
    buf02 ix1286 (.Y (nx1287), .A (nx1096)) ;
    buf02 ix1288 (.Y (nx1289), .A (nx1098)) ;
    buf02 ix1290 (.Y (nx1291), .A (nx1100)) ;
    buf02 ix1292 (.Y (nx1293), .A (nx1102)) ;
    buf02 ix1294 (.Y (nx1295), .A (nx1105)) ;
    buf02 ix1296 (.Y (nx1297), .A (nx1107)) ;
    buf02 ix1298 (.Y (nx1299), .A (nx1109)) ;
    buf02 ix1300 (.Y (nx1301), .A (nx1111)) ;
    buf02 ix1302 (.Y (nx1303), .A (nx1114)) ;
    buf02 ix1304 (.Y (nx1305), .A (nx1116)) ;
    buf02 ix1306 (.Y (nx1307), .A (nx1118)) ;
    buf02 ix1308 (.Y (nx1309), .A (nx1120)) ;
    buf02 ix1314 (.Y (nx1315), .A (nx1321)) ;
    buf02 ix1320 (.Y (nx1321), .A (nx1327)) ;
    buf02 ix1326 (.Y (nx1327), .A (nx1333)) ;
    buf02 ix1332 (.Y (nx1333), .A (nx1339)) ;
    buf02 ix1338 (.Y (nx1339), .A (REG_RESULT[1])) ;
    ao21 ix963 (.Y (nx962), .A0 (nx958), .A1 (nx897), .B0 (nx1345)) ;
    inv02 ix1344 (.Y (nx1345), .A (ALU_SUM_0_)) ;
    and02 ix13 (.Y (nx958), .A0 (ALU_CON[11]), .A1 (nx914)) ;
    ao21 ix177 (.Y (REG_RESULT[1]), .A0 (nx166), .A1 (nx122), .B0 (nx1347)) ;
    inv02 ix1346 (.Y (nx1347), .A (nx1229)) ;
    ao22 ix972 (.Y (nx166), .A0 (ALU_SUM_1_), .A1 (nx154), .B0 (nx1213), .B1 (
         nx160)) ;
    nor02 ix41 (.Y (nx899), .A0 (nx901), .A1 (BIT_ADDRESS[2])) ;
    ao21 ix988 (.Y (nx987), .A0 (nx1373), .A1 (nx958), .B0 (nx1349)) ;
    inv02 ix1348 (.Y (nx1349), .A (ALU_SUM_2_)) ;
    ao21 ix223 (.Y (nx222), .A0 (nx1373), .A1 (nx160), .B0 (nx1351)) ;
    inv02 ix1350 (.Y (nx1351), .A (nx1235)) ;
    and02 ix31 (.Y (nx904), .A0 (nx901), .A1 (BIT_ADDRESS[2])) ;
    ao21 ix1003 (.Y (nx1002), .A0 (nx904), .A1 (nx958), .B0 (nx1353)) ;
    inv02 ix1352 (.Y (nx1353), .A (ALU_SUM_4_)) ;
    ao21 ix279 (.Y (nx278), .A0 (nx904), .A1 (nx160), .B0 (nx1355)) ;
    inv02 ix1354 (.Y (nx1355), .A (nx1239)) ;
    ao22 ix487 (.Y (nx486), .A0 (OPERAND_B[0]), .A1 (nx482), .B0 (nx1371), .B1 (
         nx1357)) ;
    inv02 ix1356 (.Y (nx1357), .A (nx1052)) ;
    and04 ix1051 (.Y (nx454), .A0 (ALU_CON[14]), .A1 (nx1037), .A2 (ALU_CON[13])
          , .A3 (OPCODE[5])) ;
    and02 ix743 (.Y (nx742), .A0 (OPCODE[4]), .A1 (CARRY_FLAG)) ;
    inv02 ix1358 (.Y (nx1359), .A (ALU_CON[16])) ;
    inv02 ix1360 (.Y (nx1361), .A (nx1359)) ;
    inv02 ix1362 (.Y (nx1363), .A (nx1359)) ;
    inv02 ix1364 (.Y (nx1365), .A (nx1359)) ;
    buf04 ix1366 (.Y (nx1367), .A (ALU_CON[5])) ;
    buf04 ix1368 (.Y (nx1369), .A (ALU_CON[5])) ;
    buf02 ix1370 (.Y (nx1371), .A (nx454)) ;
    inv02 ix1372 (.Y (nx1373), .A (nx1159)) ;
endmodule


module block02 ( S, P, G, C_IN, C_EN ) ;

    output [3:0]S ;
    input [3:0]P ;
    input [2:0]G ;
    input C_IN ;
    input C_EN ;

    wire nx4, nx10, nx212, nx219, nx231;



    xor2 ix25 (.Y (S[0]), .A0 (C_IN), .A1 (P[0])) ;
    aoi22 ix213 (.Y (nx212), .A0 (G[0]), .A1 (C_EN), .B0 (C_IN), .B1 (P[0])) ;
    xnor2 ix19 (.Y (S[3]), .A0 (P[3]), .A1 (nx231)) ;
    aoi22 ix220 (.Y (nx219), .A0 (G[2]), .A1 (C_EN), .B0 (P[2]), .B1 (nx10)) ;
    inv02 ix5 (.Y (nx4), .A (nx212)) ;
    buf02 ix230 (.Y (nx231), .A (nx219)) ;
    xor2 ix23 (.Y (S[1]), .A0 (P[1]), .A1 (nx4)) ;
    xor2 ix21 (.Y (S[2]), .A0 (P[2]), .A1 (nx10)) ;
    ao22 ix216 (.Y (nx10), .A0 (G[1]), .A1 (C_EN), .B0 (P[1]), .B1 (nx4)) ;
endmodule


module block01 ( P, CO, ALU_CON, A, B ) ;

    output P ;
    output CO ;
    input [5:0]ALU_CON ;
    input A ;
    input B ;

    wire nx178, nx180, nx183, nx185;



    nor02 ix9 (.Y (CO), .A0 (nx178), .A1 (nx180)) ;
    inv02 ix179 (.Y (nx178), .A (A)) ;
    mux21 ix181 (.Y (nx180), .A0 (ALU_CON[5]), .A1 (ALU_CON[4]), .S0 (B)) ;
    mux21 ix33 (.Y (P), .A0 (nx183), .A1 (nx185), .S0 (B)) ;
    mux21 ix184 (.Y (nx183), .A0 (ALU_CON[0]), .A1 (ALU_CON[3]), .S0 (A)) ;
    mux21 ix186 (.Y (nx185), .A0 (ALU_CON[1]), .A1 (ALU_CON[2]), .S0 (A)) ;
endmodule

